package com.jiaoyinbrother.monkeyking.manager.activity

import android.content.Intent
import android.net.Uri
import android.view.View
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.detail.OrderDetailActivity
import com.jiaoyinbrother.monkeyking.manager.util.DialogUtil
import com.jiaoyinbrother.library.base.BaseActivity
import com.jiaoyinbrother.library.bean.OrderDetailResult
import com.jiaoyinbrother.library.util.ConstantsUtil
import kotlinx.android.synthetic.main.activity_audit_result.*

/**
 * by Soda on 2018/2/1.
 */
class AuditResultActivity : BaseActivity() {

    private var status: Int? = null
    private var orderResult: OrderDetailResult? = null

    override fun getLayoutId(): Int {
        orderResult = intent?.getSerializableExtra(ConstantsUtil.ORDER_RESULT) as OrderDetailResult?
        status = orderResult?.return_car_image?.status_code
        return R.layout.activity_audit_result
    }

    override fun initView() {
    }

    override fun initToolBar() {
        mainTitle.text = "审核结果"
    }

    override fun initListeners() {
    }

    override fun initData() {
        when (status) {
            0 -> {
                // 认证失败
                //      orderResult?.return_car_image?.xxx
                resultDataView.setEmptyData(R.mipmap.icon_xiaobai_fail, "未通过审核", "", "")
                resultDataView.setPositiveButton("重新上传", View.OnClickListener {
                    val intent = Intent(this, SmartKeyFeedBackActivity::class.java)
                    intent.putExtra(ConstantsUtil.FLAG_SMART_KEY, SmartKeyFeedBackActivity.STATUS_RETURN)
                    intent.putExtra(ConstantsUtil.ORDER_RESULT, orderResult)
                    startActivity(intent)
                    finish()
                })
                resultDataView.setNegativeButton("联系客服", View.OnClickListener {
                    val intent = Intent(Intent.ACTION_CALL, Uri.parse("tel:" + DialogUtil.SERVICE_PHONE))
                    startActivity(intent)
                })
            }
            1 -> {
                // 认证通过
                resultDataView.setEmptyData(R.mipmap.icon_xiaobai_success, "通过审核", "让您久等了，您的照片已通过审核，您可在订单详情页中查看~", "")
                resultDataView.setNegativeButton("查看订单", View.OnClickListener { onBackPressed() })
            }
        }
    }

    override fun onBackPressed() {
        val intent = Intent(this@AuditResultActivity, OrderDetailActivity::class.java)
        intent.putExtra(ConstantsUtil.ORDER_ID, orderResult?.orderid)
        intent.flags = Intent.FLAG_ACTIVITY_CLEAR_TOP
        intent.addFlags(Intent.FLAG_ACTIVITY_SINGLE_TOP)
        startActivity(intent)
        super.onBackPressed()
    }

}