package com.jiaoyinbrother.monkeyking.manager.activity

import android.content.Context
import android.content.Intent
import android.widget.Button
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.monkeymain.MonkeyMainActivity
import com.jiaoyinbrother.monkeyking.manager.util.H5Utils
import com.jiaoyinbrother.library.base.BaseActivity
import com.jiaoyinbrother.library.util.AuthUtil
import com.jiaoyinbrother.library.util.ConstantsUtil
import com.jiaoyinbrother.library.util.StatisticsUtil
import com.jiaoyinbrother.library.util.TextViewUtil
import kotlinx.android.synthetic.main.activity_certification_result.*

class CertificationResultActivity : BaseActivity() {

    private var userStatus = 2
    private var type = ACTITYPE_TYPE_ZUCHE


    override fun getLayoutId(): Int {

        try{
            userStatus = intent?.getIntExtra(USER_STATUS,2)!!
            type =intent?.getStringExtra(ConstantsUtil.ACTIVITY_TYPE) ?:""
        }catch (e:Exception){

        }

        return R.layout.activity_certification_result
    }

    override fun initView() {

    }

    override fun initToolBar() {

    }

    override fun initListeners() {

    }

    override fun initData() {
        (findViewById<Button>(R.id.ivTitleName)).text = "实名认证"

        if (userStatus == AuthUtil.USER_AUTHING) {
            // 认证中
            act_tenant_suss_img_iv.setImageResource(R.mipmap.certificating)
            act_tenant_suss_status_tv.text = "认证中"
            act_tenant_suss_text1_tv.text = "我们正全力审核中，请耐心等待。"
            button_left.text = "联系客服"
            button_left.setOnClickListener { handleCustomService() }
            button_right.text = "去看看车"
            button_right.setOnClickListener { }
        } else if (userStatus == AuthUtil.USER_AUTHED) {
            // 认证成功
            act_tenant_suss_img_iv.setImageResource(R.mipmap.certification_passed)
            act_tenant_suss_status_tv.text = "认证通过"
            act_tenant_suss_text1_tv.text = "想租好车？赶紧去升级吧~"
            button_left.text = "会员升级"
            button_left.setOnClickListener { handleLevelUpdate() }
            button_right.text = "去看看车"
            button_right.setOnClickListener {  }
            TextViewUtil.setButtonStatus(button_right, this@CertificationResultActivity, TextViewUtil.BUTTON_ENABLE_NORMAL)
        } else if (userStatus == AuthUtil.USER_BLACKLIST) {
            // 认证失败(重新提交)
            act_tenant_suss_img_iv.setImageResource(R.mipmap.certification_fail)
            act_tenant_suss_status_tv.text = "认证未通过"
            act_tenant_suss_text1_tv.text = "认证未通过"
            button_left.text = "联系客服"
            button_left.setOnClickListener { handleCustomService() }
            button_right.text = "重新提交"
            button_right.setOnClickListener { handleResubmit() }
        }
    }

    private fun handleResubmit() {
        // 认证失败(重新提交)
        IdentificationActivity.startIdentificationActivity(this, IdentificationActivity.ACTIVITY_TYPE_GENRRAL, "")
        finish()
    }

    private fun handleHome() {
        // 认证失败(不重新提交)
        val intent = Intent(this@CertificationResultActivity, MonkeyMainActivity::class.java)
        intent.flags = Intent.FLAG_ACTIVITY_NEW_TASK or Intent.FLAG_ACTIVITY_CLEAR_TOP
        startActivity(intent)
        finish()
    }

    private fun handleLevelUpdate() {
        finish()
    }


    private fun handleCustomService() {
        StatisticsUtil.onEvent(this, ConstantsUtil.AUTH_STATUS_CUSTOMER_SERVICE, "")
        H5Utils.contactService(this@CertificationResultActivity)
    }

    companion object {
        const val ACTITYPE_TYPE_TIME_SHARE = "ACTITYPE_TYPE_TIME_SHARE"
        const val ACTITYPE_TYPE_ZUCHE = "ACTITYPE_TYPE_ZUCHE"
        private const val USER_STATUS = "USER_STATUS"

        fun startCertificationResult(context: Context, type:String, userStatus:Int, isClearTop:Boolean){
            val intent = Intent(context, CertificationResultActivity::class.java)
            if(isClearTop)
                intent.flags = Intent.FLAG_ACTIVITY_NEW_TASK or Intent.FLAG_ACTIVITY_CLEAR_TOP
            intent.putExtra(ConstantsUtil.ACTIVITY_TYPE, type)
            intent.putExtra(USER_STATUS,userStatus)
            context.startActivity(intent)

        }
    }

}
