package com.jiaoyinbrother.monkeyking.manager.activity

import android.content.Intent
import android.net.Uri
import android.os.Build
import android.text.TextUtils
import android.view.View
import com.google.gson.Gson
import com.google.gson.JsonSyntaxException
import com.jiaoyinbrother.library.base.BaseActivity
import com.jiaoyinbrother.library.bean.H5PayParam
import com.jiaoyinbrother.library.bean.PayInfoBean
import com.jiaoyinbrother.library.bean.ShareConfigEntity
import com.jiaoyinbrother.library.bean.WebPayBean
import com.jiaoyinbrother.library.util.*
import com.jiaoyinbrother.monkeyking.manager.Constants
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.console.manager.CarManagerActivity.Companion.newInstance
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.console.price.CarPriceManagerActivity
import com.jiaoyinbrother.monkeyking.manager.util.NetUtil
import com.jiaoyinbrother.monkeyking.manager.view.ProgressWebView
import com.tencent.smtt.export.external.interfaces.JsResult
import com.tencent.smtt.sdk.ValueCallback
import com.tencent.smtt.sdk.WebChromeClient
import com.tencent.smtt.sdk.WebView
import kotlinx.android.synthetic.main.act_webview.*
import me.yokeyword.fragmentation.ISupportFragment
import org.json.JSONObject
import java.net.URLDecoder

class CustomServiceWebViewActivity : BaseActivity(), ProgressWebView.ProgressWebViewListener {
    private var mURLStrings: Array<String>? = null

    override fun getLayoutId(): Int {
        return R.layout.act_webview
    }

    override fun initView() {
        ivTitleBtnLeft?.setOnClickListener {
            onBackPressed()
        }
        shareBtn?.visibility = View.GONE
    }

    override fun initToolBar() {}

    override fun initListeners() {
        webView1.setActionListner(this)
    }

    override fun initData() {
        titleActivity?.text = intent?.getStringExtra(WEB_TITLE)
        loadWebView()
    }

    override fun shouldOverrideUrlLoading(view: WebView?, url: String): Boolean {
        if (url.contains("console.wkzuche.com/m/pages/m.jsp") ||url.contains("console.wkzuche.com//m/pages/m.jsp") ) {
            this.finish()
            return true
        }
        if (url.startsWith("tel:")) {
            val intent = Intent(Intent.ACTION_VIEW, Uri.parse(url))
            startActivity(intent)
            return true
        } else if (url.contains("pay/yeepay/notify") && !url.contains("callBackUrl")) {
//                易宝支付成功
            LogUtil.e("易宝支付成功")
            this.setResult(RESULT_YIBAO_SUCCESS)
            this.finish()
            return true
        }
        val strs = url.split(":".toRegex()).toTypedArray()
        if (strs[0] != "wkzuche") {
            return false
        }
        if (strs.size == 3) {
            mURLStrings = strs
            strs[2] = URLDecoder.decode(strs[2])
            val param = strs[2]
            when (strs[1]) {
                "webpay" -> handleWebPay(param)
                "pagetitle" -> handlePageTitle(param)
                "share" -> {
                }
                "LoginAndRegister_viewControllerForMKLogin_" -> handleLogin()
                "ManageCar_viewControllerForCarManage" -> handleMyCarManagement()
                "TimeSharing_viewControllerForOrderDetail_" -> GeneralWebViewActivity.handleTimeShareOrderDetail(this, param)
                "OrderDetail_viewControllerForOrderDetail_" -> GeneralWebViewActivity.handleZucheOrderDetail(this, param)
                "Navigator_callWithParams_" -> GeneralWebViewActivity.handleNavi(this, param)
                "pay" -> handlePay(param)
                "timeShareHome" -> GeneralWebViewActivity.handleTimeShareHome(this)
                "ManagePrice_viewControllerForPriceManage" -> startActivity(Intent(this, CarPriceManagerActivity::class.java))
            }
            //悟空url，已经处理
            return true
        }
        return false
    }

    override fun onJsAlert(view: WebView?, url: String?, message: String?, result: JsResult?): Boolean {
        return false
    }

    private val isWebResult = false

    private fun handleWebPay(param: String) {
        try {
            val webPayBean: WebPayBean
            val gson = Gson()
            webPayBean = gson.fromJson(param, WebPayBean::class.java)
            if (webPayBean != null) {
                if (!isWebResult) {
                    AppCacheUtil(this).webPayResult = ""
                    val intent = Intent(this, CashierDeskActivity::class.java)
                    intent.putExtra(ConstantsUtil.BUNDLE_EXTRA_KEY, ConstantsUtil.PAY_PROJECT_WEB)
                    intent.putExtra(ConstantsUtil.PAY_PROJECT_WEB, webPayBean)
                    startActivityForResult(intent, Constants.WEB_PAY_RESULT)
                }
            }
        } catch (e: JsonSyntaxException) {
            e.printStackTrace()
        }
    }


    private fun handleMyCarManagement() {
        newInstance(this)
    }


    private fun handleLogin() {
        if (!NetUtil.isNetworkAvailable(this)) {
            OldToastUtil.showerror(this, OldToastUtil.TIMEOUT_EXCEPTION)
            return
        }
        if (UserUtil(this).isLogin()) {
            postLoginInfoBack()
        }
    }

    private fun handlePageTitle(param: String) {
        try {
            val json = JSONObject(param)
            val code = json.optString("title")
            titleActivity.setText(code)
        } catch (e: Exception) {
            e.printStackTrace()
        }
    }


    private fun handlePay(param: String) {
        try {
            val h5PayParam = Gson().fromJson(param, H5PayParam::class.java)
            if (null != h5PayParam) {
                val bean = PayInfoBean()
                bean.flag = PayInfoBean.PAYMENT_TYPE_ZJY
                bean.amount = h5PayParam.price.toFloat()
                bean.payMethod = h5PayParam.payMethod
                bean.tn = h5PayParam.orderid
                val intent = Intent(this, PayMethodActivity::class.java)
                intent.putExtra(ConstantsUtil.START_PAYMETHOD, bean)
                startActivityForResult(intent, REQUEST_H5_PAY)
            }
        } catch (e: Exception) {
            LogUtil.e("handlePay e = $e")
        }
    }

    private fun postLoginInfoBack() {
        val userUtil = UserUtil(this)
        var loginInfo = userUtil.loginResultPref
        LogUtil.e("relogin: loginInfo =$loginInfo")
        if (TextUtils.isEmpty(loginInfo)) loginInfo = "test" else LogUtil.e("LoginInfo = $loginInfo")
        if (mURLStrings == null) return
        val shareConfigEntity = Gson().fromJson<ShareConfigEntity>(mURLStrings?.get(2), ShareConfigEntity::class.java)
        if (shareConfigEntity?.callbacks != null) {
            val JSString = shareConfigEntity.callbacks.success
            webView1.loadUrl("javascript:$JSString($loginInfo)")
            LogUtil.e("javascript:$JSString($loginInfo)")
        }
    }

    private fun loadWebView() {
        LogUtil.e("loadWebView*********************************************")
        if (!NetUtil.isNetworkAvailable(this)) {
            onReceivedError()
            return
        }
        webView1.isNeedProgressBar = false
        webView1.loadUrl(intent?.getStringExtra(WEB_URL))
        webView1.clearHistory()
    }

    //    本地文件选择操作
    private val INPUT_FILE_REQUEST_CODE = 1
    private val FILECHOOSER_RESULTCODE = 1

    private var mUploadMessage: ValueCallback<Uri?>? = null
    private var mFilePathCallback: ValueCallback<Array<Uri>?>? = null

    // For Android 5.0
    override fun onShowFileChooser(view: WebView?, filePath: ValueCallback<Array<Uri>?>?,
                                   fileChooserParams: WebChromeClient.FileChooserParams?): Boolean {
        // Double check that we don't have any existing callbacks
        if (mFilePathCallback != null) {
            mFilePathCallback!!.onReceiveValue(null)
        }
        mFilePathCallback = filePath
        val contentSelectionIntent = Intent(Intent.ACTION_GET_CONTENT)
        contentSelectionIntent.addCategory(Intent.CATEGORY_OPENABLE)
        contentSelectionIntent.type = "image/*"
        val chooserIntent = Intent(Intent.ACTION_CHOOSER)
        chooserIntent.putExtra(Intent.EXTRA_INTENT, contentSelectionIntent)
        chooserIntent.putExtra(Intent.EXTRA_TITLE, "选择图片")
        startActivityForResult(chooserIntent, INPUT_FILE_REQUEST_CODE)
        return true
    }

    // openFileChooser for Android 3.0+
    override fun openFileChooser(uploadMsg: ValueCallback<Uri?>?, acceptType: String?) {
        mUploadMessage = uploadMsg
        val i = Intent(Intent.ACTION_GET_CONTENT)
        i.addCategory(Intent.CATEGORY_OPENABLE)
        i.type = "image/*"

        // Create file chooser intent
        val chooserIntent = Intent.createChooser(i, "Image Chooser")

        // On select image call onActivityResult method of activity
        startActivityForResult(chooserIntent, FILECHOOSER_RESULTCODE)
    }

    override fun onReceivedError() {
    }


    override fun onActivityResult(requestCode: Int, resultCode: Int, intent: Intent?) {
        super.onActivityResult(requestCode, resultCode, intent)
        LogUtil.e("requestCode = $requestCode")
        if (null == intent) {
            if (mFilePathCallback != null) {
                mFilePathCallback!!.onReceiveValue(null)
                mFilePathCallback = null
            }
            if (mUploadMessage != null) {
                mUploadMessage!!.onReceiveValue(null)
                mUploadMessage = null
            }
            return
        }
        handleFileOperation(requestCode, resultCode, intent)
    }

    private fun handleFileOperation(requestCode: Int, resultCode: Int, intent: Intent) {
        if (Build.VERSION.SDK_INT >= 21) {
            if (requestCode != INPUT_FILE_REQUEST_CODE || mFilePathCallback == null) {
                return
            }
            var results: Array<Uri>? = null

            // Check that the response is a good one
            if (resultCode == ISupportFragment.RESULT_OK) {
                val dataString = intent.dataString
                if (dataString != null) {
                    results = arrayOf(Uri.parse(dataString))
                }
            }
            mFilePathCallback!!.onReceiveValue(results)
            mFilePathCallback = null
        }
    }


    override fun onBackPressed() {
        if (webView1.canGoBack()) {
            webView1.goBack()
        } else {
            super.onBackPressed()
        }
    }

    companion object {
        const val WEB_URL = "WEB_URL"
        const val WEB_TITLE = "WEB_TITLE"
        private const val REQUEST_H5_LOGIN = 2
        private const val REQUEST_H5_PAY = 3
        const val RESULT_YIBAO_SUCCESS = 9999
    }
}