package com.jiaoyinbrother.monkeyking.manager.activity

import android.content.Intent
import android.os.Handler
import android.view.View
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.monkeymain.MonkeyMainActivity
import com.jiaoyinbrother.monkeyking.manager.util.DialogUtil
import com.jiaoyinbrother.library.base.BaseActivity
import com.jiaoyinbrother.library.util.ConstantsUtil
import kotlinx.android.synthetic.main.activity_pay_result.*

class PayResultActivity : BaseActivity(), View.OnClickListener {

    private var status = 0
    private var message = ""
    private var amount = 0

    override fun getLayoutId(): Int {
        return R.layout.activity_pay_result
    }

    override fun initView() {
        amount = intent.getIntExtra(ConstantsUtil.PAY_RESULT_AMOUNT, 0)
        status = intent.getIntExtra(ConstantsUtil.PAY_RESULT_CODE, 0)
        message = intent.getStringExtra(ConstantsUtil.PAY_RESULT_MSG) ?: ""
    }

    override fun initToolBar() {
        mainTitle.text = "支付"
    }

    override fun initListeners() {
        negativeFail.setOnClickListener(this)
        positiveFail.setOnClickListener(this)
        negativeSucc.setOnClickListener(this)
        positiveSucc.setOnClickListener(this)
    }

    override fun initData() {
        payAmountTv.text = "$amount"
        Handler().postDelayed({
            mLoading.visibility = View.GONE
            mSuccess.visibility = if (status == PayMethodActivity.SUCC) View.VISIBLE else View.GONE
            mFailed.visibility = if (status == PayMethodActivity.FAIL) View.VISIBLE else View.GONE
            mainTitle.text = if (status == PayMethodActivity.SUCC) "支付成功" else "支付失败"
        }, 2000)
    }

    override fun onClick(v: View?) {
        when (v?.id) {
            R.id.positiveFail, R.id.positiveSucc -> finish()
            R.id.negativeFail -> DialogUtil.onServiceDial(this@PayResultActivity)
            R.id.negativeSucc -> {
                val intent = Intent(this@PayResultActivity, MonkeyMainActivity::class.java)
                intent.flags = Intent.FLAG_ACTIVITY_NEW_TASK or Intent.FLAG_ACTIVITY_CLEAR_TOP
                startActivity(intent)
                finish()
            }
        }
    }

}