package com.jiaoyinbrother.monkeyking.manager.activity

import android.Manifest
import android.app.Activity
import android.content.Context
import android.content.Intent
import android.net.Uri
import android.os.AsyncTask
import android.os.Build
import android.os.Environment
import android.support.v4.content.FileProvider
import android.support.v7.app.AlertDialog
import android.text.InputFilter
import android.text.TextUtils
import android.view.Gravity
import android.view.MotionEvent
import android.view.View
import android.view.inputmethod.EditorInfo
import android.view.inputmethod.InputMethodManager
import android.widget.EditText
import android.widget.TextView
import com.bumptech.glide.Glide
import com.bumptech.glide.load.resource.bitmap.CircleCrop
import com.bumptech.glide.request.RequestOptions
import com.google.gson.Gson
import com.jiaoyinbrother.monkeyking.manager.CarEntity
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.network.CarLib
import com.jiaoyinbrother.monkeyking.manager.network.HttpFileUpTool
import com.jiaoyinbrother.monkeyking.manager.util.MKUtil
import com.jiaoyinbrother.monkeyking.manager.util.NetUtil
import com.jiaoyinbrother.monkeyking.manager.util.SharedPreferencesUtil
import com.jiaoyinbrother.monkeyking.manager.view.IOSdialog.IOSAlertDialog
import com.jiaoyinbrother.monkeyking.manager.view.date.SelectBirthdayDialog
import com.jiaoyinbrother.monkeyking.manager.wxutil.WXUitls
import com.jiaoyinbrother.library.base.BaseActivity
import com.jiaoyinbrother.library.bean.*
import com.jiaoyinbrother.library.impl.WeChatModel
import com.jiaoyinbrother.library.listeners.WeChatListener
import com.jiaoyinbrother.library.presenter.UserDetailPresenter
import com.jiaoyinbrother.library.util.*
import com.jiaoyinbrother.library.view.IGeneralModel
import com.jiaoyinbrother.library.widget.BottomDialog
import com.tbruyelle.rxpermissions2.RxPermissions
import com.tencent.mm.opensdk.modelbase.BaseResp
import com.tencent.mm.opensdk.openapi.IWXAPI
import io.reactivex.disposables.Disposable
import kotlinx.android.synthetic.main.act_personal.*
import kotlinx.android.synthetic.main.main_title.*
import org.json.JSONException
import java.io.File
import java.io.IOException
import java.text.SimpleDateFormat
import java.util.*
import java.util.concurrent.TimeoutException

class PersonalInfoActivity : BaseActivity(), View.OnClickListener {

    private var mCarLib: CarLib? = null
    private var mUdr: UserDetailResult? = null

    private var uid: String? = null

    private var headImgUrl: String? = null

    private var mWXUtil: WeChatUtil? = null
    private var manager: WeChatManager? = null

    private val mRxPermissions = RxPermissions(this@PersonalInfoActivity)

    override fun getLayoutId(): Int {
        return R.layout.act_personal
    }

    override fun initView() {
    }

    override fun initToolBar() {

    }

    override fun initListeners() {
        headImage_layout.setOnClickListener(this)
        sex_layout.setOnClickListener(this)
        nick_name_layout.setOnClickListener(this)
        tv_nickname.setOnClickListener(this)
        birthday_layout.setOnClickListener(this)
        qrcode_layout.setOnClickListener(this)
        third_binding_layout.setOnClickListener(this)


        tv_nickname.onFocusChangeListener = View.OnFocusChangeListener { v, hasFocus ->
            if (hasFocus) {
                tv_nickname.gravity = Gravity.LEFT or Gravity.CENTER_VERTICAL
            }
        }


        tv_nickname.setOnTouchListener(View.OnTouchListener { _, event ->
            if (event.action === MotionEvent.ACTION_OUTSIDE) {
                tv_nickname.isFocusable = false//EditText 失去焦点
                //其他要实现的功能。
                return@OnTouchListener true
            }
            false
        })

        tv_nickname.setOnEditorActionListener { v, actionId, event ->
            var isOK = true
            when (actionId) {
                EditorInfo.IME_ACTION_DONE -> {
                    //处理事件
                    tv_nickname.isFocusable = false
                    tv_nickname.gravity = Gravity.RIGHT or Gravity.CENTER_VERTICAL
                    if (!TextUtils.isEmpty(tv_nickname.text.toString()))
                        UserUpdataAsyncTask().execute()
                    isOK = true
                }
                else -> isOK = false
            }
            isOK
        }

        // 微信登录
        manager?.setWeChatListener(object : WeChatListener {
            override fun success(code: String) {
                if (!TextUtils.isEmpty(code)) {
                    dismissLoadingDialog()
                    mWXUtil?.getWxOpenId(code, wxModel)
                } else {
                    showToast("授权失败")
                }
            }

            override fun failed(baseResp: BaseResp) {
                dismissLoadingDialog()
            }
        })

    }

    private val wxModel = object : WeChatModel {
        override fun onSuccess(bean: Any) {
            mWeChatResult = bean as WeChatUserInfoResult
            mWeChatOpenId = mWeChatResult?.openid
            mWeChatUnionid = mWeChatResult?.unionid
            bindThird()
            isBindingWechat = false

        }

        override fun onFailed() {
            showToast("授权失败")
        }
    }

    override fun initData() {
        iwxApi = WXUitls.initWxApi(this@PersonalInfoActivity)
        mWXUtil = WeChatUtil(this)
        manager = WeChatManager.getInstance()


        val intent = this.intent
        val b = intent.extras
        if (b != null) {
            try {
                mUdr = b.getSerializable("PersonInfo") as UserDetailResult
            } catch (e: Exception) {

            }

        }

        ivTitleName.text = "个人信息"

        val emojiFilters = arrayOf<InputFilter>(TextUtil.getEmojiFilter(), InputFilter.LengthFilter(20))
        tv_nickname.filters = emojiFilters
        tv_nickname.imeOptions = EditorInfo.IME_ACTION_DONE;
        setData(mUdr)
    }

    private fun setData(userDetailResult: UserDetailResult?) {
        if (userDetailResult == null) {
            requestUserDetail()
            return
        }

        var userUtil = UserUtil(this@PersonalInfoActivity)

        val head_img_url = SharedPreferencesUtil.getInstance()
                .getString("head_img" + userUtil.uid)

        Glide.with(this).load(head_img_url).placeholder(R.mipmap.icon_default_head)
                .apply(RequestOptions.bitmapTransform(CircleCrop()))
                .into(imageview_head)

        // 姓名
        if (!TextUtils.isEmpty(userDetailResult.name)) {
            tv_username.text = userDetailResult.name
        } else {
            tv_username.text = userUtil.userName
        }
        // 电话
        if (!TextUtils.isEmpty(userDetailResult.uid)) {
            val pcode = userDetailResult.uid.substring(0, 3) + "****" + userDetailResult.uid.substring(7)
            tv_usernum.text = pcode
        } else {
            uid = userUtil.uid
            val pcode = formatPhoneNum(uid!!)
            tv_usernum.text = pcode
        }
        // 昵称
        if (!TextUtils.isEmpty(userDetailResult.nickname)) {
            tv_nickname.setText(userDetailResult.nickname)
        }
        // 性别
        if (!TextUtils.isEmpty(userDetailResult.gender)) {
            when (userDetailResult.gender) {
                "f" -> tv_sex.text = "女"
                "m" -> tv_sex.text = "男"
                "u" -> tv_sex.text = "男"
                else -> tv_sex.text = "添加"
            }
        }
        // 生日
        if (!TextUtils.isEmpty(userDetailResult.birthday)) {
            tv_birthday.text = userDetailResult.birthday
        }

//        微信绑定状态
        if (userDetailResult.thirdparty != null && userDetailResult.thirdparty.size > 0) {
            for (i in 0 until userDetailResult.thirdparty.size) {
                if (userDetailResult.thirdparty[i].type.contains("ZUCHE_WEIXIN")) {
                    setButtonText(bind_status_textview, true)
                } else {
                    setButtonText(bind_status_textview, false)
                }
            }
        } else {
            setButtonText(bind_status_textview, false)
        }

    }

    private fun formatPhoneNum(phoneNum: String): String {
        return phoneNum.substring(0, 3) + "****" + phoneNum.substring(7)
    }

    private fun requestUserDetail() {
        val userDetailBean = UserDetailRequestBean()
        userDetailBean.uid = UserUtil(this@PersonalInfoActivity).uid

        showLoadingDialog()
        var model = UserDetailPresenter()
        model.getUserDetail(this, userDetailBean, UserDetailResult::class.java, object : IGeneralModel {
            override fun getCodeBeanFail(errorCode: Int) {
                dismissLoadingDialog()
                showErrorToast(errorCode)
            }

            override fun getCodeObjectSuccess(bean: Any) {
                dismissLoadingDialog()
                setData(bean as UserDetailResult)
            }
        })
    }

    /**
     * 设置button要显示内容
     */
    private fun setButtonText(btn: TextView, bindStatus: Boolean) {
        if (bindStatus) {
            btn.text = "解除绑定"
        } else {
            btn.text = "绑定"
        }
        isWeChatBind = bindStatus
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        myOnActivityResult(requestCode, resultCode, data)
    }

    override fun onClick(v: View?) {
        when (v?.id) {
            R.id.headImage_layout -> uploadHeadImage()
            R.id.sex_layout -> goGender()

            R.id.nick_name_layout -> goNickName()
            R.id.tv_nickname -> goNickName()

            R.id.birthday_layout -> goBirthday()

            R.id.qrcode_layout -> goQrcode()

            R.id.third_binding_layout -> goThirdBinding()
        }
    }

    /**
     * 更新个人信息
     */
    internal inner class UserUpdataAsyncTask : AsyncTask<Void, Void, BaseResult>() {
        override fun doInBackground(vararg params: Void): BaseResult {
            mCarLib = CarLib.getInstance(applicationContext)
            val uue = UserUpdataRequest()
            uue.uid = UserUtil(this@PersonalInfoActivity).uid

            if (!TextUtils.isEmpty(tv_nickname.text.toString()) && !TextUtils.equals("添加", tv_nickname.text.toString())) {
                uue.nickname = tv_nickname.text.toString()
            }

            if (!TextUtils.isEmpty(tv_sex.text.toString()) && !TextUtils.equals("添加", tv_sex.text.toString())) {
                when (tv_sex.text.toString()) {
                    "男" -> uue.gender = "m"
                    "女" -> uue.gender = "f"
                }
            }

            if (!TextUtils.isEmpty(tv_birthday.text.toString()) && !TextUtils.equals("添加", tv_birthday.text.toString())) {
                uue.birthday = tv_birthday.text.toString()
            }

            if (!TextUtils.isEmpty(headImgUrl)) {
                uue.headimg_url = headImgUrl
            }

            var br = BaseResult()
            try {
                br = mCarLib?.postRequest(Gson().toJson(uue), "user/update", BaseResult::class.java) as BaseResult
            } catch (e: Exception) {
                NetUtil.handlePostExceptionBaseResult(br, e)
            }

            return br
        }

        override fun onPostExecute(result: BaseResult) {
            super.onPostExecute(result)
            if (result.errCode == -1) {
                if (result.code == CarEntity.SUCC) {
                    OldToastUtil.show(this@PersonalInfoActivity, "个人信息修改成功")
                } else {
                    OldToastUtil.show(this@PersonalInfoActivity, result.msg)
                }
            } else {
                OldToastUtil.showerror(this@PersonalInfoActivity, result.errCode)
            }
        }
    }

    /**
     * 上传头像
     */
    private fun uploadHeadImage() {
        BottomDialog(this@PersonalInfoActivity).builder().addItems(arrayOf("拍照", "从相册选择")).setCancel("取消") {}.setItemClick { _, i ->
            if (i == 0) {// 相机
                //11.29 动态权限
                autoObtainCameraPermission()
            } else {// 相册
                autoObtainStoragePermission()
            }
        }.show()
    }

    private fun myOnActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {

        if (resultCode == Activity.RESULT_OK) {
            when (requestCode) {
                //拍照完成回调
                CODE_CAMERA_REQUEST -> {
                    cropImageUri = Uri.fromFile(fileCropUri)
                    if (imageUri == null || cropImageUri == null)
                        return
                    PhotoUtils.cropImageUri(this, imageUri!!, cropImageUri!!, 1, 1, OUTPUT_X, OUTPUT_Y, CODE_RESULT_REQUEST)
                }
                //访问相册完成回调
                CODE_GALLERY_REQUEST ->
                    if (hasSdcard()) {
                        cropImageUri = Uri.fromFile(fileCropUri)
                        if (data?.data == null || cropImageUri == null)
                            return
                        var newUri = Uri.parse(PhotoUtils.getPath(this, data?.data!!))
                        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.N) {
                            newUri = FileProvider.getUriForFile(this, "$packageName.fileProvider", File(newUri.path!!))
                        }
                        PhotoUtils.cropImageUri(this, newUri, cropImageUri!!, 1, 1, OUTPUT_X, OUTPUT_Y, CODE_RESULT_REQUEST)
                    } else {
                        showToast("设备没有SD卡！")
                    }
                CODE_RESULT_REQUEST -> {
                    if (cropImageUri == null) {
                        return
                    }

                    val bitmap = PhotoUtils.getBitmapFromUri(cropImageUri!!, this)
                    if (bitmap != null) {

                        Glide.with(this).load(bitmap).placeholder(R.mipmap.icon_default_head)
                                .apply(RequestOptions.bitmapTransform(CircleCrop()))
                                .into(imageview_head)
                        PostHeadImageAsyncTask().execute()
                    }
                }
            }
        }
    }


    internal inner class PostHeadImageAsyncTask : AsyncTask<Void, Int, UploadResult>() {

        override fun onPreExecute() {
            super.onPreExecute()
        }

        override fun doInBackground(vararg params: Void): UploadResult {
            val map_params = HashMap<String, String>()
            map_params.put("type", "64")
            val mFiles = HashMap<String, File>()
            mFiles.put("file1", fileCropUri)
            var ur = UploadResult()
            try {
                ur = HttpFileUpTool.post(CarEntity.UploadActionUrl, map_params, mFiles, this@PersonalInfoActivity)
            } catch (e: IOException) {
                ur.errCode = OldToastUtil.IO_EXCEPTION
            } catch (e: JSONException) {
                ur.errCode = OldToastUtil.IO_EXCEPTION
            } catch (e: TimeoutException) {
                ur.errCode = OldToastUtil.TIMEOUT_EXCEPTION
            }

            return ur
        }

        override fun onPostExecute(result: UploadResult) {
            super.onPostExecute(result)
            if (result.errCode == -1) {
                if (result.code == CarEntity.SUCC) {
                    if (!TextUtils.isEmpty(result.file1)) {

                        Glide.with(this@PersonalInfoActivity).load(result.file1).placeholder(R.mipmap.icon_default_head)
                                .apply(RequestOptions.bitmapTransform(CircleCrop()))
                                .into(imageview_head)

                        MKUtil.saveHeadImage(result.file1, this@PersonalInfoActivity)
                        headImgUrl = result.file1
                        UserUpdataAsyncTask().execute()
                    }
                } else {
                    OldToastUtil.show(this@PersonalInfoActivity, result.msg)
                }
            } else {
                OldToastUtil.showerror(this@PersonalInfoActivity, result.errCode)
            }
        }
    }

    // 生日
    private fun goBirthday() {
        var time = ""
        if (!TextUtils.isEmpty(tv_birthday.text.toString()) && !TextUtils.equals(tv_birthday.text.toString(), "添加")) {
            time = tv_birthday.text.toString()
        } else {
            time = SimpleDateFormat("yyyy-MM-dd").format(Date())
        }
        SelectBirthdayDialog.Builder(this@PersonalInfoActivity)
                .setTitle("出生日期")
                .setDefaultDate(time)
                .setOnResultListener { resultTime ->
                    tv_birthday.text = resultTime
                    UserUpdataAsyncTask().execute()
                }
                .show()

    }

    // 我的二维码
    private fun goQrcode() {
        if (!NetUtil.isNetworkAvailable(this@PersonalInfoActivity)) {
            OldToastUtil.showerror(this@PersonalInfoActivity, OldToastUtil.TIMEOUT_EXCEPTION)
            return
        }
        var userUtil = UserUtil(this@PersonalInfoActivity)
        if (userUtil.isLogin()) {
            val intent = Intent(this@PersonalInfoActivity, UserQBCodeActivity::class.java)
            var userUtil = UserUtil(this)
            intent.putExtra("uid", userUtil.uid)
            intent.putExtra("name", userUtil.userName)
            intent.putExtra("role", userUtil.userRole)
            intent.putExtra("rolename", userUtil.userRoleName)
            startActivity(intent)
        }
    }

    // 第三方绑定
    private fun goThirdBinding() {
        if (isWeChatBind)
            unbindWechat(CarEntity.ThirdLoginType.WEIXIN.typeName) // 解除绑定
        else
            mWXUtil?.goToWx(iwxApi)
    }


    /**
     * 微信解绑
     */
    private fun unbindWechat(type: String) {
        IOSAlertDialog(this@PersonalInfoActivity).builder().setTitle("温馨提示").setMsg("确定解除绑定？", true)
                .setRightButton("解绑") { unBind(type) }.setLeftButton("取消") { }.show()

    }

    //    微信是否绑定
    private var isWeChatBind = false
    private var iwxApi: IWXAPI? = null
    private var isBindingWechat = false


    private var isUnbindTaskRun = false
    /**
     * 解除绑定接口
     */
    private fun unBind(type: String) {
        if (!NetUtil.isNetworkAvailable(this@PersonalInfoActivity)) {
            OldToastUtil.showerror(this@PersonalInfoActivity, OldToastUtil.TIMEOUT_EXCEPTION)
            return
        }
        if (!isUnbindTaskRun) {
            isUnbindTaskRun = true
            UnbingThirdAsyncTask(type).execute()
        }
    }


    internal inner class UnbingThirdAsyncTask constructor(private val type: String) : AsyncTask<Void, Void, BaseResult>() {

        override fun onPreExecute() {
            super.onPreExecute()

            showLoadingDialog()
        }

        override fun doInBackground(vararg params: Void): BaseResult {
            if (null == mCarLib)
                mCarLib = CarLib.getInstance(this@PersonalInfoActivity)
            val ute = UnbindThirdRequest()
            // 解除绑定内容
            ute.type = this.type
            ute.uid = UserUtil(this@PersonalInfoActivity).uid
            var br = BaseResult()
            var gson = Gson()
            try {
                br = mCarLib?.postRequest(gson.toJson(ute), "user/thirdparty/unbinding", BaseResult::class.java) as BaseResult
            } catch (e: Exception) {
                NetUtil.handlePostExceptionBaseResult(br, e)
            }

            return br
        }

        override fun onPostExecute(result: BaseResult) {
            super.onPostExecute(result)

            dismissLoadingDialog()
            isUnbindTaskRun = false

            if (result.errCode == -1) {
                if (result.code == CarEntity.SUCC) {
                    setButtonText(bind_status_textview, false)
                    OldToastUtil.show(this@PersonalInfoActivity, "解除绑定成功")
                } else {
                    OldToastUtil.show(this@PersonalInfoActivity, result.msg)
                }
            } else {
                OldToastUtil.showerror(this@PersonalInfoActivity, result.errCode)
            }
        }
    }

//    微信绑定receiver

    /* wechat */
    private var mWeChatOpenId: String? = null
    private var mWeChatUnionid: String? = null
    private var mWeChatResult: WeChatUserInfoResult? = null


    private var isBindThirdTaskRun = false

    private fun bindThird() {
        if (!NetUtil.isNetworkAvailable(this@PersonalInfoActivity)) {
            OldToastUtil.showerror(this@PersonalInfoActivity, OldToastUtil.TIMEOUT_EXCEPTION)
            return
        }
        if (mWeChatResult == null || TextUtils.isEmpty(mWeChatOpenId)) {
            OldToastUtil.showerror(this@PersonalInfoActivity, OldToastUtil.TIMEOUT_EXCEPTION)
            return
        }
        if (mWeChatResult == null || TextUtils.isEmpty(mWeChatUnionid)) {
            OldToastUtil.showerror(this@PersonalInfoActivity, OldToastUtil.TIMEOUT_EXCEPTION)
            return
        }
        if (!isBindThirdTaskRun) {
            isBindThirdTaskRun = true
            BindThirdAsyncTask().execute()
        }
    }


    internal inner class BindThirdAsyncTask : AsyncTask<Void, Void, BindThirdResult>() {

        override fun onPreExecute() {
            super.onPreExecute()

            showLoadingDialog()
        }

        override fun doInBackground(vararg params: Void): BindThirdResult {
            if (mCarLib == null)
                mCarLib = CarLib.getInstance(this@PersonalInfoActivity)
            val bte = BindThirdEntitiy()
            bte.uid = UserUtil(this@PersonalInfoActivity).uid
            bte.openid = mWeChatOpenId
            bte.unionid = mWeChatUnionid
            if (!TextUtils.isEmpty(mWeChatResult?.nickname)) {
                bte.nickname = mWeChatResult?.nickname
            }
            if (!TextUtils.isEmpty(mWeChatResult?.sex)) {
                if (mWeChatResult?.sex == "2") {
                    bte.gender = "女"
                } else {
                    bte.gender = "男"
                }
            } else {
                bte.gender = "男"
            }
            if (!TextUtils.isEmpty(mWeChatResult?.province)) {
                bte.province = mWeChatResult?.province
            }
            if (!TextUtils.isEmpty(mWeChatResult?.city)) {
                bte.city = mWeChatResult?.city
            }
            if (!TextUtils.isEmpty(mWeChatResult?.country)) {
                bte.country = mWeChatResult?.country
            }
            if (!TextUtils.isEmpty(mWeChatResult?.headimgurl)) {
                bte.headimgurl = mWeChatResult?.headimgurl
            }
            bte.type = CarEntity.ThirdLoginType.WEIXIN.typeName
            var btr = BindThirdResult()
            try {
                btr = mCarLib?.postRequest(Gson().toJson(bte), "user/thirdparty/binding",
                        BindThirdResult::class.java) as BindThirdResult
            } catch (e: Exception) {
                NetUtil.handlePostExceptionBaseResult(btr, e)
            }

            return btr
        }

        override fun onPostExecute(result: BindThirdResult) {
            super.onPostExecute(result)

            dismissLoadingDialog()
            isBindThirdTaskRun = false

            if (result.errCode == -1) {
                if (result.code == CarEntity.SUCC) {
                    setButtonText(bind_status_textview, true)
                } else {
                    OldToastUtil.show(this@PersonalInfoActivity, result.msg)
                }
            } else {
                OldToastUtil.showerror(this@PersonalInfoActivity, result.errCode)
            }
        }
    }


    private val sexArry = arrayOf("男", "女")// 性别选择
    /* 性别选择框 */
    private fun goGender() {
        var checkedItem = 0

        when (tv_sex.text.toString()) {
            "男" -> checkedItem = 0
            "女" -> checkedItem = 1
        }

        val builder = AlertDialog.Builder(this)// 自定义对话框
        builder.setSingleChoiceItems(sexArry, checkedItem) { dialog, which ->
            // which是被选中的位置
            tv_sex.text = sexArry[which]
            dialog.dismiss()// 随便点击一个item消失对话框，不用点击确认取消
            UserUpdataAsyncTask().execute()
        }
        builder.show()// 让弹出框显示
    }


//    昵称相关

    /**
     * 昵称
     */
    private fun goNickName() {
        // 获取焦点弹出键盘，并且文字置右
        tv_nickname.isFocusable = true
        tv_nickname.isFocusableInTouchMode = true
        tv_nickname.requestFocus()
        tv_nickname.findFocus()
        val inputManager = tv_nickname.context.getSystemService(Context.INPUT_METHOD_SERVICE) as InputMethodManager
        inputManager.showSoftInput(tv_nickname, 0)
    }


    override fun dispatchTouchEvent(ev: MotionEvent): Boolean {
        if (ev.action === MotionEvent.ACTION_DOWN) {
            val v = currentFocus
            if (isShouldHideInput(v, ev)) {
                val imm = getSystemService(Context.INPUT_METHOD_SERVICE) as InputMethodManager
                if (imm != null) {
                    imm!!.hideSoftInputFromWindow(v?.windowToken, 0)
                }
            }
            return super.dispatchTouchEvent(ev)
        }
        // 必不可少，否则所有的组件都不会有TouchEvent了
        return if (window.superDispatchTouchEvent(ev)) {
            true
        } else onTouchEvent(ev)
    }

    private fun isShouldHideInput(v: View?, event: MotionEvent): Boolean {
        if (v != null && v is EditText) {
            val leftTop = intArrayOf(0, 0)
            //获取输入框当前的location位置
            v.getLocationInWindow(leftTop)
            val left = leftTop[0]
            val top = leftTop[1]
            val bottom = top + v.height
            val right = left + v.width
            if (event.x > left && event.x < right
                    && event.y > top && event.y < bottom) {
                // 点击的是输入框区域，保留点击EditText的事件
                return false
            } else {
                //使EditText触发一次失去焦点事件
                v.isFocusable = false
                v.isFocusableInTouchMode = false
                return true
            }
        }
        return false
    }


    //权限管理
    /**
     * 自动获取sdk权限
     */

    private var imageUri: Uri? = null
    private var cropImageUri: Uri? = null
    private val fileUri = File(Environment.getExternalStorageDirectory().path + "/photo.jpg")
    private val fileCropUri = File(Environment.getExternalStorageDirectory().path + "/crop_photo.jpg")

    private val CODE_GALLERY_REQUEST = 0xa0
    private val CODE_CAMERA_REQUEST = 0xa1
    private val CODE_RESULT_REQUEST = 0xa2

    private val OUTPUT_X = 480
    private val OUTPUT_Y = 480
    private fun autoObtainStoragePermission() {

        disposable = mRxPermissions.request(Manifest.permission.READ_EXTERNAL_STORAGE).subscribe { granted ->
            if (granted) { // Always true pre-M
                // I can control the camera now
                PhotoUtils.openPic(this, CODE_GALLERY_REQUEST)
            } else {
                // Oups permission denied
            }
        }

    }


    private var disposable: Disposable? = null

    /** .compose(rxPermissions.ensureEach(permission.CAMERA))
     * 自动获取相机权限
     */
    private fun autoObtainCameraPermission() {

        imageUri = Uri.fromFile(fileUri)
        //通过FileProvider创建一个content类型的Uri
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.N) {
            imageUri = FileProvider.getUriForFile(this@PersonalInfoActivity, "$packageName.fileProvider", fileUri)
        }



        disposable = mRxPermissions.request(Manifest.permission.CAMERA, Manifest.permission.READ_EXTERNAL_STORAGE, Manifest.permission.WRITE_EXTERNAL_STORAGE).subscribe { granted ->
            if (granted) { // Always true pre-M
                // I can control the camera now
                if (imageUri != null)
                    PhotoUtils.takePicture(this, imageUri!!, CODE_CAMERA_REQUEST)
            } else {
                // Oups permission denied
                showToast("权限被拒绝")
            }
        }

    }

    /**
     * 检查设备是否存在SDCard的工具方法
     */
    fun hasSdcard(): Boolean {
        val state = Environment.getExternalStorageState()
        return state == Environment.MEDIA_MOUNTED
    }

    override fun onDestroy() {
        setResult(ConstantsUtil.USER_INFO_REFRESH)
        if (disposable != null && !disposable?.isDisposed!!) {
            disposable!!.dispose()
        }
        super.onDestroy()
    }
}
