package com.jiaoyinbrother.monkeyking.manager.activity

import android.content.Context
import android.content.Intent
import android.text.TextUtils
import android.view.View
import android.widget.ImageView
import com.bumptech.glide.Glide
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.util.MKUtil
import com.jiaoyinbrother.library.base.BaseActivity
import com.jiaoyinbrother.library.bean.ImageBean
import com.jiaoyinbrother.library.util.*
import kotlinx.android.synthetic.main.activity_show_big_image.*
import kotlinx.android.synthetic.main.main_title.*
import java.io.UnsupportedEncodingException
import java.net.URLEncoder

/**
 * Created by zhangbo on 2018/1/29.
 */
class ShowBigImageActivity : BaseActivity() {


    companion object {
        const val TO_SHOOT = 99
        const val IMG_URI = "IMG_URI"
        const val IMG_PATH_ENCODE = "IMG_PATH_ENCODE"

        fun newInstancePath(context: Context, url: String, isEdit: Boolean) {
            val intent = Intent(context, ShowBigImageActivity::class.java)
            intent.putExtra(IMG_PATH_ENCODE, url)
            intent.putExtra(ConstantsUtil.IMAGE_EDIT, isEdit)
            context.startActivity(intent)
        }

        fun newInstanceUri(context: Context, uri: String, isEdit: Boolean) {
            val intent = Intent(context, ShowBigImageActivity::class.java)
            intent.putExtra(IMG_URI, uri)
            intent.putExtra(ConstantsUtil.IMAGE_EDIT, isEdit)
            context.startActivity(intent)
        }


        fun newInstanceUri(context: Context, uri: String, entrance: String) {
            val intent = Intent(context, ShowBigImageActivity::class.java)
            intent.putExtra(IMG_URI, uri)
            intent.putExtra(ConstantsUtil.IMAGE_EDIT, false)
            intent.putExtra("entrance", entrance)
            context.startActivity(intent)
        }
    }

    private var toEdit = false

    override fun getLayoutId(): Int {
        return R.layout.activity_show_big_image
    }

    override fun initView() {
    }

    override fun initToolBar() {
        val entrance = intent.getStringExtra("entrance") ?: ""
        ivTitleName.text = if (TextUtils.isEmpty(entrance)) "查看照片" else entrance
    }

    override fun initListeners() {

        big_img_btn.setOnClickListener {
            //重拍功能未处理
            val intent = Intent()
            setResult(TO_SHOOT, intent)
            finish()
        }
        if (toEdit) {
            big_img_view.setOnClickListener {
                finish()
            }
        }

    }

    override fun initData() {
        toEdit = intent.getBooleanExtra(ConstantsUtil.IMAGE_EDIT, false)
        val imgUri = intent.getStringExtra(IMG_URI)
        val imgPath = intent.getStringExtra(IMG_PATH_ENCODE)

//        val title = intent.getStringExtra(ConstantsUtil.PAGE_TITLE)
//        if (!TextUtils.isEmpty(title)) {
//            ivTitleName.text = title
//        }

        big_img_btn.visibility = if (toEdit) View.VISIBLE else View.GONE
        big_img_view.setScaleType(ImageView.ScaleType.FIT_CENTER)
        when {
            imgPath != null -> {
                val requset = ImageBean()
                requset.path = imgPath
                requset.flag = "ZUCHE"
                val params = MKUtil.addBeanToJson(requset, this@ShowBigImageActivity)
                val token = UserUtil(this@ShowBigImageActivity).getToken()
                val hashMap = MD5Util.createCommitParams(params, token)
                try {
                    val tempParams = StringBuilder()
                    for ((pos, key) in hashMap.keys.withIndex()) {
                        if (pos > 0) {
                            tempParams.append("&")
                        }
                        tempParams.append(String.format("%s=%s", key, URLEncoder.encode(hashMap[key], "utf-8")))
                    }
                    val p = tempParams.toString()

                    val imageUrl = UrlUtil.getUrl() + UrlUtil.URL_FILE_READ + "?" + p
                    LogUtil.e("ImageUrl --->>>>> $imageUrl")
                    Glide.with(this).load(imageUrl).into(big_img_view)

                } catch (e: UnsupportedEncodingException) {
                    e.printStackTrace()
                }
            }
            imgUri != null -> {
                LogUtil.e("ImageUrl --->>>>> $imgUri")
                PhotoUtils.loadPicIntoImageViewNoCache(this@ShowBigImageActivity, imgUri, big_img_view)
            }
//            imgMipMap != null -> {
//                LogUtil.e("imgMipMap --->>>>> $imgUri")
//                Glide.with(this).load(imgMipMap).into(big_img_view)
//            }
        }


    }

}