package com.jiaoyinbrother.monkeyking.manager.activity

import android.content.Intent
import android.support.v4.content.ContextCompat
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.library.base.BaseActivity
import com.jiaoyinbrother.library.bean.OrderDetailResult
import com.jiaoyinbrother.library.util.ConstantsUtil
import com.jiaoyinbrother.library.widget.GeneralBottomButton
import kotlinx.android.synthetic.main.activity_smart_key_auth.*
import kotlinx.android.synthetic.main.layout_smart_key_status.*

class SmartKeyAuthActivity : BaseActivity() {

    private var mOrderInfo: OrderDetailResult? = null

    override fun getLayoutId(): Int {
        mOrderInfo = intent?.getSerializableExtra(ConstantsUtil.ORDER_RESULT) as OrderDetailResult?
        return R.layout.activity_smart_key_auth
    }

    override fun initView() {}

    override fun initToolBar() {
        mainTitle.text = "身份验证"
    }

    override fun initListeners() {
        goSubmit.setListener(object : GeneralBottomButton.SubmitListener {
            override fun submit() {
                //跳转人脸识别,然后跳转到拍摄图片
//                var intent = Intent(this@SmartKeyAuthActivity, FaceDetectorActivity::class.java)
//                intent.putExtra("orderId",mOrderInfo?.orderid)
//                startActivityForResult(intent,1000)
            }
        })
    }

    override fun initData() {
        goSubmit.setText("开始验证")
        setStatusInfo()
    }

    private fun setStatusInfo() {
        tvStatusOne.text = "身份验证"
        tvStatusTwo.text = "拍照反馈车况"
        ivStatusOne.setBackgroundResource(R.mipmap.h_1)
        ivStatusTwo.setBackgroundResource(R.mipmap.w_2)
        tvStatusOne.setTextColor(ContextCompat.getColor(this, R.color.color_6))
        tvStatusTwo.setTextColor(ContextCompat.getColor(this, R.color.color_3))
        statusLine.setBackgroundColor(ContextCompat.getColor(this, R.color.color_3))
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        if (requestCode == 1000 && resultCode == 1){
            val intent = Intent(this@SmartKeyAuthActivity, SmartKeyFeedBackActivity::class.java)
            intent.putExtra(ConstantsUtil.FLAG_SMART_KEY, SmartKeyFeedBackActivity.STATUS_TAKE)
            intent.putExtra(ConstantsUtil.ORDER_RESULT, mOrderInfo)
            startActivity(intent)
        }
    }
}