package com.jiaoyinbrother.monkeyking.manager.activity

import android.annotation.SuppressLint
import android.app.Activity
import android.content.Intent
import android.net.Uri
import android.os.Environment
import android.os.Handler
import android.provider.MediaStore
import android.support.v4.content.ContextCompat
import android.support.v7.widget.GridLayoutManager
import android.text.Editable
import android.text.TextUtils
import android.text.TextWatcher
import android.view.View
import com.jiaoyinbrother.monkeyking.manager.CarEntity
import com.jiaoyinbrother.monkeyking.manager.Constants
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.adapter.SelectImagesAdapter
import com.jiaoyinbrother.monkeyking.manager.util.H5Utils
import com.jiaoyinbrother.monkeyking.manager.view.IOSdialog.IOSAlertDialog
import com.jiaoyinbrother.library.base.BaseActivity
import com.jiaoyinbrother.library.bean.*
import com.jiaoyinbrother.library.impl.UploadListener
import com.jiaoyinbrother.library.presenter.CarImgPresenterImpl
import com.jiaoyinbrother.library.presenter.OrderPresenterImpl
import com.jiaoyinbrother.library.util.*
import com.jiaoyinbrother.library.view.IGeneralModel
import com.jiaoyinbrother.library.widget.GeneralBottomButton
import kotlinx.android.synthetic.main.activity_smart_key_feedback.*
import kotlinx.android.synthetic.main.layout_smart_key_feedback.*
import kotlinx.android.synthetic.main.layout_smart_key_status.*
import java.io.File
import java.util.HashMap
import kotlin.collections.ArrayList

@SuppressLint("SetTextI18n")
class SmartKeyFeedBackActivity : BaseActivity() {

    private var statusType: String? = null
    private var mOrderInfo: OrderDetailResult? = null
    private var mOrderID: String? = null
    // aliyun util
    private var mUploadUtil: AliYunPictureUtil? = null
    // 接口区分 取,还车
    private var postType: String? = null
    // 必传照片
    private var requiredAdapter: SelectImagesAdapter? = null
    private var requiredList: ArrayList<PicBean>? = null
    private var requiredImagesUri = ArrayList<String>()
    private var requiredImages = ArrayList<String>()
    private var imageUri0: Uri? = null
    private var imageUri1: Uri? = null
    private var imageUri2: Uri? = null
    private var imageUri3: Uri? = null
    // 可选照片
    private var optionalAdapter: SelectImagesAdapter? = null
    private var optionalList: ArrayList<PicBean>? = null
    private var optionalImagesUri = ArrayList<String>()
    private var optionalImages = ArrayList<String>()
    private var imageUri4: Uri? = null
    private var imageUri5: Uri? = null
    private var imageUri6: Uri? = null
    private var imageUri7: Uri? = null
    private var imageUri8: Uri? = null
    private var imageUri9: Uri? = null
    private var postImages = ArrayList<String>()

    override fun getLayoutId(): Int {
        statusType = intent?.getStringExtra(ConstantsUtil.FLAG_SMART_KEY).toString()
        mOrderInfo = intent?.getSerializableExtra(ConstantsUtil.ORDER_RESULT) as OrderDetailResult?
        return R.layout.activity_smart_key_feedback
    }

    override fun initView() {}

    override fun initToolBar() {
        mainTitle.text = "拍照反馈车况"
    }

    override fun initListeners() {
        // 提交拍照反馈内容
        goSubmit.setListener(object : GeneralBottomButton.SubmitListener {
            override fun submit() {
                LogUtil.e("submit ------>>>> success")
                uploadImages()
            }
        })
        // 拍照示例
        takenSample.setOnClickListener({
            H5Utils.onTakenSample(this)
        })
        // 必传照片
        requiredAdapter?.setOnItemClickListener({ _, position ->
            if (isDeactivate(statusType))
                return@setOnItemClickListener
            when (requiredList?.get(position)?.status) {
                PicBean.PIC_DEF -> onCamera(position)
                PicBean.PIC_SUCC -> showBigImages(position, SelectImagesAdapter.TYPE_NORMAL)
            }
        })
        // 可选照片
        optionalAdapter?.setOnItemClickListener({ _, position ->
            if (isDeactivate(statusType))
                return@setOnItemClickListener
            when (optionalList?.get(position)?.status) {
                PicBean.PIC_DEF -> onCamera(position + OPTIONAL_INDEX)
                PicBean.PIC_SUCC -> showBigImages(position + OPTIONAL_INDEX, SelectImagesAdapter.TYPE_OPTIONAL)
            }
        })
        etFeedback.addTextChangedListener(object : TextWatcher {

            override fun afterTextChanged(s: Editable?) {
                val length = (s?.length) ?: 0
                supplementCount.text = "还可输入${(200 - length)}个字"
            }

            override fun beforeTextChanged(s: CharSequence?, start: Int, count: Int, after: Int) {}

            override fun onTextChanged(s: CharSequence?, start: Int, before: Int, count: Int) {
                val editable = etFeedback.text.toString()
                val str = TextUtil.StringFilter(editable)
                if (editable != str) {
                    etFeedback.setText(str)
                    etFeedback.setSelection(str.length) // 光标置后
                }
            }
        })
    }

    @Suppress("DEPRECATION")
    override fun initData() {
        mOrderID = mOrderInfo?.orderid
        mUploadUtil = AliYunPictureUtil.getInstance(this)
        setStatusInfo()
        // 拍照示例
        val drawable = resources.getDrawable(R.mipmap.ic_b_q)
        drawable.setBounds(0, 0, drawable.minimumWidth / 5 * 2, drawable.minimumHeight / 5 * 2)
        takenSample.setCompoundDrawables(null, null, drawable, null)
        // 底部按钮初始化
        goSubmit.disable()
        goSubmit.setText("提交")
        // 初始化
        postType = if (statusType == STATUS_TAKE) POST_TAKE else POST_RETURN
        // 必传照片
        requiredAdapter = SelectImagesAdapter(this, SelectImagesAdapter.TYPE_NORMAL)
        requiredAdapter?.list = defaultRequiredList(mOrderInfo)
        val mManager = GridLayoutManager(this, 2)
        mainRv.layoutManager = mManager
        mainRv.isNestedScrollingEnabled = false
        mainRv.adapter = requiredAdapter
        // 可选照片
        optionalAdapter = SelectImagesAdapter(this, SelectImagesAdapter.TYPE_OPTIONAL)
        optionalAdapter?.list = defaultOptionalList(mOrderInfo)
        val mManager2 = GridLayoutManager(this, 2)
        subRv.layoutManager = mManager2
        subRv.isNestedScrollingEnabled = false
        subRv.adapter = optionalAdapter
    }

    /** status layout info */
    private fun setStatusInfo() {
        tvStatusOne.text = if (statusType == STATUS_TAKE) "验证成功" else "支付违章押金"
        tvStatusTwo.text = "拍照反馈车况"
        ivStatusOne.setBackgroundResource(R.mipmap.h_f)
        ivStatusTwo.setBackgroundResource(R.mipmap.h_2)
        tvStatusOne.setTextColor(ContextCompat.getColor(this, R.color.color_6))
        tvStatusTwo.setTextColor(ContextCompat.getColor(this, R.color.color_6))
        statusLine.setBackgroundColor(ContextCompat.getColor(this, R.color.color_6))

        hideViews(mOrderInfo)
    }

    /** 根据订单状态显示隐藏控件 */
    private fun hideViews(result: OrderDetailResult?) {
        if (result == null) return

        if (result.take_car_image == null || result.return_car_image == null) {
            // default
            mainItem.text = "固定角度拍摄 0/4"
            subItem.text = "车辆带伤部位特写 0/6"
            supplement.text = TextUtil.setForegroundColorAndSize("补充描述(可选)", 4, 8,
                    ContextCompat.getColor(this, R.color.color_3), 4, 8, 0.8f)
        } else {
            goSubmit.visibility = View.GONE
            if (statusType == STATUS_TAKE) {
                statusLayout.visibility = View.GONE
                mainItem.text = "固定角度拍摄"// 完成页面 ↓
                subItem.text = "车辆带伤部位特写"
                supplement.text = "补充描述"
                takenSample.visibility = View.GONE
                mainPrompt.visibility = View.GONE
                subPrompt.visibility = View.GONE
                supplementLayout.background = null
                etFeedback.isEnabled = false
                supplementCount.visibility = View.GONE
                if (result.take_damage_image == null) {
                    subItemLayout.visibility = View.GONE
                    commentLayout.visibility = View.GONE
                } else {
                    subItemLayout.visibility = View.VISIBLE
                    commentLayout.visibility = View.VISIBLE
                }
            } else {
                if (result.return_car_image?.status_code == 2) {
                    // 还车认证中 0:认证失败;1:认证通过;2:认证中
                    mainItem.text = "固定角度拍摄 ${result.return_car_image?.pics?.size}/4"
                    subItem.text = "车辆带伤部位特写 ${result.return_damage_image?.pics?.size}/6"
                    supplement.text = "补充描述(可选)"
                    auditTime.visibility = View.VISIBLE
                } else {
                    statusLayout.visibility = View.GONE
                    mainItem.text = "固定角度拍摄"
                    subItem.text = "车辆带伤部位特写"
                    supplement.text = "补充描述"
                    takenSample.visibility = View.GONE
                    mainPrompt.visibility = View.GONE
                    subPrompt.visibility = View.GONE
                    if (result.return_damage_image == null) {
                        subItemLayout.visibility = View.GONE
                        commentLayout.visibility = View.GONE
                    } else {
                        subItemLayout.visibility = View.VISIBLE
                        commentLayout.visibility = View.VISIBLE
                    }
                }
            }
        }
    }

    /** 必传照片初始化 */
    private fun defaultRequiredList(result: OrderDetailResult?): ArrayList<PicBean> {
        val auth = if (statusType == STATUS_TAKE) result?.take_car_image else result?.return_car_image
        requiredList = ArrayList()
        if (auth == null || auth.status_code == 0) {
            for (i in 0..3) {// init no data
                requiredList?.add(PicBean(null, PicBean.PIC_DEF))
            }
        } else {
            for (imgUrl in auth.pics ?: ArrayList()) {
                requiredList?.add(PicBean(imgUrl, PicBean.PIC_SUCC))
            }
        }
        return requiredList ?: ArrayList()
    }

    /** 可选照片初始化 */
    private fun defaultOptionalList(result: OrderDetailResult?): ArrayList<PicBean> {
        val damage = if (statusType == STATUS_TAKE) result?.take_damage_image else result?.return_damage_image
        val auth = result?.return_car_image
        optionalList = ArrayList()
        if (damage == null || damage.pics?.size == 0 || auth?.status_code == 2) {
            optionalList?.add(PicBean())
        } else {
            for (imgUrl in damage.pics ?: ArrayList()) {
                optionalList?.add(PicBean(imgUrl, PicBean.PIC_SUCC))
            }
        }
        return optionalList ?: ArrayList()
    }

    /** item 是否可以点击 */
    private fun isDeactivate(status: String?): Boolean {
        return when (status) {
            STATUS_TAKE -> mOrderInfo?.take_car_image != null
            else -> mOrderInfo?.return_car_image != null && mOrderInfo?.return_car_image?.status_code != 0
        }
    }

    /**  拉起相机 */
    private fun onCamera(position: Int) {
        if (Environment.getExternalStorageState() == Environment.MEDIA_MOUNTED) {
            val file = File(path)
            if (!file.exists())
                file.mkdir()
            val intent = Intent(MediaStore.ACTION_IMAGE_CAPTURE)
            intent.putExtra(MediaStore.EXTRA_OUTPUT, setImageUri(position))
            startActivityForResult(intent, position)
        }
    }

    private fun setImageUri(position: Int): Uri? {
        val filePath = "${path}_TAKING_PIC_IMG_$position.jpg"
        val file = File(filePath)
        val uri = Uri.fromFile(file)
        when (position) {
            0 -> imageUri0 = uri
            1 -> imageUri1 = uri
            2 -> imageUri2 = uri
            3 -> imageUri3 = uri
            4 -> imageUri4 = uri
            5 -> imageUri5 = uri
            6 -> imageUri6 = uri
            7 -> imageUri7 = uri
            8 -> imageUri8 = uri
            9 -> imageUri9 = uri
        }
        return uri
    }

    private fun getImageUriPath(position: Int): String? {
        return when (position) {
            0 -> imageUri0?.path
            1 -> imageUri1?.path
            2 -> imageUri2?.path
            3 -> imageUri3?.path
            4 -> imageUri4?.path
            5 -> imageUri5?.path
            6 -> imageUri6?.path
            7 -> imageUri7?.path
            8 -> imageUri8?.path
            else -> imageUri9?.path
        }
    }

    /**  查看大图 */
    private fun showBigImages(position: Int, type: Int) {
        val intent = Intent(this, ShowBigImageActivity::class.java)
        if (type == SelectImagesAdapter.TYPE_NORMAL)
            intent.putExtra(ShowBigImageActivity.IMG_URI, requiredList?.get(position)?.imgUri)
        else
            intent.putExtra(ShowBigImageActivity.IMG_URI, optionalList?.get(position - OPTIONAL_INDEX)?.imgUri)
        startActivityForResult(intent, position)
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        if (data == null) {
            if (resultCode == Activity.RESULT_OK) setImageInfo(requestCode)
        } else {
            if (resultCode == ShowBigImageActivity.TO_SHOOT) onCamera(requestCode)
        }
    }

    /** 拍照后返回bitmap设置图片 */
    private fun setImageInfo(position: Int) {
        var bitmap = BitmapUtil.compressDefaultBitmap(getImageUriPath(position))
        val degree = BitmapUtil.getBitmapDegree(getImageUriPath(position))
        bitmap = BitmapUtil.rotateBitmapByDegree(bitmap, degree)
        BitmapUtil.saveImage( getImageUriPath(position),bitmap)
        notifyAdapter(getImageUriPath(position).toString(), PicBean.PIC_SUCC, position)
    }

    private fun notifyAdapter(imgUri: String, status: Int, position: Int) {
        if (position < 4) {
            setRequiredData(imgUri, status, position)
        } else {
            setOptionalData(imgUri, status, (position - OPTIONAL_INDEX))
        }
    }

    private fun setRequiredData(imgUri: String, status: Int, position: Int) {
        if (imgUri.isNotEmpty()) requiredList?.get(position)?.imgUri = imgUri
        requiredList?.get(position)?.status = status
        requiredAdapter?.notifyItemChanged(position)
        requiredImagesUri.clear()
        for (entity: PicBean in requiredList ?: ArrayList()) {
            if (!TextUtils.isEmpty(entity.imgUri)) requiredImagesUri.add(entity.imgUri.toString())
        }
        mainItem.text = "固定角度拍摄 ${requiredImagesUri.size}/4"
        if (requiredImagesUri.size == 4) {
            goSubmit.normal()
        }
    }

    private fun setOptionalData(imgUri: String, status: Int, position: Int) {
        if (imgUri.isNotEmpty()) optionalList?.get(position)?.imgUri = imgUri
        optionalList?.get(position)?.status = status
        optionalImagesUri.clear()
        for (entity: PicBean in optionalList ?: ArrayList()) {
            if (!TextUtils.isEmpty(entity.imgUri)) optionalImagesUri.add(entity.imgUri.toString())
        }
        if (optionalList?.size ?: 0 < 6 && !TextUtils.isEmpty(optionalList?.get(position)?.imgUri))
            optionalList?.add(PicBean())
        optionalAdapter?.list = optionalList
        subRv.adapter = optionalAdapter//?.notifyItemChanged(position)
        subItem.text = "车辆带伤部位特写 ${optionalImagesUri.size}/6"
    }

    /** 上传照片至阿里云 */
    private fun uploadImages() {
        postImages.clear()
        postImages.addAll(requiredImagesUri)
        postImages.addAll(optionalImagesUri)
        showLoadingDialog()
        mUploadUtil?.setDatas(AliYunPictureUtil.BUCKET_TYPE_PUBLIC,postImages, AliYunPictureUtil.SMART_KEY, uploadListener)
    }

    private val uploadListener = object : UploadListener {
        override fun onUploadComplete(success: HashMap<Int, String>, failure: HashMap<Int, String>) {
            dismissLoadingDialog()
            if (success.size > 0) {
                var i = 0
                val count = success.size
                while (i < count) {
                    if (i < 4) {
                        requiredImages.add(success[i].toString())
                    } else {
                        optionalImages.add(success[i].toString())
                    }
                    i++
                }
                postApply()
            } else {
                upLoadFailed()
            }
        }

        override fun onUploadComplete(net: String?, local: String?) {}
    }

    private fun upLoadFailed() {
        IOSAlertDialog(this).builder().setCancelable(false).setTitle("提交失败").setMsg("照片提交失败，是否重试？", true)
                .setLeftButton("取消") { }.setRightButton("重试") { uploadImages() }.show()
    }

    /** 提交 */
    private fun postApply() {
        showLoadingDialog()
        val presenter = CarImgPresenterImpl(this, TakingPicResult::class.java, postApplyModel)
//        presenter.addListener(postApplyModel)
        val request = TakingPicRequest()
        request.order_id = mOrderID
        request.type = postType
        request.pics = requiredImages
        request.other_types = setOtherTypes()
        presenter.applyCarImg(request)
    }

    private fun setOtherTypes(): List<ImagesOtherTypeBean>? {
        val entity = ImagesOtherTypeBean()
        entity.type = postType
        entity.pics = optionalImages
        entity.desc = etFeedback.text.toString()
        val data = ArrayList<ImagesOtherTypeBean>()
        data.add(entity)
        return data
    }

    private val postApplyModel = object : IGeneralModel {
        override fun getCodeBeanFail(errorCode: Int) {
            dismissLoadingDialog()
            applyFailed()
        }

        override fun getCodeObjectSuccess(bean: Any?) {
            dismissLoadingDialog()
            val result = bean as TakingPicResult
            when (result.code) {
                CarEntity.SUCC -> {
                    when (statusType) {
                        STATUS_TAKE -> {
                            showToast("提交成功！")
                            val intent = Intent(this@SmartKeyFeedBackActivity, RemoteCarActivity::class.java)
                            intent.putExtra(Constants.KEY_TAKING_PIC, statusType)
                            intent.flags = Intent.FLAG_ACTIVITY_CLEAR_TOP
                            intent.addFlags(Intent.FLAG_ACTIVITY_SINGLE_TOP)
                            startActivity(intent)
                            finish()
                        }
                        else -> {
                            IOSAlertDialog(this@SmartKeyFeedBackActivity).builder().setCancelable(false).setTitle("提交成功！")
                                    .setMsg(result.tips, true).setRightButton("我知道了") { onPolling() }.show()
                        }
                    }
                }
                else -> applyFailed()
            }
        }
    }

    private fun applyFailed() {
        IOSAlertDialog(this).builder().setCancelable(false).setTitle("提交失败").setMsg("照片提交失败，是否重试？", true)
                .setLeftButton("取消") { }.setRightButton("重试") { postApply() }.show()
    }

    var isPollRunning = false
    internal val handler = Handler()
    /** 轮询 */
    private fun onPolling() {
        if (isPollRunning)
            return
        isPollRunning = true
        handler.post(runnable)
    }

    internal var runnable: Runnable = object : Runnable {
        override fun run() {
            if (!isPollRunning)
                return
            handler.postDelayed(this, POLL_TIME.toLong())// 30秒
            orderDetail()
        }
    }

    private fun orderDetail() {
        val presenter = OrderPresenterImpl(this, OrderDetailResult::class.java, orderInfoModel)
//        presenter.addListener(orderInfoModel)
        val request = OrderDetailRequest()
        request.orderid = mOrderID
        request.uid = UserUtil(this@SmartKeyFeedBackActivity).uid
        presenter.getOrderDetail(request)
    }

    private val orderInfoModel = object : IGeneralModel {
        override fun getCodeBeanFail(errorCode: Int) {}

        override fun getCodeObjectSuccess(bean: Any?) {
            val result = bean as OrderDetailResult
            if (result.code == CarEntity.SUCC) {
                mOrderInfo = result
                if (statusType == STATUS_RETURN) {
                    if (result.return_car_image != null && result.return_car_image?.status_code != 2) {
                        isPollRunning = false
                        onAuditResult(result)
                    } else {
                        val sp = "预计审核时间:${result.return_car_image?.approve_time}"
                        auditTime.text = TextUtil.setForegroundColor(sp, ContextCompat.getColor(this@SmartKeyFeedBackActivity, R.color.color_6), 6, sp.length)
                        if (auditTime.visibility == View.GONE) auditTime.visibility = View.VISIBLE
                        hideViews(result)
                    }
                } else {
                    isPollRunning = false
                }
            }
        }
    }

    private fun onAuditResult(result: OrderDetailResult) {
        val intent = Intent(this@SmartKeyFeedBackActivity, AuditResultActivity::class.java)
        intent.putExtra(ConstantsUtil.ORDER_RESULT, result)
        startActivity(intent)
        finish()
    }

    override fun onBackPressed() {
        isPollRunning = false
        if (Util.isEmptyList(optionalImagesUri) || Util.isEmptyList(requiredImagesUri)) {
            super.onBackPressed()
        } else {
            IOSAlertDialog(this@SmartKeyFeedBackActivity).builder().setCancelable(false).setTitle("温馨提示")
                    .setMsg("尚未完成拍照操作，是否退出？", true).setLeftButton("取消") { }
                    .setRightButton("确认") { super.onBackPressed() }.show()
        }
//            if (orderResult?.return_car_image == null) {
//            } else {
//                val intent = Intent(this@TakingPicturesActivity, OrderDetailActivity::class.java)
//                intent.putExtra(ConstantsUtil.ORDER_ID, orderResult?.orderid)
//                startActivity(intent)
//                super.onBackPressed()
//            }
    }


    companion object {
        const val STATUS_TAKE = "STATUS_TAKE"
        const val STATUS_RETURN = "STATUS_RETURN"
        // post params
        const val POST_TAKE = "TAKE_CAR"
        const val POST_RETURN = "RETURN_CAR"
        const val POLL_TIME = 30000// 30秒
        const val OPTIONAL_INDEX = 4
        private val path = Environment.getExternalStorageDirectory().toString() + File.separator + Environment.DIRECTORY_DCIM + File.separator
    }

}