package com.jiaoyinbrother.monkeyking.manager.adapter

import android.content.Context
import android.view.WindowManager
import android.widget.ImageView
import android.widget.LinearLayout
import com.bumptech.glide.Glide
import com.bumptech.glide.load.resource.bitmap.CenterCrop
import com.bumptech.glide.load.resource.bitmap.RoundedCorners
import com.bumptech.glide.request.RequestOptions
import com.camnter.easyrecyclerview.adapter.EasyRecyclerViewAdapter
import com.camnter.easyrecyclerview.holder.EasyRecyclerViewHolder
import com.jiaoyinbrother.library.util.DensityUtil
import com.jiaoyinbrother.library.util.LogUtil
import com.jiaoyinbrother.library.util.Util
import com.jiaoyinbrother.monkeyking.manager.R

class CheckCarImageAdapter(val context: Context) : EasyRecyclerViewAdapter() {


    private var width: Int = 0
    private var margin: Int = 0

    override fun getRecycleViewItemType(position: Int): Int {
        return 0
    }

    override fun onBindRecycleViewHolder(viewHolder: EasyRecyclerViewHolder?, position: Int) {
//        val url = list[position] as String

        LogUtil.e("check image adapter ******************************************")
        val image = viewHolder?.findViewById<ImageView>(R.id.image)
        val params = LinearLayout.LayoutParams(width, width)
        params.setMargins(margin, margin, margin, margin)
        image?.layoutParams = params


        if (image != null) {

            val options = RequestOptions().transforms(CenterCrop(), RoundedCorners(Util.dip2px(context, 5f)))
            Glide.with(context).load(list.get(position)).apply(options).into(image)

        }

    }

    override fun getItemLayouts(): IntArray {
        return intArrayOf(R.layout.item_check_car_image)
    }


    init {
        val wm = context.getSystemService(Context.WINDOW_SERVICE) as WindowManager
        width = (wm.defaultDisplay.width - DensityUtil.dip2px(context, 54f)) / 3
        margin = DensityUtil.dip2px(context, 4f)
    }
}