package com.jiaoyinbrother.monkeyking.manager.adapter

import android.content.Context
import android.view.View
import android.widget.ImageView
import android.widget.TextView
import com.bumptech.glide.Glide
import com.bumptech.glide.load.resource.bitmap.CircleCrop
import com.bumptech.glide.request.RequestOptions
import com.camnter.easyrecyclerview.adapter.EasyRecyclerViewAdapter
import com.camnter.easyrecyclerview.holder.EasyRecyclerViewHolder
import com.hyphenate.chat.EMConversation
import com.hyphenate.easeui.utils.EaseCommonUtils
import com.hyphenate.easeui.utils.EaseSmileUtils
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.util.EMUtil
import com.jiaoyinbrother.library.bean.ImInfoBean
import java.util.*

class ConversationAdapter(private val context: Context): EasyRecyclerViewAdapter() {

    var mConversationsMap : Map<String, EMConversation>? = null


    override fun getRecycleViewItemType(position: Int): Int {
        return 0
    }

    override fun getItemLayouts(): IntArray {
        return intArrayOf(R.layout.conversation_item)
    }
    override fun onBindRecycleViewHolder(viewHolder: EasyRecyclerViewHolder?, position: Int) {
        val img_iv = viewHolder?.findViewById<ImageView>(R.id.img_iv)
        val name_tv = viewHolder?.findViewById<TextView>(R.id.name_tv)
        val time_tv = viewHolder?.findViewById<TextView>(R.id.time_tv)
        val msg_tv = viewHolder?.findViewById<TextView>(R.id.msg_tv)
        val flag_iv = viewHolder?.findViewById<ImageView>(R.id.flag_iv)

        val list = list as List<ImInfoBean>?
        val infoBean = list?.get(position)
        Glide.with(context).load(infoBean?.im_headimg_url).apply(RequestOptions.bitmapTransform(CircleCrop())).into(img_iv!!)
        name_tv?.text = infoBean?.im_nickname
        if(mConversationsMap?.containsKey(infoBean?.im_username)?:false){
            val emConversation = mConversationsMap?.get(infoBean?.im_username)
            flag_iv?.visibility = if(emConversation?.unreadMsgCount?:0 > 0) View.VISIBLE else View.GONE
//            time_tv?.text = DateUtils.getTimestampString(Date(emConversation?.lastMessage?.msgTime?:0))
            time_tv?.text = EMUtil.instance.getIMDateString(Date(emConversation?.lastMessage?.msgTime?:0))
            msg_tv?.setText(EaseSmileUtils.getSmiledText(context, EaseCommonUtils.getMessageDigest(emConversation?.lastMessage, context)),
                TextView.BufferType.SPANNABLE)
        }

    }

}