package com.jiaoyinbrother.monkeyking.manager.adapter

import android.content.Context
import android.text.TextUtils
import android.view.View
import android.widget.ImageView
import android.widget.TextView
import com.camnter.easyrecyclerview.adapter.EasyRecyclerViewAdapter
import com.camnter.easyrecyclerview.holder.EasyRecyclerViewHolder
import com.jiaoyinbrother.library.bean.BillContentBean
import com.jiaoyinbrother.library.util.MoneyUtil
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.view.IOSdialog.IOSAlertDialog

class CostAdapter() : EasyRecyclerViewAdapter() {

    private var mOnUrlListener: OnUrlListener? = null

    override fun getRecycleViewItemType(position: Int): Int {
        return 0
    }

    override fun getItemLayouts(): IntArray {
        return intArrayOf(R.layout.cost_item)
    }

    override fun onBindRecycleViewHolder(viewHolder: EasyRecyclerViewHolder?, position: Int) {
        val cost_name_tv = viewHolder?.findViewById<TextView>(R.id.cost_name_tv)
        val cost_price_tv = viewHolder?.findViewById<TextView>(R.id.cost_price_tv)
        val cost_desc_tv = viewHolder?.findViewById<TextView>(R.id.cost_desc_tv)
        val wk_undertake_tv = viewHolder?.findViewById<TextView>(R.id.wk_undertake_tv)
        val cost_question_iv = viewHolder?.findViewById<ImageView>(R.id.cost_question_iv)

        val list = list as List<BillContentBean>?
        val billContentBean = list?.get(position)

        cost_name_tv?.text = billContentBean?.title
        cost_price_tv?.text = billContentBean?.content
        cost_desc_tv?.visibility = if (TextUtils.isEmpty(billContentBean?.description)) View.GONE else View.VISIBLE
        cost_desc_tv?.text = "(" + billContentBean?.description + ")"

        billContentBean?.wk_undertake?.let {
            wk_undertake_tv?.visibility = if (it > 0) View.VISIBLE else View.GONE
            wk_undertake_tv?.text = "平台承担 ${MoneyUtil().getMoneyText(it.toString())}"
        }

        when (billContentBean?.title) {
            "手续费" -> {

                cost_question_iv?.visibility = View.VISIBLE
            }
            "基本保障服务费" -> {

                cost_question_iv?.visibility = View.VISIBLE
            }
            else -> {

                cost_question_iv?.visibility = View.GONE
            }
        }

        cost_question_iv?.setOnClickListener {

            when (billContentBean?.title) {
                "手续费" -> {

                    IOSAlertDialog(viewHolder.itemView.context).builder()
                            .setTitle("手续费")
                            .setMsg("门店收取的用于车辆清洁、车辆保养、单据制作、人员服务等。",false)
                            .setRightButton("知道了"){}
                            .show()

                }
                "基本保障服务费" -> {

                    IOSAlertDialog(viewHolder.itemView.context).builder()
                            .setTitle("基本保障服务费")
                            .setMsg("指租车公司向您提供的车辆均购买有交强险及商业保险，保障您用车安全的一种服务。",false)
                            .setRightButton("知道了"){}
                            .show()
                }
            }
        }

    }

    inner class MyListener : View.OnClickListener {
        private var mBillContentBean: BillContentBean? = null

        constructor(billContentBean: BillContentBean?) {
            this.mBillContentBean = billContentBean
        }

        override fun onClick(p0: View?) {
            mOnUrlListener?.onUrl(mBillContentBean)
        }

    }

    fun setOnUrlListener(onUrlListener: OnUrlListener?) {
        this.mOnUrlListener = onUrlListener
    }

    interface OnUrlListener {
        fun onUrl(billContentBean: BillContentBean?)
    }

}