package com.jiaoyinbrother.monkeyking.manager.adapter

import android.support.constraint.ConstraintLayout
import android.support.v4.content.ContextCompat
import android.widget.TextView
import com.camnter.easyrecyclerview.adapter.EasyRecyclerViewAdapter
import com.camnter.easyrecyclerview.holder.EasyRecyclerViewHolder
import com.jiaoyinbrother.library.bean.OperatingDataBean
import com.jiaoyinbrother.monkeyking.manager.R

class OperatingDataAdapter : EasyRecyclerViewAdapter() {

    companion object {
        const val ITEM_HEAD = 0
        const val ITEM_CONTENT = 1
    }


    override fun getRecycleViewItemType(position: Int): Int {
        return if (position == 0)
            ITEM_HEAD
        else {
            ITEM_CONTENT
        }
    }

    override fun onBindRecycleViewHolder(viewHolder: EasyRecyclerViewHolder?, position: Int) {
        val type = getRecycleViewItemType(position)
        if (type == ITEM_HEAD) {
            // 啥也用做。
        } else {
            viewHolder?.let {
                setOperatingData(it, position)
            }
        }
    }

    override fun getItemLayouts(): IntArray {
        return intArrayOf(R.layout.item_operating_data_title, R.layout.item_operating_data_content)
    }


    private fun setOperatingData(holder: EasyRecyclerViewHolder, position: Int) {
        val entity = list[position] as? OperatingDataBean

        val mLayout = holder.findViewById<ConstraintLayout>(R.id.item_operating_data)
        val mOperatingTimeTv = holder.findViewById<TextView>(R.id.item_operating_data_time)
        val mOperatingTypeTv = holder.findViewById<TextView>(R.id.item_operating_data_type)
        val mOperatorTv = holder.findViewById<TextView>(R.id.item_operating_data_operator)

        entity?.let {

            mLayout?.setBackgroundColor(
                if (position % 2 == 0)
                    ContextCompat.getColor(holder.itemView.context, R.color.color_0)
                else
                    ContextCompat.getColor(holder.itemView.context, R.color.color_f5f5f5)
            )

            mOperatingTimeTv?.text = it.createdstamp

            mOperatingTypeTv?.text = it.type_name

            mOperatorTv?.text = it.createduser

        }
    }
}