package com.jiaoyinbrother.monkeyking.manager.adapter

import android.content.Context
import android.support.v4.app.FragmentActivity
import android.support.v4.content.ContextCompat
import android.text.TextUtils
import android.view.View
import android.widget.*
import com.camnter.easyrecyclerview.adapter.EasyRecyclerViewAdapter
import com.camnter.easyrecyclerview.holder.EasyRecyclerViewHolder
import com.jiaoyinbrother.library.bean.OrderCancelWorkListRequest
import com.jiaoyinbrother.library.bean.OrderCancelWorkListRowBean
import com.jiaoyinbrother.library.bean.OrderReletApplyListRowsBean
import com.jiaoyinbrother.library.util.LogUtil
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.util.DialogUtil
import java.lang.StringBuilder
import java.text.SimpleDateFormat

class OrderCancelWorkFlowListAdapter(val context: Context): EasyRecyclerViewAdapter(){
    private var mBottomButtonListener:BottomButtonListener? = null
//    var mOnPhoneListener: ((OrderCancelWorkListRowBean?) -> Unit)? = null

    override fun getItemLayouts(): IntArray {
        return intArrayOf(R.layout.item_order_cancel_work_flow_list)
    }

    override fun getRecycleViewItemType(position: Int): Int {
        return 0
    }

    fun setOnBottomClickListener(bottomButtonListener:BottomButtonListener){
        LogUtil.e("WorkflowListAdapter setOnBottomClickListener  bottomButtonListener = $bottomButtonListener")
        mBottomButtonListener = bottomButtonListener
    }

    override fun onBindRecycleViewHolder(viewHolder: EasyRecyclerViewHolder?, position: Int) {
        val order = list[position] as OrderCancelWorkListRowBean
        LogUtil.e("WorkflowListAdapter onBindRecycleViewHolder  1111111***********, order = $order")

        // 订单号
        val orderNo = viewHolder?.findViewById<TextView>(R.id.orderNo)
        orderNo?.text = "订单号：${order.getOrderShowID()}"
        // 订单渠道 (车管端)
        val orderChannel = viewHolder?.findViewById<TextView>(R.id.orderChannel)
//        orderChannel?.text = if (TextUtils.isEmpty(order.channel_name)) "" else " (${order.channel_name})"
        orderChannel?.text = if (TextUtils.isEmpty(order.channel_name)) "" else " ${order.channel_name}"

        // 订单状态
        val orderStatus = viewHolder?.findViewById<TextView>(R.id.orderStatus)
        orderStatus?.text = order.order_status_name
        val layoutOrderInfo = viewHolder?.findViewById<LinearLayout>(R.id.layoutOrderInfo)


        redTagInfo(layoutOrderInfo, orderNo, orderChannel, orderStatus, order)
        LogUtil.e("orderid-->" + order.order_id + "--state-->" + order.order_status)

        LogUtil.e("WorkflowListAdapter onBindRecycleViewHolder  222222***********")

        // 车辆类别
        val carType = viewHolder?.findViewById<TextView>(R.id.carType)
        carType?.text = order.car_type
        // 车辆牌号ß
        val carNumber = viewHolder?.findViewById<TextView>(R.id.carNumber)
        if (order.car_number != null && order.car_number!!.isNotEmpty() && order.car_number != "未知") {
            carNumber?.text = order.car_number
        } else {
            carNumber?.text = "    未排车    "
        }

        LogUtil.e("WorkflowListAdapter onBindRecycleViewHolder  33333***********")

        //用户信息
        val mUserName = viewHolder?.findViewById<TextView>(R.id.item_order_user_name)
        val userPhone = viewHolder?.findViewById<TextView>(R.id.item_order_user_phone)

        if(order.member!=null)
            mUserName?.text = getUserName(order.member!!)

        userPhone?.text = order.member_phone
        userPhone?.setOnClickListener {
            onUserPhone(order.member_phone ?: "")
//            mOnPhoneListener?.invoke(order)
        }

        LogUtil.e("WorkflowListAdapter onBindRecycleViewHolder  44444***********")


        // 原租期--- 取车时间
        val original_rent_date_from = viewHolder?.findViewById<TextView>(R.id.original_rent_date_from)
        original_rent_date_from?.text = order.start_time
        // 还车时间
        val original_rent_date_to = viewHolder?.findViewById<TextView>(R.id.original_rent_date_to)
        original_rent_date_to?.text = order.end_time

        // 工单提交时间
        val workflow_submit_time = viewHolder?.findViewById<TextView>(R.id.workflow_submit_time)
        workflow_submit_time?.text = order.created_stamp
        //产生费用
        val order_relet_fee = viewHolder?.findViewById<TextView>(R.id.order_relet_fee)
//        order_relet_fee?.text = order.penalty_amount.toString()
        order_relet_fee?.text = "¥" + order.penalty_amount.toString()

        LogUtil.e("WorkflowListAdapter onBindRecycleViewHolder  55555***********")

        val order_cancel_reason_content = viewHolder?.findViewById<TextView>(R.id.order_cancel_reason_content)
        order_cancel_reason_content?.text = order.cancel_reason

        //底部按钮
        val orderBottom = viewHolder?.findViewById<RelativeLayout>(R.id.item_order_bottom)
        val work_flow_status_imageview = viewHolder?.findViewById<ImageView>(R.id.work_flow_status_imageview)

        orderBottom?.visibility = View.GONE
        LogUtil.e("WorkflowListAdapter order.apply_status = $order.apply_status ")

        when(order.workcard_status){
            OrderCancelWorkListRequest.STATUS_PENDING ->{
                orderBottom?.visibility = View.VISIBLE
                LogUtil.e("WorkflowListAdapter WORK_LIST_APPLY_STATUS_AUDITING ")
                val button_orders_item_bottom_right = viewHolder?.findViewById<Button>(R.id.button_orders_item_bottom_right)
                button_orders_item_bottom_right?.setOnClickListener {
                    LogUtil.e("WorkflowListAdapter button_orders_item_bottom_right?.setOnClickListener ")
                    mBottomButtonListener?.onChargeClicked(order)
                }
                val button_orders_item_bottom_left = viewHolder?.findViewById<Button>(R.id.button_orders_item_bottom_left)
                button_orders_item_bottom_left?.setOnClickListener {
                    LogUtil.e("WorkflowListAdapter button_orders_item_bottom_left?.setOnClickListener ")
                    mBottomButtonListener?.onFreeClicked(order)
                }

            }
            OrderCancelWorkListRequest.STATUS_CANCELLED->{
                work_flow_status_imageview?.setBackgroundResource(R.mipmap.work_flow_cancel)
            }
            OrderCancelWorkListRequest.STATUS_PROCESSED->{
//                是否收取违约金  0：是  1：否
                if(order.operation_status == 0){
                    LogUtil.e("setBackgroundResource icon_order_cancel_charge")
                    work_flow_status_imageview?.setBackgroundResource(R.mipmap.icon_order_cancel_charge)
                }else{
                    LogUtil.e("setBackgroundResource icon_order_cancel_free")
                    work_flow_status_imageview?.setBackgroundResource(R.mipmap.icon_order_cancel_free)
                }

            }

        }

    }

    /**
     * 订单title标红
     * 当处于待交车&& 已经超过交车时间的订单
     * */
    private fun redTagInfo(layoutOrderInfo: LinearLayout?, orderNo: TextView?, orderChannel: TextView?, orderState: TextView?, order: OrderCancelWorkListRowBean) {

        val nowTime = System.currentTimeMillis()
        val startTime = getDateTime(order.start_time ?: "")
        val endTime = getDateTime(order.end_time ?: "")

//        layoutOrderInfo?.setBackgroundResource(R.color.color_0)
//        orderNo?.setTextColor(ContextCompat.getColor(context, R.color.color_5))
//        orderChannel?.setTextColor(ContextCompat.getColor(context, R.color.color_3))
//        orderState?.setTextColor(ContextCompat.getColor(context, R.color.color_D32928))
        if ((order.order_status== OrderReletApplyListRowsBean.ORDER_ILLEGAL_PAYED && nowTime > startTime)
                || (order.order_status == OrderReletApplyListRowsBean.ORDER_EXECUTING && nowTime > endTime)) {
            layoutOrderInfo?.setBackgroundResource(R.color.color_6)
            orderNo?.setTextColor(ContextCompat.getColor(context, R.color.color_0))
            orderChannel?.setTextColor(ContextCompat.getColor(context, R.color.color_0))
            orderState?.setTextColor(ContextCompat.getColor(context, R.color.color_0))
        } else {
            layoutOrderInfo?.setBackgroundResource(R.color.color_0)
            orderNo?.setTextColor(ContextCompat.getColor(context, R.color.color_5))
            orderChannel?.setTextColor(ContextCompat.getColor(context, R.color.color_3))
            orderState?.setTextColor(ContextCompat.getColor(context, R.color.color_D32928))
        }
    }

    private fun getDateTime(date: String): Long {
        val sdf = SimpleDateFormat("yyyy-MM-dd HH:mm")
        return try {
            val d = sdf.parse(date)
            d.time
        } catch (ex: Exception) {
            0
        }
    }

    /**
     * 拨打客户电话
     * */
    private fun onUserPhone(phone: String) {
        if (context is FragmentActivity) {
            DialogUtil.onSiteDial(context, phone)
        }
    }

    interface BottomButtonListener{
        fun onChargeClicked(orderCancelWorkListRowBean: OrderCancelWorkListRowBean)
        fun onFreeClicked(orderCancelWorkListRowBean: OrderCancelWorkListRowBean)
    }

    private fun getUserName(name: String): String {
        val sb = StringBuilder()
        if (TextUtils.isEmpty(name))
            return ""
        if (name.length > 7) {
            sb.append(name.substring(0, 8))
            sb.append("...")
        } else {
            sb.append(name)
        }
        return sb.toString()
    }
}

