package com.jiaoyinbrother.monkeyking.manager.adapter

import android.annotation.SuppressLint
import android.content.Context
import android.content.Intent
import android.support.constraint.ConstraintLayout
import android.support.v4.app.FragmentActivity
import android.support.v4.content.ContextCompat
import android.text.TextUtils
import android.view.View
import android.widget.LinearLayout
import android.widget.TextView
import com.camnter.easyrecyclerview.adapter.EasyRecyclerViewAdapter
import com.camnter.easyrecyclerview.holder.EasyRecyclerViewHolder
import com.google.android.flexbox.FlexboxLayout
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.library.bean.OrdersBean
import com.jiaoyinbrother.library.util.*
import com.jiaoyinbrother.library.widget.OrdersItemBottomButton
import com.jiaoyinbrother.monkeyking.manager.util.DialogUtil
import java.lang.StringBuilder
import java.text.SimpleDateFormat

/**
 * by Lyy on 2018/3/27.
 */
class OrderListAdapter(val context: Context) : EasyRecyclerViewAdapter() {

    private var footer = false

    companion object {
        const val ORDER_LIST_TO_DROP_IN = "ORDER_LIST_TO_DROP_IN"
        const val ORDER_LIST_TO_DETAIL = "ORDER_LIST_TO_DETAIL"
        const val ORDER_LIST_TO_DELIVER = "ORDER_LIST_TO_DELIVER"
        const val ORDER_LIST_TO_ALSO = "ORDER_LIST_TO_ALSO"
    }


    override fun getItemLayouts(): IntArray {
        return intArrayOf(R.layout.item_order, R.layout.item_footer)
    }

    override fun onBindRecycleViewHolder(viewHolder: EasyRecyclerViewHolder?, position: Int) {

        val recycleViewItemType = getRecycleViewItemType(position)
        when (recycleViewItemType) {
            0 -> orderViewHolder(viewHolder, position)
            1 -> footerViewHolder()
        }
    }

    @SuppressLint("SetTextI18n")
    private fun orderViewHolder(viewHolder: EasyRecyclerViewHolder?, position: Int) {
//        LogUtil.e("order.renterid***************** = 1111111" )
        val order = list[position] as OrdersBean

        var orderItem = viewHolder?.findViewById<ConstraintLayout>(R.id.order_item_layout)
        orderItem?.setOnClickListener {
            mItemListener?.onItemClick(ORDER_LIST_TO_DETAIL, order)
        }
        // 订单号
        val orderNo = viewHolder?.findViewById<TextView>(R.id.orderNo)

        val orderPlatFormView = viewHolder?.findViewById<TextView>(R.id.carType_plat_form)
        orderNo?.text = "订单号：${order.getOrderShowID()}"

        // 订单渠道 (车管端)
        val orderChannel = viewHolder?.findViewById<TextView>(R.id.orderChannel)
        orderChannel?.visibility = if (UserUtil(context).userRole == UserUtil.USER_ROLE_OWNER) View.VISIBLE else View.INVISIBLE
        orderChannel?.text = if (TextUtils.isEmpty(order.channel_name)) "" else " (${order.channel_name})"
        // 车辆类别
        val carType = viewHolder?.findViewById<TextView>(R.id.carType)
        carType?.text = order.type

        //区分平台
        if (order.is_avis == true) {
            orderPlatFormView?.visibility = View.VISIBLE
        } else {
            orderPlatFormView?.visibility = View.GONE
        }
        // 车辆牌号ß
        val carNumber = viewHolder?.findViewById<TextView>(R.id.carNumber)
        carNumber?.visibility = if (UserUtil(context).userRole == UserUtil.USER_ROLE_RENTER && order.status < OrdersBean.ORDER_STATUS_5) View.GONE else View.VISIBLE
        if (order.number != null && order.number!!.isNotEmpty() && order.number != "未知") {
            carNumber?.text = order.number
        } else {
            carNumber?.text = "    未排车    "
        }
//        LogUtil.e("order.renterid***************** =333" )
        // 订单状态
        val orderStatus = viewHolder?.findViewById<TextView>(R.id.orderStatus)
        orderStatus?.text = order.status_name
        // 取车时间
        val orderTakeTime = viewHolder?.findViewById<TextView>(R.id.orderTakeTime)
        orderTakeTime?.text = order.start_time
        // 取车地点
        val orderTakeAddress = viewHolder?.findViewById<TextView>(R.id.orderTakeAddress)
        orderTakeAddress?.text = order.address
        // 还车时间
        val orderReturnTime = viewHolder?.findViewById<TextView>(R.id.orderReturnTime)
        orderReturnTime?.text = order.end_time
        LogUtil.e("order.renterid***************** =444")
        // 还车时间
        val mUserName = viewHolder?.findViewById<TextView>(R.id.item_order_user_name)
        //用户电话
        val userPhone = viewHolder?.findViewById<TextView>(R.id.item_order_user_phone)

        val member = order.member

        mUserName?.text = if (TextUtils.isEmpty(getUserName(member?.name ?: ""))) {
            getUserName(order.renter_name ?: "")
        } else {
            getUserName(member?.name ?: "")
        }

        userPhone?.text = if (TextUtils.isEmpty(member?.member_phone)) {
            order.renterid
        } else {
            member?.member_phone
        }

        // 还车地点
        val orderReturnAddress = viewHolder?.findViewById<TextView>(R.id.orderReturnAddress)
        orderReturnAddress?.text = if (TextUtils.isEmpty(order.return_address)) order.address else order.return_address
        val layoutOrderInfo = viewHolder?.findViewById<LinearLayout>(R.id.layoutOrderInfo)

        redTagInfo(layoutOrderInfo, orderNo, orderChannel, orderStatus, order)

        LogUtil.e("orderid-->" + order.orderid + "--state-->" + order.status)

        //底部按钮
        val mOrderBottom = viewHolder?.findViewById<OrdersItemBottomButton>(R.id.item_order_bottom)
        mOrderBottom?.setBottomLayoutStatus(order)
        mOrderBottom?.setListener(object : OrdersItemBottomButton.OrderButtonListener {
            override fun onConfirmTakeCar() {
                mItemListener?.onItemClick(ORDER_LIST_TO_DELIVER, order)
            }

            override fun onConfirmReturnCar() {
                mItemListener?.onItemClick(ORDER_LIST_TO_ALSO, order)
            }

            override fun onTakeCarBackFromDoor() {
                mItemListener?.onItemClick(ORDER_LIST_TO_DROP_IN, order)
            }

            override fun onSendCarToDoor() {
                mItemListener?.onItemClick(ORDER_LIST_TO_DROP_IN, order)
            }
        })

        //上门取送
        val orderTakeOnSite = viewHolder?.findViewById<TextView>(R.id.orderTakeOnSite)
        val orderReturnOnSite = viewHolder?.findViewById<TextView>(R.id.orderReturnOnSite)

//        if (order.is_onsite_service == 1 || order.remote == 1) {
//            orderTakeOnSite?.text = if (order.is_onsite_service == 1) "上门取送" else "自助取还"
//            orderReturnOnSite?.text = if (order.is_onsite_service == 1) "上门取送" else "自助取还"
//            orderTakeOnSite?.visibility = View.VISIBLE
//            orderReturnOnSite?.visibility = View.VISIBLE
//        } else {
//            orderTakeOnSite?.visibility = View.GONE
//            orderReturnOnSite?.visibility = View.GONE
//        }

        when (order.is_onsite_service) {
            OrdersBean.SEND_TO_CAR -> {
                orderTakeOnSite?.text = "上门取送"
                orderReturnOnSite?.text = "上门取送"
                orderTakeOnSite?.visibility = View.VISIBLE
                orderReturnOnSite?.visibility = View.VISIBLE
            }
            OrdersBean.PICK_UP_PERSON -> {
                orderTakeOnSite?.text = "接送至门店"
                orderReturnOnSite?.text = "接送至门店"
                orderTakeOnSite?.visibility = View.VISIBLE
                orderReturnOnSite?.visibility = View.VISIBLE
            }
            else -> {
                if (order.remote == 1) {
                    orderTakeOnSite?.text = "自助取还"
                    orderReturnOnSite?.text = "自助取还"
                    orderTakeOnSite?.visibility = View.VISIBLE
                    orderReturnOnSite?.visibility = View.VISIBLE
                } else{
                    orderTakeOnSite?.visibility = View.GONE
                    orderReturnOnSite?.visibility = View.GONE
                }
            }
        }

        userPhone?.setOnClickListener {
            if (member == null) {
                onUserPhone(order.renterid ?: "")
            } else {
                onUserPhone(member.member_phone ?: "")
            }
        }

        val flexboxLayout = viewHolder?.findViewById<FlexboxLayout>(R.id.item_order_flex)
        val list = order.service_tags
        initBrandView(flexboxLayout, list)
        LogUtil.e("item __ setData finish -----------------------------------------------------")
    }


    private fun footerViewHolder() {}


    override fun getRecycleViewItemType(position: Int): Int {
        return if (footer && position == itemCount - 1) 1 else 0
    }

    fun addFooter(footer: Boolean) {
        this.footer = footer
    }

//    fun onItemClick(l: OrderItemClickListener) {
//        this.listener = l
//    }
//
//    interface OrderItemClickListener {
//        fun onSmallOne(order: OrdersBean, position: Int)
//        fun onSmallTwo(order: OrdersBean, position: Int)
//        fun onBigThree(order: OrdersBean, position: Int)
//    }

    private fun initBrandView(contentView: FlexboxLayout?, list: List<String>?) {
        contentView?.removeAllViews()
        if (list != null && list.isNotEmpty()) {
            for (item in list!!) {
                val child = View.inflate(context, R.layout.item_order_flex_layout, null)
                val content = child.findViewById<TextView>(R.id.item_order_flex_item)
                content.text = item
                contentView?.addView(child)
            }
        }
    }

    /**
     * 订单title标红
     * 当处于待交车&& 已经超过交车时间的订单
     * */
    private fun redTagInfo(layoutOrderInfo: LinearLayout?, orderNo: TextView?, orderChannel: TextView?, orderState: TextView?, order: OrdersBean) {
        val role = UserUtil(context).userRole
        val nowTime = System.currentTimeMillis()
        val startTime = getDateTime(order.start_time ?: "")
        val endTime = getDateTime(order.end_time ?: "")
        if ((role == 1 && order.status == OrdersBean.ORDER_STATUS_4 && nowTime > startTime)
                || (role == 1 && order.status == OrdersBean.ORDER_STATUS_5 && nowTime > endTime)) {
            layoutOrderInfo?.setBackgroundResource(R.color.color_6)
            orderNo?.setTextColor(ContextCompat.getColor(context, R.color.color_0))
            orderChannel?.setTextColor(ContextCompat.getColor(context, R.color.color_0))
            orderState?.setTextColor(ContextCompat.getColor(context, R.color.color_0))
        } else {
            layoutOrderInfo?.setBackgroundResource(R.color.color_0)
            orderNo?.setTextColor(ContextCompat.getColor(context, R.color.color_5))
            orderChannel?.setTextColor(ContextCompat.getColor(context, R.color.color_3))
            orderState?.setTextColor(ContextCompat.getColor(context, R.color.color_D32928))
        }
    }

    private fun getDateTime(date: String): Long {
        val sdf = SimpleDateFormat("yyyy-MM-dd HH:mm")
        return try {
            val d = sdf.parse(date)
            d.time
        } catch (ex: Exception) {
            0
        }
    }

    /**
     * 拨打客户电话
     * */
    private fun onUserPhone(phone: String) {
        if (context is FragmentActivity) {
            DialogUtil.onSiteDial(context, phone)
        }
    }


    private fun getUserName(name: String): String {
        val sb = StringBuilder()
        if (TextUtils.isEmpty(name))
            return ""
        if (name.length > 7) {
            sb.append(name.substring(0, 8))
            sb.append("...")
        } else {
            sb.append(name)
        }
        return sb.toString()
    }

    private var mItemListener: OnOrderItemListener? = null

    fun setOrderItemListener(listener: OnOrderItemListener) {
        mItemListener = listener
    }

    interface OnOrderItemListener {
        fun onItemClick(type: String, order: OrdersBean)
    }
}