package com.jiaoyinbrother.monkeyking.manager.adapter

import android.content.Context
import android.support.v4.content.ContextCompat
import android.text.Spannable
import android.text.SpannableString
import android.text.TextUtils
import android.text.style.ForegroundColorSpan
import android.text.style.RelativeSizeSpan
import android.widget.ImageView
import android.widget.TextView
import com.camnter.easyrecyclerview.adapter.EasyRecyclerViewAdapter
import com.camnter.easyrecyclerview.holder.EasyRecyclerViewHolder
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.library.bean.PayMethodAvaiBean

/**
 *  by Soda on 2018/1/9.
 */
class PayMethodAdapter(val context: Context) : EasyRecyclerViewAdapter() {

    private var selectMethod: Int = 0
    private var balance: Int = 0
    private var payAmount: Int = 0

    override fun getItemLayouts(): IntArray {
        return intArrayOf(R.layout.item_paymethod)
    }

    override fun getRecycleViewItemType(position: Int): Int {
        return 0
    }

    override fun onBindRecycleViewHolder(holder: EasyRecyclerViewHolder?, position: Int) {


        val entity = list[position] as PayMethodAvaiBean

        // icon
        val icon = holder?.findViewById<ImageView>(R.id.icon)
        icon?.setImageResource(setIcon(entity))
        // title
        val methodName = holder?.findViewById<TextView>(R.id.methodName)
        methodName?.text = if (!TextUtils.isEmpty(entity.description)) {// 设置描述内容
            setSpString(entity.name ?: "", entity.description ?: "")
        } else {
            if (entity.id == PayMethodAvaiBean.ACCOUNTPAY) setSpString(entity.name
                    ?: "", "¥" + balance + "可用") else entity.name
        }
        // 选取
        val selectIcon = holder?.findViewById<ImageView>(R.id.selectIcon)
        if (entity.id == selectMethod) {
            selectIcon?.setBackgroundResource(R.mipmap.icon_selector_checked)
        } else {
            selectIcon?.setBackgroundResource(R.mipmap.icon_selector_unchecked)
        }
    }

    private fun setSpString(title: String, describe: String): SpannableString {
        val str = "$title ($describe)"
        val sp = SpannableString(str)
        sp.setSpan(RelativeSizeSpan(0.85f), title.length, sp.length, Spannable.SPAN_INCLUSIVE_EXCLUSIVE)
        sp.setSpan(ForegroundColorSpan(ContextCompat.getColor(context, R.color.color_3)), title.length, sp.length,
                Spannable.SPAN_EXCLUSIVE_EXCLUSIVE)
        return sp
    }

    private fun setIcon(entity: PayMethodAvaiBean?): Int {
        return when (entity?.id) {
            PayMethodAvaiBean.WECHATPAY -> R.mipmap.icon_wechat
            PayMethodAvaiBean.ALIPAY -> R.mipmap.icon_alipay
            PayMethodAvaiBean.UNIONPAY -> R.mipmap.icon_unionpay
            PayMethodAvaiBean.YIBAOPAY -> R.mipmap.icon_bankcard
            PayMethodAvaiBean.HUABEIPAY -> R.mipmap.icon_huabei
            else -> {
                if (balance < payAmount) R.mipmap.icon_account_disable else R.mipmap.icon_account
            }
        }
    }

    fun setAmout(balance: Int, payAmount: Int) {
        this.balance = balance
        this.payAmount = payAmount
    }

    fun selectPayMethod(payMethod: Int) {
        this.selectMethod = payMethod
        notifyDataSetChanged()
    }
}