package com.jiaoyinbrother.monkeyking.manager.adapter

import android.content.Context
import android.support.v4.content.ContextCompat
import android.widget.TextView
import com.camnter.easyrecyclerview.adapter.EasyRecyclerViewAdapter
import com.camnter.easyrecyclerview.holder.EasyRecyclerViewHolder
import com.jiaoyinbrother.library.bean.HolidaysBean
import com.jiaoyinbrother.monkeyking.manager.R

class SelectFestivalAdapter(private val context: Context): EasyRecyclerViewAdapter() {


    private var mSelectedPosition = 0
    private var mOnItemListener: OnItemListener? = null

    override fun getRecycleViewItemType(position: Int): Int {
        return 0
    }

    override fun getItemLayouts(): IntArray {
        return intArrayOf(R.layout.item_select_festival)
    }

    override fun onBindRecycleViewHolder(viewHolder: EasyRecyclerViewHolder?, position: Int) {
        val tv_name = viewHolder?.findViewById<TextView>(R.id.tv_name)

        val bean = list?.get(position) as? HolidaysBean
        tv_name?.text = bean?.holiday_name

        tv_name?.setTextColor(ContextCompat.getColor(context,if(mSelectedPosition == position) R.color.color_f83144 else R.color.color_333333))

        tv_name?.setOnClickListener {
            mSelectedPosition = position
            notifyDataSetChanged()
            mOnItemListener?.onSelect(bean)
        }
    }

    fun setSelectItem(defaultHolidaysBean: HolidaysBean?){
        if(defaultHolidaysBean != null && list != null && list?.size?:0 > 0){
            var defaultPosition = 0
            for(i in list.indices){
                val bean = list?.get(i) as? HolidaysBean
                if(bean?.holiday_id  == defaultHolidaysBean.holiday_id){
                    defaultPosition = i
                    break
                }
            }

            mSelectedPosition = defaultPosition
            notifyDataSetChanged()
        }
    }

    fun setOnItemListener(listener: OnItemListener){
        this.mOnItemListener = listener
    }

    interface OnItemListener{
        fun onSelect(holiday: HolidaysBean?)
    }
}