package com.jiaoyinbrother.monkeyking.manager.adapter

import android.content.Context
import android.support.constraint.Group
import android.support.v4.app.FragmentActivity
import android.support.v4.content.ContextCompat
import android.text.Html
import android.text.TextUtils
import android.view.View
import android.widget.*
import com.camnter.easyrecyclerview.adapter.EasyRecyclerViewAdapter
import com.camnter.easyrecyclerview.holder.EasyRecyclerViewHolder
import com.jiaoyinbrother.library.bean.OrderReletApplyListRowsBean
import com.jiaoyinbrother.library.bean.SpiderListItemBean
import com.jiaoyinbrother.library.util.LogUtil
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.workflowlist.WorkFlowListActivity
import com.jiaoyinbrother.monkeyking.manager.util.DialogUtil
import java.lang.StringBuilder
import java.text.SimpleDateFormat


/**
 * @author zhangbo
 * @date 2020/7/23
 * Email : b.zhang@wkzuche.com
 * Describe: 异常价格工单列表适配器
 */
class SpiderListAdapter : EasyRecyclerViewAdapter() {
    private var mBottomButtonListener: BottomButtonListener? = null

    override fun getItemLayouts(): IntArray {
        return intArrayOf(R.layout.item_spider_list)
    }

    override fun getRecycleViewItemType(position: Int): Int {
        return 0
    }


    fun setOnBottomClickListener(bottomButtonListener: BottomButtonListener) {
        LogUtil.e("WorkflowListAdapter setOnBottomClickListener  bottomButtonListener = $bottomButtonListener")
        mBottomButtonListener = bottomButtonListener

    }

    override fun onBindRecycleViewHolder(viewHolder: EasyRecyclerViewHolder?, position: Int) {

        lateinit var mTvNumber: TextView
        lateinit var mTvDesc: TextView
        lateinit var mTvCarInfo: TextView
        lateinit var mTvSite: TextView
        lateinit var mTvTimeStart: TextView
        lateinit var mTvTimeEnd: TextView
        lateinit var mTvUser: TextView
        lateinit var mRlBottom: RelativeLayout
        lateinit var mBtnBottomRight: Button
        lateinit var mBtnBottomLeft: Button
        lateinit var mIvStatus: ImageView
        lateinit var mGroupAuditing: Group
        lateinit var mContext: Context

        viewHolder?.apply {

            mTvNumber = findViewById(R.id.item_spider_number_tv)
            mTvDesc = findViewById(R.id.item_spider_desc_tv)
            mTvCarInfo = findViewById(R.id.item_spider_car_info_tv)
            mTvSite = findViewById(R.id.item_spider_site_tv)
            mTvTimeStart = findViewById(R.id.item_spider_time_start_tv)
            mTvTimeEnd = findViewById(R.id.item_spider_time_end_tv)
            mTvUser = findViewById(R.id.item_spider_user_tv)
            mRlBottom = findViewById(R.id.item_spider_bottom_rl)
            mBtnBottomRight = findViewById(R.id.item_spider_bottom_right_btn)
            mBtnBottomLeft = findViewById(R.id.item_spider_bottom_left_btn)
            mGroupAuditing = findViewById(R.id.item_spider_auditing_group)
            mIvStatus = findViewById(R.id.item_spider_status_iv)

            mContext = itemView.context
        }

        val bean = list[position] as? SpiderListItemBean

        bean?.apply {

            mTvNumber.text = "工单号：$id"

            var mAbnormalPriceDesc = ""
            if (abnormal_price_desc != null){

                mAbnormalPriceDesc = abnormal_price_desc.toString()
            }
            mTvDesc.text = Html.fromHtml("异常内容：<font color=\"#CB2A1E\">$mAbnormalPriceDesc</font>")
            mTvCarInfo.text = Html.fromHtml("车型信息：$car_type_name<font color=\"#999999\">（$config_info）</font>")

            var mSiteName = ""
            if (site_name != null){

                mSiteName = site_name.toString()
            }

            var mGroupName = ""
            if (site_name != null){

                mGroupName = group_name.toString()
            }
            mTvSite.text = Html.fromHtml("网点：$mSiteName<font color=\"#999999\">（$mGroupName）</font>")

            var mCreatedStamp = ""
            if (created_stamp != null){

                mCreatedStamp = created_stamp.toString()
            }
            mTvTimeStart.text = "发起时间：$mCreatedStamp"

            var mHandleTime = ""
            if (handle_time != null){

                mHandleTime = handle_time.toString()
            }
            mTvTimeEnd.text = "处理时间：$mHandleTime"

            var mHandleUserName = ""
            if (handle_user_name != null){

                mHandleUserName = handle_user_name.toString()
            }
            mTvUser.text = "处理人：$mHandleUserName"

            if (status == "AUDITING"){

                mRlBottom.visibility = View.VISIBLE
                mGroupAuditing.visibility = View.GONE
                mTvNumber.setBackgroundColor(ContextCompat.getColor(mContext,R.color.color_6))
                mTvNumber.setTextColor(ContextCompat.getColor(mContext,R.color.white))
            }else {

                mRlBottom.visibility = View.GONE
                mGroupAuditing.visibility = View.VISIBLE
                mTvNumber.setTextColor(ContextCompat.getColor(mContext,R.color.color_gray_28))
                mTvNumber.setBackgroundColor(ContextCompat.getColor(mContext,R.color.white))

                when(status){
                    OrderReletApplyListRowsBean.WORK_LIST_APPLY_STATUS_CANCEL->{
                        mIvStatus.setBackgroundResource(R.mipmap.work_flow_cancel)
                    }
                    OrderReletApplyListRowsBean.WORK_LIST_APPLY_STATUS_AUDITED->{
                        mIvStatus.setBackgroundResource(R.mipmap.work_flow_audited)
                    }
                    OrderReletApplyListRowsBean.WORK_LIST_APPLY_STATUS_REJECT->{
                        mIvStatus.setBackgroundResource(R.mipmap.work_flow_rejected)
                    }
                }

            }

            mBtnBottomRight.setOnClickListener {

                mBottomButtonListener?.onRightClicked(site_car_type_id)
            }

            mBtnBottomLeft.setOnClickListener {

                mBottomButtonListener?.onLeftClicked(site_car_type_id,bean.id)
            }

        }

    }

    interface BottomButtonListener {
        fun onRightClicked(site_car_type_id : Int)
        fun onLeftClicked(site_car_type_id : Int,id:Int)
    }

}