package com.jiaoyinbrother.monkeyking.manager.adapter

import android.content.Context
import android.support.constraint.ConstraintLayout
import android.support.v4.content.ContextCompat
import android.widget.TextView
import com.camnter.easyrecyclerview.adapter.EasyRecyclerViewAdapter
import com.camnter.easyrecyclerview.holder.EasyRecyclerViewHolder
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.util.EMUtil
import com.jiaoyinbrother.library.bean.BulletinsBean
import com.jiaoyinbrother.library.util.DateTimeUtil
import com.jiaoyinbrother.library.util.LogUtil

/**
 * Created by Sgq
 * Create Date 2019/4/22 and 11:12
 * desc: 系统公告
 */
class SystNotificationAdapter(private val context: Context) : EasyRecyclerViewAdapter() {

    override fun getRecycleViewItemType(position: Int): Int {
        return 0
    }

    override fun onBindRecycleViewHolder(viewHolder: EasyRecyclerViewHolder?, position: Int) {

        val cl_allcontentl = viewHolder?.findViewById<ConstraintLayout>(R.id.cl_allcontent)
        val tv_title = viewHolder?.findViewById<TextView>(R.id.tv_title)
        val tv_time = viewHolder?.findViewById<TextView>(R.id.tv_time)
        val tv_content = viewHolder?.findViewById<TextView>(R.id.tv_content)


        val list = list as List<BulletinsBean>?
        val messageORMBean = list?.get(position)

        tv_title?.text = messageORMBean?.bulletin_name ?: ""
        tv_content?.text = messageORMBean?.description ?: ""


        tv_time?.text = EMUtil.instance.getIMDateString(DateTimeUtil.stringToDate(messageORMBean?.created_stamp
                ?: ""))

        LogUtil.e("message" + list.toString())
//        unread 是否未读，1：是，0：否
        if (messageORMBean?.unread ?: 0 == 1) {
            // 未读消息处理
            var color = ContextCompat.getColor(context, R.color.color_333333)
            tv_title?.setTextColor(color)
            color = ContextCompat.getColor(context, R.color.color_999999)
            tv_time?.setTextColor(color)
            tv_content?.setTextColor(color)
        } else {
            // 已读消息处理
            val color = ContextCompat.getColor(context, R.color.color_999999)
            tv_title?.setTextColor(color)
            tv_time?.setTextColor(color)
            tv_content?.setTextColor(color)
        }


    }

    override fun getItemLayouts(): IntArray {
        return intArrayOf(R.layout.adapter_sysnoti_item)
    }
}