package com.jiaoyinbrother.monkeyking.manager.adapter

import android.content.Context
import android.support.v4.content.ContextCompat
import android.text.Spannable
import android.text.SpannableString
import android.text.SpannableStringBuilder
import android.text.style.ForegroundColorSpan
import android.widget.TextView
import com.camnter.easyrecyclerview.adapter.EasyRecyclerViewAdapter
import com.camnter.easyrecyclerview.holder.EasyRecyclerViewHolder
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.library.bean.TimeOthersFeeBean
import com.jiaoyinbrother.library.util.MoneyUtil
import com.jiaoyinbrother.library.util.TextViewUtil
import com.jiaoyinbrother.library.util.UserUtil

/**
 * Created by Administrator on 2018/8/6.
 */

class TimeOrderFeesAdapter(val type: String, val context: Context) : EasyRecyclerViewAdapter() {

    companion object {
        const val TYPE_USER = "TYPE_USER"
        const val TYPE_OWNER = "TYPE_OWNER"
    }


    override fun getRecycleViewItemType(position: Int): Int {
        return 0
    }

    override fun onBindRecycleViewHolder(viewHolder: EasyRecyclerViewHolder?, position: Int) {
        val textview_title = viewHolder?.findViewById<TextView>(R.id.textview_title)
        val textview_status_name = viewHolder?.findViewById<TextView>(R.id.textview_status_name)
        val timeOthersFeeBean = list[position] as TimeOthersFeeBean

        when (type) {
            TYPE_USER -> handleUserAction(textview_title, textview_status_name, timeOthersFeeBean)
            TYPE_OWNER -> handleOwnerAction(textview_title, textview_status_name, timeOthersFeeBean)
        }


    }

    private fun handleUserAction(textview_title: TextView?, textview_status_name: TextView?, timeOthersFeeBean: TimeOthersFeeBean) {
        val spannableString = SpannableStringBuilder(timeOthersFeeBean.type_name)
        var moneySpanString = SpannableString(MoneyUtil().getMoneyText(timeOthersFeeBean.amount.toString()))

        moneySpanString.setSpan(ForegroundColorSpan(ContextCompat.getColor(context, R.color.color_6)), 0, moneySpanString.length, Spannable.SPAN_EXCLUSIVE_EXCLUSIVE)
        spannableString.append(moneySpanString)
        textview_title?.text = spannableString

        if (timeOthersFeeBean.enabled == UserUtil.DEPOSIT_PAY_ENABLED) {
            textview_status_name?.text = "在线支付"
        } else
            textview_status_name?.text = timeOthersFeeBean.status_name

        TextViewUtil.setButtonStatus(textview_status_name, context, TextViewUtil.BUTTON_NO_BACKGROUND)
        when (timeOthersFeeBean.status) {
            UserUtil.DEPOSIT_WAIT_PAYED -> {
                if (timeOthersFeeBean.enabled != null || timeOthersFeeBean.enabled == 1)
                    TextViewUtil.setButtonStatus(textview_status_name, context, TextViewUtil.BUTTON_ENABLE_NORMAL)
                else
                    TextViewUtil.setButtonStatus(textview_status_name, context, TextViewUtil.BUTTON_DISABLE)
            }
        }
    }

    private fun handleOwnerAction(textview_title: TextView?, textview_status_name: TextView?, timeOthersFeeBean: TimeOthersFeeBean) {
        textview_title?.text = timeOthersFeeBean.type_name
        textview_status_name?.text = timeOthersFeeBean.status_name
    }

    override fun getItemLayouts(): IntArray {
        return intArrayOf(R.layout.item_time_order_fees)
    }

}
