package com.jiaoyinbrother.monkeyking.manager.adapter

import android.content.Context
import android.widget.LinearLayout
import android.widget.TextView
import com.camnter.easyrecyclerview.adapter.EasyRecyclerViewAdapter
import com.camnter.easyrecyclerview.holder.EasyRecyclerViewHolder
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.library.bean.SiteBean
import com.jiaoyinbrother.library.util.DensityUtil

/**
 * The Author : adminn
 */

class TimeSiteAdapter(private val context: Context) : EasyRecyclerViewAdapter() {

    override fun getItemLayouts(): IntArray {
        return intArrayOf(R.layout.item_site_title, R.layout.item_site_time)
    }

    override fun getRecycleViewItemType(position: Int): Int {
        val siteBean = list[position] as SiteBean
        return if (siteBean.itemType == SiteBean.TYPE_TITLE) NORMAL else TITLE
    }

    override fun onBindRecycleViewHolder(viewHolder: EasyRecyclerViewHolder?, position: Int) {
        val itemType = getRecycleViewItemType(position)

        when (itemType) {
            0 -> areaHolder(viewHolder, position)
            1 -> siteHolder(viewHolder, position)
        }
    }

    private fun areaHolder(holder: EasyRecyclerViewHolder?, position: Int) {
        val siteBean = list[position] as SiteBean

        val mainView = holder?.findViewById<LinearLayout>(R.id.siteTitleLayout)
        val params = LinearLayout.LayoutParams(LinearLayout.LayoutParams.MATCH_PARENT, DensityUtil.dip2px(context, 33F))
        mainView?.layoutParams = params

        val mTitle = holder?.findViewById<TextView>(R.id.siteTitle)
        mTitle?.text = siteBean.area
    }

    private fun siteHolder(holder: EasyRecyclerViewHolder?, position: Int) {
        val siteBean = list[position] as SiteBean

        // site 名称
        val siteName = holder?.findViewById<TextView>(R.id.siteName)
        siteName?.text = siteBean.name

        // site 地址
        val siteAddress = holder?.findViewById<TextView>(R.id.siteAddress)
        siteAddress?.text = siteBean.address
    }

    companion object {
        private const val TITLE = 1
        private const val NORMAL = 0
    }


}