package com.jiaoyinbrother.monkeyking.manager.adapter

import android.content.Context
import android.support.v4.app.FragmentActivity
import android.support.v4.content.ContextCompat
import android.text.TextUtils
import android.view.View
import android.widget.*
import com.camnter.easyrecyclerview.adapter.EasyRecyclerViewAdapter
import com.camnter.easyrecyclerview.holder.EasyRecyclerViewHolder
import com.jiaoyinbrother.library.bean.OrderReletApplyListRowsBean
import com.jiaoyinbrother.library.util.LogUtil
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.fragment.workflowlist.WorkflowListPresenter
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.workflowlist.WorkFlowListActivity
import com.jiaoyinbrother.monkeyking.manager.util.DialogUtil
import java.lang.StringBuilder
import java.text.SimpleDateFormat

class WorkflowListAdapter(val context: Context):EasyRecyclerViewAdapter(){
    private var mBottomButtonListener:BottomButtonListener? = null
    private var mOrderActionType = WorkFlowListActivity.PAGE_TYPE_RELET
//    var mOnPhoneListener: ((OrderReletApplyListRowsBean?) -> Unit)? = null

    override fun getItemLayouts(): IntArray {
        return intArrayOf(R.layout.item_workflow_list)
    }

    override fun getRecycleViewItemType(position: Int): Int {
        return 0
    }

    fun setAdapterType(type:Int){
        LogUtil.e("setAdapterType, type =" + type)
        mOrderActionType = type
    }

    fun setOnBottomClickListener(bottomButtonListener:BottomButtonListener){
        LogUtil.e("WorkflowListAdapter setOnBottomClickListener  bottomButtonListener = $bottomButtonListener")
        mBottomButtonListener = bottomButtonListener

    }

    override fun onBindRecycleViewHolder(viewHolder: EasyRecyclerViewHolder?, position: Int) {
        val order = list[position] as OrderReletApplyListRowsBean
        LogUtil.e("WorkflowListAdapter onBindRecycleViewHolder  1111111***********, order = $order")

        // 订单号
        val orderNo = viewHolder?.findViewById<TextView>(R.id.orderNo)
        orderNo?.text = "订单号：${order.getOrderShowID()}"
        // 订单渠道 (车管端)
        val orderChannel = viewHolder?.findViewById<TextView>(R.id.orderChannel)
        orderChannel?.text = if (TextUtils.isEmpty(order.channel_name)) "" else " (${order.channel_name})"
        // 订单状态
        val orderStatus = viewHolder?.findViewById<TextView>(R.id.orderStatus)
        orderStatus?.text = order.status_name
        val layoutOrderInfo = viewHolder?.findViewById<LinearLayout>(R.id.layoutOrderInfo)
        redTagInfo(layoutOrderInfo, orderNo, orderChannel, orderStatus, order)
        LogUtil.e("orderid-->" + order.order_id + "--state-->" + order.status)

        LogUtil.e("WorkflowListAdapter onBindRecycleViewHolder  222222***********")

        // 车辆类别
        val carType = viewHolder?.findViewById<TextView>(R.id.carType)
        carType?.text = order.car_type_name
        // 车辆牌号ß
        val carNumber = viewHolder?.findViewById<TextView>(R.id.carNumber)
        if (order.number != null && order.number!!.isNotEmpty() && order.number != "未知") {
            carNumber?.text = order.number
        } else {
            carNumber?.text = "    未排车    "
        }

        LogUtil.e("WorkflowListAdapter onBindRecycleViewHolder  33333***********")

        //用户信息
        val mUserName = viewHolder?.findViewById<TextView>(R.id.item_order_user_name)
        val userPhone = viewHolder?.findViewById<TextView>(R.id.item_order_user_phone)
        if(order.name!=null)
            mUserName?.text = getUserName(order.name!!)
        userPhone?.text = order.telephone
        userPhone?.setOnClickListener {
            onUserPhone(order.telephone ?: "")
//            mOnPhoneListener?.invoke(order)
        }

        LogUtil.e("WorkflowListAdapter onBindRecycleViewHolder  44444***********")

        // 原取车时间
        val originalStartTime = viewHolder?.findViewById<TextView>(R.id.original_rent_date_from)
        originalStartTime?.text = order.old_start_time
        // 原还车时间
        val originalEndTime = viewHolder?.findViewById<TextView>(R.id.original_rent_date_to)
        originalEndTime?.text = order.old_end_time

        // 取车时间
        val renewalStartTime = viewHolder?.findViewById<TextView>(R.id.relet_rent_date_from)
        renewalStartTime?.text = order.start_time
        // 还车时间
        val renewalEndTime = viewHolder?.findViewById<TextView>(R.id.relet_rent_date_to)
        renewalEndTime?.text = order.end_time

        // 工单提交时间
        val workflow_submit_time = viewHolder?.findViewById<TextView>(R.id.workflow_submit_time)
        workflow_submit_time?.text = order.created_stamp
        //产生费用
        val order_relet_fee = viewHolder?.findViewById<TextView>(R.id.order_relet_fee)
        order_relet_fee?.text = order.total_amount

        LogUtil.e("WorkflowListAdapter onBindRecycleViewHolder  55555***********")

        //底部按钮
        val orderBottom = viewHolder?.findViewById<RelativeLayout>(R.id.item_order_bottom)
        val work_flow_status_imageview = viewHolder?.findViewById<ImageView>(R.id.work_flow_status_imageview)

        orderBottom?.visibility = View.GONE
        LogUtil.e("WorkflowListAdapter order.apply_status = $order.apply_status ")

        when(order.apply_status){
            OrderReletApplyListRowsBean.WORK_LIST_APPLY_STATUS_AUDITING ->{
                orderBottom?.visibility = View.VISIBLE
                LogUtil.e("WorkflowListAdapter WORK_LIST_APPLY_STATUS_AUDITING ")
                val button_orders_item_bottom_right = viewHolder?.findViewById<Button>(R.id.button_orders_item_bottom_right)

                var agreeTitle = ""
                var denyTitle = ""
                when(mOrderActionType){
                    WorkFlowListActivity.PAGE_TYPE_MODIFY -> {
                        agreeTitle = "同意修改"
                        denyTitle = "拒绝修改"
                    }
                    WorkFlowListActivity.PAGE_TYPE_RELET ->{
                        agreeTitle = "同意续租"
                        denyTitle = "拒绝续租"
                    }
                    WorkFlowListActivity.PAGE_TYPE_ADVANCE ->{
                        agreeTitle = "同意还车"
                        denyTitle = "拒绝还车"
                    }
                }
                button_orders_item_bottom_right?.text =agreeTitle
//                button_orders_item_bottom_right?.text = if(mOrderActionType == WorkFlowListActivity.PAGE_TYPE_MODIFY)
//                    "同意修改" else "同意续租"
                button_orders_item_bottom_right?.setOnClickListener {
                    LogUtil.e("WorkflowListAdapter button_orders_item_bottom_right?.setOnClickListener ")
                    mBottomButtonListener?.onApproveClicked(order, order.amount)
                }
                val button_orders_item_bottom_left = viewHolder?.findViewById<Button>(R.id.button_orders_item_bottom_left)
                button_orders_item_bottom_left?.text = denyTitle
//                button_orders_item_bottom_left?.text = if(mOrderActionType == WorkFlowListActivity.PAGE_TYPE_MODIFY)
//                    "拒绝修改" else "拒绝续租"
                button_orders_item_bottom_left?.setOnClickListener {
                    LogUtil.e("WorkflowListAdapter button_orders_item_bottom_left?.setOnClickListener ")
                    mBottomButtonListener?.onRejectClicked(order, order.amount)
                }

            }
            OrderReletApplyListRowsBean.WORK_LIST_APPLY_STATUS_CANCEL->{
                work_flow_status_imageview?.setBackgroundResource(R.mipmap.work_flow_cancel)
            }
            OrderReletApplyListRowsBean.WORK_LIST_APPLY_STATUS_AUDITED->{
                work_flow_status_imageview?.setBackgroundResource(R.mipmap.work_flow_approved)
            }
            OrderReletApplyListRowsBean.WORK_LIST_APPLY_STATUS_REJECT->{
                work_flow_status_imageview?.setBackgroundResource(R.mipmap.work_flow_rejected)
            }
        }

    }

    /**
     * 订单title标红
     * 当处于待交车&& 已经超过交车时间的订单
     * */
    private fun redTagInfo(layoutOrderInfo: LinearLayout?, orderNo: TextView?, orderChannel: TextView?, orderState: TextView?, order: OrderReletApplyListRowsBean) {

        val nowTime = System.currentTimeMillis()
        val startTime = getDateTime(order.start_time ?: "")
        val endTime = getDateTime(order.end_time ?: "")
        if ((order.status == OrderReletApplyListRowsBean.ORDER_ILLEGAL_PAYED && nowTime > startTime)
                || (order.status == OrderReletApplyListRowsBean.ORDER_EXECUTING && nowTime > endTime)) {
            layoutOrderInfo?.setBackgroundResource(R.color.color_6)
            orderNo?.setTextColor(ContextCompat.getColor(context, R.color.color_0))
            orderChannel?.setTextColor(ContextCompat.getColor(context, R.color.color_0))
            orderState?.setTextColor(ContextCompat.getColor(context, R.color.color_0))
        } else {
            layoutOrderInfo?.setBackgroundResource(R.color.color_0)
            orderNo?.setTextColor(ContextCompat.getColor(context, R.color.color_5))
            orderChannel?.setTextColor(ContextCompat.getColor(context, R.color.color_3))
            orderState?.setTextColor(ContextCompat.getColor(context, R.color.color_D32928))
        }
    }

    private fun getDateTime(date: String): Long {
        val sdf = SimpleDateFormat("yyyy-MM-dd HH:mm")
        return try {
            val d = sdf.parse(date)
            d.time
        } catch (ex: Exception) {
            0
        }
    }

    /**
     * 拨打客户电话
     * */
//    private fun onUserPhone(phone: String) {
////        if (context is FragmentActivity) {
////            DialogUtil.onSiteDial(context, phone)
////        }
////    }

    interface BottomButtonListener{
        fun onApproveClicked(orderReletApplyListRowsBean: OrderReletApplyListRowsBean,amount:Int)
        fun onRejectClicked(orderReletApplyListRowsBean: OrderReletApplyListRowsBean,amount:Int)
    }

    private fun getUserName(name: String): String {
        val sb = StringBuilder()
        if (TextUtils.isEmpty(name))
            return ""
        if (name.length > 7) {
            sb.append(name.substring(0, 8))
            sb.append("...")
        } else {
            sb.append(name)
        }
        return sb.toString()
    }

    /**
     * 拨打客户电话
     * */
    private fun onUserPhone(phone: String) {
        if (context is FragmentActivity) {
            DialogUtil.onSiteDial(context, phone)
        }
    }
}
