package com.jiaoyinbrother.monkeyking.manager.fragment


import android.arch.lifecycle.Observer
import android.content.ClipData
import android.content.ClipboardManager
import android.content.Context
import android.content.Intent
import android.graphics.drawable.Drawable
import android.os.Bundle
import android.support.v7.widget.LinearLayoutManager
import android.text.TextUtils
import android.view.Gravity
import android.view.View
import android.view.ViewGroup
import android.view.WindowManager
import android.widget.LinearLayout
import android.widget.ScrollView
import android.widget.TextView
import com.bumptech.glide.Glide
import com.bumptech.glide.load.resource.bitmap.CircleCrop
import com.bumptech.glide.request.RequestOptions
import com.camnter.easyrecyclerview.adapter.EasyRecyclerViewAdapter
import com.camnter.easyrecyclerview.holder.EasyRecyclerViewHolder
import com.jeremyliao.livedatabus.LiveDataBus
import com.jiaoyinbrother.monkeyking.manager.CarEntity
import com.jiaoyinbrother.monkeyking.manager.Constants
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.activity.*
import com.jiaoyinbrother.monkeyking.manager.activity.CouponsManageActivity
import com.jiaoyinbrother.monkeyking.manager.jpush.MKPushUtil
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.feedback.FeedbackActivity
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.login.LoginActivity
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.mywallet.MyWalletActivity
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.setting.SettingActivity
import com.jiaoyinbrother.monkeyking.manager.util.H5Utils
import com.jiaoyinbrother.monkeyking.manager.util.MKUtil
import com.jiaoyinbrother.monkeyking.manager.util.SharedPreferencesUtil
import com.jiaoyinbrother.monkeyking.manager.view.IOSdialog.IOSAlertDialog
import com.jiaoyinbrother.monkeyking.manager.view.NotifyingScrollView
import com.jiaoyinbrother.monkeyking.manager.wxutil.WXUitls
import com.jiaoyinbrother.library.base.BaseFragment
import com.jiaoyinbrother.library.bean.AccountResult
import com.jiaoyinbrother.library.bean.UnreadMessagesBean
import com.jiaoyinbrother.library.bean.UserDetailResult
import com.jiaoyinbrother.library.presenter.UserDetailPresenter
import com.jiaoyinbrother.library.util.*
import com.jiaoyinbrother.library.view.IGeneralModel
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.price.batch.PriceBatchActivity
import com.jiaoyinbrother.monkeyking.manager.util.DialogUtil
import com.sensorsdata.analytics.android.sdk.SensorsDataAPI
import kotlinx.android.synthetic.main.fragment_rental_my.*
import kotlinx.android.synthetic.main.fragment_rental_my_refreshview.*
import org.json.JSONException
import org.json.JSONObject
import java.util.*


/**
 * Created by Administrator on 2018/3/26.
 */


class RentalMyFragment : BaseFragment(), View.OnClickListener, EasyRecyclerViewHolder.OnItemClickListener {
    override fun updataFragment() {
    }

    private var mMonkeyMainTitleDrawable: Drawable? = null

    private val ITEM_BALANCE = 0
    private val ITEM_WUKONG_COIN = 1
    private val ITEM_COUPON = 2
    private val ITEM_POINT = 3  //积分

    private lateinit var mWalletAdapter: WalletAdapter
    private var userDetailResult: UserDetailResult? = null
    private var spTools: SharePreferenceTools? = null

    override fun getLayoutId(): Int {
        return R.layout.fragment_rental_my_refreshview
    }

    override fun initViews(view: View?, savedInstanceState: Bundle?) {


    }

    override fun initToolbar(savedInstanceState: Bundle?) {

    }


    override fun initData() {
        spTools = SharePreferenceTools(mActivity)
//顶部渐变
        notify_scrollview.smoothScrollTo(0, 0);
        ivTitleContent.alpha = 0.0f
        mMonkeyMainTitleDrawable = resources.getDrawable(R.color.color_rental_my_title_background)
        mMonkeyMainTitleDrawable?.alpha = 0
        title.setBackgroundDrawable(mMonkeyMainTitleDrawable)


        val manager = object : LinearLayoutManager(mActivity) {
            override fun canScrollHorizontally(): Boolean {
                return false
            }
        }
        manager.orientation = LinearLayoutManager.HORIZONTAL
        recyclerview_wallet.layoutManager = manager
        mWalletAdapter = WalletAdapter(mActivity)

        val list = Arrays.asList("账户余额", "悟空币", "优惠券", "可用积分")
        mWalletAdapter.list = list;
        recyclerview_wallet.adapter = mWalletAdapter;

//        无消息
        refreshMsgImg(false)

        refreshUserDetail()

//        LiveDataBus.get().with(ConstantsUtil.LIVEDATA_LOGIN).observeSticky(_mActivity, Observer {
//            refreshUserDetail()
//        })
        LiveDataBus.get().with(ConstantsUtil.LIVEDATA_LOGOUT).observe(mActivity, Observer {
            //Logout,清空数据
            userDetailResult = null
            updateLogoutView()
        })


    }

    private fun updateView() {
        val userUtil = UserUtil(mActivity)
        if (userUtil.isLogin() && userDetailResult != null) {
            updateLoginView(userDetailResult)
        } else {
            updateLogoutView()
        }

    }

    override fun onResume() {
        super.onResume()

        if (userDetailResult == null)
            refreshUserDetail()
    }

    override fun initListeners() {
        mWalletAdapter.setOnItemClickListener(this);

        imageview_head.setOnClickListener(this)
        relativelayout_invite.setOnClickListener(this)
        relativelayout_setting.setOnClickListener(this)
        relativelayout_feedback.setOnClickListener(this)
        msg_indicator_imageview.setOnClickListener(this)
        textview_user_id.setOnClickListener(this)
        my_wallet_linearlayout.setOnClickListener(this)

        notify_scrollview.setOnScrollChangedListener(MyScrollListener())

    }


    override fun onClick(v: View?) {
        val bundle = Bundle()
        when (v?.id) {
            R.id.textview_user_id -> {
                StatisticsUtil.onEvent(mActivity, ConstantsUtil.MINE_SETTINGS_OPEN_LOGIN, "")
                handlePersonInfo(bundle)
            }
            R.id.imageview_head -> {
                StatisticsUtil.onEvent(mActivity, ConstantsUtil.MINE_SETTINGS_OPEN_LOGIN, "")
                handlePersonInfo(bundle)
            }
            R.id.my_wallet_linearlayout -> {
//                我的钱包
                bundle.putSerializable(MyWalletActivity.USER_DETAIL, userDetailResult)
                onStartActivity(bundle, MyWalletActivity::class.java)
            }
            R.id.relativelayout_invite -> {
                LogUtil.e("邀请朋友")
                onStartActivity(bundle, InviteFriendActivity::class.java)
            }
            R.id.relativelayout_feedback -> {
                LogUtil.e("反馈")
                StatisticsUtil.onEvent(mActivity, ConstantsUtil.MINE_SETTINGS_FEEDBACK, "")
                onStartActivity(bundle, FeedbackActivity::class.java)
                SensorsDataAPI.sharedInstance().setViewID(relativelayout_feedback, "mine_feedback")

            }
            R.id.relativelayout_setting -> {
                onStartActivityForResult(bundle, SettingActivity::class.java)
                SensorsDataAPI.sharedInstance().setViewID(relativelayout_setting, "mine_settting")
            }
            R.id.msg_indicator_imageview -> {
                if (userDetailResult == null)
                    bundle.putSerializable("Unread_Message", ArrayList<UnreadMessagesBean>())
                else
                    bundle.putSerializable("Unread_Message", userDetailResult?.unread_messages)
                onStartActivity(bundle, MessageManageActivity::class.java)
            }

        }

    }

    private fun copyAndStartWeixin() {
        //获取剪贴板管理器：
        val cm = mActivity.getSystemService(Context.CLIPBOARD_SERVICE) as ClipboardManager?
        // 创建普通字符型ClipData
        val mClipData = ClipData.newPlainText("Label", "悟空租车")
        // 将ClipData内容放到系统剪贴板里。
        cm?.setPrimaryClip(mClipData)

        showToast("已复制到剪贴板")
        WeChatUtil(mActivity).launcherWx()
    }

    private fun handlePersonInfo(bundle: Bundle) {
        LogUtil.e("个人信息")
        val intent = Intent(mActivity, PersonalInfoActivity::class.java)
        intent.putExtra("PersonInfo", userDetailResult)
        startActivityForResult(intent, ConstantsUtil.USER_INFO_REFRESH)
//        bundle.putSerializable("PersonInfo", userDetailResult)
//        onStartActivity(bundle, PersonalInfoActivity::class.java)
    }

    override fun onItemClick(convertView: View?, position: Int) {
        val bundle = Bundle()
        when (position) {
            ITEM_BALANCE -> {
                /* 账户详情 */
                LogUtil.e("余额")
                onStartActivity(bundle, AccountDetailActivity::class.java)
            }
            ITEM_WUKONG_COIN -> {
                /* 悟空币 */
                LogUtil.e("悟空币")
                if (userDetailResult != null) {
                    bundle.putString(MyWookongCoinActivity.WKCOIN, userDetailResult?.account?.wkcoin.toString())
                    if (userDetailResult?.account?.wkcoin_transfer != null)
                        bundle.putInt(MyWookongCoinActivity.WKCOIN_TRANSFER, userDetailResult?.account?.wkcoin_transfer!!)
                }
                onStartActivity(bundle, MyWookongCoinActivity::class.java)
            }
            ITEM_COUPON -> {
                /* 优惠券 */
                LogUtil.e("优惠券")
                onStartActivity(bundle, CouponsManageActivity::class.java)
            }
            ITEM_POINT -> {
                /* 积分 */
                onStartActivity(bundle, MyIntergralActivity::class.java)
            }
        }
    }

    private inner class MyScrollListener : NotifyingScrollView.OnScrollChangedListener {

        override fun onScrollChanged(who: ScrollView, l: Int, t: Int, oldl: Int, oldt: Int) {

            var headerHeight = (rental_my_banner.height - title.height) / 3
            val ratio = Math.min(Math.max(t, 0), headerHeight).toFloat() / headerHeight
            val newAlpha = ratio * 255
            mMonkeyMainTitleDrawable?.alpha = newAlpha.toInt()

            ivTitleContent.visibility = View.VISIBLE
            msg_indicator_imageview.alpha = 1 - ratio
            ivTitleContent.alpha = ratio
        }
    }


    private fun getUserDetailSuccess(result: UserDetailResult) {
        if (result.errCode == -1) {
            if (result.code == CarEntity.SUCC) {
                userDetailResult = result
                updateSharePrefAndJPush(result)
                updateLoginView(result)
            } else {
                OldToastUtil.show(mActivity, result.msg)
            }
        } else {
            OldToastUtil.showerror(mActivity, result.errCode)
        }
    }

    private fun updateSharePrefAndJPush(result: UserDetailResult) {
        var userUtil = UserUtil(mActivity)
        userUtil.userDetail = Util.entityToJson(result)
        MKUtil.saveUserInfo(result.name, result.uid, result.id_no)
        if (!TextUtils.isEmpty(result.name)) {
            if (!TextUtils.isEmpty(userUtil.userName)) {// 姓名
                userUtil.userName = result.name
            }
        }
        if (!TextUtils.isEmpty(result.birthday)) {
            userUtil.userBirth = result.birthday
        }
        if (!TextUtils.isEmpty(result.nickname)){
            userUtil.nikeName = result.nickname
        }
        if (!TextUtils.isEmpty(result.gender)) {
            userUtil.userGender = result.gender
        }
        if (!TextUtils.isEmpty(result.uid)) {
            // 手机号
            userUtil.uid = result.uid
        }
        if (!TextUtils.isEmpty(result.rolename)) {
            userUtil.userRoleName = result.rolename
        }
        if (result.role >= 0) {
            userUtil.userRole = result.role
        }
        if (!TextUtils.isEmpty(result.headimg_url)) {
            MKUtil.saveHeadImage(result.headimg_url, mActivity)
        } else {
        }
        MKPushUtil.updateJPush(mActivity)// Jpush

//        update神策
        try {
            val properties = JSONObject()
            // 设定用户性别属性 "Sex" 为 "Male"

            properties.put("registerTime", DateTimeUtil.stringToDateHHMM(result.create_time))
            // 设定用户年龄属性 "Age" 为 18
            properties.put("userAuthStatus", result.auth.status_code)
            properties.put("userRole", result.role)

            // 设定用户属性
            SensorsDataAPI.sharedInstance().profileSet(properties)
        } catch (e: JSONException) {

        }

    }


    private fun updateLoginView(result: UserDetailResult?) {
        if (result == null || mActivity == null)
            return

        val spUtil = SharedPreferencesUtil.getInstance()
        val userUtil = UserUtil(mActivity)
        val head_img_url = SharedPreferencesUtil.getInstance()
                .getString("head_img" + userUtil.uid)

        Glide.with(this).load(head_img_url).placeholder(R.mipmap.icon_default_head)
                .apply(RequestOptions.bitmapTransform(CircleCrop()))
                .into(imageview_head)

        textview_level_name.text = userUtil.userRoleName
        textview_level_name.visibility = View.VISIBLE
        if (!TextUtils.isEmpty(userUtil.userName))
            textview_user_id.text = userUtil.userName
        else
            textview_user_id.text = userUtil.uid

        //暂时隐藏掉‘邀请朋友’
        relativelayout_invite.visibility = View.GONE

        if (result?.account != null)
            mWalletAdapter.setAccount(result?.account)

        checkMsg(result)

    }


    private fun updateLogoutView() {
        userDetailResult = null
        if (imageview_head == null)
            return

        Glide.with(this).load(R.mipmap.icon_default_head).placeholder(R.mipmap.icon_default_head)
                .apply(RequestOptions.bitmapTransform(CircleCrop()))
                .into(imageview_head)


        textview_level_name.visibility = View.INVISIBLE

        textview_user_id.text = "登录 | 注册"

        relativelayout_invite.visibility = View.GONE
        refreshMsgImg(false)

        var account = AccountResult()
        account.total_amount = 0f
        account.wkcoin = 0
        account.coupon = 0
        account.jf = 0
        mWalletAdapter.setAccount(account)

    }


    private fun checkMsg(result: UserDetailResult?) {
        if (result != null) {
            val isHasNew = result.unread_messages != null && result.unread_messages.size > 0
            refreshMsgImg(isHasNew)
        }
    }

    /**
     * 消息按钮变换状态
     */
    private fun refreshMsgImg(isHasNewMessage: Boolean) {
        if (isHasNewMessage) {
            msg_indicator_imageview.setBackgroundResource(R.mipmap.icon_have_msg)
        } else {
            msg_indicator_imageview.setBackgroundResource(R.mipmap.icon_no_msg)
        }
    }

    private fun onStartActivity(data: Bundle?, cls: Class<*>) {
        var intent: Intent?

        if (UserUtil(mActivity).isLogin()) {
            intent = Intent(mActivity, cls)
            if (data != null)
                intent.putExtras(data)
            startActivity(intent)
        } else {
            intent = Intent(mActivity, LoginActivity::class.java)
            intent.putExtra("entrance", "我的")
            startActivityForResult(intent, Constants.LOGIN_RESULT)
        }
    }

    private fun onStartActivityForResult(data: Bundle?, cls: Class<*>) {
        var intent: Intent?

        if (UserUtil(mActivity).isLogin()) {
            intent = Intent(mActivity, cls)
            if (data != null)
                intent.putExtras(data)
            startActivityForResult(intent, Constants.LOGOUT_REQUEST)
        } else {
            intent = Intent(mActivity, LoginActivity::class.java)
            intent.putExtra("entrance", "我的")
            startActivityForResult(intent, Constants.LOGIN_RESULT)
        }
    }


    private fun refreshUserDetail() {
        var userUtil = UserUtil(mActivity)
        if (userUtil.isLogin()) {

            showLoadingDialog()

            var userDetailModel = UserDetailPresenter()
            userDetailModel.getUserDetail(mActivity, userUtil.getUserRequest(), UserDetailResult::class.java, object : IGeneralModel {
                override fun getCodeBeanFail(errorCode: Int) {
                    dismissLoadingDialog()
                    showErrorToast(errorCode)
//                不刷新，则为null
                    updateView()
                }

                override fun getCodeObjectSuccess(bean: Any) {
                    dismissLoadingDialog()
                    getUserDetailSuccess(bean as UserDetailResult)
                }
            })
        } else {
            updateView()
        }

    }

    //钱包adapter
    inner class WalletAdapter(val context: Context) : EasyRecyclerViewAdapter() {
        private var mScreenWidth = 0
        private var account: AccountResult? = null

        override fun getItemLayouts(): IntArray {
            val wm = context.getSystemService(Context.WINDOW_SERVICE) as WindowManager
            mScreenWidth = wm.defaultDisplay.width

            return intArrayOf(R.layout.item_wallet)
        }

        override fun getRecycleViewItemType(position: Int): Int {
            return 0
        }

        override fun onBindRecycleViewHolder(viewHolder: EasyRecyclerViewHolder?, position: Int) {
            val wallet_linear = viewHolder?.findViewById<LinearLayout>(R.id.wallet_linear)

            val width = (mScreenWidth - 2 * DensityUtil.dip2px(context, 10f)) / 4
            val layoutParams = LinearLayout.LayoutParams(width, ViewGroup.LayoutParams.WRAP_CONTENT)
            wallet_linear?.gravity = Gravity.CENTER
            wallet_linear?.layoutParams = layoutParams

            val mTitle = list[position] as String
            val tv_title = viewHolder?.findViewById<TextView>(R.id.tv_title)
            tv_title?.text = mTitle

            val tv_count = viewHolder?.findViewById<TextView>(R.id.tv_count)

//            解决 null元 问题；
            if (account == null)
                return

            when (position) {
                ITEM_BALANCE -> tv_count?.text = account?.total_amount?.toInt().toString() + "元"
                ITEM_WUKONG_COIN -> tv_count?.text = account?.wkcoin.toString() + "个"
                ITEM_COUPON -> tv_count?.text = account?.coupon.toString() + "张"
                ITEM_POINT -> tv_count?.text = account?.jf.toString()
            }
        }

        fun setAccount(account: AccountResult) {
            this.account = account
            notifyDataSetChanged()
        }

    }


    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        LogUtil.e("onActivityResult -----------——>>>>>> Fragment")
        if (requestCode == ConstantsUtil.USER_INFO_REFRESH) refreshUserDetail()
    }
}
