package com.jiaoyinbrother.monkeyking.manager.fragment.mainordermanager

import android.Manifest
import android.arch.lifecycle.Observer
import android.content.Intent
import android.os.Bundle
import android.support.v4.app.FragmentActivity
import android.support.v7.widget.GridLayoutManager
import android.view.View
import com.jeremyliao.livedatabus.LiveDataBus
import com.jiaoyinbrother.library.bean.MainListItemBean
import com.jiaoyinbrother.library.bean.ManagerGetTaskResult
import com.jiaoyinbrother.library.util.LogUtil
import com.jiaoyinbrother.library.util.UserUtil
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.adapter.MainFragmentOrderStatusAdapter
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseFragment
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.commentlist.CommentListActivity
import com.jiaoyinbrother.monkeyking.manager.util.DialogUtil
import com.jiaoyinbrother.monkeyking.manager.util.MediaPlayerUtil
import com.jiaoyinbrother.monkeyking.manager.util.NotifyUtil
import com.tbruyelle.rxpermissions2.RxPermissions
import kotlinx.android.synthetic.main.fragment_main_order_manager_new.*


class MaiOrderManagerFragment: MvpBaseFragment<MainOrderManagerPresenter>(), IMainOrderManagerContract.View,
        View.OnClickListener {


    private var mOrderAdapter:MainFragmentOrderStatusAdapter? = null
    private var mWorkFlowAdapter:MainFragmentOrderStatusAdapter? = null

    override fun setCommentDialog(notice: String) {
        // 播放语音
        val mediaPlay = MediaPlayerUtil.getInstance()
        mediaPlay.playFromRawFile(mActivity, R.raw.android_comment)
        DialogUtil.onMainCommentDialog(mActivity,notice,object : DialogUtil.OnDialogClickListener{
            override fun onLeft() {
            }

            override fun onRight() {

                val intent = Intent(mActivity, CommentListActivity::class.java)
                intent.putExtra(CommentListActivity.COMMENT_TITLE_VISIBLE,0)
                intent.putExtra(CommentListActivity.COMMENT_TITLE_DEFAULT_CHECK,4)
                startActivity(intent)
            }

        })
    }
    companion object {
        const val ORDER_TASKSNUM = "ORDER_TASKSNUM"
    }

    override fun setManagerTaskNum(result: ManagerGetTaskResult) {

    }

    override fun setOrderTaskList(list:List<MainListItemBean>){
        LogUtil.e("setOrderTaskList list=$list")
        mOrderAdapter?.list = list
        mOrderAdapter?.notifyDataSetChanged()
    }

    override fun setWorkFlowTaskList(list: List<MainListItemBean>) {
        LogUtil.e("setWorkFlowTaskList list=$list")
        mWorkFlowAdapter?.list = list
        mWorkFlowAdapter?.notifyDataSetChanged()
    }

    override fun initPresenter(): MainOrderManagerPresenter {
        return MainOrderManagerPresenter(_mActivity, this)
    }

    override fun onClick(v: View?) {
    }


    override fun getLayoutId(): Int {
        return R.layout.fragment_main_order_manager_new
    }

    override fun initViews(view: View, savedInstanceState: Bundle?) {

    }

    override fun initToolbar(savedInstanceState: Bundle?) {

    }

    override fun initListeners() {
        mOrderAdapter?.setOnItemClickListener { convertView, position ->
            presenter?.onOrderListItemClicked(position)
        }
        mWorkFlowAdapter?.setOnItemClickListener { convertView, position ->
            presenter?.onWorkListItemClicked(position)
        }
    }

    override fun initData() {
        LiveDataBus.get().with(ORDER_TASKSNUM).observe(this, Observer {
            refreshMsg()
        })

        val gridManager = GridLayoutManager(mActivity, 3)
        mOrderAdapter = MainFragmentOrderStatusAdapter(mActivity)
        order_status_recycler_view?.layoutManager = gridManager
        order_status_recycler_view?.adapter = mOrderAdapter

        val workListGridManager = GridLayoutManager(mActivity, 3)
        mWorkFlowAdapter = MainFragmentOrderStatusAdapter(mActivity)
        work_flow_status_recycler_view?.layoutManager = workListGridManager
        work_flow_status_recycler_view?.adapter = mWorkFlowAdapter

        presenter.initData()


        RxPermissions(this).request(Manifest.permission.ACCESS_COARSE_LOCATION, Manifest.permission.ACCESS_FINE_LOCATION)
                .subscribe { aBoolean ->
                    if (aBoolean == true) {
                        LogUtil.e("定位授权成功")
                    } else {
                        LogUtil.e("定位授权失败")
                    }
                }
    }

    override fun onResume() {
        super.onResume()
        refreshMsg()
    }

    private var isUserVisible = false

    override fun setUserVisibleHint(isVisibleToUser: Boolean) {
        super.setUserVisibleHint(isVisibleToUser)
        isUserVisible = isVisibleToUser
    }

    private fun refreshMsg() {
        if (UserUtil(activity as FragmentActivity).isLogin() && isUserVisible) {
            presenter.requestGetManagerTask()
        }
    }


}

