package com.jiaoyinbrother.monkeyking.manager.fragment.ordercancelworkflowlist

import android.os.Bundle
import android.view.View
import com.jiaoyinbrother.library.bean.OrderCancelWorkListRowBean
import com.jiaoyinbrother.library.bean.OrderReletApplyListRowsBean
import com.jiaoyinbrother.library.util.LogUtil
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.adapter.OrderCancelWorkFlowListAdapter
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseFragment
import com.jiaoyinbrother.monkeyking.manager.util.PhoneConvertUtil
import com.jiaoyinbrother.monkeyking.manager.util.WkAlertDialogFactory
import kotlinx.android.synthetic.main.fragment_workflow_list.*

class OrderCancelWorkFlowListFragment: MvpBaseFragment<OrderCancelWorkFlowListPresenter>(),
        IOrderCancelWorkFlowListContract.View {

    private var mListAdapter: OrderCancelWorkFlowListAdapter? = null

    override fun initListeners() {
        refresh_layout?.setOnRefreshListener {
            presenter?.onRefresh()
        }
        refresh_layout?.setOnLoadMoreListener {
            presenter?.onLoadMore()
        }

        loading_layout?.setRetryListener {
            presenter?.onRefresh()
            LogUtil.e("setRetryListener called")
        }

        mListAdapter?.setOnItemClickListener { convertView, position ->
            //目前无反应
//            val order = mListAdapter?.getItem<OrderCancelWorkListRowBean>(position)
//            if(order?.order_id!=null)
//                presenter?.onItemClicked(order.order_id)
        }

        mListAdapter?.setOnBottomClickListener(object:OrderCancelWorkFlowListAdapter.BottomButtonListener{
            override fun onChargeClicked(orderCancelWorkListRowBean: OrderCancelWorkListRowBean){
                LogUtil.e("onApproveClicked")
                presenter?.onChargeClicked(orderCancelWorkListRowBean.workcard_id)
            }

            override fun onFreeClicked(orderCancelWorkListRowBean: OrderCancelWorkListRowBean) {
                presenter?.onFreeClicked(orderCancelWorkListRowBean.workcard_id)
            }

        })
//        mListAdapter?.mOnPhoneListener = { order ->
//            WkAlertDialogFactory.createFactory(requireContext()).getVirtualPhoneAlertDialog({
//                PhoneConvertUtil.getInstance()?.apiPhoneConvert(requireContext(), order?.member_phone ?: "", null, this, presenter)
//            },{})
//        }
    }

    override fun initPresenter(): OrderCancelWorkFlowListPresenter {
        return OrderCancelWorkFlowListPresenter(_mActivity,this)
    }

    override fun getLayoutId(): Int {
        return R.layout.fragment_workflow_list
    }

    override fun initViews(view: View?, savedInstanceState: Bundle?) {

    }

    override fun initToolbar(savedInstanceState: Bundle?) {

    }

    override fun initData() {
        loading_layout?.setEmptyText("您还没有工单")

        //初始化adapter/listview
        mListAdapter = OrderCancelWorkFlowListAdapter(mActivity)
        recycler_view?.adapter = mListAdapter

        //获取数据
        presenter.getIntentData(arguments)
        refresh_layout?.autoRefresh()
    }

    override fun finishRefresh() {
        refresh_layout?.finishRefresh()
    }

    override fun finishLoadMore() {
        refresh_layout?.finishLoadMore()
    }

    override fun finishLoadMoreWithNoMoreData() {
        refresh_layout?.finishLoadMoreWithNoMoreData()
    }

    override fun finishRefreshWithNoMoreData() {
        refresh_layout?.finishRefreshWithNoMoreData()
    }

    override fun setEnableLoadMore(b: Boolean) {
        refresh_layout?.setEnableLoadMore(b)
    }

    override fun showListData(list: List<OrderCancelWorkListRowBean>) {
        loading_layout?.showContent()
        mListAdapter?.list = list
        mListAdapter?.notifyDataSetChanged()
    }

    override fun showNoDataView() {
        setEnableLoadMore(false)
        loading_layout?.showEmpty()
    }

    override fun showNoNetView() {
        setEnableLoadMore(false)
        loading_layout?.showError()
    }


    override fun updataFragment() {
        presenter?.onRefresh()
    }

    fun onSort(type: Int?, b: Boolean) {
        presenter?.onSort(type,b)
    }


}
