package com.jiaoyinbrother.monkeyking.manager.fragment.workflowlist

import android.os.Bundle
import com.jiaoyinbrother.library.base.IBasePresenter
import com.jiaoyinbrother.library.base.OrderBaseBean
import com.jiaoyinbrother.library.bean.OrderReletApplyListRowsBean
import com.jiaoyinbrother.library.bean.SpiderListItemBean
import com.jiaoyinbrother.library.view.IBaseView

class IWorkflowListContract {
    interface View : IBaseView {
        fun finishRefresh()
        fun finishLoadMore()
        fun finishLoadMoreWithNoMoreData()
        fun finishRefreshWithNoMoreData()
        fun setEnableLoadMore(b: Boolean)

        fun showListData(list: List<OrderReletApplyListRowsBean>)

        /**
         * 异常价格工单列表
         */
        fun showSpiderListData(list: List<SpiderListItemBean>)
        fun showNoDataView()
        fun showNoNetView()

    }

    interface Presenter : IBasePresenter {
        fun getIntentData(arguments: Bundle?)

        fun onItemClicked(orderReletID: Int)
        fun onApproveWorkflow(orderReletID: Int, amount: Int)
        fun onDenyWorkflow(orderReletID: Int, amount: Int)

        fun onRefresh()
        fun onLoadMore()

        fun onSort(type: Int?, b: Boolean)

        fun getOrderType(): Int

        /**
         * 处理异常价格工单
         */
        fun apiSpiderDeal(site_car_type_id: Int, status: String, id: Int)

    }
}
