package com.jiaoyinbrother.monkeyking.manager.fragment.workflowlist

import android.content.Intent
import android.os.Bundle
import android.view.View
import com.jiaoyinbrother.library.bean.OrderReletApplyListRowsBean
import com.jiaoyinbrother.library.bean.SpiderListItemBean
import com.jiaoyinbrother.library.util.LogUtil
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.adapter.SpiderListAdapter
import com.jiaoyinbrother.monkeyking.manager.adapter.WorkflowListAdapter
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseFragment
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.price.PriceSetActivity
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.workflowlist.WorkFlowListActivity
import com.jiaoyinbrother.monkeyking.manager.util.PhoneConvertUtil
import com.jiaoyinbrother.monkeyking.manager.util.WkAlertDialogFactory
import com.jiaoyinbrother.monkeyking.manager.view.IOSdialog.IOSAlertDialog
import kotlinx.android.synthetic.main.fragment_workflow_list.*
import me.yokeyword.fragmentation.ISupportFragment

class WorkflowListFragment : MvpBaseFragment<WorkflowListPresenter>(), IWorkflowListContract.View, View.OnClickListener {

    private var mListAdapter: WorkflowListAdapter? = null

    private var mSpiderListAdapter: SpiderListAdapter? = null

    override fun setEnableLoadMore(b: Boolean) {
        refresh_layout?.setEnableLoadMore(b)
    }

    override fun showListData(list: List<OrderReletApplyListRowsBean>) {
        loading_layout?.showContent()
        mListAdapter?.list = list
        mListAdapter?.notifyDataSetChanged()
    }

    override fun showSpiderListData(list: List<SpiderListItemBean>) {
        loading_layout?.showContent()
        mSpiderListAdapter?.list = list
        mSpiderListAdapter?.notifyDataSetChanged()
    }

    override fun showNoDataView() {
        setEnableLoadMore(false)
        loading_layout?.showEmpty()
    }

    override fun showNoNetView() {
        setEnableLoadMore(false)
        loading_layout?.showError()
    }

    override fun finishRefreshWithNoMoreData() {
        refresh_layout?.finishRefreshWithNoMoreData()
    }

    override fun finishLoadMoreWithNoMoreData() {
        refresh_layout?.finishLoadMoreWithNoMoreData()
    }

    override fun finishRefresh() {
        refresh_layout?.finishRefresh()
    }

    override fun finishLoadMore() {
        refresh_layout?.finishLoadMore()
    }

    override fun initPresenter(): WorkflowListPresenter {
        return WorkflowListPresenter(_mActivity, this)
    }

    override fun onClick(v: View?) {

    }

    override fun getLayoutId(): Int {
        return R.layout.fragment_workflow_list
    }

    override fun initViews(view: View?, savedInstanceState: Bundle?) {

    }

    override fun initToolbar(savedInstanceState: Bundle?) {

    }

    override fun initListeners() {

        refresh_layout?.setOnRefreshListener {
            presenter?.onRefresh()
        }
        refresh_layout?.setOnLoadMoreListener {
            presenter?.onLoadMore()
        }

        loading_layout?.setRetryListener {
            presenter?.onRefresh()
            LogUtil.e("setRetryListener called")
        }

        mListAdapter?.setOnItemClickListener { convertView, position ->
            val order = mListAdapter?.getItem<OrderReletApplyListRowsBean>(position)
//            if(order?.order_id!=null)
//                presenter?.onItemClicked(order.order_id)
        }

        mListAdapter?.setOnBottomClickListener(object : WorkflowListAdapter.BottomButtonListener {
            override fun onApproveClicked(orderReletApplyListRowsBean: OrderReletApplyListRowsBean, amount: Int) {
                LogUtil.e("onApproveClicked")
                presenter?.onApproveWorkflow(orderReletApplyListRowsBean.relet_id, amount)
            }

            override fun onRejectClicked(orderReletApplyListRowsBean: OrderReletApplyListRowsBean, amount: Int) {
                presenter?.onDenyWorkflow(orderReletApplyListRowsBean.relet_id, amount)
            }

        })
//        mListAdapter?.mOnPhoneListener = { order ->
//            WkAlertDialogFactory.createFactory(requireContext()).getVirtualPhoneAlertDialog({
//                PhoneConvertUtil.getInstance()?.apiPhoneConvert(requireContext(), order?.telephone ?: "", null, this, presenter)
//            },{})
//        }
        mSpiderListAdapter?.setOnBottomClickListener(object : SpiderListAdapter.BottomButtonListener {
            override fun onRightClicked(site_car_type_id: Int) {
                startActivityForResult(PriceSetActivity.newInstance(requireContext(), site_car_type_id), WorkflowListPresenter.WORK_ORDER_STATUS_FOR_PRICE)
            }

            override fun onLeftClicked(site_car_type_id: Int, id: Int) {
                //暂不处理
                IOSAlertDialog(mActivity).builder().setTitle("温馨提示").setMsg("是否确认不处理今日的异常价格数据", true)
                        .setRightButton("返回") {

                        }.setLeftButton("确认") {

                            // 拒绝
                            presenter.apiSpiderDeal(site_car_type_id, "REJECT", id)
                        }.show()
            }

        })

    }


    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        when {
            data != null && requestCode == WorkflowListPresenter.WORK_ORDER_STATUS_FOR_PRICE && resultCode == RESULT_OK -> {
                // 异常价格返回工单列表刷新
                presenter?.onRefresh()
            }
        }
    }

    override fun initData() {

        loading_layout?.setEmptyText("您还没有工单")

        //获取数据
        presenter.getIntentData(arguments)

        //初始化adapter/listview
        if (arguments?.getInt(WorkFlowListActivity.PAGE_TYPE_KEY) == WorkFlowListActivity.PAGE_TYPE_AUDITING) {

            mSpiderListAdapter = SpiderListAdapter()
            recycler_view?.adapter = mSpiderListAdapter
        } else {

            mListAdapter = WorkflowListAdapter(mActivity)
            recycler_view?.adapter = mListAdapter
            //获取是续租还是修改订单，类型
            mListAdapter?.setAdapterType(presenter.getOrderType())
        }
        refresh_layout?.autoRefresh()
    }

    override fun updataFragment() {
        presenter?.onRefresh()
    }

    fun onSort(type: Int?, b: Boolean) {
        presenter?.onSort(type, b)
    }

}
