package com.jiaoyinbrother.monkeyking.manager.mvpactivity.bigimg

import android.content.Context
import android.support.v4.view.PagerAdapter
import android.support.v7.app.AppCompatActivity
import android.view.View
import android.view.ViewGroup
import com.github.chrisbanes.photoview.PhotoView
import com.jiaoyinbrother.library.util.LogUtil
import com.jiaoyinbrother.library.util.PhotoUtils

class MyImageAdapter(private val imageUrls: List<String>?, private val context: Context) : PagerAdapter() {

    private var listener: BigImageListener? = null

    override fun instantiateItem(container: ViewGroup, position: Int): Any {
        val url = imageUrls!![position]
        val photoView = PhotoView(context)

        LogUtil.e("instantiateItem, url =$url")
//        Glide.with(activity).load(url).into(photoView)

        PhotoUtils.loadPicIntoImageViewNoCache(
                context,
            url,
            photoView
        )

        container.addView(photoView)
        photoView.setOnClickListener {
            if (listener != null) {
                listener?.onDismiss()
            }
        }
        return photoView
    }

    override fun getCount(): Int {
        return imageUrls?.size ?: 0
    }

    override fun isViewFromObject(view: View, `object`: Any): Boolean {
        return view === `object`
    }

    override fun destroyItem(container: ViewGroup, position: Int, `object`: Any) {
        container.removeView(`object` as View)
    }

    override fun getItemPosition(`object`: Any): Int {
        return POSITION_NONE
    }

    fun setListener(listener: BigImageListener) {
        this.listener = listener
    }


    interface BigImageListener {
        fun onDismiss()
    }

    companion object {

        val TAG = MyImageAdapter::class.java.simpleName
    }
}
