package com.jiaoyinbrother.monkeyking.manager.mvpactivity.billrecord.billRecordUpdate

import android.annotation.SuppressLint
import android.os.Bundle
import android.text.Editable
import android.text.TextUtils
import android.text.TextWatcher
import android.view.View
import android.widget.LinearLayout
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseFragment
import com.jiaoyinbrother.library.bean.BillRecordUpdateRequest
import com.jiaoyinbrother.library.listeners.BillRecordListener
import com.jiaoyinbrother.library.util.ConstantsUtil
import com.jiaoyinbrother.library.util.DensityUtil
import com.jiaoyinbrother.library.widget.GeneralBottomButton.SubmitListener
import kotlinx.android.synthetic.main.fragment_bill_note.*

@SuppressLint("SetTextI18n")
class BillNoteFragment : MvpBaseFragment<BillUpdatePresenter>(), IBillUpdateContract.view {
    override fun initViews(view: View?, savedInstanceState: Bundle?) {

    }

    private var mOrderId: String? = null
    private var mComment: String? = null
    private var mCaching: String? = null
    private var isVisibleToUser = false
    private var listener: BillRecordListener? = null

    override fun setUserVisibleHint(isVisibleToUser: Boolean) {
        super.setUserVisibleHint(isVisibleToUser)
        this.isVisibleToUser = isVisibleToUser
    }

    override fun getLayoutId(): Int {
        return R.layout.fragment_bill_note
    }

    override fun initPresenter(): BillUpdatePresenter {
        return BillUpdatePresenter(mActivity, this)
    }

    override fun initToolbar(savedInstanceState: Bundle?) {}

    override fun initData() {
        mOrderId = arguments?.getString(ConstantsUtil.ORDER_ID)
        onSubmit.disable()
    }

    override fun initListeners() {
        // edit watcher
        etContent.addTextChangedListener(object : TextWatcher {

            override fun afterTextChanged(s: Editable?) {
                val length = s?.length ?: 0
                if (length > 0) onSubmit.normal() else onSubmit.disable()
                limitCount.text = "还可输入${200 - length}个字"
            }

            override fun beforeTextChanged(s: CharSequence?, start: Int, count: Int, after: Int) {}

            override fun onTextChanged(s: CharSequence?, start: Int, before: Int, count: Int) {}
        })

        // submit
        onSubmit.setListener(object : SubmitListener {
            override fun submit() {
                mComment = etContent.text.toString().trim()
                presenter?.requestUpdate(getUpdateRequest())
            }
        })
    }

    private fun getUpdateRequest(): BillRecordUpdateRequest {
        val request = BillRecordUpdateRequest()
        request.order_id = mOrderId
        request.comment = mComment
        return request
    }

    /**
     * 提交成功后隐藏界面view
     * */
    private fun hideView(isHide: Boolean) {
        val margin = DensityUtil.dip2px(activity, 15f)
        if (isHide) {
            val params = LinearLayout.LayoutParams(LinearLayout.LayoutParams.MATCH_PARENT, LinearLayout.LayoutParams.WRAP_CONTENT)
            params.setMargins(margin, margin, margin, margin)
            editBackground.layoutParams = params
            editBackground.background = null
            etContent.isEnabled = false
            limitCount.visibility = View.GONE
            onSubmit.visibility = View.GONE
        } else {
            val params = LinearLayout.LayoutParams(LinearLayout.LayoutParams.MATCH_PARENT, DensityUtil.dip2px(activity, 130f))
            params.setMargins(margin, margin, margin, margin)
            editBackground.layoutParams = params
            editBackground.setBackgroundResource(R.drawable.bg_frame)
            etContent.isEnabled = true
            limitCount.visibility = View.VISIBLE
            onSubmit.visibility = View.VISIBLE
        }
    }

    fun setData(comment: String?) {
        mCaching = comment
        if (TextUtils.isEmpty(comment)) {
            hideView(false)
        } else {
            hideView(true)
            etContent.setText(comment)
        }
    }

    fun setListener(listener: BillRecordListener) {
        this.listener = listener
    }

    fun setDisplayEditing() {
        if (isVisibleToUser && !TextUtils.isEmpty(mCaching))
            listener?.displayEditing(true)
        else
            listener?.displayEditing(false)
    }

    fun setIsEditor(isEditor: Boolean) {
        if (isEditor) {
            hideView(false)
        } else {
            hideView(true)
            etContent.setText(mCaching)
        }
    }

    override fun onSuccess() {
        mCaching = mComment
        hideView(true)
        listener?.editCompleted(true)
    }

}