package com.jiaoyinbrother.monkeyking.manager.mvpactivity.billrecord.billRecordUpdate

import android.Manifest
import android.app.Activity
import android.content.Intent
import android.net.Uri
import android.os.Build
import android.os.Bundle
import android.os.Environment
import android.provider.MediaStore
import android.support.v4.app.FragmentActivity
import android.support.v4.content.FileProvider
import android.support.v7.widget.GridLayoutManager
import android.text.TextUtils
import android.view.View
import com.jiaoyinbrother.monkeyking.manager.CarEntity
import com.jiaoyinbrother.monkeyking.manager.Constants
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.activity.ShowBigImageActivity
import com.jiaoyinbrother.monkeyking.manager.adapter.BillPhotoAdapter
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseFragment
import com.jiaoyinbrother.monkeyking.manager.util.ImageSelectorUtils
import com.jiaoyinbrother.library.bean.BillPhotoBean
import com.jiaoyinbrother.library.bean.BillRecordUpdateRequest
import com.jiaoyinbrother.library.bean.FilesBean
import com.jiaoyinbrother.library.impl.UploadListener
import com.jiaoyinbrother.library.listeners.BillRecordListener
import com.jiaoyinbrother.library.listeners.ViewImageListener
import com.jiaoyinbrother.library.util.*
import com.jiaoyinbrother.library.widget.BottomDialog
import com.jiaoyinbrother.library.widget.GeneralBottomButton.SubmitListener
import com.tbruyelle.rxpermissions2.RxPermissions
import io.reactivex.disposables.Disposable
import kotlinx.android.synthetic.main.fragment_bill.*
import java.io.File
import java.util.*

class BillPhotoFragment : MvpBaseFragment<BillUpdatePresenter>(), IBillUpdateContract.view {


    // constant
    companion object {
        //        private val PATH = BitmapUtil.SYSTEM_BITMAP_PATH
        private val PATH = Environment.getExternalStorageDirectory().toString() + File.separator + Environment.DIRECTORY_DCIM + File.separator

    }

    // variable
    private var mType: String? = null
    private var mOrderID: String? = null
    private var isVisibleToUser = false
    private var isEditing = false

    private var mImages = ArrayList<FilesBean>()
    private var mCaching = ArrayList<FilesBean>()
    private var mAdapter: BillPhotoAdapter? = null
    private var listener: BillRecordListener? = null
    // aliyun util
    private var mUploadUtil: AliYunPictureUtil? = null
    private var imageUri1: Uri? = null
    private var imageUri2: Uri? = null
    private var imageUri3: Uri? = null
    private var imageUri4: Uri? = null
    private var imageUri5: Uri? = null
    private var imageUri6: Uri? = null
    private var imageUri7: Uri? = null
    private var imageUri8: Uri? = null
    private var disposable: Disposable? = null

    override fun setUserVisibleHint(isVisibleToUser: Boolean) {
        super.setUserVisibleHint(isVisibleToUser)
        this.isVisibleToUser = isVisibleToUser
    }

    override fun getLayoutId(): Int {
        return R.layout.fragment_bill
    }

    override fun initViews(view: View?, savedInstanceState: Bundle?) {}

    override fun initPresenter(): BillUpdatePresenter {
        return BillUpdatePresenter(mActivity, this)
    }

    override fun initToolbar(savedInstanceState: Bundle?) {}

    override fun initListeners() {
        // submit
        onSubmit.setListener(object : SubmitListener {
            override fun submit() {
                val postList = ArrayList<String>()
                for (file in mImages) {
                    if (!TextUtils.isEmpty(file.file_uri)) {//
                        postList.add(file.file_uri)
                    }
                }
                if (postList.size > 0) {
                    showLoadingDialog()
                    mUploadUtil?.setDatas(AliYunPictureUtil.BUCKET_TYPE_PUBLIC,postList, AliYunPictureUtil.ORDER_PRINT, uploadListener)
                } else {
                    presenter?.requestUpdate(getUpdateRequest())
                }
            }
        })

        mAdapter?.setListener(object : ViewImageListener {
            override fun showBigImage(position: Int) {
                if (mImages[position].file_path == null) {
                    ShowBigImageActivity.newInstanceUri(mActivity, mImages[position].file_uri, false)
                } else {
                    ShowBigImageActivity.newInstancePath(mActivity, mImages[position].file_path, false)
                }
            }

            override fun showDialog(position: Int) {
                BottomDialog(activity).builder().addItems(arrayOf("拍照", "相册")).setCancel("取消") {}.setItemClick { _, i ->
                    when (i) {
                        // 相机(单选)
                        0 -> {
                            disposable = RxPermissions(context as FragmentActivity).request(Manifest.permission.CAMERA,
                                    Manifest.permission.READ_EXTERNAL_STORAGE, Manifest.permission.WRITE_EXTERNAL_STORAGE).subscribe({ granted ->
                                if (granted) { // Always true pre-M
                                    if (Environment.getExternalStorageState() == Environment.MEDIA_MOUNTED) {
                                        val file = File(PATH)
                                        if (!file.exists()) file.mkdir()
                                        val intent = Intent(MediaStore.ACTION_IMAGE_CAPTURE)
                                        intent.putExtra(MediaStore.EXTRA_OUTPUT, setImageUri(mType, position))
                                        startActivityForResult(intent, position)
                                    }
                                } else {
                                    //permission denied
                                }
                            }, { throwable ->
                                LogUtil.e("RxJava throwable = " + throwable.toString())
                            })


                        }
                        // 相册(支持多选)
                        else -> {
                            if (mImages.size > 1) {
                                ImageSelectorUtils.openPhoto(activity, Constants.REQUEST_PIC, false, 8 - (mImages.size - 1), ArrayList<String>(), mType)
                            } else {
                                ImageSelectorUtils.openPhoto(activity, Constants.REQUEST_PIC, false, 8, null, mType)
                            }
                        }
                    }
                }.show()
            }

            override fun deleteImage(position: Int) {
                mImages.removeAt(position)
                if (mImages.size in 1..7 && (mImages[mImages.size - 1].file_uri != null) || mImages[mImages.size - 1].file_path != null) mImages.add(FilesBean())
                mAdapter?.list = mImages
                billRv.adapter = mAdapter
                if (mImages.size > 0 && mImages[0].file_path == null && mImages[0].file_uri == null)
                    onSubmit.disable()
//                else
//                    onSubmit.normal()
            }
        })
    }

    private fun setImageUri(type: String?, position: Int): Uri? {
        var file = File("${PATH}_${type}_$position.jpg")
        var uri: Uri?
        try {
            uri = Uri.fromFile(file)
            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.N) {
                uri = FileProvider.getUriForFile(mActivity, mActivity.packageName + ".fileProvider", file)
            }
            LogUtil.e("getUriFromFile uri->" + uri.toString())
        } catch (e: Exception) {
            LogUtil.e("PackageName错误-----" + e.toString())
            uri = null
        }


        when (position) {
            0 -> imageUri1 = uri
            1 -> imageUri2 = uri
            2 -> imageUri3 = uri
            3 -> imageUri4 = uri
            4 -> imageUri5 = uri
            5 -> imageUri6 = uri
            6 -> imageUri7 = uri
            7 -> imageUri8 = uri
        }
        return uri
    }

    private fun getUriPath(position: Int): String? {
        return when (position) {
            0 -> imageUri1?.path
            1 -> imageUri2?.path
            2 -> imageUri3?.path
            3 -> imageUri4?.path
            4 -> imageUri5?.path
            5 -> imageUri6?.path
            6 -> imageUri7?.path
            else -> imageUri8?.path
        }
    }

    private fun getFilePath(position: Int): File {
        return File("${PATH}_${mType}_$position.jpg")
    }

    override fun initData() {
        mOrderID = arguments?.getString(ConstantsUtil.ORDER_ID)
        mType = arguments?.getString("BILL_TYPE")
        onSubmit.disable()
        // RecyclerView
        val layoutManager = GridLayoutManager(activity, 2, GridLayoutManager.VERTICAL, false)
        billRv.layoutManager = layoutManager
        mAdapter = BillPhotoAdapter(activity)
        // 阿里云
        mUploadUtil = AliYunPictureUtil.getInstance(activity)
    }

    fun setData(list: ArrayList<BillPhotoBean>?) {
        val tempList = ArrayList<FilesBean>()
        if (list != null && list.size > 0) {
            for (result in list) {
                tempList.add(FilesBean(result.file_type, result.file_name, result.file_path))
            }
        }
        mCaching.addAll(tempList)
        mImages.addAll(tempList)
        onSubmit.visibility = if (mCaching.size > 0) View.GONE else View.VISIBLE
        if (mCaching.size > 0) mAdapter?.setEditing(false) else mAdapter?.setEditing(true)
        setViewData()
    }

    fun setDisplayEditing() {
        if (isVisibleToUser && mCaching.size > 0)
            listener?.displayEditing(true)
        else
            listener?.displayEditing(false)
    }

    fun setIsEditor(isEditing: Boolean) {
        this.isEditing = isEditing
        if (isEditing) {
            onSubmit.normal()
            onSubmit.visibility = View.VISIBLE
            if (mImages.size in 1..7 && mImages[mImages.size - 1].file_name != null) mImages.add(FilesBean())
        } else {
            onSubmit.disable()
            onSubmit.visibility = View.GONE
            mImages.clear()
            mImages.addAll(mCaching)
        }
        mAdapter?.setEditing(isEditing)
        setViewData()
    }

    private fun setViewData() {
        if (mImages.size == 0) {
            mImages.add(FilesBean())
        }
        mAdapter?.list = mImages
        billRv.adapter = mAdapter
    }


    fun setListener(l: BillRecordListener) {
        this.listener = l
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        if (data == null) {
            if (resultCode == Activity.RESULT_OK) setImageInfo(requestCode)
        }
    }

    private fun setImageInfo(position: Int) {
        if (mImages.size > position) {
            val compressedImage = PhotoUtils.compressFile(mActivity, getFilePath(position))

            mImages[position].file_uri = compressedImage.absolutePath
            if (mImages.size < 8 && mImages[position].file_uri.isNotEmpty()) {
                mImages.add(FilesBean())
            }
            mAdapter?.list = mImages
            billRv.adapter = mAdapter
            onSubmit.normal()
        }
    }

    private val uploadListener = object : UploadListener {
        override fun onUploadComplete(success: HashMap<Int, String>, failure: HashMap<Int, String>) {
            dismissLoadingDialog()
            if (success.size > 0) {
                LogUtil.e("success --->>> ： $success")
                var index = 1
                for (images in mImages) {
                    if (images.file_path == null && images.file_uri != null) {
                        val value = success[index]
                        val path = value?.split(AliYunPictureUtil.ORDER_PRINT)
                        val name = path?.get(1)?.split("/")
                        images.file_path = "${AliYunPictureUtil.ORDER_PRINT}${path?.get(1)}"
                        images.file_name = name?.get(3) ?: ""
                        images.file_type = mType
                        index++
                    }
                }
                presenter?.requestUpdate(getUpdateRequest())
            } else {
                showToast("提交失败，请重试")
            }
        }

        override fun onUploadComplete(success: String?, failure: String?) {}
    }

    private fun getUpdateRequest(): BillRecordUpdateRequest {

        val request = BillRecordUpdateRequest()
        request.order_id = mOrderID
        if (mImages.size > 0) {
            if (mImages[mImages.size - 1].file_uri == null && mImages[mImages.size - 1].file_path == null) mImages.removeAt(mImages.size - 1)
            request.files = mImages
        }
        return request
    }

    fun setImages(images: ArrayList<String>) {
        val imagesList = ArrayList<String>()
        imagesList.addAll(images)
        for (i in images.indices) {
            if (mImages.size in 1..7) mImages.add(FilesBean())
        }
        for (file in mImages) {
            if (file.file_path == null && file.file_uri == null && imagesList.isNotEmpty()) {
                file.file_uri = imagesList[0]
                imagesList.removeAt(0)
            }
        }
        mAdapter?.list = mImages
        billRv.adapter = mAdapter
        onSubmit.normal()
    }

    override fun onSuccess() {
        mCaching.clear()
        mCaching.addAll(mImages)
        setIsEditor(false)
        listener?.editCompleted(true)
    }
}