package com.jiaoyinbrother.monkeyking.manager.mvpactivity.billrecord.billRecordUpdate

import android.content.Context
import com.alibaba.android.arouter.launcher.ARouter

import com.jiaoyinbrother.library.base.BasePresenterImpl
import com.jiaoyinbrother.library.bean.BaseResult
import com.jiaoyinbrother.library.bean.BillRecordUpdateRequest
import com.jiaoyinbrother.library.retrofit.ApiException
import com.jiaoyinbrother.library.retrofit.BaseObserver
import com.jiaoyinbrother.library.retrofit.RetrofitHelper
import io.reactivex.android.schedulers.AndroidSchedulers
import io.reactivex.schedulers.Schedulers
import java.util.concurrent.TimeUnit

class BillUpdatePresenter(context: Context, view: IBillUpdateContract.view) : BasePresenterImpl<IBillUpdateContract.view>(context, view), IBillUpdateContract.presenter {

    override fun handleException(apiExcpetion: ApiException) {
        view.dismissLoadingDialog()
        when (apiExcpetion.code) {
            ApiException.SERVER_EXCEPTION, ApiException.OTHER_EXCEPTION, ApiException.API_ERROR_EXCEPTION -> view.showToast("提交失败，请重试")
            ApiException.TOKEN_EXPIRED_EXCEPTION -> {
                view.showToast(apiExcpetion.message)
                ARouter.getInstance().build("/user/loginactivity").navigation()
            }
            else -> view.showToast("提交失败，请重试")
        }
    }

    override fun requestUpdate(request: BillRecordUpdateRequest) {

        val service = RetrofitHelper.getInstance(context).service

        val params = RetrofitHelper.getInstance(context).convertRequestToMap(request)

        val observable = service.billPhotoUpdate(params).debounce(1000, TimeUnit.MILLISECONDS)


        observable.subscribeOn(Schedulers.io()).doOnSubscribe {

            view.showLoadingDialog()

        }.observeOn(AndroidSchedulers.mainThread()).subscribe(object : BaseObserver<BaseResult>(context,this) {

            override fun onSuccess(response: BaseResult?) {

                view.dismissLoadingDialog()

                view.showToast("提交成功")

                view.onSuccess()
            }

        })
    }

}
