package com.jiaoyinbrother.monkeyking.manager.mvpactivity.changecartype

import android.content.Context
import android.content.Intent
import android.text.Editable
import android.text.TextUtils
import android.text.TextWatcher
import android.view.View
import android.widget.TextView
import com.camnter.easyrecyclerview.adapter.EasyRecyclerViewAdapter
import com.camnter.easyrecyclerview.holder.EasyRecyclerViewHolder
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.library.bean.CarSearchRequest
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseActivity
import com.jiaoyinbrother.library.bean.CarBean
import com.jiaoyinbrother.library.util.LogUtil
import com.jiaoyinbrother.library.util.Util
import kotlinx.android.synthetic.main.activity_change_car_type.*
import java.util.*


class ChangeCarTypeActivity : MvpBaseActivity<ChangeCarTypePresenter>(), IChangeCarTypeContract.view {
    override fun initView() {

    }

    private var searchAddressAdapter: KeyValueListAdapter? = null
//    private var page =1;
    private var carSearchRequest: CarSearchRequest = CarSearchRequest()

    override fun getLayoutId(): Int {
        return R.layout.activity_change_car_type
    }

    override fun initToolBar() {
        mainTitle?.text = "换车"
    }

    override fun initListeners() {
        searchAddressAdapter?.setOnItemClickListener { _, position ->
            val carBean = searchAddressAdapter?.getItem<CarBean>(position)
            val intent = Intent()
            intent.putExtra(RESULT_CARBEAN, carBean)
            setResult(RESULT_OK, intent)
            finish()
        }

        searchBox.addTextChangedListener(object : TextWatcher {
            override fun onTextChanged(s: CharSequence, start: Int, before: Int, count: Int) {
                if (!TextUtils.isEmpty(s.toString())) {
                    updateCarList(presenter.searchCarTypeByKeyWord(s.toString()))
                }else{
                    updateCarList(presenter.carList)
                }
            }

            override fun beforeTextChanged(s: CharSequence, start: Int, count: Int, after: Int) {}

            override fun afterTextChanged(s: Editable) {

            }
        })

//        refreshLayout.setMoreListener {
////            page++;
//            requestCarTypeAPI(page)
//        }
//        refreshLayout.setRefreshListener {
//            page = 1;
//            requestCarTypeAPI(page)
//        }

    }

    private fun requestCarTypeAPI() {
//        carSearchRequest.page = page;
        presenter.requestCarType(carSearchRequest)
    }

    override fun initData() {

        searchAddressAdapter = KeyValueListAdapter(this)
        carSearchRequest = intent.getSerializableExtra(CAR_SEARCH_REQEUST_KEY) as CarSearchRequest
        if (carSearchRequest == null) {
            finish()
            return
        }

//        refreshLayout.setFooter()
//        page = 1;
        requestCarTypeAPI()

    }

    override fun initPresenter(): ChangeCarTypePresenter {
        return ChangeCarTypePresenter(this, this)
    }


    override fun setData(carList: ArrayList<CarBean>) {
//        refreshLayout.refreshIsEnd()
//        refreshLayout.loadMoreIsEnd()

        LogUtil.e("setData")
        updateCarList(carList)
    }

    private fun updateCarList(carList: ArrayList<CarBean>) {
        searchAddressAdapter?.list = carList
        resultRv.adapter = searchAddressAdapter

        setEmptyDataVisibility(Util.isEmptyList(carList))
    }


    private fun setEmptyDataVisibility(emptyDataVisibility: Boolean) {
        resultRv.visibility = if (emptyDataVisibility) View.GONE else View.VISIBLE
        emptyData.visibility = if (emptyDataVisibility) View.VISIBLE else View.GONE
    }



    companion object {
        val CAR_SEARCH_REQEUST_KEY = "CAR_SEARCH_REQEUST_KEY"
        val RESULT_CARBEAN = "RESULT_CARBEAN"
    }


    class KeyValueListAdapter(val context: Context) : EasyRecyclerViewAdapter() {

        override fun getItemLayouts(): IntArray {
            return intArrayOf(R.layout.change_cartype_item)
        }

        override fun getRecycleViewItemType(position: Int): Int {
            return position
        }

        override fun onBindRecycleViewHolder(view: EasyRecyclerViewHolder?, position: Int) {
            val poiInfo = list[position] as CarBean

            val name_tv = view?.findViewById<TextView>(R.id.name_tv)
            name_tv?.text = poiInfo.type
            val num_tv = view?.findViewById<TextView>(R.id.num_tv)
            num_tv?.text = poiInfo.number
        }

    }
}
