package com.jiaoyinbrother.monkeyking.manager.mvpactivity.changecartype

import android.content.Context
import com.jiaoyinbrother.library.bean.CarSearchRequest
import com.jiaoyinbrother.library.base.BasePresenterImpl
import com.jiaoyinbrother.library.bean.CarBean
import com.jiaoyinbrother.library.bean.SearchCarsResult
import com.jiaoyinbrother.library.retrofit.BaseObserver
import com.jiaoyinbrother.library.retrofit.RetrofitHelper
import com.jiaoyinbrother.library.util.LogUtil
import io.reactivex.android.schedulers.AndroidSchedulers
import io.reactivex.schedulers.Schedulers
import java.util.*
import java.util.concurrent.TimeUnit

/**
 * Created by Administrator on 2018/6/29.
 */

class ChangeCarTypePresenter(context: Context, view: IChangeCarTypeContract.view) : BasePresenterImpl<IChangeCarTypeContract.view>(context, view),
        IChangeCarTypeContract.presenter {

    override fun searchCarTypeByKeyWord(keyword: String): ArrayList<CarBean> {
        val list = ArrayList<CarBean>()

        carList.forEach {
            if (it.number.contains(keyword.toUpperCase()) ||
                    it.type.contains(keyword.toUpperCase())
                    ) {
                list.add(it)
            }
        }

        return list
    }

    val carList = ArrayList<CarBean>()

    override fun requestCarType(carSearchEntity: CarSearchRequest) {
        var mRetrofitService = RetrofitHelper.getInstance(context).service

        val hashMap = RetrofitHelper.getInstance(context).convertRequestToMap(carSearchEntity)

        var observable = mRetrofitService.carSearch(hashMap).debounce(1000, TimeUnit.MILLISECONDS)
        observable.subscribeOn(Schedulers.io()).
                doOnSubscribe {
                    view.showLoadingDialog()
                }.
                observeOn(AndroidSchedulers.mainThread()).
                subscribe(object: BaseObserver<SearchCarsResult>(context,this) {
                    override fun onSuccess(response: SearchCarsResult?) {
                        handleSuccess(response)
                        view.dismissLoadingDialog()
                    }
                })

    }


    private fun handleSuccess(searchCarsResult: SearchCarsResult?) {

        LogUtil.e("Subscriber onNext =" + searchCarsResult.toString())

        if (searchCarsResult?.cars != null) {
            carList.clear()
            carList.addAll(searchCarsResult.cars)
            view.setData(carList)
        }
    }



}
