package com.jiaoyinbrother.monkeyking.manager.mvpactivity.chat

import android.app.Activity
import android.arch.lifecycle.Observer
import android.content.Intent
import android.graphics.Bitmap
import android.media.ThumbnailUtils
import android.os.Bundle
import android.text.TextUtils
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import com.google.gson.Gson
import com.hyphenate.chat.EMClient
import com.hyphenate.chat.EMMessage
import com.hyphenate.easeui.EaseConstant
import com.hyphenate.easeui.EaseUI
import com.hyphenate.easeui.domain.EaseUser
import com.hyphenate.easeui.ui.EaseChatFragment
import com.hyphenate.easeui.utils.EaseCommonUtils
import com.hyphenate.easeui.widget.chatrow.EaseCustomChatRowProvider
import com.hyphenate.util.PathUtil
import com.jeremyliao.livedatabus.LiveDataBus
import com.jiaoyinbrother.library.bean.EMChatBookBean
import com.jiaoyinbrother.library.bean.EMChatOrderBean
import com.jiaoyinbrother.monkeyking.manager.util.PreferenceManager
import com.jiaoyinbrother.library.bean.EMChatBaseBean
import com.jiaoyinbrother.library.util.UserUtil
import java.io.File
import java.io.FileOutputStream

class ChatFragment : EaseChatFragment(), EaseChatFragment.EaseChatFragmentHelper, ChatContract.View {

    companion object {
        //private val ITEM_VIDEO = 11
        private val REQUEST_CODE_SELECT_VIDEO = 11
        const val EM_CHAT_DATA = "EM_CHAT_DATA"
    }

    private var mChatMenu: List<String>? = null

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        PreferenceManager.init(activity)
        return super.onCreateView(
            inflater,
            container,
            savedInstanceState,
            PreferenceManager.getInstance().isMsgRoaming && chatType != EaseConstant.CHATTYPE_CHATROOM
        )
    }

    override fun turnOnTyping(): Boolean {
        return PreferenceManager.getInstance().isShowMsgTyping
    }


    override fun setUpView() {
        initWKData()
        setChatFragmentHelper(this)
        super.setUpView()
        //sendDefaultMsg()
    }


    private var mEMChatBookBean: EMChatBookBean? = null
    private var mEMChatOrderBean: EMChatOrderBean? = null

    private fun initWKData() {
        val userUtil = UserUtil(activity!!)
        LiveDataBus.get().with(EM_CHAT_DATA, EMChatBaseBean::class.java).observeSticky(this, Observer {
            toChatUsername = it?.to_username
            val im_to_headimg_url = it?.to_headimg_url
            val im_to_nickname = it?.to_nickname

            if (it is EMChatBookBean) {
                mEMChatBookBean = it
            } else if (it is EMChatOrderBean) {
                mEMChatOrderBean = it
            }
            //用户信息
            EaseUI.getInstance().userProfileProvider = EaseUI.EaseUserProfileProvider { username ->
                if (TextUtils.equals(username, userUtil.im_username)) {
                    val user = EaseUser(username)
                    user.avatar = userUtil.im_headimg_url
                    user
                } else {
                    val user = EaseUser(toChatUsername)
                    user.nickname = im_to_nickname
                    user.avatar = im_to_headimg_url
                    user
                }
            }

        })


        //快捷咨询Btn
//        val shortcut_btn = view?.findViewById<View>(com.hyphenate.easeui.R.id.shortcut_btn)
//        shortcut_btn?.setOnClickListener {
//            if (mChatMenu != null) {
//                val chatMenuDialog = ChatMenuDialog()
//                chatMenuDialog.show(fragmentManager!!,mChatMenu)
//                chatMenuDialog.setOnSelectListener(object : ChatMenuDialog.OnSelectListener {
//
//                    override fun onSelect(msg: String?) {
//                        if (!TextUtils.isEmpty(msg)) {
//                            sendTextMessage(msg)
//                        }
//                    }
//                })
//            }
//        }
//        //请求快捷菜单
//        val chatPresenter = ChatPresenter(activity!!, this)
//        chatPresenter.requestChatMenu()
    }

    override fun onChatMenu(value: List<String>?) {
        mChatMenu = value
    }

    override fun registerExtendMenuItem() {
        super.registerExtendMenuItem()
        /*inputMenu.registerExtendMenuItem(
            R.string.attach_video,
            R.drawable.em_chat_video_selector,
            ITEM_VIDEO,
            extendMenuItemClickListener
        )*/
    }

    override fun onSetMessageAttributes(message: EMMessage) {

    }

    override fun onEnterToChatDetails() {

    }

    override fun onAvatarClick(username: String) {

    }

    override fun onAvatarLongClick(username: String) {

    }

    override fun onMessageBubbleClick(message: EMMessage): Boolean {
        return false
    }

    override fun onMessageBubbleLongClick(message: EMMessage) {

    }

    override fun onExtendMenuItemClick(itemId: Int, view: View): Boolean {
        when (itemId) {
            ITEM_VIDEO -> {
                val intent = Intent(activity, ImageGridActivity::class.java)
                startActivityForResult(intent, REQUEST_CODE_SELECT_VIDEO)
            }
        }
        return false
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        if (resultCode == Activity.RESULT_OK) {
            when (requestCode) {
                REQUEST_CODE_SELECT_VIDEO //send the video
                -> if (data != null) {
                    val duration = data.getIntExtra("dur", 0)
                    val videoPath = data.getStringExtra("path")
                    val file = File(PathUtil.getInstance().imagePath, "thvideo" + System.currentTimeMillis())
                    try {
                        val fos = FileOutputStream(file)
                        val ThumbBitmap = ThumbnailUtils.createVideoThumbnail(videoPath, 3)
                        ThumbBitmap.compress(Bitmap.CompressFormat.JPEG, 100, fos)
                        fos.close()
                        sendVideoMessage(videoPath, file.absolutePath, duration)
                    } catch (e: Exception) {
                        e.printStackTrace()
                    }

                }
            }
        }
    }

    override fun onSetCustomChatRowProvider(): EaseCustomChatRowProvider? {
        return null
    }



//    private fun sendDefaultMsg() {
//        val conversation = EMClient.getInstance().chatManager().getConversation(toChatUsername, EaseCommonUtils.getConversationType(chatType), true)
//
//        var hasBookMsg = false
//        var hasOrderMsg = false
//        var messagesCount = 0
//        if (conversation != null){
//            val allMessages = conversation.getAllMessages()
//            messagesCount = allMessages.size
//            for (message in allMessages){
//                val bookBean = Gson().fromJson(message?.getStringAttribute(EaseConstant.EXT_MSG_CONTENT,""),EMChatBookBean::class.java)
//                val orderBean = Gson().fromJson(message?.getStringAttribute(EaseConstant.EXT_MSG_CONTENT,""),EMChatOrderBean::class.java)
//                if(mEMChatBookBean != null && TextUtils.equals(bookBean?.car_type_id,mEMChatBookBean?.car_type_id)){
//                    hasBookMsg = true
//                }
//                if(mEMChatOrderBean != null && TextUtils.equals(orderBean?.orderid,mEMChatOrderBean?.orderid)){
//                    hasOrderMsg = true
//                }
//            }
//        }
//        //预订消息，同一会话同一车型只发一次
//        if(!hasBookMsg)sendMessageWKBook()
//        //订单消息，同一会话同一订单只发一次
//        if(!hasOrderMsg)sendMessageWKOrder()
//
//        if(messagesCount == 0){
//            //温馨提示，相同会话只发一次
//            sendMessageWKPrompt()
//        }
//    }
//
//
//    private fun sendMessageWKBook() {
//        //车型：别克GL8  自动挡/7座/2.4L  280元
//        if(mEMChatBookBean == null) return
//
//        val content = "车型："+mEMChatBookBean?.car_type_name+"  "+
//                mEMChatBookBean?.transmission_name+"/"+mEMChatBookBean?.capacity+"座/"+mEMChatBookBean?.displacement+"  "+
//                mEMChatBookBean?.price+"元"
//        //LogUtil.e("sendMessageWKBook*********************"+content)
//        val message = EMMessage.createTxtSendMessage(content, toChatUsername)
//        message.setAttribute(EaseConstant.EXT_MSG_TYPE, EaseConstant.WK_BOOK)
//        message.setAttribute(EaseConstant.EXT_MSG_CONTENT,Gson().toJson(mEMChatBookBean))
//        sendMessage(message)
//    }
//
//    private fun sendMessageWKOrder() {
//        //订单：2019xxxxxxxxxxxxx
//        if(mEMChatOrderBean == null) return
//
//        val content = "订单："+mEMChatOrderBean?.orderid
//        //LogUtil.e("sendMessageWKOrder*********************"+content)
//        val message = EMMessage.createTxtSendMessage(content, toChatUsername)
//        message.setAttribute(EaseConstant.EXT_MSG_TYPE, EaseConstant.WK_ORDER)
//        message.setAttribute(EaseConstant.EXT_MSG_CONTENT,Gson().toJson(mEMChatOrderBean))
////        message.setAttribute(EaseConstant.ORDER_DURATION,
////            TimeGenerateUtil.getTimePeriodString(mEMChatOrderBean?.start_time, mEMChatOrderBean?.end_time, TimeGenerateUtil.TYPE_DAY_HOUR))
//        sendMessage(message)
//    }

    private fun sendMessageWKPrompt() {
        val content = "请务必在悟空租车上完成车辆预订，避免给您的出行带来不必要的损失。"
        val message = EMMessage.createTxtSendMessage(content, toChatUsername)
        message.setAttribute(EaseConstant.EXT_MSG_TYPE, EaseConstant.WK_PROMPT)
        sendMessage(message)
    }


    override fun showLoadingDialog() {

    }

    override fun dismissLoadingDialog() {

    }

    override fun showToast(text: String) {

    }


}
