package com.jiaoyinbrother.monkeyking.manager.mvpactivity.checkcar

import android.arch.lifecycle.Observer
import android.content.Intent
import android.view.View
import com.bumptech.glide.Glide
import com.jeremyliao.livedatabus.LiveDataBus
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseActivity
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.issuedetail.IssueDetailActivity
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.refundcar.adapter.IssuesAdapter
import com.jiaoyinbrother.library.bean.CarValidatesBean
import com.jiaoyinbrother.library.bean.OrderDetailResult
import com.jiaoyinbrother.library.util.ConstantsUtil
import com.jiaoyinbrother.library.util.LogUtil
import kotlinx.android.synthetic.main.activity_check_car.*

class CheckCarActivity : MvpBaseActivity<CheckCarPresenter>(), ICheckCarContract.View {

    private var isShowCarItems = false
    private var isShowSign = true
    private var mAdapter: IssuesAdapter? = null

    override fun initPresenter(): CheckCarPresenter {
        return CheckCarPresenter(this, this)
    }

    override fun getLayoutId(): Int {
        return R.layout.activity_check_car
    }

    override fun initView() {
        sbTakeOil.isEnabled = false
        sbRefundOil.isEnabled = false
        mAdapter = IssuesAdapter(this)
        issueRv.adapter = mAdapter
    }

    override fun initToolBar() {
        mainTitle.text = "验车单"
    }

    override fun initData() {
        LiveDataBus.get().with("CheckCar").observeSticky(this, Observer {
            presenter.getOrderInfo(it as OrderDetailResult)
        })
    }

    override fun initListeners() {
        carItemsLayout.setOnClickListener { onShowCarItems() }
        signLayout.setOnClickListener { onShowSign() }
        carPicLayout.setOnClickListener {
            presenter.onCheckCarPic()
        }
//        groupPhoto.setOnClickListener { presenter.onSeeBigImage(GROUP_PHOTO) }
//        takeOilPhoto.setOnClickListener { presenter.onSeeBigImage(TAKE_PHOTO) }
//        refundOilPhoto.setOnClickListener { presenter.onSeeBigImage(REFUND_PHOTO) }
//        groupPhotoTips.setOnClickListener { H5Utils.onGroupTip(this) }
//        takeOilPhotoTips.setOnClickListener { H5Utils.onOilTip(this) }
//        refundOilPhotoTips.setOnClickListener { H5Utils.onOilTip(this) }
        mAdapter?.setOnItemClickListener { _, position ->
            val issue = mAdapter?.getItem<CarValidatesBean>(position)
            LiveDataBus.get().with(ConstantsUtil.LIVEDATA_ORDER_ISSUE_DDTAIL).postValue(issue)
            startActivity(Intent(this, IssueDetailActivity::class.java))
        }
    }


    /**
     * display 随车物品
     * */
    private fun onShowCarItems() {
        isShowCarItems = !isShowCarItems
        itemView.visibility = if (isShowCarItems) View.VISIBLE else View.GONE
        if (isShowCarItems) {
            itemsArrow.setBackgroundResource(R.mipmap.up_item)
        } else {
            itemsArrow.setBackgroundResource(R.mipmap.down_item)
        }
    }

    /**
     * display 签名
     * */
    private fun onShowSign() {
        isShowSign = !isShowSign
        signImage.visibility = if (isShowSign) View.VISIBLE else View.GONE
        if (isShowSign) {
            signArrow.setBackgroundResource(R.mipmap.up_item)
        } else {
            signArrow.setBackgroundResource(R.mipmap.down_item)
        }
    }

    override fun setOrderNum(num: String) {
        orderNum.text = num
    }

    override fun setOrderChannel(channel: String) {
        orderChannel.text = channel
    }

    override fun setCarNum(num: String) {
        carNum.text = num
    }

    override fun setCarTypeName(name: String) {
        carTypeName.text = name
    }

    override fun setRealTakeTime(title: String, time: String) {
        realTakeCarTimeTitle.text = title
        realTakeCarTime.text = time
    }

    override fun setRealRefundTime(title: String, time: String) {
        realRefundCarTimeTitle.text = title
        realRefundCarTime.text = time
    }

    override fun hideOilShowElectric(isOil: Boolean) {
        electricLayout.visibility = if (isOil) View.VISIBLE else View.GONE
        oilLayout.visibility = if (isOil) View.GONE else View.VISIBLE
    }

    override fun setTakeMiles(miles: String) {
        takeMiles.text = miles
    }

    override fun setRefundMiles(show: Boolean, miles: String) {
        refundMilesTitle.visibility = if (show) View.VISIBLE else View.GONE
        refundMiles.visibility = if (show) View.VISIBLE else View.GONE
        refundKm.visibility = if (show) View.VISIBLE else View.GONE
        refundMiles.text = miles
    }

    override fun setTakeOil(scale: Int, oilMass: String) {
        sbTakeOil.setProgress(scale)
        takeOil.text = oilMass
    }

    override fun setRefundOil(show: Boolean, scale: Int, oilMass: String) {
        refundOilTitle.visibility = if (show) View.VISIBLE else View.GONE
        refundOilDesc.visibility = if (show) View.VISIBLE else View.GONE
        sbRefundOil.visibility = if (show) View.VISIBLE else View.GONE
        refundOil.visibility = if (show) View.VISIBLE else View.GONE
        sbRefundOil.setProgress(scale)
        refundOil.text = oilMass
    }

    override fun setTakeElectric(electric: String) {
        takeElectric.text = electric
    }

    override fun setRefundElectric(show: Boolean, electric: String) {
        refundElectricTitle.visibility = if (show) View.VISIBLE else View.GONE
        refundElectric.visibility = if (show) View.VISIBLE else View.GONE
        refundPercent.visibility = if (show) View.VISIBLE else View.GONE
        refundElectric.text = electric
    }

    override fun setTakeItems(states: ArrayList<String>) {
        itemView.setTakeData(false, states)
    }

    override fun setRefundItems(states: ArrayList<String>) {
        itemView.setRefundData(false, states)
    }

//    override fun setGroupPhoto(url: String) {
//        Glide.with(this).load(url).apply(RequestOptions()
//                .placeholder(R.mipmap.empty_bg_1_1)
//                .error(R.mipmap.empty_bg_1_1))
//                .into(groupPhoto)
//    }
//
//    override fun setTakeOilPhoto(url: String) {
//        Glide.with(this).load(url).apply(RequestOptions()
//                .placeholder(R.mipmap.empty_bg_1_1)
//                .error(R.mipmap.empty_bg_1_1))
//                .into(takeOilPhoto)
//    }
//
//    override fun setRefundOilPhoto(show: Boolean, url: String) {
//        refundOilPhotoTitle.visibility = if (show) View.VISIBLE else View.GONE
//        refundOilPhotoTips.visibility = if (show) View.VISIBLE else View.GONE
//        refundOilPhotoDesc.visibility = if (show) View.VISIBLE else View.GONE
//        refundOilPhoto.visibility = if (show) View.VISIBLE else View.GONE
//        line6.visibility = if (show) View.VISIBLE else View.GONE
//        Glide.with(this).load(url).apply(RequestOptions()
//                .placeholder(R.mipmap.empty_bg_1_1)
//                .error(R.mipmap.empty_bg_1_1))
//                .into(refundOilPhoto)
//    }

    override fun setIssuesContent(isCarAlso: Boolean) {
        if (isCarAlso) {
            checkCarPhotoTitle.text = "还车验车图片"
            checkCarPhotoDesc.text = "以下为还车验车车损情况"
        } else {
            checkCarPhotoTitle.text = "取车验车图片"
            checkCarPhotoDesc.text = "以下为取车验车车损情况"
        }
    }

    override fun setIssues(hide: Boolean, validates: ArrayList<CarValidatesBean>) {
//        issueLayout.visibility = if (hide) View.GONE else View.VISIBLE

        LogUtil.e("setIssues, hide = " + hide)
        if (hide) {
            issueLayout.visibility = View.GONE
            no_old_issue_textview.visibility = View.VISIBLE
        } else {
            issueLayout.visibility = View.VISIBLE
            no_old_issue_textview.visibility = View.GONE
        }

        mAdapter?.list = validates
        mAdapter?.notifyDataSetChanged()
    }

    override fun setComment(hide: Boolean, comment: String) {
        commentLayout.visibility = if (hide) View.GONE else View.VISIBLE
        line7.visibility = if (hide) View.GONE else View.VISIBLE
        commentContent.text = comment
    }

    override fun setSign(hide: Boolean, url: String) {
        signLayout.visibility = if (hide) View.GONE else View.VISIBLE
        signImage.visibility = if (hide) View.GONE else View.VISIBLE
        Glide.with(this).load(url).into(signImage)
    }
}