package com.jiaoyinbrother.monkeyking.manager.mvpactivity.checkcar

import android.content.Context
import android.text.TextUtils
import com.jiaoyinbrother.library.base.BasePresenterImpl
import com.jiaoyinbrother.library.bean.CarValidatesBean
import com.jiaoyinbrother.library.bean.OrderDetailResult
import com.jiaoyinbrother.library.bean.OrdersBean
import com.jiaoyinbrother.library.util.LogUtil
import com.jiaoyinbrother.library.util.Util
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.checkcar.image.CheckCarImageActivity

class CheckCarPresenter(context: Context, view: ICheckCarContract.View)
    : BasePresenterImpl<ICheckCarContract.View>(context, view), ICheckCarContract.Presenter {
    override fun onCheckCarPic() {
        if (orderInfo != null) {
            CheckCarImageActivity.newInstance(context, orderInfo!!)

        }
    }

    //    companion object {
//        const val GROUP_PHOTO = 0
//        const val TAKE_PHOTO = 1
//        const val REFUND_PHOTO = 2
//    }
//
//    private var groupURL: String? = null
//    private var takeURL: String? = null
//    private var refundURL: String? = null
    private var orderInfo: OrderDetailResult? = null

    override fun getOrderInfo(result: OrderDetailResult) {
        orderInfo = result
        // 订单号
        view.setOrderNum("订单号：${result.getOrderShowID()}")

        // 订单渠道
        if (TextUtils.isEmpty(result.channel_name)) view.setOrderChannel("") else view.setOrderChannel("(${result.channel_name})")

        // 车牌号
        view.setCarNum(result.number ?: "")

        // 车型
        view.setCarTypeName(result.type ?: "")

        val usage = result.usage

        // 取车里程
        view.setTakeMiles(usage?.take_miles ?: "")

        // 还车里程
        view.setRefundMiles(isCarAlso(result), usage?.return_miles ?: "0")

        // 油 电 车界面 显示
        view.hideOilShowElectric(TextUtils.equals(result.transmission, "ET"))

        if (TextUtils.equals(result.transmission, "ET")) {
            // 电动车
            view.setTakeElectric(usage?.take_fuel ?: "0")

            view.setRefundElectric(isCarAlso(result), usage?.return_fuel ?: "0")

        } else {
            // 汽油车
            view.setTakeOil(getOilScale(usage?.take_fuel), usage?.take_fuel ?: "0/16")

            view.setRefundOil(isCarAlso(result), getOilScale(usage?.return_fuel), usage?.return_fuel
                    ?: "0/16")
        }

        // 随车物品 取车时
        view.setTakeItems(usage?.take_car?.accessories ?: ArrayList())

        // 随车物品 还车时
        view.setRefundItems(usage?.return_car?.accessories ?: ArrayList())

//        // 人车合影
//        groupURL = usage?.take_car?.front_url ?: ""
//        view.setGroupPhoto(usage?.take_car?.front_url ?: "")
//
//        // 取车油（电）表图片
//        takeURL = usage?.take_car?.fuel_url ?: ""
//        view.setTakeOilPhoto(usage?.take_car?.fuel_url ?: "")
//
//        // 还车油（电）表图片
//        refundURL = usage?.return_car?.fuel_url ?: ""
//        view.setRefundOilPhoto(isCarAlso(result), usage?.return_car?.fuel_url ?: "")

        view.setIssuesContent(isCarAlso(result))

        if (isCarAlso(result)) {
            /** 还车验车单 */
            view.setRealTakeTime("实际取车时间：", result.real_start_time ?: "")// 实际取车时间

            view.setRealRefundTime("实际还车时间：", result.real_end_time ?: "")// 实际还车时间

            view.setComment(TextUtils.isEmpty(usage?.return_car?.comments
                    ?: ""), usage?.return_car?.comments ?: "")

            view.setSign(TextUtils.isEmpty(usage?.return_car?.sign_url
                    ?: ""), usage?.return_car?.sign_url ?: "")

            // 已有问题
            view.setIssues(Util.isEmptyList(usage?.return_car?.validates
                    ?: ArrayList<CarValidatesBean>()), usage?.return_car?.validates ?: ArrayList())
        } else {
            /** 取车验车单 */
            view.setRealTakeTime("预计取车时间：", result.start_time ?: "")// 预计取车时间

            view.setRealRefundTime("预计还车时间：", result.end_time ?: "")// 预计还车时间

            view.setComment(TextUtils.isEmpty(usage?.take_car?.comments
                    ?: ""), usage?.take_car?.comments ?: "")

            view.setSign(TextUtils.isEmpty(usage?.take_car?.sign_url
                    ?: ""), usage?.take_car?.sign_url ?: "")

            // 已有问题
            view.setIssues(Util.isEmptyList(usage?.take_car?.validates
                    ?: ArrayList<CarValidatesBean>()), usage?.take_car?.validates ?: ArrayList())
        }
    }

//    override fun onSeeBigImage(type: Int) {
//        val url = when (type) {
//            GROUP_PHOTO -> groupURL
//            TAKE_PHOTO -> takeURL
//            REFUND_PHOTO -> refundURL
//            else -> ""
//        }
//        showBigImage(url.toString())
//    }

//    /**
//     * 查看大图
//     * */
//    private fun showBigImage(url: String) {
//        if (!TextUtils.isEmpty(url)) {
//            ShowBigImageActivity.newInstanceUri(context, url, false)
//        }
//    }

    /**
     * 油量截取
     * @param fuel
     * */
    private fun getOilScale(fuel: String?): Int {
        var scale = "0"
        if (!TextUtils.isEmpty(fuel)) {
            scale = fuel!!.split("/")[0]
        }
        LogUtil.e("scale == " + scale.toInt())
        return scale.toInt()
    }

    private fun isCarAlso(result: OrderDetailResult): Boolean {
        return result.status > OrdersBean.ORDER_STATUS_5
    }
}