package com.jiaoyinbrother.monkeyking.manager.mvpactivity.checkcar.image

import android.content.Context
import android.content.Intent
import android.support.v7.widget.GridLayoutManager
import android.view.View
import com.jiaoyinbrother.library.bean.OrderDetailResult
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.adapter.CheckCarImageAdapter
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseActivity
import kotlinx.android.synthetic.main.activity_check_image.*

class CheckCarImageActivity : MvpBaseActivity<CheckImagePresenter>(), ICheckImageContract.View {


    private var mTakeAdapter: CheckCarImageAdapter? = null
    private var mReturnAdapter: CheckCarImageAdapter? = null
    override fun initPresenter(): CheckImagePresenter {
        return CheckImagePresenter(this, this)
    }

    override fun getLayoutId(): Int {
        return R.layout.activity_check_image
    }

    override fun initView() {
    }

    override fun initToolBar() {
        mainTitle.text = "验车图片"
    }

    override fun initData() {

        val manager = GridLayoutManager(this, 3, GridLayoutManager.VERTICAL, false)
        mTakeAdapter = CheckCarImageAdapter(this)
        takeRv.layoutManager = manager

        val manager1 = GridLayoutManager(this, 3, GridLayoutManager.VERTICAL, false)
        mReturnAdapter = CheckCarImageAdapter(this)
        returnRv.layoutManager = manager1

        presenter.getData(intent)
    }

    override fun initListeners() {
        mTakeAdapter?.setOnItemClickListener { _, position ->
            val url = mTakeAdapter?.getItem<String>(position)
            presenter.showBigImage(url ?: "")
        }

        mReturnAdapter?.setOnItemClickListener { _, position ->
            val url = mReturnAdapter?.getItem<String>(position)
            presenter.showBigImage(url ?: "")
        }
    }

    override fun setReturnHide(b: Boolean) {
        ll_return_pic.visibility = if (b) View.GONE else View.VISIBLE
    }

    override fun setReturnInfo(list: ArrayList<String>) {
        mReturnAdapter?.list = list
        returnRv.adapter = mReturnAdapter
    }

    override fun setTakeInfo(list: ArrayList<String>) {
        mTakeAdapter?.list = list
        takeRv.adapter = mTakeAdapter
    }

    companion object {
        fun newInstance(context: Context, order: OrderDetailResult) {
            val intent = Intent(context, CheckCarImageActivity::class.java)
            intent.putExtra("ORDER", order)
            context.startActivity(intent)
        }
    }
}