package com.jiaoyinbrother.monkeyking.manager.mvpactivity.checkcar.image

import android.content.Context
import android.content.Intent
import android.text.TextUtils
import com.jiaoyinbrother.library.base.BasePresenterImpl
import com.jiaoyinbrother.library.bean.OrderDetailResult
import com.jiaoyinbrother.monkeyking.manager.activity.ShowBigImageActivity

class CheckImagePresenter(context: Context, view: ICheckImageContract.View)
    : BasePresenterImpl<ICheckImageContract.View>(context, view), ICheckImageContract.Presenter {


    override fun getData(intent: Intent) {
        val orderInfo = intent.getSerializableExtra("ORDER") as OrderDetailResult?

        setData(orderInfo)
    }

    private fun setData(result: OrderDetailResult?) {
        if (result?.usage == null || result.usage?.take_car == null)
            return
        val takeBean = result.usage?.take_car
        val takeList = ArrayList<String>()
        if (!TextUtils.isEmpty(takeBean?.fuel_url))
            takeList.add(takeBean?.fuel_url ?: "")
        if (!TextUtils.isEmpty(takeBean?.front_url))
            takeList.add(takeBean?.front_url ?: "")
        if (!TextUtils.isEmpty(takeBean?.left_front))
            takeList.add(takeBean?.left_front ?: "")
        if (!TextUtils.isEmpty(takeBean?.left_side))
            takeList.add(takeBean?.left_side ?: "")
        if (!TextUtils.isEmpty(takeBean?.left_rear))
            takeList.add(takeBean?.left_rear ?: "")
        if (!TextUtils.isEmpty(takeBean?.right_rear))
            takeList.add(takeBean?.right_rear ?: "")
        if (!TextUtils.isEmpty(takeBean?.right_side))
            takeList.add(takeBean?.right_side ?: "")
        if (!TextUtils.isEmpty(takeBean?.right_front))
            takeList.add(takeBean?.right_front ?: "")
        view.setTakeInfo(takeList)

        view.setReturnHide(result.usage?.return_car == null)

        val returnBean = result.usage?.return_car
        val returnList = ArrayList<String>()
        if (!TextUtils.isEmpty(returnBean?.fuel_url))
            returnList.add(returnBean?.fuel_url ?: "")
        if (!TextUtils.isEmpty(returnBean?.front_url))
            returnList.add(returnBean?.front_url ?: "")
        if (!TextUtils.isEmpty(returnBean?.left_front))
            returnList.add(returnBean?.left_front ?: "")
        if (!TextUtils.isEmpty(returnBean?.left_side))
            returnList.add(returnBean?.left_side ?: "")
        if (!TextUtils.isEmpty(returnBean?.left_rear))
            returnList.add(returnBean?.left_rear ?: "")
        if (!TextUtils.isEmpty(returnBean?.right_rear))
            returnList.add(returnBean?.right_rear ?: "")
        if (!TextUtils.isEmpty(returnBean?.right_side))
            returnList.add(returnBean?.right_side ?: "")
        if (!TextUtils.isEmpty(returnBean?.right_front))
            returnList.add(returnBean?.right_front ?: "")
        view.setReturnInfo(returnList)

    }


    override fun showBigImage(url: String) {
        ShowBigImageActivity.newInstanceUri(context, url, false)
    }
}