package com.jiaoyinbrother.monkeyking.manager.mvpactivity.choosesite

import android.arch.lifecycle.Observer
import android.content.Context
import android.content.Intent
import com.jeremyliao.livedatabus.LiveDataBus
import com.jiaoyinbrother.library.bean.ChooseSiteBean
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseActivity
import kotlinx.android.synthetic.main.activity_choose_site.*
import kotlinx.android.synthetic.main.main_title.*

class ChooseSiteActivity : MvpBaseActivity<ChooseSitePresenter>(), IChooseSiteContract.IChooseSiteView {

    override fun onRefreshEnd() {
        choose_site_refresh.refreshIsEnd()
    }

    override fun onLoadMoreEnd() {
        choose_site_refresh.loadMoreIsEnd()
    }

    companion object {
        fun newInstance(context: Context,mDefaultCheck : Int) {
            val intent = Intent(context, ChooseSiteActivity::class.java)
            intent.putExtra(SITE_CHECK_DEFAULT_POSITION,mDefaultCheck)
            context.startActivity(intent)
        }

        const val SITE_CHECK_POSITION = "SITE_CHECK_POSITION"
        const val SITE_CHECK_BEAN_INFO = "SITE_CHECK_BEAN_INFO"
        const val SITE_CHECK_DEFAULT_POSITION = "SITE_CHECK_DEFAULT_POSITION"

    }

    private var mChooseSiteAdapter: ChooseSiteAdapter? = null

    private var mPage : Int = 1

    override fun setList(list: ArrayList<ChooseSiteBean>) {
        mChooseSiteAdapter?.list = list
        mChooseSiteAdapter?.notifyDataSetChanged()
    }

    override fun initListeners() {

        choose_site_refresh.setRefreshListener {
            mPage = 1

            presenter.getChooseSiteList(mPage)
        }

        choose_site_refresh.setMoreListener {
            mPage ++

            presenter.getChooseSiteList(mPage)

        }

    }

    override fun initPresenter(): ChooseSitePresenter {
        return ChooseSitePresenter(this, this)
    }

    override fun getLayoutId(): Int {
        return R.layout.activity_choose_site
    }

    override fun initView() {
    }

    override fun initToolBar() {
        ivTitleName.text = "选择网点"
    }

    override fun initData() {
        mChooseSiteAdapter = ChooseSiteAdapter()

        choose_site_refresh.setFooter()

        choose_site_recycler?.adapter = mChooseSiteAdapter

        presenter.setDefaultPosition(intent.getIntExtra(SITE_CHECK_DEFAULT_POSITION,0))

        LiveDataBus.get().with(SITE_CHECK_POSITION).observe(this, Observer {
            finish()
        })

        presenter.getChooseSiteList(mPage)
    }

}
