package com.jiaoyinbrother.monkeyking.manager.mvpactivity.commentlist

import android.view.View
import android.widget.TextView
import com.jiaoyinbrother.library.bean.ChooseSiteBean
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseActivity
import com.jiaoyinbrother.monkeyking.mvpactivity.commentlist.ICommentListContract
import com.jiaoyinbrother.library.bean.CommentTypeCheckBean
import com.jiaoyinbrother.library.bean.MarksBean
import com.jiaoyinbrother.library.util.ConstantsUtil
import com.jiaoyinbrother.library.util.LogUtil
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.choosesite.ChooseSiteActivity
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.commentlist.CommentListPresenter.Companion.COMMENT_LIST_DATA_GROUP_ID
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.commentlist.CommentListPresenter.Companion.COMMENT_LIST_DATA_SITE_ID
import kotlinx.android.synthetic.main.activity_comment_list.*
import java.util.*

class CommentListActivity : MvpBaseActivity<CommentListPresenter>(), ICommentListContract.ICommentListView {

    companion object{
        const val COMMENT_TITLE_VISIBLE = "COMMENT_TITLE_VISIBLE"
        const val COMMENT_TITLE_DEFAULT_CHECK = "COMMENT_TITLE_DEFAULT_CHECK"
    }

    override fun setTopChooseSiteLayoutVisible(isShow: Boolean) {

        LogUtil.e("isShow->$isShow")

        mAdapter?.setConditionViewVisible(isShow)

//        if (isShow) {
//
//            comment_list_condition_title.visibility = View.VISIBLE
//            comment_list_title_line.visibility = View.VISIBLE
//        } else {
//
//            comment_list_condition_title.visibility = View.GONE
//            comment_list_title_line.visibility = View.GONE
//        }
    }

    override fun setDefaultCheck(position: Int) {
//        mCheckDefaultPosition = position
        mAdapter?.setDefaultPosition(position)
    }

    override fun setDefaultCheckBean(mCheckBean: ChooseSiteBean) {
//        comment_list_condition_title.text = mCheckBean.site_name
        mAdapter?.setConditionTitle(mCheckBean.site_name?:"全部网点")
    }


    private var mAdapter: CommentListAdapter1? = null
    private var mToolBarTitle: TextView? = null
    private var mCheckDefaultPosition: Int = 0

    override fun initPresenter(): CommentListPresenter {
        return CommentListPresenter(this, this)
    }

    override fun getLayoutId(): Int {
        return R.layout.activity_comment_list
    }

    override fun initView() {
        mToolBarTitle = findViewById(R.id.ivTitleName)
        comment_list_refresh.setFooter()
        mAdapter = CommentListAdapter1(this)
        comment_list_recycler.adapter = mAdapter

    }

    override fun initToolBar() {
        mToolBarTitle?.text = "评价管理"
    }

    private var mDefaultCheck = 0

    override fun initData() {
        presenter.initLiveBus(this)

        val isTopLayoutShow = intent.getIntExtra(COMMENT_TITLE_VISIBLE,-1)

        mDefaultCheck = intent.getIntExtra(COMMENT_TITLE_DEFAULT_CHECK,0)

        val mSiteId = intent.getStringExtra(COMMENT_LIST_DATA_SITE_ID)

        val mGroupId = intent.getStringExtra(COMMENT_LIST_DATA_GROUP_ID)

        if (isTopLayoutShow > -1){
            setTopChooseSiteLayoutVisible(true)
        }else{
            setTopChooseSiteLayoutVisible(false)
        }

        presenter.setSiteId(mSiteId)

        presenter.setGroupId(mGroupId)

        LogUtil.e("getCommentList -> 5")
        presenter.getCommentList(true)

    }


    override fun initListeners() {
        comment_list_refresh.setRefreshListener {
            LogUtil.e("getCommentList -> 6")
            presenter.getCommentList(true)
        }

        comment_list_refresh.setMoreListener {
            presenter.getCommentList(false)
        }

        mAdapter?.setTitleListener(object : CommentListAdapter1.CommentTypeListener {
            override fun onCommentType(type: String?) {

                presenter.getCommentListTyple(type)
            }

            override fun onHasCommentReply(reply: Int?) {

                presenter.getCommentListHasReply(reply)
            }
        })

//        comment_list_condition_title.setOnClickListener {
//            ChooseSiteActivity.newInstance(this@CommentListActivity, mCheckDefaultPosition)
//        }
    }

    override fun setRefreshEnd() {
        comment_list_refresh.refreshIsEnd()
        comment_list_refresh.loadMoreIsEnd()
    }

    override fun setCommentData(comments: ArrayList<MarksBean>) {
        mAdapter?.list = comments
        mAdapter?.notifyDataSetChanged()
    }

    override fun setNoDataView(show: Boolean, state: Int) {

        comment_list_no_list.visibility = if (show) View.VISIBLE else View.GONE
        if (state == ConstantsUtil.NO_DATA) {
            comment_list_no_list.setState(3)
            comment_list_no_list.setTitleContent("这里空空如也")
        } else {
            comment_list_refresh.visibility = if (show) View.GONE else View.VISIBLE
            comment_list_no_list.setState(1)
            comment_list_no_list.setButtonListener(View.OnClickListener {
                LogUtil.e("getCommentList -> 7")
                presenter.getCommentList(true)
            })
        }
    }

    override fun setCommentNoMore() {
//        comment_list_refresh.setNoMore()
    }

    override fun setTitleData(list: ArrayList<CommentTypeCheckBean>,replyTypes: ArrayList<CommentTypeCheckBean>) {
        mAdapter?.setHeaderData(list,replyTypes)

        //用于默认勾选项
        mAdapter?.setDefaultCheck(mDefaultCheck)
    }

//    private var mPageIndex  = 1
//
//    private var mCommentListAdapter : CommentListAdapter ?= null
//
//    private var mCommentListTitle : List<CommentTypeCheckBean> ?= null
//
//
//    override fun setTitleData(list: List<CommentTypeCheckBean>?) {
//        if (list != null && mCommentListTitle ==null) {
//            comment_list_type.visibility = View.VISIBLE
//            mCommentListTitle = list
//            refreshTitleView(comment_list_type)
//        }
//    }
//
//    override fun addCommentList(comments: List<MarksBean>) {
//        comment_list_no_list.visibility = View.GONE
//        mCommentListAdapter?.list = comments
//        //comment_list_recycler.adapter = mCommentListAdapter
//        mCommentListAdapter?.notifyDataSetChanged()
//    }
//
//    override fun orderListIsNull() {
//        mCommentListAdapter?.clear()
//        mCommentListAdapter?.notifyDataSetChanged()
//        comment_list_no_list.visibility = View.VISIBLE
//    }
//
//    override fun setRefreshList() {
//        mPageIndex = 1
//        presenter.getCommentList(mPageIndex)
//    }
//
//    override fun onRefresh() {
//        mPageIndex = 1
//        presenter.getCommentList(mPageIndex)
//    }
//
//    override fun onLoadMore() {
//        mPageIndex += 1
//        presenter.getCommentList(mPageIndex)
//    }

//    private fun refreshTitleView(contentView: FlexboxLayout?){
//
//        contentView?.removeAllViews()
//        for (index in mCommentListTitle!!.indices) {
//            val child = View.inflate(this, R.layout.item_filter_name, null)
//            val checkBox = child.findViewById<CheckBox>(R.id.item_filter_name)
//            checkBox.tag = index
//            val item = mCommentListTitle!![index]
//            checkBox.text = item.name
//            checkBox.isChecked = item.isCheck
//            checkBox.setOnClickListener {
//
//                for (item in 0 until contentView!!.childCount){
//                    val itemRoot = contentView?.getChildAt(item) as ConstraintLayout
//                    val check = itemRoot.getChildAt(0) as CheckBox
//                    check.isChecked = false
//                }
//                (it as CheckBox).isChecked = true
//
//                presenter.setCommentListTyple(item.type)
//            }
//
//            contentView?.addView(child)
//        }
//    }

}
