package com.jiaoyinbrother.monkeyking.manager.mvpactivity.commentlist

import android.content.Context
import android.content.Intent
import android.support.v7.widget.GridLayoutManager
import android.text.Html
import android.text.TextUtils
import android.view.View
import android.widget.CheckBox
import android.widget.ImageView
import android.widget.LinearLayout
import android.widget.TextView
import com.bumptech.glide.Glide
import com.bumptech.glide.load.resource.bitmap.CircleCrop
import com.bumptech.glide.request.RequestOptions
import com.camnter.easyrecyclerview.adapter.EasyRecyclerViewAdapter
import com.camnter.easyrecyclerview.holder.EasyRecyclerViewHolder
import com.camnter.easyrecyclerview.widget.EasyRecyclerView
import com.google.android.flexbox.FlexboxLayout
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.commentreply.CommentReplyActivity
import com.jiaoyinbrother.monkeyking.manager.util.MKUtil
import com.jiaoyinbrother.library.bean.CommentTypeCheckBean
import com.jiaoyinbrother.library.bean.MarksBean
import com.jiaoyinbrother.library.util.ConstantsUtil
import com.jiaoyinbrother.library.util.LogUtil
import com.jiaoyinbrother.library.util.SpaceItemDecoration
import com.jiaoyinbrother.monkeyking.manager.Constants
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.choosesite.ChooseSiteActivity
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.commentreply.CommentReplyActivity.Companion.COMMENT_REPLY_KEY_BAD
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.commentreply.CommentReplyActivity.Companion.COMMENT_REPLY_KEY_GOOD
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.commentreply.CommentReplyActivity.Companion.COMMENT_REPLY_KEY_NEUTRAL
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.detail.OrderDetailActivity

class CommentListAdapter1(val context: Context) : EasyRecyclerViewAdapter() {


    private var mTitleTypes: ArrayList<CommentTypeCheckBean>? = null
    private var mReplyTypes: ArrayList<CommentTypeCheckBean>? = null
    private var listener: CommentTypeListener? = null
    private var selectIndex = 0
    private var selectReplyIndex = 0

    override fun getRecycleViewItemType(position: Int): Int {
        return if (position == 0) HEADER else BODY
    }

    override fun onBindRecycleViewHolder(viewHolder: EasyRecyclerViewHolder?, position: Int) {
        val type = getRecycleViewItemType(position)

        when (type) {
            HEADER -> setHeaderHolder(viewHolder)
            BODY -> setBodyHolder(viewHolder, position)
        }
    }

    private fun setBodyHolder(holder: EasyRecyclerViewHolder?, position: Int) {
        val avatar = holder?.findViewById<ImageView>(R.id.item_comment_avatar)
        val mUserPhoneView = holder?.findViewById<TextView>(R.id.item_comment_phone)
        val mDateView = holder?.findViewById<TextView>(R.id.item_comment_date)
        val mCommentStateView = holder?.findViewById<TextView>(R.id.item_comment_state)
        val mSiteNameView = holder?.findViewById<TextView>(R.id.item_comment_store_site_name)

        val mCommentImageListView = holder?.findViewById<EasyRecyclerView>(R.id.item_comment_images_recycler)
        val mContentView = holder?.findViewById<TextView>(R.id.item_comment_content)
        val mStoreMsgType0 = holder?.findViewById<TextView>(R.id.item_comment_store_msg_type0)
        val mStoreMsgTime0 = holder?.findViewById<TextView>(R.id.item_comment_store_msg_time0)
        val mStoreMsgContent0 = holder?.findViewById<TextView>(R.id.item_comment_store_msg_content0)
        val mStoreMsgType1 = holder?.findViewById<TextView>(R.id.item_comment_store_msg_type1)
        val mStoreMsgTime1 = holder?.findViewById<TextView>(R.id.item_comment_store_msg_time1)
        val mStoreMsgContent1 = holder?.findViewById<TextView>(R.id.item_comment_store_msg_content1)
        val mOrderId = holder?.findViewById<TextView>(R.id.item_comment_id)
        val mStoreMsgLayout = holder?.findViewById<View>(R.id.item_comment_store_msg)
        val mBottomLine = holder?.findViewById<View>(R.id.item_comment_bottom_line)
        //回复按钮
        val mReplyButton = holder?.findViewById<TextView>(R.id.item_comment_store_reply)

        if (position < list.size - 1) {
            mBottomLine?.visibility = View.VISIBLE
        } else {
            mBottomLine?.visibility = View.GONE
        }

        val marksBean = list[position] as MarksBean

        mDateView?.text = marksBean.time
        mSiteNameView?.text = marksBean.site_name ?: ""

        if (marksBean.is_noname == 1) {

            mOrderId?.text = "订单号：******"
            mUserPhoneView?.text = "匿名评价"
        } else {

            val html = "订单号：<font color=\"#3E98F9\">${marksBean.orderid}</font>"
            mOrderId?.text = Html.fromHtml(html)
            mUserPhoneView?.text = marksBean.name
            mOrderId?.setOnClickListener {

                val intent = Intent(context, OrderDetailActivity::class.java)
                intent.putExtra(ConstantsUtil.ORDER_ID, marksBean.orderid)
                context.startActivity(intent)
            }
        }

        val rate = marksBean.rate?.toFloat() ?: 0.0f
        val commentStateBuilder = StringBuilder()
        commentStateBuilder.append(rate).append("分")
        if (rate != null) {
            commentStateBuilder.append(" ")
            var text = ""
            if (rate > 2.9 && rate < 4) {
                text = "还不错"
            } else if (rate >= 3.9 && rate < 4.5) {
                text = "挺好哒"
            } else if (rate >= 4.5) {
                text = "棒极啦"
            }
            commentStateBuilder.append(text)
        }
        mCommentStateView?.text = commentStateBuilder

        val comment = marksBean.comment
        if (comment != null && comment.isNotEmpty()) {

            mContentView?.visibility = View.VISIBLE

            mContentView?.text = marksBean.comment
        } else {

            mContentView?.visibility = View.GONE
        }

        if (marksBean.display_reply == 0) {
            mReplyButton?.visibility = View.VISIBLE
            val list = marksBean.reply_list ?: emptyList()
            if (list.isEmpty()) {
                mStoreMsgLayout?.visibility = View.GONE
                mReplyButton?.visibility = View.VISIBLE
            } else {
                mStoreMsgLayout?.visibility = View.VISIBLE
                mStoreMsgType1?.visibility = View.GONE
                mStoreMsgTime1?.visibility = View.GONE
                mStoreMsgContent1?.visibility = View.GONE
                val rereplyBean = list[0]
                mStoreMsgType0?.text = rereplyBean.title
                mStoreMsgTime0?.text = rereplyBean.time
                mStoreMsgContent0?.text = rereplyBean.comment
                if (TextUtils.equals("GROUP", rereplyBean.type)) {
                    mReplyButton?.visibility = View.INVISIBLE
                }
                if (list.size > 1) {
                    mStoreMsgType1?.visibility = View.VISIBLE
                    mStoreMsgTime1?.visibility = View.VISIBLE
                    mStoreMsgContent1?.visibility = View.VISIBLE
                    val rereplyBean1 = list[1]
                    mStoreMsgType1?.text = rereplyBean1.title
                    mStoreMsgTime1?.text = rereplyBean1.time
                    mStoreMsgContent1?.text = rereplyBean1.comment
                    if (TextUtils.equals("GROUP", rereplyBean1.type)) {
                        mReplyButton?.visibility = View.INVISIBLE
                    }
                }
            }
        } else {
            mReplyButton?.visibility = View.INVISIBLE
            mStoreMsgLayout?.visibility = View.GONE
        }

        //跳转回复页面
        mReplyButton?.setOnClickListener {

            val type = when (marksBean.rate_type) {

                COMMENT_REPLY_KEY_GOOD -> CommentReplyActivity.COMMENT_REPLY_TYPE_GOOD
                COMMENT_REPLY_KEY_NEUTRAL -> CommentReplyActivity.COMMENT_REPLY_TYPE_NEUTRAL
                COMMENT_REPLY_KEY_BAD -> CommentReplyActivity.COMMENT_REPLY_TYPE_BAD
                else -> -1
            }
            CommentReplyActivity.newInstance(context, type, marksBean.id.toString())
        }

        Glide.with(context)
                .load(marksBean.headimg_url)
                .apply(
                        RequestOptions.bitmapTransform(CircleCrop())
                                .placeholder(R.mipmap.icon_default_head)
                                .error(R.mipmap.icon_default_head)
                ).into(avatar!!)


        val layoutManager = GridLayoutManager(context, 3, GridLayoutManager.VERTICAL, false)
        mCommentImageListView?.layoutManager = layoutManager
        if (mCommentImageListView?.itemDecorationCount == 0) {
            mCommentImageListView.addItemDecoration(SpaceItemDecoration(context, 7, 3))
        }
        val mImageAdapter = NineImageAdapter(context)
        mCommentImageListView?.adapter = mImageAdapter
        val images = marksBean.images
        if (images != null && images.isNotEmpty()) {
            mCommentImageListView?.visibility = View.VISIBLE
            mImageAdapter.list = images
            mImageAdapter.notifyDataSetChanged()
        } else {
            mCommentImageListView?.visibility = View.GONE
        }


    }

    private fun setHeaderHolder(holder: EasyRecyclerViewHolder?) {
        val mFlexBox = holder?.findViewById<FlexboxLayout>(R.id.comment_list_type)
        val mFbReply = holder?.findViewById<FlexboxLayout>(R.id.comment_list_reply_tag)
        val mConditionTextView = holder?.findViewById<TextView>(R.id.comment_list_condition_title)
        val mConditionLine = holder?.findViewById<View>(R.id.comment_list_title_line)

        if (isShowConditionTitle) {
            mConditionTextView?.visibility = View.VISIBLE
            mConditionLine?.visibility = View.VISIBLE
        } else {
            mConditionTextView?.visibility = View.GONE
            mConditionLine?.visibility = View.GONE
        }

        mConditionTextView?.text = mConditionTitle

        mConditionTextView?.setOnClickListener {

            ChooseSiteActivity.newInstance(context, mCheckDefaultPosition)
        }

        mFlexBox?.removeAllViews()
        if (mTitleTypes != null) {
            for (index in mTitleTypes!!.indices) {
                val child = View.inflate(context, R.layout.item_comment_tag, null)
                val layout = child.findViewById<LinearLayout>(R.id.ll_filter_name)
                val checkBox = child.findViewById<CheckBox>(R.id.item_filter_name)
                val mLine = child.findViewById<View>(R.id.item_filter_line)
                val item = mTitleTypes!![index]
                checkBox.tag = index
                checkBox.text = item.name
                checkBox.isChecked = index == selectIndex

                if (checkBox.isChecked) {

                    mLine.visibility = View.VISIBLE
                } else {

                    mLine.visibility = View.GONE
                }
//                item.isCheck
                layout.setOnClickListener {
                    if (!MKUtil.isNoNetwork(context)) {
//                        for (child in 0 until mFlexBox?.childCount!!) {
//                            val itemRoot = mFlexBox.getChildAt(child) as ConstraintLayout
//                            val check = itemRoot.getChildAt(0) as CheckBox
////                        check.isChecked = false
//                        }
                        selectIndex = index
                        notifyItemChanged(0)
                        listener?.onCommentType(item.type)
                    }
                }
                mFlexBox?.addView(child)
            }
        }

        mFbReply?.removeAllViews()
        if (mReplyTypes != null) {
            for (index in mReplyTypes!!.indices) {
                val child = View.inflate(context, R.layout.item_comment_reply_type, null)
                val layout = child.findViewById<LinearLayout>(R.id.ll_filter_name)
                val checkBox = child.findViewById<CheckBox>(R.id.item_filter_name)
                val item = mReplyTypes?.get(index) ?: return
                checkBox.tag = index
                checkBox.text = item.name
                checkBox.isChecked = index == selectReplyIndex

                layout.setOnClickListener {
                    if (!MKUtil.isNoNetwork(context)) {
                        selectReplyIndex = index
                        notifyItemChanged(0)
                        listener?.onHasCommentReply(item.type.toInt())
                    }
                }
                mFbReply?.addView(child)
            }
        }

    }

    override fun getItemLayouts(): IntArray {
        return intArrayOf(R.layout.item_comment_header, R.layout.item_comment_list)
    }

    private var isFirstRun = false

    private var isShowConditionTitle = false

    private var mCheckDefaultPosition = 0

    private var mConditionTitle = "全部网点"

    fun setConditionViewVisible(isShow: Boolean) {
        isShowConditionTitle = isShow
        notifyItemChanged(0)
    }

    fun setDefaultPosition(position: Int) {
        mCheckDefaultPosition = position
    }

    fun setConditionTitle(title: String) {
        mConditionTitle = title
        notifyItemChanged(0)
    }

    /**
     * 默认选中
     */
    fun setDefaultCheck(check: Int) {

        if (!isFirstRun) {

            selectIndex = check
            notifyItemChanged(0)

            LogUtil.e("type=---${mTitleTypes.toString()}")

//            listener?.onCommentType(mTitleTypes?.get(selectIndex)?.type)

            isFirstRun = true
        }

    }

    fun setHeaderData(titleTypes: ArrayList<CommentTypeCheckBean>, replyTypes: ArrayList<CommentTypeCheckBean>) {
        mTitleTypes = titleTypes
        mReplyTypes = replyTypes
    }

    fun setTitleListener(listener: CommentTypeListener) {
        this.listener = listener
    }

    interface CommentTypeListener {
        fun onCommentType(type: String?)

        fun onHasCommentReply(reply: Int?)
    }


    companion object {
        const val HEADER = 0
        const val BODY = 1


        /**
         * 添加Header
         */
        fun addHeader(datas: ArrayList<MarksBean>): ArrayList<MarksBean> {
            datas.add(0, MarksBean())
            return datas
        }
    }

}