package com.jiaoyinbrother.monkeyking.manager.mvpactivity.commentreply

import android.content.Context
import android.content.Intent
import android.text.TextUtils
import android.util.EventLog
import android.view.MotionEvent
import android.view.MotionEvent.ACTION_DOWN
import android.view.inputmethod.InputMethodManager
import com.jiaoyinbrother.library.util.LogUtil
import com.jiaoyinbrother.library.util.TextUtil
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseActivity
import com.jiaoyinbrother.monkeyking.manager.view.IOSdialog.IOSAlertDialog
import kotlinx.android.synthetic.main.activity_comment_reply.*


class CommentReplyActivity : MvpBaseActivity<CommentReplyPresenter>(), ICommentReplyContract.ICommentReplyView {

    companion object{

        const val COMMENT_REPLY_TYPE_KEY = "COMMENT_REPLY_TYPE_KEY"
        const val MARKS_ID = "MARKS_ID"
        const val COMMENT_REPLY_TYPE_GOOD = 1
        const val COMMENT_REPLY_TYPE_NEUTRAL = 2
        const val COMMENT_REPLY_TYPE_BAD = 3
        const val COMMENT_REPLY_KEY_GOOD = "GOOD"
        const val COMMENT_REPLY_KEY_NEUTRAL = "NEUTRAL"
        const val COMMENT_REPLY_KEY_BAD = "BAD"

        fun newInstance(context: Context,type : Int,markersId : String){

            val intent = Intent(context,CommentReplyActivity::class.java)
            intent.putExtra(COMMENT_REPLY_TYPE_KEY,type)
            intent.putExtra(MARKS_ID,markersId)
            context.startActivity(intent)
        }
    }
    override fun setEditTextContentLength(num: String) {
        send_comment_edit_content_number.text = num
    }

    override fun onSuccess() {
        showToast("回复成功")
        finish()
    }

    override fun initListeners() {
        //提交回复
        subTitle.setOnClickListener {
            val content = send_comment_edit_content.text.toString()
            if (!TextUtils.isEmpty(content)) {
                if (!TextUtil.containsEmoji(content)) {
                    presenter.sendReply(send_comment_edit_content.text.toString())
                } else {
                    showToast("回复内容不可包含表情符号")
                }
            } else {
                showToast("回复内容不能为空")
//

            }
        }
//
//        send_comment_edit_quick_rv.setOnScrollChangeListener { v, scrollX, scrollY, oldScrollX, oldScrollY ->
//
//            if (send_comment_edit_content.isFocused){
//
//                send_comment_edit_content.clearFocus()
//                val imm: InputMethodManager = getSystemService(Context.INPUT_METHOD_SERVICE) as InputMethodManager
//                imm.hideSoftInputFromWindow(this.window.decorView.windowToken, 0)
//            }
//        }

        send_comment_edit_quick_rv.setOnTouchListener { v, event ->

            send_comment_edit_content.clearFocus()
            val imm: InputMethodManager = getSystemService(Context.INPUT_METHOD_SERVICE) as InputMethodManager
            imm.hideSoftInputFromWindow(this.window.decorView.windowToken, 0)
            return@setOnTouchListener false
        }

    }



    override fun initPresenter(): CommentReplyPresenter {
        return CommentReplyPresenter(this, this)
    }

    override fun getLayoutId(): Int {
        return R.layout.activity_comment_reply
    }

    override fun initView() {
        presenter.setEditWatcher(send_comment_edit_content)
    }

    override fun initToolBar() {
        mainTitle.text = "回复"
        subTitle.text = "完成"
    }

    override fun initData() {
        presenter.initMarksId(intent)

        val type = intent.getIntExtra(COMMENT_REPLY_TYPE_KEY,-1)
        val mQuickReplyAdapter = QuickReplyAdapter()
        send_comment_edit_quick_rv.adapter = mQuickReplyAdapter
        val localList = ArrayList<String>()

        //好评类
        val localGood = ArrayList<String>()
        localGood.add("非常感谢您的点评，热忱期待您的再次光临！")
        localGood.add("感谢您的选择，我们会继续努力，为您提供更好的服务！")
        localGood.add("能为您提供服务是我们的荣幸，我们期待与您下次相遇！")
        localGood.add("您好，我们能得到您如此的支持与认可，深感荣幸，很感谢您选择我们租车！")
        localGood.add("您好，我们会不断努力进步，我们也定会不负众望。感谢您支持，祝您生活愉快！")
        localGood.add("谢谢您的支持与肯定，我们会再接再厉，服务更上一层楼！")
        localGood.add("感谢您对我们的支持！祝您每天都能拥有阳光般的好心情。欢迎亲下次光临！")
        localGood.add("尊敬的客户您好！非常谢谢您的肯定，客户满意是我们一直坚守的追求，祝您生活愉快！")
        localGood.add("非常感谢您的支持，选择我店租车为您服务，对我们服务的肯定，欢迎您下次来！")
        localGood.add("感谢您的好评，感谢您对我们服务的肯定，我们会再接再厉！")
        localGood.add("谢谢您的肯定，前行路上有您的陪伴，我们是幸福的！期待您的再次光临！")

        //建议类
        val localProposal = ArrayList<String>()
        localProposal.add("非常感谢您的建议，我们一定会加强培训，提高服务质量。期待您的再次光临！")
        localProposal.add("非常感谢您的点评！感谢您对我们提出的宝贵建议，我们会提升我们的服务质量，让您有更好的体验！同时也会加强员工的培训，加强业务知识的学习，期待您的再次光临！")
        localProposal.add("非常感谢您的建议，我们会用心对待并积极采纳！感谢您的支持与信赖，这是我们努力做得更好的动力！我们会再接再厉，给每一位客户带来更棒的用车体验！")

        //差评类
        val localBad = ArrayList<String>()
        localBad.add("非常感谢您的建议！首先，因我们工作人员的原因导致不愉快的体验，我们表示深深的歉意。其次，我们一定会加强管理及培训，提高服务水平，让每一位顾客满意是我们不懈的追求！期待您的再次光临！" )
        localBad.add("深感歉意，未能给您带来一个满意的用车服务，我们会努力做到更好。")
        localBad.add("您好，很高兴您能在百忙中抽出时间给我们点评，做得不太好的地方我们会认可并改善，如果期间有给您带来不好的体验，我们深感歉意，祝您生活愉快！")

        //投诉类
        val localComplaint = ArrayList<String>()
        localComplaint.add("您好！我司会及时跟进并及时改进，感谢你给出的宝贵意见！")
        localComplaint.add("尊敬的客人您好！先代表公司给您致歉了，您反馈的问题，我们已移交给专人处理，希望下次能给您带来更好的用车体验！")


        when(type){

            COMMENT_REPLY_TYPE_GOOD -> {

                localList.addAll(localGood)
                localList.addAll(localProposal)
            }
            COMMENT_REPLY_TYPE_NEUTRAL -> {

                localList.addAll(localGood)
                localList.addAll(localProposal)
                localList.addAll(localComplaint)
                localList.addAll(localBad)
            }
            COMMENT_REPLY_TYPE_BAD -> {

                localList.addAll(localComplaint)
                localList.addAll(localBad)
                localList.addAll(localProposal)
            }
        }

        mQuickReplyAdapter.list = localList
        mQuickReplyAdapter.notifyDataSetChanged()

        mQuickReplyAdapter.setOnItemClickListener { convertView, position ->

            send_comment_edit_content.setText(localList[position])
            send_comment_edit_content.setSelection(send_comment_edit_content.text.toString().length)
        }
    }


    override fun onBackPressed() {

        if (send_comment_edit_content.text.toString().isNotEmpty()) {

            IOSAlertDialog(this).builder().setTitle("确认放弃回复？").setMsg("放弃回复内容将不会保存", true)
                    .setRightButton("确定") {
                        super.onBackPressed()
                    }.setLeftButton("取消") {

                    }.show()
        } else {
            super.onBackPressed()
        }

    }
}
