package com.jiaoyinbrother.monkeyking.manager.mvpactivity.commentreply

import android.content.Context
import android.content.Intent
import android.text.Editable
import android.text.TextWatcher
import android.widget.EditText
import com.jeremyliao.livedatabus.LiveDataBus
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.commentlist.CommentListPresenter
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.dropinthecar.IDropInTheCarContract
import com.jiaoyinbrother.library.base.BasePresenterImpl
import com.jiaoyinbrother.library.bean.BaseResult
import com.jiaoyinbrother.library.bean.SendReplyRequest
import com.jiaoyinbrother.library.retrofit.BaseObserver
import com.jiaoyinbrother.library.retrofit.RetrofitHelper
import io.reactivex.android.schedulers.AndroidSchedulers
import io.reactivex.schedulers.Schedulers
import java.util.concurrent.TimeUnit

class CommentReplyPresenter(context: Context, view: ICommentReplyContract.ICommentReplyView) :
        BasePresenterImpl<ICommentReplyContract.ICommentReplyView>(context, view), ICommentReplyContract.ICommentReplyPresenter {
    override fun setEditWatcher(editText: EditText) {

        editText.addTextChangedListener(object : TextWatcher {
            override fun beforeTextChanged(p0: CharSequence?, p1: Int, p2: Int, p3: Int) {
            }

            override fun onTextChanged(p0: CharSequence?, p1: Int, p2: Int, p3: Int) {
            }

            override fun afterTextChanged(p0: Editable?) {
                val length = editText.text.toString().length
                view.setEditTextContentLength((200-length).toString() + "字")
            }

        })
    }

    var initMarksId : String ?= null

    override fun initMarksId(intent: Intent) {
        initMarksId = intent.getStringExtra("MARKS_ID")
    }

    override fun sendReply(content: String?) {

        var mRetrofitService = RetrofitHelper.getInstance(context).service

        val sendReplyRequest = SendReplyRequest()
        sendReplyRequest.id = initMarksId
        sendReplyRequest.content = content
        sendReplyRequest.reply_type = "GROUP"

        val hashMap = RetrofitHelper.getInstance(context).convertRequestToMap(sendReplyRequest)

        var observable = mRetrofitService.sendReply(hashMap).debounce(1000, TimeUnit.MILLISECONDS)
        observable.subscribeOn(Schedulers.io()).
                doOnSubscribe {
                    view.showLoadingDialog()
                }.
                observeOn(AndroidSchedulers.mainThread()).
                subscribe(object: BaseObserver<BaseResult>(context,this) {
                    override fun onSuccess(response: BaseResult?) {
                        LiveDataBus.get().with(CommentListPresenter.COMMENT_LIST_REFRESH).setValue(null)
                        view.dismissLoadingDialog()
                        view.onSuccess()
                    }
                })
    }


}