package com.jiaoyinbrother.monkeyking.manager.mvpactivity.console.manager

import android.content.Context
import android.content.Intent
import android.view.View
import android.widget.LinearLayout
import android.widget.TextView
import com.camnter.easyrecyclerview.adapter.EasyRecyclerViewAdapter
import com.camnter.easyrecyclerview.holder.EasyRecyclerViewHolder
import com.jiaoyinbrother.library.bean.SimpleCarBean
import com.jiaoyinbrother.monkeyking.manager.CarEntity
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.activity.RemoteCarActivity
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.notrent.NoRentDateActivity
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.list.OrderManageActivity
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.price.PriceSetActivity

class CarManagerAdapter(private val context: Context) : EasyRecyclerViewAdapter() {

    override fun getItemLayouts(): IntArray {
        return intArrayOf(R.layout.item_car_manger)
    }

    override fun getRecycleViewItemType(position: Int): Int {
        return 0
    }

    override fun onBindRecycleViewHolder(viewHolder: EasyRecyclerViewHolder?, position: Int) {
        viewHolder?.let {
            val mCarId = it.findViewById<TextView>(R.id.tv_car_id)
            val mCarStatus = it.findViewById<TextView>(R.id.tv_car_status)
            val mCarName = it.findViewById<TextView>(R.id.tv_car_name)
            val mCarNum = it.findViewById<TextView>(R.id.tv_car_number)
            val mLlRemote = it.findViewById<LinearLayout>(R.id.ll_remote_car)
            val mBtnNotRent = it.findViewById<TextView>(R.id.btn_see_not_rent)
            val mBtnAllOrder = it.findViewById<TextView>(R.id.btn_see_all_order)
            val mTvChangePrice = it.findViewById<TextView>(R.id.tv_change_price)

            val entity = list[position] as? SimpleCarBean

            mCarId?.text = "车辆编号：${entity?.carid}"
            mCarStatus?.text = getCarStatus(entity?.status?:0)
            mCarName?.text = entity?.type ?: ""
            mCarNum?.text = entity?.number ?: ""
            mLlRemote?.visibility = if (entity?.remote?:0 > 0) View.VISIBLE else View.GONE
            mLlRemote?.setOnClickListener {
                val intent = Intent(context, RemoteCarActivity::class.java)
                intent.putExtra(CarEntity.EXTRA_BUNDLE_KEY, "MyCar")
                intent.putExtra("Mycar", entity)
                context.startActivity(intent)
            }

            mBtnNotRent?.setOnClickListener {
                NoRentDateActivity.newInstance(context, entity?.carid?:"")
            }

            mBtnAllOrder?.setOnClickListener {
                val intent = Intent(context, OrderManageActivity::class.java)
                intent.putExtra(OrderManageActivity.ORDER_CAR_ID, entity?.carid)
                context.startActivity(intent)
            }

            mTvChangePrice?.setOnClickListener {
                context.startActivity(PriceSetActivity.newInstance(context,entity?.site_car_type_id))
            }
        }

    }

    private fun getCarStatus(status: Int): String? {
        // （0：未审核、1：已审核、3：审核中、 4：暂不出租）
        return when (status) {
            1 -> "已审核"
            2 -> "审核中"
            3 -> "暂不出租"
            else -> "未审核"
        }
    }


}
