package com.jiaoyinbrother.monkeyking.manager.mvpactivity.console.price

import android.view.View
import com.jiaoyinbrother.library.bean.PriceCarBean
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseActivity
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.price.PriceSetActivity
import kotlinx.android.synthetic.main.activity_car_price_manager.*
import java.lang.Exception

class CarPriceManagerActivity : MvpBaseActivity<CarPriceManagerPresenter>(), ICarPriceManagerContract.View {
    private val mAdapter: CarPriceManagerAdapter by lazy {
        val carPriceManagerAdapter = CarPriceManagerAdapter()
        carPriceManagerAdapter.itemClickListener = { priceCarBean, _ ->
            startActivity(PriceSetActivity.newInstance(this@CarPriceManagerActivity, priceCarBean?.id))
        }
        carPriceManagerAdapter
    }

    override fun initListeners() {
        refresh_layout?.setOnRefreshListener {
            presenter?.doRefresh()
        }
        refresh_layout?.setOnLoadMoreListener {
            presenter?.doLoadMore()
        }
        tv_address?.setOnClickListener(::onClick)
    }

    private fun onClick(v: View) {
        try {

        presenter.showSiteDialog()
        }catch (e:Exception){
            e.printStackTrace()
        }
    }

    override fun initPresenter(): CarPriceManagerPresenter {
        return CarPriceManagerPresenter(this, this)
    }

    override fun initToolBar() {
        mainTitle.text = "车型价格"
    }

    override fun initData() {
        presenter.apiSites()
    }

    override fun getLayoutId(): Int {
        return R.layout.activity_car_price_manager
    }

    override fun initView() {
        carPriceManagerRv?.adapter = mAdapter
    }

    override fun finishRefresh() {
        refresh_layout?.finishRefresh()
    }

    override fun finishLoadMore() {
        refresh_layout?.finishLoadMore()
    }

    override fun finishRefreshWithNoMoreData() {
        refresh_layout?.finishRefreshWithNoMoreData()
    }

    override fun finishLoadMoreWithNoMoreData() {
        refresh_layout?.finishLoadMoreWithNoMoreData()
    }

    override fun setEnableLoadMore(b: Boolean) {
        refresh_layout?.setEnableLoadMore(b)
    }

    override fun updateSite(name: String?) {
        tv_address?.text = name
    }

    override fun showAllNoDataView() {
        tv_address.visibility = View.GONE
        showNoDataView()
        loading_layout?.setEmptyText("登录账号未绑定有效门店")
        refresh_layout.setEnableRefresh(false)
        refresh_layout?.setEnableLoadMore(false)
    }

    override fun showNoDataView() {
        setEnableLoadMore(false)
        loading_layout?.setEmptyText("暂时没有任何车辆")
        loading_layout?.showEmpty()
    }

    override fun showListData(data: List<PriceCarBean>) {
        loading_layout?.showContent()
        mAdapter.list = data
        mAdapter.notifyDataSetChanged()
    }

}
