package com.jiaoyinbrother.monkeyking.manager.mvpactivity.cost

import android.content.Context
import com.jiaoyinbrother.library.base.BasePresenterImpl
import com.jiaoyinbrother.library.bean.BillHistoriesRequest
import com.jiaoyinbrother.library.bean.BillHistoriesResult
import com.jiaoyinbrother.library.retrofit.BaseObserver
import com.jiaoyinbrother.library.retrofit.RetrofitHelper
import io.reactivex.android.schedulers.AndroidSchedulers
import io.reactivex.schedulers.Schedulers
import java.util.concurrent.TimeUnit

class CostPresenter(context: Context,view: CostContract.View): BasePresenterImpl<CostContract.View>(context,view) ,CostContract.Presenter{


    companion object {
        const val ORDER_DETAIL = "ORDER_DETAIL"
    }

    override fun requestBillHistories(orderId: String?) {
        val request = BillHistoriesRequest()
        request.order_id = orderId
        val mRetrofitService = RetrofitHelper.getInstance(context).service
        val hashMap = RetrofitHelper.getInstance(context).convertRequestToMap(request)
        val observable = mRetrofitService.billHistories(hashMap).debounce(1000, TimeUnit.MILLISECONDS)
        observable.subscribeOn(Schedulers.io()).doOnSubscribe {
            view.showLoadingDialog()
        }.observeOn(AndroidSchedulers.mainThread()).subscribe(object : BaseObserver<BillHistoriesResult>(context, this) {
            override fun onSuccess(response: BillHistoriesResult) {
                view.onBillHistories(response?.history_list)
                view.dismissLoadingDialog()
            }
        })
    }
}