package com.jiaoyinbrother.monkeyking.manager.mvpactivity.dataanalysis

import android.view.View
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseActivity
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.dataanalysis.car.CarDataAnalysisFragment
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.dataanalysis.comment.CommentDataAnalysisFragment
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.dataanalysis.deal.DealDataAnalysisFragment
import kotlinx.android.synthetic.main.activity_data_analysis.*
import java.lang.Exception

class DataAnalysisActivity : MvpBaseActivity<DataAnalysisPresenter>(), IDataAnalysisContract.View {
    private val fragments by lazy {
        listOf(
                DealDataAnalysisFragment(),
                CarDataAnalysisFragment(),
                CommentDataAnalysisFragment()
        )
    }

    override fun initListeners() {
        rg_data.setOnCheckedChangeListener { _, checkedId ->
            val beginTransaction = supportFragmentManager.beginTransaction()
            when (checkedId) {
                R.id.rb_deal -> {
                    beginTransaction.show(fragments[0])
                            .hide(fragments[1])
                            .hide(fragments[2])
                }
                R.id.rb_car -> {
                    beginTransaction.hide(fragments[0])
                            .show(fragments[1])
                            .hide(fragments[2])
                }
                R.id.rb_comment -> {
                    beginTransaction.hide(fragments[0])
                            .hide(fragments[1])
                            .show(fragments[2])
                }
                else -> {
                }
            }
            beginTransaction.commit()
        }
        tv_address?.setOnClickListener(::onClick)
    }

    private fun onClick(v: View) {
        try {
            presenter.showSiteDialog()
        } catch (e: Exception) {
            e.printStackTrace()
        }
    }


    override fun initPresenter(): DataAnalysisPresenter {
        return DataAnalysisPresenter(this, this)
    }

    override fun initToolBar() {
        mainTitle.text = "数据中心"
    }

    override fun initData() {
        presenter.apiSites()
    }

    override fun getLayoutId(): Int {
        return R.layout.activity_data_analysis
    }

    override fun initView() {
        rg_data.check(R.id.rb_deal)
        supportFragmentManager.beginTransaction()
                .add(R.id.fl_container, fragments[2])
                .hide(fragments[2])
                .add(R.id.fl_container, fragments[1])
                .hide(fragments[1])
                .add(R.id.fl_container, fragments[0])
                .show(fragments[0])
                .commit()

    }

    override fun updateSite(name: String?, id: String?) {
        tv_address?.text = name
        for (fragment in fragments) {
            fragment.updateFragment(id)
        }
    }

    override fun showAllNoDataView() {
        tv_address.visibility = View.GONE
        loading_layout?.setEmptyText("登录账号未绑定有效门店")
        loading_layout?.showEmpty()
    }

}