package com.jiaoyinbrother.monkeyking.manager.mvpactivity.dataanalysis.car

import android.os.Bundle
import android.view.View
import com.jiaoyinbrother.library.bean.OrderStatsRequest
import com.jiaoyinbrother.library.util.LogUtil
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.dataanalysis.BaseDataAnalysisFragment
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.dataanalysis.sales.SalesAnalysisActivity
import com.jiaoyinbrother.monkeyking.manager.view.EchartsView
import kotlinx.android.synthetic.main.fragment_car_data_analysis.*

class CarDataAnalysisFragment : BaseDataAnalysisFragment<CarDataAnalysisPresenter>(),
    ICarDataAnalysisContract.View {


    override fun initPresenter(): CarDataAnalysisPresenter {
        return CarDataAnalysisPresenter(requireContext(), this)
    }

    override fun getLayoutId(): Int {
        return R.layout.fragment_car_data_analysis
    }

    override fun initToolbar(savedInstanceState: Bundle?) {}

    override fun initViews(view: View?, savedInstanceState: Bundle?) {}

    override fun initData() {
        presenter.initData()
    }

    override fun initListeners() {
        fg_car_sales_day?.setOnClickListener {
            presenter.setDataType(OrderStatsRequest.DAY)
        }

        fg_car_sales_week?.setOnClickListener {
            presenter.setDataType(OrderStatsRequest.WEEK)
        }

        fg_car_sales_month?.setOnClickListener {
            presenter.setDataType(OrderStatsRequest.MONTH)
        }

        fg_car_sales_date?.setOnClickListener {
            presenter.datetimeDialog(childFragmentManager)
        }

        fg_car_sales_refresh?.setOnRefreshListener {
            presenter.refreshData()
        }

        fg_car_sales_more?.setOnClickListener {
            startActivity(
                SalesAnalysisActivity.newInstance(
                    requireContext(), presenter.site_id, presenter.data_type
                )
            )
        }
    }

    override fun onHiddenChanged(hidden: Boolean) {
        super.onHiddenChanged(hidden)
        if (!hidden) {
            LogUtil.e("Lyy ---->> onHiddenChanged")
            presenter.onLoadECarSalesCharts()
            presenter.onLoadECarStockCharts()
        }
    }

    override fun dismissLoadingDialog() {
        super.dismissLoadingDialog()
        fg_car_sales_refresh?.finishRefresh()
    }

    override fun updateFragment(id: String?) {
        presenter.site_id = id
        presenter.refreshData()
    }

    override fun setCarStockData(data: String?) {
        fg_stock_chart?.refreshChart(object : EchartsView.OnRefreshChartListener {
            override fun onRefresh() {
                fg_stock_chart?.loadUrl("javascript:setCarStockData($data)")
            }
        })
    }

    override fun setCarSalesData(data: String?) {
        fg_sales_chart?.refreshChart(object : EchartsView.OnRefreshChartListener {
            override fun onRefresh() {
                fg_sales_chart?.loadUrl("javascript:setCarRentTop($data)")
            }
        })
    }

    override fun setDate(date: String) {
        fg_car_sales_date?.text = date
    }

}