package com.jiaoyinbrother.monkeyking.manager.mvpactivity.dataanalysis.comment

import android.os.Bundle
import android.view.View
import com.jiaoyinbrother.library.bean.OrderStatsBean
import com.jiaoyinbrother.library.bean.OrderStatsRequest
import com.jiaoyinbrother.library.bean.SiteMarkResult
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.dataanalysis.BaseDataAnalysisFragment
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.dataanalysis.deal.DealDataAnalysisAdapter
import com.jiaoyinbrother.monkeyking.manager.view.IOSdialog.IOSAlertDialog
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.dataanalysis.detail.DetailAnalysisActivity
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.dataanalysis.detail.DetailPresenter
import kotlinx.android.synthetic.main.fragment_comment_data_analysis.*

class CommentDataAnalysisFragment : BaseDataAnalysisFragment<CommentDataAnalysisPresenter>(),
    ICommentDataAnalysisContract.View, DealDataAnalysisAdapter.DataAnalysisItemClickListener {

    private val adapter by lazy {
        DealDataAnalysisAdapter(presenter.list)
    }

    override fun updateFragment(id: String?) {
        presenter.site_id = id
        presenter.refresh()
    }

    override fun initListeners() {
        rg_type?.setOnCheckedChangeListener { _, checkedId ->
            presenter.setDataType(
                when (checkedId) {
                    R.id.rb_day -> {
                        OrderStatsRequest.DAY
                    }
                    R.id.rb_week -> {
                        OrderStatsRequest.WEEK
                    }
                    R.id.rb_month -> {
                        OrderStatsRequest.MONTH
                    }
                    else -> {
                        OrderStatsRequest.DAY
                    }
                }
            )
        }
        tv_time?.setOnClickListener {
            presenter.datetimeDialog(childFragmentManager)
        }
        srl_deal?.setOnRefreshListener {
            presenter.refresh()
        }

    }

    override fun dismissLoadingDialog() {
        super.dismissLoadingDialog()
        srl_deal?.finishRefresh()
    }

    override fun initViews(view: View?, savedInstanceState: Bundle?) {}

    override fun initData() {
        presenter.initData()
    }

    override fun initToolbar(savedInstanceState: Bundle?) {
        adapter.dataAnalysisItemClickListener = this
        rv_data?.adapter = adapter
        rg_type?.check(R.id.rb_day)
    }

    override fun updateView() {
        adapter.setDataType(presenter.data_type)
        adapter.notifyDataSetChanged()
    }

    override fun showTime(time: String) {
        tv_time?.text = time
    }

    override fun showRating(response: SiteMarkResult) {
        tv_rating_all.text = response.rate0
        tv_rating_car_hardware.text = "车辆硬件 ${response.rate_car_hardware ?: 0}"
        tv_rating_service_level.text = "服务水平 ${response.rate_service_level ?: 0}"
        tv_rating_all_desc.text = response.rate_desc
        tv_rating_car_clean.text = "车辆清洁 ${response.rate_car_clean ?: 0}"
        tv_rating_take_return.text = "取还便捷 ${response.rate_take_return ?: 0}"
    }

    override fun getLayoutId(): Int {
        return R.layout.fragment_comment_data_analysis
    }


    override fun initPresenter(): CommentDataAnalysisPresenter {
        return CommentDataAnalysisPresenter(requireContext(), this)
    }

    override fun onQuestionClick(data: OrderStatsBean, position: Int) {
        IOSAlertDialog(requireContext()).builder()
            .setTitle(data.type_name)
            .setMsg(data.type_desc, false)
            .setRightButton("知道了") {}
            .show()
    }

    override fun onItemClick(data: OrderStatsBean, position: Int) {
        startActivity(
            DetailAnalysisActivity.newInstance(
                requireContext(), presenter.site_id, DetailPresenter.ANALYSIS_MARK, data
            )
        )
    }
}