package com.jiaoyinbrother.monkeyking.manager.mvpactivity.dataanalysis.deal

import android.os.Bundle
import android.view.View
import com.jiaoyinbrother.library.bean.OrderStatsBean
import com.jiaoyinbrother.library.bean.OrderStatsRequest
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.dataanalysis.BaseDataAnalysisFragment
import com.jiaoyinbrother.monkeyking.manager.view.IOSdialog.IOSAlertDialog
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.dataanalysis.detail.DetailAnalysisActivity
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.dataanalysis.detail.DetailPresenter
import com.jiaoyinbrother.monkeyking.manager.util.WkAlertDialogFactory
import kotlinx.android.synthetic.main.fragment_deal_data_analysis.*

class DealDataAnalysisFragment : BaseDataAnalysisFragment<DealDataAnalysisPresenter>(),
    IDealDataAnalysisContract.View, DealDataAnalysisAdapter.DataAnalysisItemClickListener {

    private val adapter by lazy {
        DealDataAnalysisAdapter(presenter.list)
    }

    override fun updateFragment(id: String?) {
        presenter.site_id = id
        presenter.refresh()
    }

    override fun initListeners() {
        rg_type?.setOnCheckedChangeListener { _, checkedId ->
            presenter.setDataType(
                when (checkedId) {
                    R.id.rb_day -> {
                        OrderStatsRequest.DAY
                    }
                    R.id.rb_week -> {
                        OrderStatsRequest.WEEK
                    }
                    R.id.rb_month -> {
                        OrderStatsRequest.MONTH
                    }
                    else -> {
                        OrderStatsRequest.DAY
                    }
                }
            )
        }
        tv_time?.setOnClickListener {
            presenter.datetimeDialog(childFragmentManager)
        }
        srl_deal?.setOnRefreshListener {
            presenter.refresh()
        }

    }

    override fun dismissLoadingDialog() {
        super.dismissLoadingDialog()
        srl_deal?.finishRefresh()
    }

    override fun initViews(view: View?, savedInstanceState: Bundle?) {}

    override fun initData() {
        presenter.initData()
    }

    override fun getLayoutId(): Int {
        return R.layout.fragment_deal_data_analysis
    }

    override fun initToolbar(savedInstanceState: Bundle?) {
        adapter.dataAnalysisItemClickListener = this
        rv_data?.adapter = adapter
        rg_type?.check(R.id.rb_day)
    }

    override fun initPresenter(): DealDataAnalysisPresenter {
        return DealDataAnalysisPresenter(requireContext(), this)
    }

    override fun updateView() {
        adapter?.setDataType(presenter.data_type)
        adapter.notifyDataSetChanged()
    }

    override fun showTime(time: String) {
        tv_time?.text = time
    }

    override fun onQuestionClick(data: OrderStatsBean, position: Int) {
        IOSAlertDialog(requireContext()).builder()
                .setTitle(data.type_name)
                .setMsg(data.type_desc,false)
                .setRightButton("知道了"){}
                .show()
    }

    override fun onItemClick(data: OrderStatsBean, position: Int) {
        startActivity(
            DetailAnalysisActivity.newInstance(
                requireContext(), presenter.site_id, DetailPresenter.ANALYSIS_ORDER, data
            )
        )
    }
}