package com.jiaoyinbrother.monkeyking.manager.mvpactivity.dataanalysis.detail

import android.content.Context
import android.content.Intent
import android.support.v7.widget.LinearLayoutManager
import com.jiaoyinbrother.library.bean.OrderStatsBean
import com.jiaoyinbrother.library.bean.OrderStatsRequest
import com.jiaoyinbrother.library.util.LogUtil
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseActivity
import com.jiaoyinbrother.monkeyking.manager.view.EchartsView
import kotlinx.android.synthetic.main.activity_analyze_detail.*


class DetailAnalysisActivity : MvpBaseActivity<DetailPresenter>(),
    IDetailContract.View {

    private var mAdapter: AnalysisTabAdapter? = null

    companion object {
        // 网点ID
        const val SITE_ID = "SITE_ID"

        // 交易 or 评价
        const val ANALYSIS_ITEMS = "ANALYSIS_ITEMS"

        // type 类型
        const val ANALYSIS_CLASS = "ANALYSIS_CLASS"

        fun newInstance(
            context: Context,
            siteId: String?,
            items: Int,
            data: OrderStatsBean
        ): Intent {
            return Intent(context, DetailAnalysisActivity::class.java)
                .putExtra(SITE_ID, siteId)
                .putExtra(ANALYSIS_ITEMS, items)
                .putExtra(ANALYSIS_CLASS, data)
        }
    }

    override fun initPresenter(): DetailPresenter {
        return DetailPresenter(this, this)
    }

    override fun getLayoutId(): Int {
        return R.layout.activity_analyze_detail
    }

    override fun initToolBar() {}

    override fun initView() {
        mAdapter = AnalysisTabAdapter()
        analysis_tab_rv?.layoutManager =
            LinearLayoutManager(this, LinearLayoutManager.HORIZONTAL, false)
        analysis_tab_rv?.adapter = mAdapter
    }

    override fun initData() {
        presenter.initData(intent)
    }

    override fun initListeners() {
        analysis_day_seven?.setOnClickListener {
            presenter.setDayType(OrderStatsRequest.DAY_SEVEN)
        }
        analysis_day_fifteen?.setOnClickListener {
            presenter.setDayType(OrderStatsRequest.DAY_FIFTEEN)
        }
        analysis_day_thirty?.setOnClickListener {
            presenter.setDayType(OrderStatsRequest.DAY_THIRTY)
        }
        mAdapter?.setOnItemClickListener(object : AnalysisTabAdapter.OnItemClickListener {
            override fun onItemClick(entity: OrderStatsBean?, position: Int) {
                entity?.let {
                    mAdapter?.onSelectItem(it.type)
                    presenter.setTabItem(it)
                    mAdapter?.notifyDataSetChanged()
                }
            }
        })
    }

    override fun setToolbarInfo(title: String) {
        mainTitle.text = title
    }

    override fun setModifyData(data: String) {
        analysis_update_time?.text = data
    }

    override fun setTabData(data: ArrayList<OrderStatsBean>?, type: OrderStatsBean?) {
        if (data == null || data.size == 0) {
            return
        }
        mAdapter?.onSelectItem(type?.type)
        mAdapter?.list = data
        mAdapter?.notifyDataSetChanged()
    }

    override fun setAnalysisData(data: String) {
        analysis_chart?.refreshChart(object : EchartsView.OnRefreshChartListener {
            override fun onRefresh() {
                analysis_chart?.loadUrl("javascript:setLine($data)")
            }
        })
    }
}