package com.jiaoyinbrother.monkeyking.manager.mvpactivity.dataanalysis.sales

import android.content.Context
import android.content.Intent
import android.view.View
import com.jiaoyinbrother.library.bean.OrderStatsBean
import com.jiaoyinbrother.library.bean.OrderStatsRequest
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseActivity
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.dataanalysis.detail.DetailAnalysisActivity
import kotlinx.android.synthetic.main.activity_sales_analysis.*

class SalesAnalysisActivity : MvpBaseActivity<SalesPresenter>(), ISalesContract.View {

    companion object {
        fun newInstance(context: Context, siteId: String?, type: String?): Intent {
            return Intent(context, SalesAnalysisActivity::class.java)
                .putExtra(DetailAnalysisActivity.SITE_ID, siteId)
                .putExtra(DetailAnalysisActivity.ANALYSIS_CLASS, type)
        }
    }

    private var mAdapter: SalesAnalysisAdapter? = null

    override fun initPresenter(): SalesPresenter {
        return SalesPresenter(this, this)
    }

    override fun getLayoutId(): Int {
        return R.layout.activity_sales_analysis
    }

    override fun initToolBar() {
        mainTitle.text = "车型销量"
    }

    override fun initView() {
        mAdapter = SalesAnalysisAdapter()
        sales_car_rv?.adapter = mAdapter
    }

    override fun initData() {
        presenter.initData(intent)
    }

    override fun initListeners() {
        sales_day_seven?.setOnClickListener {
            presenter.setDayType(OrderStatsRequest.DAY_SEVEN)
        }
        sales_day_fifteen?.setOnClickListener {
            presenter.setDayType(OrderStatsRequest.DAY_FIFTEEN)
        }
        sales_day_thirty?.setOnClickListener {
            presenter.setDayType(OrderStatsRequest.DAY_THIRTY)
        }
    }

    override fun setSalesRefreshDate(date: String) {
        sales_update_time?.text = date
    }

    override fun setCarSalesData(data: ArrayList<OrderStatsBean>) {
        mAdapter?.list = data
        mAdapter?.notifyDataSetChanged()
        showNoneData(mAdapter?.listSize ?: 1 <= 1)

    }

    private fun showNoneData(b: Boolean) {
        sales_no_data?.visibility = if (b) View.VISIBLE else View.GONE
        sales_car_rv?.visibility = if (b) View.GONE else View.VISIBLE
    }
}