package com.jiaoyinbrother.monkeyking.manager.mvpactivity.dropinthecar

import android.view.View
import com.jiaoyinbrother.library.bean.LocationBean
import com.jiaoyinbrother.library.util.MapUtil
import com.jiaoyinbrother.library.util.UserLocationUtil
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseActivity
import com.jiaoyinbrother.monkeyking.manager.view.IOSdialog.IOSAlertDialog
import kotlinx.android.synthetic.main.activity_drop_in_the_car.*
import kotlinx.android.synthetic.main.main_title.*

class DropInTheCarActivity : MvpBaseActivity<DropInTheCarPresenter>(), IDropInTheCarContract.view {


    override fun setViewFinish() {
        finish()
    }

    private var mPhone: String? = null
    private var mLocation: LocationBean? = null
    private var mSiteName: String? = null


    override fun setLocation(location: LocationBean, siteName: String) {
        mLocation = location
        mSiteName = siteName
    }


    override fun initListeners() {
        //送车地址
        deliveryAddress_ll.setOnClickListener {
            if (mLocation != null)
                MapUtil().startChooseMap(this@DropInTheCarActivity, UserLocationUtil(this@DropInTheCarActivity).userGPSLocation, mLocation!!, mSiteName
                        ?: "")
        }

        //租客信息
        tenantInformation_ll.setOnClickListener {

            presenter.onRenterPhone()
//            IOSAlertDialog(this@DropInTheCarActivity).builder().setCancelable(false).setTitle("温馨提示")
//                    .setMsg("拨打电话: $mPhone", true)
//                    .setLeftButton("取消") { }
//                    .setRightButton("拨打电话") {
//                        presenter.onRenterPhone()
//                    }.show()

        }
    }

    override fun initPresenter(): DropInTheCarPresenter {
        return DropInTheCarPresenter(this, this)
    }

    override fun getLayoutId(): Int {
        return R.layout.activity_drop_in_the_car
    }

    override fun initView() {
    }

    override fun initToolBar() {
        ivTitleName?.text = "出发送车"
        ivTitleBtnRight_ll?.visibility = View.INVISIBLE
    }

    override fun setPickUpTime(time: String) {
        pickUpTime_tv.text = time
    }

    override fun setDeliveryAddress(address: String) {
        deliveryAddress_tv.text = address
    }

    override fun setCarModel(model: String) {
        model_tv.text = model
    }

    override fun setNumberPlate(num: String) {
        numberPlate_tv.text = num
    }


    override fun setPickUpTheCar(refund: String) {
        pickUpTheCar_tv.text = refund
    }

    override fun setPhoneInfo(name: String, phone: String) {
        // 隐藏用户手机号 减少改动
//        tenantInformation_tv.text = name // + " " + phone
        tenantInformation_tv.text = "$name $phone"
        mPhone = phone
    }

    override fun setTitleName(title: String) {
        ivTitleName?.text = title
    }

    override fun setButtonName(name: String) {
        bottom_button?.text = name
    }

    override fun setDialogMsg(msg: String, positive: String, negative: String, orderId: String, onsiteOperation: String) {
        IOSAlertDialog(this@DropInTheCarActivity).builder()
                .setMsg(msg, true)
                .setRightButton(positive) {
                    presenter.onsiteOperation(orderId, onsiteOperation)
                }.setLeftButton(negative) {

                }.show()
    }

    override fun setResult() {

    }

    override fun initData() {
        presenter.getIntent(intent)
    }

    fun confirmedDelivery(view: View) {
        presenter.confirmedDelivery()
    }

    override fun setAddressTitle(title: String) {
        deliveryAddress_title?.text = title
    }
}
