package com.jiaoyinbrother.monkeyking.manager.mvpactivity.feedback

import android.text.Editable
import android.text.TextUtils
import android.text.TextWatcher
import android.view.KeyEvent
import android.view.View
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseActivity
import com.jiaoyinbrother.library.bean.UserFeedbackRequest
import com.jiaoyinbrother.library.util.OldToastUtil
import com.jiaoyinbrother.library.util.TextUtil
import com.jiaoyinbrother.library.util.UserUtil
import com.jiaoyinbrother.monkeyking.manager.util.ActivityTestUtil
import kotlinx.android.synthetic.main.act_feedback.*
import kotlinx.android.synthetic.main.main_title.*


class FeedbackActivity : MvpBaseActivity<FeedbackPresenter>(), IFeedbackContract.view{
    override fun initView() {

    }

    override fun setData() {
        finish();
    }

    override fun initPresenter(): FeedbackPresenter {
        return FeedbackPresenter(this, this)
    }

    private val contentWatcher = object : TextWatcher {

        override fun onTextChanged(s: CharSequence, start: Int, before: Int, count: Int) {
            val editable = content_edittext.text.toString()
            val str = TextUtil.StringFilter(editable)
            if (editable != str) {
                content_edittext.setText(str)
                content_edittext.setSelection(str.length) // 光标置后
            }

        }

        override fun beforeTextChanged(s: CharSequence, start: Int, count: Int, after: Int) {

        }

        override fun afterTextChanged(s: Editable) {
            val lenth = s.length
            count_textview.text = "还可输入" + (200 - lenth) + "个字"
            updateSubmitButton(s.toString())
        }
    }

    private fun getFeedbackRequest(): UserFeedbackRequest {
        val userFeedbackRequest = UserFeedbackRequest()
        if (null != content_edittext) {
            val contentStr = content_edittext.text.toString()
            userFeedbackRequest.feedback = contentStr
        }

        userFeedbackRequest.work_sheet_type = "PRODUCT_FEEDBACK"
        userFeedbackRequest.type = "OTHER"

        //			uid在租车就是手机号,自驾游不是
        var userUtil = UserUtil(this@FeedbackActivity)
        if (!TextUtils.isEmpty(userUtil.uid)) {
            userFeedbackRequest.userphone = userUtil.uid
        }
        return userFeedbackRequest
    }

    override fun getLayoutId(): Int {
        return R.layout.act_feedback
    }

    override fun initToolBar() {

    }

    override fun initListeners() {
        content_edittext.addTextChangedListener(contentWatcher)
    }

    override fun initData() {
        ivTitleName?.text = resources.getString(R.string.feedback)
        ivTitleBtnRight_ll?.visibility = View.INVISIBLE

        updateSubmitButton("")

    }

    private fun updateSubmitButton(editable: String) {
        bottom_button.isEnabled = !editable.isEmpty()
    }

    fun onPost(view: View) {
        if (null == content_edittext)
            return
        val str2 = content_edittext.text.toString()
        if (null == str2 || str2.isEmpty()) {
            OldToastUtil.show(this@FeedbackActivity, "请输入内容")
            return
        }
        presenter.requestFeedback(getFeedbackRequest())
    }

    override fun onKeyDown(keyCode: Int, event: KeyEvent): Boolean {
        if (keyCode == KeyEvent.KEYCODE_BACK) {
            finish()
        }
        return false
    }

}
