package com.jiaoyinbrother.monkeyking.manager.mvpactivity.feedback

import android.content.Context
import com.jiaoyinbrother.library.base.BasePresenterImpl
import com.jiaoyinbrother.library.bean.BaseResult
import com.jiaoyinbrother.library.bean.UserFeedbackRequest
import com.jiaoyinbrother.library.retrofit.BaseObserver
import com.jiaoyinbrother.library.retrofit.RetrofitHelper
import io.reactivex.android.schedulers.AndroidSchedulers
import io.reactivex.schedulers.Schedulers
import java.util.concurrent.TimeUnit

/**
 * Created by Administrator on 2018/7/3.
 */

class FeedbackPresenter(context: Context, view: IFeedbackContract.view) : BasePresenterImpl<IFeedbackContract.view>(context, view),
        IFeedbackContract.presenter {

    override fun requestFeedback(request: UserFeedbackRequest?) {

        var mRetrofitService = RetrofitHelper.getInstance(context).service

        val hashMap = RetrofitHelper.getInstance(context).convertRequestToMap(request)

        var observable = mRetrofitService.addFeedback(hashMap).debounce(1000, TimeUnit.MILLISECONDS)
        observable.subscribeOn(Schedulers.io()).
                doOnSubscribe {
                    view.showLoadingDialog()
                }.
                observeOn(AndroidSchedulers.mainThread()).
                subscribe(object: BaseObserver<BaseResult>(context,this) {
                    override fun onSuccess(response: BaseResult?) {
                        view.showToast("反馈成功")
                        view.setData()
                        view.dismissLoadingDialog()
                    }
                })

    }

}

