package com.jiaoyinbrother.monkeyking.manager.mvpactivity.login

import android.content.Intent
import com.jiaoyinbrother.library.base.IBasePresenter
import com.jiaoyinbrother.library.bean.WeChatBean
import com.jiaoyinbrother.library.bean.WeChatUserInfoResult
import com.jiaoyinbrother.library.view.IBaseView

interface LoginContract {

    interface View : IBaseView {
        fun getPhone(): String
        fun getCode(): String
        fun getPassword(): String
        fun setPasswordShow()
        fun setCodeShow()
        fun setCodeInfo(code: String)
        fun setCodeFocus()
        fun setErrorTips(tips: String)
        fun setCodeSmsEnable(b: Boolean)
        fun setCodeVoiceEnable(b: Boolean)
        fun setCountDown(s: String)
        fun setIMParty(flag: String, b: Boolean)
        fun setThirdPartyLogin(b: Boolean)
        fun setPicCode(pic: String, msg: String)
        fun setUserBind(result: WeChatUserInfoResult)
        fun setLoginEnable(b:Boolean)
    }

    interface Presenter : IBasePresenter {
        fun getData(intent: Intent)
        fun doPasswordChecked()
        fun doCodeChecked()
        fun doTextChangeWatcher(s: String)
        fun getPicCode(code: String)
        fun doPicCode()
        fun doSmsCode()
        fun doVoiceCode()
        fun doLogin()
        fun doWeChat()
        fun doSmsReceiver()
        fun unSmsReceiver()
        fun doWeChatAuth(it: WeChatBean)
        fun doBindLogin(data:Intent?)
//        fun requestIMParty()
    }
}