package com.jiaoyinbrother.monkeyking.manager.mvpactivity.monkeymain

import android.annotation.SuppressLint
import android.app.ProgressDialog
import android.arch.lifecycle.Observer
import android.content.Intent
import android.text.TextUtils
import android.view.View
import com.alibaba.android.arouter.facade.annotation.Route
import com.alibaba.android.arouter.launcher.ARouter
import com.hyphenate.chat.EMMessage
import com.jeremyliao.livedatabus.LiveDataBus
import com.jiaoyinbrother.library.bean.AndroidBean
import com.jiaoyinbrother.library.bean.WebViewConfigEntity
import com.jiaoyinbrother.library.util.*
import com.jiaoyinbrother.monkeyking.manager.CarEntity
import com.jiaoyinbrother.monkeyking.manager.Constants
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.activity.GeneralWebViewActivity
import com.jiaoyinbrother.monkeyking.manager.adapter.MyFragmentAdapter
import com.jiaoyinbrother.monkeyking.manager.fragment.CustomServiceFragment
import com.jiaoyinbrother.monkeyking.manager.fragment.RentalMyFragment
import com.jiaoyinbrother.monkeyking.manager.fragment.mainordermanager.MaiOrderManagerFragment
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseActivity
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.login.LoginActivity
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.message.MainMessageFragment
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.detail.OrderDetailActivity
import com.jiaoyinbrother.monkeyking.manager.util.CheckVersionUtil
import com.jiaoyinbrother.monkeyking.manager.util.EMUtil
import com.sensorsdata.analytics.android.sdk.SensorsDataAPI
import kotlinx.android.synthetic.main.activity_monkey_main.*


@Route(path = ARouterConstantUtil.ACTIVITY_MAIN)
class MonkeyMainActivity : MvpBaseActivity<MonkeyMainPresenter>(), IMonkeyMainView.View,
    View.OnClickListener {


    private var messageId: String = ""

    //三个页面
    private var mFragmentAdapter: MyFragmentAdapter? = null
    private var maiOrderManagerFragmentNew: MaiOrderManagerFragment? = null
    private var mMineFragment: RentalMyFragment? = null
    private var customServiceFragment: CustomServiceFragment? = null

    //消息页面
    private var mMainMessageFragment: MainMessageFragment? = null

    //版本升级
    private var pdDialog: ProgressDialog? = null// 版本升级进度条

    private var exitFirstTime: Long = 0

    override fun getLayoutId(): Int {
        return R.layout.activity_monkey_main
    }

    override fun initView() {}

    private fun addVersionTextView() {
        val version = UrlUtil.getCurrentEnv()
        when (version) {
            UrlUtil.VERSION_DEBUG -> {
                main_tv_debug.visibility = View.VISIBLE
                main_tv_debug.text = "测"
            }

            UrlUtil.VERSION_RELEASE -> main_tv_debug.visibility = View.GONE

            UrlUtil.VERSION_DEV -> {
                main_tv_debug.visibility = View.VISIBLE
                main_tv_debug.text = "开"
            }

            UrlUtil.VERSION_PRE_RELEASE -> {
                main_tv_debug.visibility = View.VISIBLE
                main_tv_debug.text = "预"
            }
        }
    }


    private fun initARouter() {
        if (!UrlUtil.isReleaseVersion()) {
            ARouter.openLog() // 开启日志
            ARouter.openDebug() // 使用InstantRun的时候，需要打开该开关，上线之后关闭，否则有安全风险
            ARouter.printStackTrace() // 打印日志的时候打印线程堆栈
        }
        ARouter.init(application)
    }


    override fun initPresenter(): MonkeyMainPresenter {
        return MonkeyMainPresenter(this, this)
    }

    override fun initToolBar() {}

    override fun initListeners() {
        radioButtonOrder.setOnClickListener(this)
        radioButtonMsg.setOnClickListener(this)
        radioButtonWorkStation.setOnClickListener(this)
        radioButtonMine.setOnClickListener(this)

        LiveDataBus.get().with(ConstantsUtil.LIVEDATA_EXIT_APPLICATION)
            .observeSticky(this, Observer {
                LogUtil.e("Observer******************" + "LIVEDATA_EXIT_APPLICATION")
                finish()
                System.exit(0)
            })

    }

    @SuppressLint("CheckResult")
    override fun initData() {


        AppCacheUtil(this@MonkeyMainActivity).showNav = false

        travel_main_content_viewpager.offscreenPageLimit = 4
        initARouter()

        mFragmentAdapter = MyFragmentAdapter(this, supportFragmentManager)
        mMineFragment = RentalMyFragment()
        customServiceFragment = CustomServiceFragment()
        maiOrderManagerFragmentNew = MaiOrderManagerFragment()
        mMainMessageFragment = MainMessageFragment()

        /* 版本升级进度 */
        pdDialog = ProgressDialog(this@MonkeyMainActivity)// 创建进度对话框
        pdDialog?.setTitle("正在下载")// 设置标题
        pdDialog?.setCancelable(false)
        pdDialog?.setProgressStyle(ProgressDialog.STYLE_HORIZONTAL)// 设置进度条样
        //更新开发环境标识
        addVersionTextView()
        mFragmentAdapter?.clearFragments()
        mFragmentAdapter?.addFragment(maiOrderManagerFragmentNew)
        mFragmentAdapter?.addFragment(mMainMessageFragment)
        mFragmentAdapter?.addFragment(customServiceFragment)
        mFragmentAdapter?.addFragment(mMineFragment)
        travel_main_content_viewpager.adapter = mFragmentAdapter


        presenter.registerCheckVersionReceiver()
        presenter.requestAdBanner()

        presenter.checkVersion()

// 推送初始化
        EMUtil.instance.initEM(applicationContext);
        EMUtil.instance.addPushListener()
        EMUtil.instance.addMessageListener(mIMListener)

        presenter.doPushInit()

        messageId = intent.getStringExtra(ARouterConstantUtil.IM_FROM_ID) ?: ""
        LogUtil.e("NotifyUtil ---> Main init :" + messageId);
        toChat()

        handleDeepLink(intent)
    }

    override fun onNewIntent(intent: Intent?) {
        super.onNewIntent(intent)
        messageId = intent?.getStringExtra(ARouterConstantUtil.IM_FROM_ID) ?: ""
        LogUtil.e("NotifyUtil ---> Main newIntent :" + messageId);
        toChat()
        handleDeepLink(intent)
    }


    private fun toChat() {
        if (!TextUtils.isEmpty(messageId)) {
            LiveDataBus.get().with("toChat").postValue(messageId)
        }
    }

    override fun onClick(v: View) {
        when (v.id) {
            R.id.radioButtonOrder -> {
                travel_main_content_viewpager.currentItem = 0
                LiveDataBus.get().with(MaiOrderManagerFragment.ORDER_TASKSNUM).postValue(true)
            }
            R.id.radioButtonMsg -> {
                travel_main_content_viewpager.currentItem = 1
                LiveDataBus.get().with(MainMessageFragment.REFRESH_MSG).postValue(true)
            }
            R.id.radioButtonWorkStation -> {
                travel_main_content_viewpager.currentItem = 2
                SensorsDataAPI.sharedInstance().setViewID(radioButtonWorkStation, "home_nav_work")
            }
            R.id.radioButtonMine -> {
                travel_main_content_viewpager.currentItem = 3
                SensorsDataAPI.sharedInstance().setViewID(radioButtonMine, "home_nav_mine")
            }
        }
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        LogUtil.e("onActivityResult -----------——>>>>>> MonkeyMain")
        if (requestCode == Constants.LOGIN_RESULT) {

        }
    }

    override fun onBackPressed() {
        val secondTime = System.currentTimeMillis()
        if (secondTime - exitFirstTime > 2000) {
            showToast("再按一次退出租车帮·悟空")
            exitFirstTime = secondTime
        } else {
            super.onBackPressed()
        }
    }

    override fun onResume() {
        super.onResume()
        if (!UserUtil(this).isLogin()) {
            val intent = Intent(this, LoginActivity::class.java)
            startActivityForResult(intent, Constants.LOGIN_RESULT)
            return
        }

    }

    override fun onDestroy() {
        EMUtil.instance.removeMessageListener(mIMListener)
        presenter.onDestroy()
        super.onDestroy()
    }

    override fun setDownloadCompleted() {
        pdDialog?.dismiss()
        this@MonkeyMainActivity.finish()
    }

    override fun setUpdateProgress(progress: Int) {
        if (progress < 0 || progress > 100) {
            pdDialog?.dismiss()
        } else {
            pdDialog?.show()
            pdDialog?.progress = progress
        }
    }

    override fun setVersionUpdateDialog(android: AndroidBean) {
        CheckVersionUtil(this).showUploadVersionDialog(android, this)
    }


    private val mIMListener = object : EMUtil.OnMessageListener {
        override fun onMessageReceived(messages: List<EMMessage>) {
            LiveDataBus.get().with("MSG_LISTENER").postValue(messages)
        }
    }


    //deeplink跳转订单详情
    private fun handleDeepLink(intent: Intent?) {
        if (intent != null && intent.data != null) {
            LogUtil.e("intent data = " + intent.data.toString())
            var type = ""
            val uri = intent.data
            try {
                val query = uri?.query

                type = uri?.getQueryParameter("type") ?: ""
                LogUtil.e("uri type = $type")

                when (type) {
// from push
                    "HOME" -> {
//                        LiveDataBus.get().with(MainManagerFragment.GO_MAIN_LIVEDATA_KEY)
//                            .postValue(MainManagerFragment.GO_MAIN_HOME)
                        ARouter.getInstance().build(ARouterConstantUtil.ACTIVITY_MAIN).navigation()
                    }
                    "ORDER" -> {
                        val orderID = uri?.getQueryParameter("orderId")
                        if (!TextUtils.isEmpty(orderID)) {
                            val i = Intent(this, OrderDetailActivity::class.java)
                            i.putExtra(ConstantsUtil.ORDER_ID, orderID)
                            i.flags = Intent.FLAG_ACTIVITY_CLEAR_TOP
                            i.addFlags(Intent.FLAG_ACTIVITY_SINGLE_TOP)
                            startActivity(i)
                        }
                    }
                    "URL" -> {
                        val url = uri?.getQueryParameter("url")
                        // http://test-m.wkzuche.com/#/profile/more/bulletin_detail?bulletin_id=313
                        url?.let {
                            if (it.indexOf("bulletin_id") >= 0){
                                val id = getValueByName(url,"bulletin_id")
                                LogUtil.e("Lyy push bulletinId == $id")
                                LiveDataBus.get().with("PUSH_BULLETIN_ID").setValue(id)
                            }
                        }

                        val webViewConfigBean = WebViewConfigEntity()
                        webViewConfigBean.title = "悟空租车"
                        webViewConfigBean.url = url
                        webViewConfigBean.isNeedProgressBar = true
                        webViewConfigBean.isNeedShareButton = false
                        webViewConfigBean.imageUrl = ""
                        webViewConfigBean.description = ""
                        val i = Intent(this, GeneralWebViewActivity::class.java)
                        i.putExtra(CarEntity.FEATURE_ITEM, webViewConfigBean)
                        startActivity(i)
                    }
                }
            } catch (e: Exception) {
                LogUtil.e("handleDeepLink exception, e =$e")
            }
        }
    }


    private fun getValueByName(url: String, name: String): String? {
        var result = ""
        val index = url.indexOf("?")
        val temp = url.substring(index + 1)
        val keyValue = temp.split("&".toRegex()).toTypedArray()
        for (str in keyValue) {
            if (str.contains(name)) {
                result = str.replace("$name=", "")
                break
            }
        }
        return result
    }
}
