package com.jiaoyinbrother.monkeyking.manager.mvpactivity.mywallet

import android.content.Intent
import android.os.Bundle
import android.view.View
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.activity.AccountDetailActivity
import com.jiaoyinbrother.monkeyking.manager.activity.CouponsManageActivity
import com.jiaoyinbrother.monkeyking.manager.activity.MyIntergralActivity
import com.jiaoyinbrother.monkeyking.manager.activity.MyWookongCoinActivity
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseActivity
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.timecashierdesk.TimeCashierDeskActivity
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.timedepositdetail.TimeDepositDetailActivity
import com.jiaoyinbrother.library.bean.UserDetailResult
import com.jiaoyinbrother.library.util.LogUtil
import com.jiaoyinbrother.library.util.UserUtil
import com.jiaoyinbrother.library.view.IBaseView
import kotlinx.android.synthetic.main.activity_my_wallet.*

class MyWalletActivity : MvpBaseActivity<MyWalletPresenter>(), IBaseView, View.OnClickListener {
    private var userDetailResult: UserDetailResult? = null

    override fun onClick(v: View?) {
        val bundle = Bundle()
        when(v){
            relativelayout_balance -> startActivity(AccountDetailActivity::class.java)
            relativelayout_deposit -> handleTimeDeposit()
            relativelayout_wukong_coin -> startMyWookongCoinActivity(bundle)
            relativelayout_coupon -> startActivity(CouponsManageActivity::class.java)
            relativelayout_jifen -> startActivity(MyIntergralActivity::class.java)

        }
    }

    private fun handleTimeDeposit(){
        //        分时押金
        if(userDetailResult?.remote_deposit == null || userDetailResult?.remote_deposit?.pay_method_avai == null)
            return

        LogUtil.e("remoteDeposit=" +userDetailResult?.remote_deposit!!)
        var remoteDeposit = userDetailResult?.remote_deposit!!
        when(remoteDeposit?.enabled){

            UserUtil.DEPOSIT_PAY_ENABLED ->{
                var param = TimeCashierDeskActivity.CashierDeskParamBean()
                param.amount = remoteDeposit.amount.toFloat()
                param.description = "分时押金"
                param.entrance = mainTitle?.text.toString()
                param.warmPrompt = remoteDeposit.warm_prompt ?: ""
                param.payMethodAvailable = remoteDeposit.pay_method_avai
                param.typeAPI = TimeCashierDeskActivity.TYPE_DEPOSIT_PAY
                TimeCashierDeskActivity.startTimeCashierDesk(this@MyWalletActivity, param)
            }
            UserUtil.DEPOSIT_PAY_DISABLED ->{
                TimeDepositDetailActivity.startTimeDespositDetail(this@MyWalletActivity, remoteDeposit.amount )
            }

        }
    }

    private fun startMyWookongCoinActivity(bundle: Bundle) {
        if(userDetailResult== null)
            return;

        var acountResult = userDetailResult?.account
        if (acountResult != null) {
            bundle.putString(MyWookongCoinActivity.WKCOIN, acountResult?.wkcoin.toString())
            if (acountResult?.wkcoin_transfer != null)
                bundle.putInt(MyWookongCoinActivity.WKCOIN_TRANSFER, acountResult?.wkcoin_transfer!!)
            intent = Intent(this@MyWalletActivity, MyWookongCoinActivity::class.java)
            if (bundle != null)
                intent.putExtras(bundle)
            startActivity(intent)
        }
    }

    override fun initPresenter(): MyWalletPresenter {
        return MyWalletPresenter(this@MyWalletActivity,this)
    }

    override fun getLayoutId(): Int {
        return  R.layout.activity_my_wallet
    }

    override fun initView() {

    }

    override fun initToolBar() {
        mainTitle?.text = "我的钱包"

    }

    override fun initData() {
        val intent = this.intent
        val b = intent.extras
        if (b != null) {
            try {
                userDetailResult = b.getSerializable(USER_DETAIL) as UserDetailResult
            } catch (e: Exception) {

            }
        }
        if(userDetailResult == null || userDetailResult?.remote_deposit == null) {
            LogUtil.e("MyWalletActivity userDetailResult == null || userDetailResult?.remote_deposit == null")
            finish()
            return
        }

        var remoteDeposit = userDetailResult?.remote_deposit!!

        var acountResult = userDetailResult?.account
        textview_balance.text = acountResult?.total_amount?.toInt().toString() + "元"


        textview_wukong_coin.text = acountResult?.wkcoin.toString()
        textview_coupon.text = acountResult?.coupon.toString() + "张"
        textview_jifen.text = acountResult?.jf.toString()

        if(remoteDeposit.enabled==UserUtil.DEPOSIT_PAY_ENABLED)
            textview_time_deposit.text = "去支付"
        else{
            //        分时押金
            when(remoteDeposit.status){

                UserUtil.DEPOSIT_REFUNDING->textview_time_deposit.text = userDetailResult?.remote_deposit?.amount.toString() +"元（退回中）"
                else->textview_time_deposit.text = userDetailResult?.remote_deposit?.amount.toString() +"元"
            }
        }


    }

    override fun initListeners() {
        relativelayout_balance.setOnClickListener(this)
        relativelayout_deposit.setOnClickListener(this)
        relativelayout_wukong_coin.setOnClickListener(this)
        relativelayout_coupon.setOnClickListener(this)
        relativelayout_jifen.setOnClickListener(this)
    }

    companion object {
        const val USER_DETAIL = "USER_DETAIL"


    }

}
