package com.jiaoyinbrother.monkeyking.manager.mvpactivity.notrent

import android.content.Context
import android.content.Intent
import android.view.View
import com.jiaoyinbrother.library.bean.UnavailableBean
import com.jiaoyinbrother.library.util.ConstantsUtil
import com.jiaoyinbrother.library.widget.GeneralBottomButton
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseActivity
import com.monkey.datetimelibrary.listener.OnSelectDateListener
import com.monkey.datetimelibrary.view.NoRentView
import kotlinx.android.synthetic.main.activity_not_rent.*
import java.util.*

class NoRentDateActivity : MvpBaseActivity<NotRentPresenter>(), INotRentContract.View, View.OnClickListener {


    override fun initPresenter(): NotRentPresenter {
        return NotRentPresenter(this, this)
    }

    override fun getLayoutId(): Int {
        return R.layout.activity_not_rent
    }

    override fun initView() {}

    override fun initToolBar() {
        mainTitle.text = getString(R.string.title_not_rent)
    }

    override fun initData() {
        onSave.disable()
        presenter.getData(intent)
    }

    override fun initListeners() {
        rbSetSingle.setOnClickListener(this)
        rbSetMore.setOnClickListener(this)
        noRentView.setNoRentListener(object : OnSelectDateListener {
            override fun onSelectSingleDate(date: Date) {
                presenter.showReason(date, null)
            }

            override fun onSelectMoreDate(sd: Date, ed: Date) {
                presenter.showReason(sd, ed)
            }

            override fun onSelectCancel() {
                onSave.disable()
            }

        })

        onSave.setListener(object : GeneralBottomButton.SubmitListener {
            override fun submit() {
                presenter.updateNoRent(noRentView.unavailableList)
            }
        })
    }

    override fun onClick(v: View?) {
        when (v?.id) {
            R.id.rbSetSingle -> noRentView.setSelectMode(NoRentView.SINGLE)
            R.id.rbSetMore -> noRentView.setSelectMode(NoRentView.MORE)
        }
    }

    override fun setNoRentDate(data: ArrayList<UnavailableBean>) {
        noRentView.setData(data)
    }

    override fun setActiveSave(active: Boolean) {
        if (active) onSave.normal() else onSave.disable()
    }

    override fun setNoRentReason(code: Int, sd: Date, ed: Date?) {
        noRentView.setReason(code, sd, ed)
    }

    override fun setNoRentCancel() {
        if (rbSetMore.isChecked){
            noRentView.clearCalendar()
        }
    }

    override fun setNoRentSuccess() {
        finish()
    }

    companion object {
        fun newInstance(context: Context, carID: String) {
            val intent = Intent(context, NoRentDateActivity::class.java)
            intent.putExtra(ConstantsUtil.CAR_ID, carID)
            context.startActivity(intent)
        }
    }
}