package com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.delivercar

import android.content.Context
import android.content.Intent
import android.support.v7.widget.AppCompatEditText
import android.view.MotionEvent
import android.view.View
import android.view.inputmethod.InputMethodManager
import android.widget.EditText
import com.jeremyliao.livedatabus.LiveDataBus
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.delivercar.fragments.main.DeliverCarMainFragment
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.refundcar.fragment.main.RefundMainFragment
import com.jiaoyinbrother.monkeyking.manager.view.IOSdialog.IOSAlertDialog
import com.jiaoyinbrother.library.bean.OrderDetailResult
import com.jiaoyinbrother.library.util.ConstantsUtil
import com.jiaoyinbrother.library.util.ConstantsUtil.ORDER_ID
import com.jiaoyinbrother.library.util.LogUtil
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseActivity

class DeliverCarActivity: MvpBaseActivity<DeliverCarPresenter>(), IDeliverCarContract.IDeliverCarView,FragmentListerner {


    override fun setNoauthTakeCarDialog() {
        IOSAlertDialog(this)
                .builder()
                .setCancelable(false)
                .setTitle("温馨提示")
                .setMsg("用户尚未进行实名认证，不能办理取车。请指导用户前往“悟空租车”APP进行实名认证", true)
                .setRightButton("我知道了") {
                    setDataError()
                }
                .show()
    }

    override fun setDataError() {
        finish()
    }

    override fun setOrderDetail(orderDetailResult: OrderDetailResult) {

        if (findFragment(RefundMainFragment::class.java) == null && orderDetailResult!=null) {
            loadRootFragment(R.id.fl_container, DeliverCarMainFragment.newInstance(orderDetailResult!!))
        }
    }

    override fun initPresenter(): DeliverCarPresenter {
        return DeliverCarPresenter(this,this)
    }

    override fun showRefreshButton(b: Boolean) {
        LogUtil.e("showRefreshButton, b = $b")
        if(b) {
            subTitle.text = "刷新"
            subTitle.visibility = View.VISIBLE
            subTitle.setOnClickListener{
                LiveDataBus.get().with(DELIVER_CAR_REFRESH).postValue(true)
            }
        }else{
            LogUtil.e("")
            subTitle.text = ""
            subTitle.visibility = View.GONE
        }
    }

//    private var orderDetailResult: OrderDetailResult? = null

    override fun getLayoutId(): Int {
        return R.layout.activity_refund_car
    }

    override fun initView() {
    }

    override fun initToolBar() {
        mainTitle.text = "办理取车"
    }

    override fun initData() {
        val orderId = intent.getStringExtra(ORDER_ID)
        presenter.getOrderDetail(orderId)
    }

    override fun initListeners() {}

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        LogUtil.e("onActivityResult************  activity")
    }


    override fun onBackPressedSupport() {
        IOSAlertDialog(this).builder().setTitle("温馨提示").setMsg("确认退出办理取车流程，确认后不保存之前填写信息", true)
                .setRightButton("确认") {
                    setResult(ConstantsUtil.ORDER_REFRESH_CODE)
                    super.onBackPressedSupport()
                }.setLeftButton("取消") {}.show()
    }

    override fun onTouchEvent(event: MotionEvent): Boolean {
        LogUtil.e("onTouchEvent，event.action =" + event.action )
        if (event.action === MotionEvent.ACTION_DOWN) {
            val v = currentFocus
            if (v != null && (v !is EditText || v !is AppCompatEditText)) {
                val im = getSystemService(Context.INPUT_METHOD_SERVICE) as InputMethodManager
                im?.hideSoftInputFromWindow(this@DeliverCarActivity.currentFocus?.windowToken, InputMethodManager.HIDE_NOT_ALWAYS)

            }
        }

        return super.onTouchEvent(event)
    }

    companion object {
        const val DELIVER_CAR_REFRESH = "DELIVER_CAR_REFRESH"
    }



}
