package com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.delivercar

import android.content.Context
import com.jiaoyinbrother.library.base.BasePresenterImpl
import com.jiaoyinbrother.library.bean.OrderDetailRequest
import com.jiaoyinbrother.library.bean.OrderDetailResult
import com.jiaoyinbrother.library.bean.OrdersBean
import com.jiaoyinbrother.library.retrofit.ApiException
import com.jiaoyinbrother.library.retrofit.BaseObserver
import com.jiaoyinbrother.library.retrofit.RetrofitHelper
import com.jiaoyinbrother.library.util.LogUtil
import com.jiaoyinbrother.library.util.UserUtil
import com.jiaoyinbrother.monkeyking.manager.R
import io.reactivex.android.schedulers.AndroidSchedulers
import io.reactivex.schedulers.Schedulers
import java.util.concurrent.TimeUnit

class DeliverCarPresenter(context: Context?, view: IDeliverCarContract.IDeliverCarView?) : BasePresenterImpl<IDeliverCarContract.IDeliverCarView>(context, view) ,IDeliverCarContract.IDeliverCarPresenter{

    override fun getOrderDetail(orderID: String) {

        val request = OrderDetailRequest()
        request.uid = UserUtil(context).uid
        request.orderid = orderID
        val service = RetrofitHelper.getInstance(context).service
        val params = RetrofitHelper.getInstance(context).convertRequestToMap(request)
        val observable = service.getOrderDetail(params).debounce(1000, TimeUnit.MILLISECONDS)
        observable.subscribeOn(Schedulers.io()).doOnSubscribe {
            view.showLoadingDialog()
        }.observeOn(AndroidSchedulers.mainThread()).subscribe(object : BaseObserver<OrderDetailResult>(context, this) {
            override fun onSuccess(response: OrderDetailResult) {
                view.dismissLoadingDialog()



                LogUtil.e("Lyy noauth_takecar = " + response.noauth_takecar)
                if (response.noauth_takecar == 1){
                    view.setNoauthTakeCarDialog()
                }

                view.setOrderDetail(response)

            }

            override fun onAPIError(apiException: ApiException?) {
                super.onAPIError(apiException)
                view.setDataError()
            }
        })
    }


}