package com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.delivercar.fragments.contract

import android.arch.lifecycle.Observer
import android.os.Bundle
import android.os.CountDownTimer
import android.support.v4.content.ContextCompat
import android.view.View
import com.jeremyliao.livedatabus.LiveDataBus
import com.jiaoyinbrother.library.bean.ContractPreRequest
import com.jiaoyinbrother.library.bean.ContractPreResult
import com.jiaoyinbrother.library.bean.OrderDetailResult
import com.jiaoyinbrother.library.bean.OrderExecuteRequest
import com.jiaoyinbrother.library.util.ConstantsUtil
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseFragment
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.delivercar.fragments.main.DeliverCarMainFragment
import com.jiaoyinbrother.monkeyking.manager.view.IOSdialog.IOSAlertDialog
import kotlinx.android.synthetic.main.fragment_deliver_car_contract.*

class DeliverCarContractFragment : MvpBaseFragment<DeliverCarContractPresenter>(), IDeliverCarContractModel.View {

    private var isCountDownTimeEnd = false

    private var mHintDialog: IOSAlertDialog? = null

    private var mContractPreResultState : String ?= null

    private var mContractPreResultType : Int = 1

    companion object {
        fun newInstance(): DeliverCarContractFragment {
            val args = Bundle()
            val fragment = DeliverCarContractFragment()
            fragment.arguments = args
            return fragment
        }
    }

    override fun initPresenter(): DeliverCarContractPresenter {
        return DeliverCarContractPresenter(_mActivity, this)
    }

    override fun getLayoutId(): Int {
        return R.layout.fragment_deliver_car_contract
    }

    override fun initViews(view: View?, savedInstanceState: Bundle?) {

        mHintDialog = IOSAlertDialog(context).builder().setTitle("温馨提示").setMsg("您签署过程中是否遇到问题，如遇到问题可线下签署纸质合同！是否继续签署电子合同？", true)
                .setRightButton("是") {
                    //                                contract_submit.text = "完成"
//                                contract_submit.disable()
                    contract_submit.visibility = View.GONE

                }
                .setLeftButton("否") {
                    //                                contract_submit.text = "签署纸质合同"
//                                contract_submit.normal()
                    contract_submit?.visibility = View.VISIBLE
                    contract_submit_done?.visibility = View.GONE

                }
    }

    override fun initToolbar(savedInstanceState: Bundle?) {
    }

    private var timer : CountDownTimer ?=null
    override fun initData() {
//        contract_electronic.disable()
//        contract_submit.disable()

        LiveDataBus.get().with(ConstantsUtil.CONTRACT_PRE).observe(this, Observer {
            if (it as Boolean) presenter.initPreContract()
        })

        LiveDataBus.get().with(ConstantsUtil.CONTRACT_BACK).observe(this, Observer {
            if (it as Boolean) presenter.doContractSignBack()
        })

        LiveDataBus.get().with(ConstantsUtil.LIVEDATA_ORDER_EXCUTE_REQUEST).observeSticky(this, Observer {
            presenter.getOrderExecuteRequest(it as OrderExecuteRequest)
        })

        LiveDataBus.get().with("CONTRACT_SUCCESS").observe(this, Observer {
            presenter.doContractSuccess()
        })

    }

    override fun initListeners() {
        contract_submit?.setOnClickListener {
            presenter.doContractSubmit()
        }
        contract_submit_done?.setOnClickListener {
            presenter.doContractSubmit()
        }

        contract_electronic_face?.setOnClickListener {
            presenter.doContractElectronic("FACE")
        }

        contract_electronic_msg?.setOnClickListener {
            presenter.doContractElectronic(null)
        }

        loadingLayout?.setRetryListener {
            presenter.initPreContract()
        }
    }

    fun setData(result: OrderDetailResult) {
        presenter.getOrderInfo(result)
    }

    override fun onBackPressedSupport(): Boolean {
        presenter.onBackPressedSupport()
        return true
    }

    override fun setSchoolBack() {
        val p = parentFragment as DeliverCarMainFragment
        p.onSelectPage(DeliverCarMainFragment.PAGE_FOUR, DeliverCarMainFragment.PAGE_FIVE)
    }

    override fun setNormalBack() {
        val p = parentFragment as DeliverCarMainFragment
        p.onSelectPage(DeliverCarMainFragment.PAGE_THREE, DeliverCarMainFragment.PAGE_FOUR)
    }

    override fun setErrorPager(b: Boolean) {
        if (b) loadingLayout?.showError() else loadingLayout?.showContent()
    }

    override fun setTimeLine(type: Int, index: Int) {
        contract_time_line?.setStyleType(type)
        contract_time_line?.setSelectIndex(index)
    }

    override fun setContractState(state: String, type: Int) {

        mContractPreResultState = state

        mContractPreResultType = type

        when (state) {
            ContractPreResult.SUCCESS -> {
                // 签署成功
                ll_contract_success?.visibility = View.VISIBLE
                ll_contract_state?.visibility = View.GONE
//                contract_submit.text = "完成"
//                contract_submit.normal()
                contract_submit?.visibility = View.GONE
                contract_submit_done?.visibility = View.VISIBLE
            }
            ContractPreResult.SIGN_FAILED -> {
                // 签署失败
                ll_contract_success?.visibility = View.GONE
                ll_contract_state?.visibility = View.VISIBLE
                contract_state?.text = "签署失败"
//                contract_state.setTextColor(ContextCompat.getColor(_mActivity, R.color.color_6))
                contract_desc?.visibility = View.VISIBLE
                ll_contract_electronic?.visibility = View.VISIBLE
//                contract_electronic.normal()
//                contract_submit.text = "签署纸质合同"
//                contract_submit.normal()
                contract_submit?.visibility = View.VISIBLE
                contract_submit_done?.visibility = View.GONE
            }
            ContractPreResult.CERTIFICATION_FAILED -> {
                // 认证失败
                ll_contract_success?.visibility = View.GONE
                ll_contract_electronic?.visibility = View.GONE
                ll_contract_state?.visibility = View.VISIBLE
                contract_state?.text = "签署失败"
//                contract_state.setTextColor(ContextCompat.getColor(_mActivity, R.color.color_6))
                contract_desc?.visibility = View.GONE
//                contract_electronic.disable()
//                contract_submit.text = "签署纸质合同"
//                contract_submit.normal()
                contract_submit?.visibility = View.VISIBLE
                contract_submit_done?.visibility = View.GONE
            }
            else -> {
                // 未签署
                ll_contract_success?.visibility = View.GONE
                ll_contract_state?.visibility = View.VISIBLE
                ll_contract_electronic?.visibility = View.VISIBLE
                contract_state?.text = "未签署"
//                contract_state.setTextColor(ContextCompat.getColor(_mActivity, R.color.color_282828))
                contract_desc?.visibility = View.VISIBLE
//                contract_electronic.normal()
                if (type == ContractPreRequest.RETAIN) {

                    if (isCountDownTimeEnd && contract_submit?.visibility == View.GONE
                            && contract_submit_done.visibility == View.GONE){

                        mHintDialog?.show()
                    }
                } else {
//                    contract_submit.text = "完成"
//                    contract_submit.disable()
                    contract_submit?.visibility = View.GONE
                    contract_submit_done?.visibility = View.GONE
                }

//                contract_submit.visibility = View.GONE
//                contract_submit_done.visibility = View.GONE
            }
        }
    }

    override fun setNormalContractPaper() {
        val a = parentFragment as DeliverCarMainFragment
        a.onSelectPage(DeliverCarMainFragment.PAGE_FIVE, DeliverCarMainFragment.PAGE_FOUR)
    }

    override fun setSchoolContractPaper() {
        val a = parentFragment as DeliverCarMainFragment
        a.onSelectPage(DeliverCarMainFragment.PAGE_SIX, DeliverCarMainFragment.PAGE_FIVE)
    }

    override fun setActivityFinish() {
        _mActivity.setResult(ConstantsUtil.ORDER_REFRESH_CODE)
        activity?.finish()
    }

    override fun onHiddenChanged(hidden: Boolean) {
        super.onHiddenChanged(hidden)

        if (hidden){

            timer?.cancel()
            timer = null

        }else{

            timer = object : CountDownTimer(5 * 60 * 1000, 1000) {
                override fun onTick(millisUntilFinished: Long) {}

                override fun onFinish() {

//                    if (mContractPreResultState != ContractPreResult.SUCCESS
//                            && mContractPreResultState != ContractPreResult.SIGN_FAILED
//                            && mContractPreResultState != ContractPreResult.CERTIFICATION_FAILED
//                    ){
//
//                        mHintDialog?.show()
//                    }

                    if (contract_submit?.visibility == View.GONE
                            && contract_submit_done?.visibility == View.GONE
                            && isVisibleToUser
                    ){

                        mHintDialog?.show()
                    }

                    isCountDownTimeEnd = true
                }
            }.start()
        }
    }

    private var isVisibleToUser = false
    override fun onResume() {
        super.onResume()

//        if (contract_submit.visibility == View.GONE
//                && contract_submit_done.visibility == View.GONE
//                && isCountDownTimeEnd
//        ){
//
//            mHintDialog?.show()
//        }

        isVisibleToUser = true
    }

    override fun onPause() {
        super.onPause()

        isVisibleToUser = false
    }
}
