package com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.delivercar.fragments.first

import android.app.Activity
import android.arch.lifecycle.Observer
import android.content.Intent
import android.os.Bundle
import android.support.v4.content.ContextCompat
import android.view.View
import com.jeremyliao.livedatabus.LiveDataBus
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseFragment
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.delivercar.DeliverCarActivity
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.delivercar.FragmentListerner
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.delivercar.fragments.main.DeliverCarMainFragment
import com.jiaoyinbrother.library.bean.OrderDetailResult
import com.jiaoyinbrother.library.util.LogUtil
import com.jiaoyinbrother.library.util.TextUtil
import com.jiaoyinbrother.library.widget.GeneralBottomButton
import kotlinx.android.synthetic.main.deliver_car_timeline.*
import kotlinx.android.synthetic.main.deliver_car_timeline_student.*
import kotlinx.android.synthetic.main.fragment_deliver_car_first.*

class DeliverCarFirstFragment : MvpBaseFragment<DeliverCarFirstPresenter>(), IDeliverCarFirstContract.View, View.OnClickListener {
    override fun LoadDataDone() {
        fragment_deliver_car_root.visibility = View.VISIBLE
        onNext.visibility = View.VISIBLE
    }

    override fun finishActivity() {
        LogUtil.e("DeliverCarFirstFragment, finishActivity")
        mActivity.finish()
    }

    override fun showRefreshButton(b: Boolean) {
        LogUtil.e("DeliverCarFirstFragment, showRefreshButton , b =" + b)
        myListener?.showRefreshButton(b)
        if (b) {
            LiveDataBus.get().with(DeliverCarActivity.DELIVER_CAR_REFRESH).observeSticky(mActivity, Observer {
                LogUtil.e("DeliverCarFirstFragment DELIVER_CAR_REFRESH ...")
                presenter.onRefreshButtonClicked()

            })
        }
    }

    override fun setDepositIllegalFreed(visible: Int, click: Boolean) {
        LogUtil.e("setDepositIllegalFreed, visible=  $visible")

        dont_need_illegal_deposit.visibility = visible
        dont_need_illegal_deposit.isEnabled = click
    }

    override fun setDepositForCarFreed(visible: Int, click: Boolean) {
        LogUtil.e("setDepositForCarFreed, visible=  $visible")
        dont_need_car_deposit.visibility = visible
        dont_need_car_deposit.isEnabled = click
    }

    override fun showStudentAuthStatusView(b: Boolean) {
        if (b)
            student_auth_status_layout.visibility = View.VISIBLE
        else
            student_auth_status_layout.visibility = View.GONE
    }

    override fun showStudentCancelOrderCheckBox(b: Boolean) {
        if (b)
            cancel_order_layout.visibility = View.VISIBLE
        else
            cancel_order_layout.visibility = View.GONE
    }

    override fun getStudentCancelOrderCheckStatus(): Boolean {
        LogUtil.e("info_1_checkbox.isEnabled =" + cancel_order_deposit_checkbox.isChecked)
        return cancel_order_deposit_checkbox.isChecked
    }

    override fun toSchoolNextPage() {
        val a = parentFragment as DeliverCarMainFragment
        a.onSelectPage(DeliverCarMainFragment.PAGE_THREE, DeliverCarMainFragment.PAGE_SECOND)
    }

    private fun onSchoolBack() {
        val a = parentFragment as DeliverCarMainFragment
        a.onSelectPage(DeliverCarMainFragment.PAGE_FIRST, DeliverCarMainFragment.PAGE_SECOND)
    }


    override fun toNormalNextPage() {
        val a = parentFragment as DeliverCarMainFragment
        a.onSelectPage(DeliverCarMainFragment.PAGE_SECOND, DeliverCarMainFragment.PAGE_FIRST)
    }


    override fun onBackPressedSupport(): Boolean {

        if (presenter.isStudent()) {
            onSchoolBack()
            return true
        } else {
            //第一页，没有操作----系统处理回退
            return false
        }

    }

    override fun setDepositStateForCar(visible: Int, state: String) {
        depositStateForCar.visibility = visible
        depositStateForCar.text = state

    }

    override fun setDepositForCarOffline(visible: Int, click: Boolean) {
        depositPayOfflineForCar.visibility = visible
        depositPayOfflineForCar.isEnabled = click
    }

    override fun setDepositForCarScan(visible: Int, click: Boolean) {
        depositPayScanForCar.visibility = visible
        depositPayScanForCar.isEnabled = click
    }

    fun setData(result: OrderDetailResult) {
        LogUtil.e("DeliverCarFirstFragment, setData, result =$result")
        presenter.getOrderInfo(result)

    }

    override fun initPresenter(): DeliverCarFirstPresenter {
        return DeliverCarFirstPresenter(_mActivity, this)
    }

    override fun setTimeLine(type: Int, index: Int) {
        first_time_line.setStyleType(type)
        first_time_line.setSelectIndex(index)
    }

    override fun setOrderNum(num: String) {
        orderNum.text = num
    }

    override fun setOrderChannel(channel: String) {
        orderChannel.text = channel
    }

    override fun setCarNum(num: String) {
        carNum.text = num
    }

    override fun setDepositCostForCar(name: String, num: String) {
        val sp = "$name $num"
        depositCostForCar.text = TextUtil.setForegroundColor(sp, ContextCompat.getColor(_mActivity, R.color.color_6), name.length, sp.length)
    }

    override fun setDepositDescForCar(desc: String) {
        depositDescForCar.text = desc
    }

    override fun setDepositCostForIllegal(name: String, num: String) {
        val sp = "$name $num"
        depositCostForIllegal.text = TextUtil.setForegroundColor(sp, ContextCompat.getColor(_mActivity, R.color.color_6), name.length, sp.length)
    }

    override fun setDepositForIllegalOffline(visible: Int, click: Boolean) {
        depositPayOfflineForIllegal.visibility = visible
        depositPayOfflineForIllegal.isEnabled = click
    }

    override fun setDepositForIllegalScan(visible: Int, click: Boolean) {
        depositPayScanForIllegal.visibility = visible
        depositPayScanForIllegal.isEnabled = click
    }

    override fun setDepositForIllegalState(visible: Int, state: String) {
        depositStateForIllegal.visibility = visible
        depositStateForIllegal.text = state
    }

    override fun setDepositDescForIllegal(desc: String) {
        depositDescForIllegal.text = desc
    }


    override fun enableNext(b: Boolean) {
        if (b) onNext.normal() else onNext.disable()
    }

    override fun onClick(v: View?) {
        when (v?.id) {
            R.id.depositPayOfflineForCar -> presenter.onOfflinePay()
            R.id.depositPayScanForCar -> presenter.onScanPay(this)
            R.id.dont_need_car_deposit -> presenter.onCarDepositFreeButtonClick()
            R.id.cancel_order_deposit_checkbox -> presenter.onStudentCancelOrderCheckChanged()

        }
    }

    companion object {
        fun newInstance(): DeliverCarFirstFragment {
            val args = Bundle()
            val fragment = DeliverCarFirstFragment()
            fragment.arguments = args
            return fragment
        }
    }

    override fun getLayoutId(): Int {
        return R.layout.fragment_deliver_car_first
    }

    override fun initViews(view: View?, savedInstanceState: Bundle?) {

    }

    override fun initToolbar(savedInstanceState: Bundle?) {

    }

    override fun initListeners() {
        onNext.setListener(object : GeneralBottomButton.SubmitListener {
            override fun submit() {
                presenter.onNext()
            }
        })
        depositPayOfflineForCar.setOnClickListener(this)
        depositPayScanForCar.setOnClickListener(this)
        cancel_order_deposit_checkbox.setOnClickListener(this)
        dont_need_car_deposit.setOnClickListener(this)

    }

    override fun initData() {

    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        LogUtil.e("first fragment, onActivityResult*************************")
        presenter.onActivityResult(requestCode, resultCode, data)
    }

    override fun updataFragment() {

    }

    override fun onDestroy() {
        presenter?.cancelTimer()
        super.onDestroy()
    }

    private var myListener: FragmentListerner? = null
    override fun onAttach(activity: Activity?) {
        super.onAttach(activity)
        myListener = getActivity() as FragmentListerner?
    }

    override fun onSupportVisible() {
        super.onSupportVisible()
        presenter?.startTimer()
        if (presenter.isStudent()) {
            showRefreshButton(true)
        } else {
            showRefreshButton(false)
        }
        LogUtil.e("DeliverCarFirstFragment onSupportVisible")
    }

    override fun onSupportInvisible() {
        super.onSupportInvisible()
        LogUtil.e("DeliverCarFirstFragment onSupportInvisible")
        presenter?.cancelTimer()
        if (presenter.isStudent()) {
            showRefreshButton(true)
        } else {
            showRefreshButton(false)
        }
    }
}
