package com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.delivercar.fragments.first

import android.content.Intent
import android.support.v4.app.Fragment
import com.jiaoyinbrother.library.base.IBasePresenter
import com.jiaoyinbrother.library.bean.OrderDetailResult
import com.jiaoyinbrother.library.view.IBaseView

interface IDeliverCarFirstContract {

    interface View : IBaseView {
        fun setOrderNum(num: String)
        fun setOrderChannel(channel: String)
        fun setCarNum(num: String)

        //车辆押金接口
        fun setDepositCostForCar(name: String, num: String)

        fun setDepositStateForCar(visible: Int, state: String)
        fun setDepositDescForCar(desc: String)
        fun setDepositForCarOffline(visible: Int, click: Boolean)
        fun setDepositForCarScan(visible: Int, click: Boolean)
        fun setDepositForCarFreed(visible: Int, click: Boolean)

        //违章押金接口
        fun setDepositCostForIllegal(name: String, num: String)

        fun setDepositForIllegalOffline(visible: Int, click: Boolean)
        fun setDepositForIllegalScan(visible: Int, click: Boolean)
        fun setDepositIllegalFreed(visible: Int, click: Boolean)
        fun setDepositForIllegalState(visible: Int, state: String)
        fun setDepositDescForIllegal(desc: String)


        //学籍认证状态
        fun showStudentAuthStatusView(b: Boolean)

        fun showStudentCancelOrderCheckBox(b: Boolean)
        //getter
        fun getStudentCancelOrderCheckStatus(): Boolean

        fun enableNext(b: Boolean)

        fun toSchoolNextPage()
        fun toNormalNextPage()

        //        fun onSchoolBack()
//        fun onNormalBack()
        //刷新
        fun showRefreshButton(b: Boolean)

        fun finishActivity()

        fun LoadDataDone()
        fun setTimeLine(type: Int, index: Int)
    }

    interface Presenter : IBasePresenter {
        fun onOfflinePay()
        fun onScanPay(fragment: Fragment)
        fun getOrderInfo(result: OrderDetailResult)
        fun requestOrderPay()
        fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?)

        fun onNext()
        fun isStudent(): Boolean

        fun onStudentCancelOrderCheckChanged()
        fun onCarDepositFreeButtonClick()

        //刷新
        fun onRefreshButtonClicked()

        fun cancelTimer()
        fun startTimer()
    }

}
