package com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.delivercar.fragments.fourth

import android.arch.lifecycle.Observer
import android.os.Bundle
import android.view.View
import com.jeremyliao.livedatabus.LiveDataBus
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseFragment
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.delivercar.fragments.main.DeliverCarMainFragment
import com.jiaoyinbrother.library.bean.OrderDetailResult
import com.jiaoyinbrother.library.bean.OrderExecuteRequest
import com.jiaoyinbrother.library.util.ConstantsUtil
import com.jiaoyinbrother.library.util.LogUtil
import com.jiaoyinbrother.library.widget.GeneralBottomButton
import kotlinx.android.synthetic.main.fragment_refund_car_four.*

class DeliverCarFourthTabFragment: MvpBaseFragment<DeliverCarFourthPresenter>(), IDeliverCarFourthContract.View, View.OnClickListener {

    override fun setCheckBoxStatus(b: Boolean) {
        owner_confirm_checkbox.isChecked = b
    }

    override fun finishActivity() {
        _mActivity.setResult(ConstantsUtil.ORDER_REFRESH_CODE)
        activity?.finish()
    }

    override fun getCheckBoxStatus(): Boolean {
        return owner_confirm_checkbox.isChecked
    }

    override fun setTipsForContract(title: String, content: ArrayList<String>) {
        tips_model_contract?.setData(title,content)
    }

    override fun setTipsForDeposit(title: String, content: ArrayList<String>) {
        tips_model_deposit?.setData(title,content)
    }

    override fun setTipsForInsurance(title: String, content: ArrayList<String>) {
        tips_model_insurance?.setData(title,content)
    }

    override fun setTipsForUseCar(title: String, content: ArrayList<String>) {
        tips_model_usecar?.setData(title,content)
    }

    override fun setTipsForComment(title: String, content: ArrayList<String>) {
        tips_model_comment?.setData(title,content)
    }

    override fun setOwnerConfirmCheckBoxText(text: String) {
        owner_confirm_checkbxo_text.text = text
    }

    override fun enableNext(b: Boolean) {
        if (b && orderExecuteRequest!=null) onNext.normal() else onNext.disable()
    }

    override fun initPresenter(): DeliverCarFourthPresenter {
        return  DeliverCarFourthPresenter(mActivity,this)
    }

    override fun onClick(v: View?) {
        when(v?.id){
            R.id.freezeDepositForCarLayout -> presenter.onCheckBoxChanged()
        }

    }

    companion object {
        fun newInstance(): DeliverCarFourthTabFragment {
            val args = Bundle()
            val fragment = DeliverCarFourthTabFragment()
            fragment.arguments = args
            return fragment
        }
    }

    override fun getLayoutId(): Int {
        return R.layout.fragment_refund_car_four
    }

    override fun initViews(view: View?, savedInstanceState: Bundle?) {

    }

    override fun initToolbar(savedInstanceState: Bundle?) {

    }

    override fun initListeners() {
        onNext.setListener(object : GeneralBottomButton.SubmitListener {
            override fun submit() {
                if(orderExecuteRequest!=null)
                    presenter.onNext(orderExecuteRequest!!)
            }
        })
        freezeDepositForCarLayout.setOnClickListener(this)
        owner_confirm_checkbxo_text.setOnClickListener(this)
    }

    private var orderExecuteRequest:OrderExecuteRequest?= null
    override fun initData() {

        presenter.getData()

        LiveDataBus.get().with(ConstantsUtil.LIVEDATA_ORDER_EXCUTE_REQUEST).observeSticky(this, Observer {
            LogUtil.e("Observer******************" + "LIVEDATA_ORDER_EXCUTE_REQUEST")
            orderExecuteRequest = it as OrderExecuteRequest
            LogUtil.e("orderExecuteRequest ="+ orderExecuteRequest.toString())

            dismissLoadingDialog()
        })

        onNext.disable()
    }

    override fun updataFragment() {

    }

    override fun onBackPressedSupport(): Boolean {
//        val a = parentFragment as DeliverCarMainFragment
//        a.onSelectPage(DeliverCarMainFragment.PAGE_FOUR, DeliverCarMainFragment.PAGE_FIVE)
        presenter.onBackPressed()
        return true
    }

    override fun onSchoolBack(b:Boolean) {
        val a = parentFragment as DeliverCarMainFragment
        if (b){
            a.onSelectPage(DeliverCarMainFragment.PAGE_FOUR, DeliverCarMainFragment.PAGE_SIX)
        } else{
            a.onSelectPage(DeliverCarMainFragment.PAGE_FIVE, DeliverCarMainFragment.PAGE_SIX)
        }
    }

    override fun onNormalBack(b:Boolean) {
        val a = parentFragment as DeliverCarMainFragment
        if (b){
            a.onSelectPage(DeliverCarMainFragment.PAGE_THREE, DeliverCarMainFragment.PAGE_FIVE)
        } else{
            a.onSelectPage(DeliverCarMainFragment.PAGE_FOUR, DeliverCarMainFragment.PAGE_FIVE)
        }

    }

    fun setData(result: OrderDetailResult){
        presenter.setOrderInfo(result)
    }
}
