package com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.delivercar.fragments.main

import android.os.Bundle
import android.view.View
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseFragment
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.delivercar.fragments.first.DeliverCarFirstFragment
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.delivercar.fragments.fourth.DeliverCarFourthTabFragment
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.delivercar.fragments.schoolinfo.DeliverCarSchoolInfoFragment
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.delivercar.fragments.second.DeliverCarSecondFragment
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.delivercar.fragments.third.DeliverCarThirdFragment
import com.jiaoyinbrother.library.base.BaseFragment
import com.jiaoyinbrother.library.bean.OrderDetailResult
import com.jiaoyinbrother.library.util.ConstantsUtil
import com.jiaoyinbrother.library.util.LogUtil
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.delivercar.fragments.contract.DeliverCarContractFragment

class DeliverCarMainFragment : MvpBaseFragment<DeliverMainPresenter>(), IDeliverCarMainContract.View {

    override fun initFragmentPagesWithSchool() {
        val firstFragment = findChildFragment(DeliverCarSchoolInfoFragment::class.java)
        if (firstFragment == null) {
            mSchoolFragments[PAGE_FIRST] = DeliverCarSchoolInfoFragment.newInstance()
            mSchoolFragments[PAGE_SECOND] = DeliverCarFirstFragment.newInstance()
            mSchoolFragments[PAGE_THREE] = DeliverCarSecondFragment.newInstance()
            mSchoolFragments[PAGE_FOUR] = DeliverCarThirdFragment.newInstance()
            mSchoolFragments[PAGE_FIVE] = DeliverCarContractFragment.newInstance()
            mSchoolFragments[PAGE_SIX] = DeliverCarFourthTabFragment.newInstance()
            loadMultipleRootFragment(R.id.fl_tab_container, PAGE_FIRST,
                    mSchoolFragments[PAGE_FIRST],
                    mSchoolFragments[PAGE_SECOND],
                    mSchoolFragments[PAGE_THREE],
                    mSchoolFragments[PAGE_FOUR],
                    mSchoolFragments[PAGE_FIVE],
                    mSchoolFragments[PAGE_SIX])
        } else {
            // 这里库已经做了Fragment恢复,所有不需要额外的处理了, 不会出现重叠问题
            // 这里我们需要拿到mFragments的引用
            mSchoolFragments[PAGE_FIRST] = firstFragment
            mSchoolFragments[PAGE_SECOND] = findChildFragment(DeliverCarFirstFragment::class.java)
            mSchoolFragments[PAGE_THREE] = findChildFragment(DeliverCarSecondFragment::class.java)
            mSchoolFragments[PAGE_FOUR] = findChildFragment(DeliverCarThirdFragment::class.java)
            mSchoolFragments[PAGE_FIVE] = findChildFragment(DeliverCarContractFragment::class.java)
            mSchoolFragments[PAGE_SIX] = findChildFragment(DeliverCarFourthTabFragment::class.java)
        }
    }

    override fun initFragmentPagesWithoutSchool() {
        val firstFragment = findChildFragment(DeliverCarFirstFragment::class.java)
        if (firstFragment == null) {
            mFragments[PAGE_FIRST] = DeliverCarFirstFragment.newInstance()
            mFragments[PAGE_SECOND] = DeliverCarSecondFragment.newInstance()
            mFragments[PAGE_THREE] = DeliverCarThirdFragment.newInstance()
            mFragments[PAGE_FOUR] = DeliverCarContractFragment.newInstance()
            mFragments[PAGE_FIVE] = DeliverCarFourthTabFragment.newInstance()
            loadMultipleRootFragment(R.id.fl_tab_container, PAGE_FIRST,
                    mFragments[PAGE_FIRST],
                    mFragments[PAGE_SECOND],
                    mFragments[PAGE_THREE],
                    mFragments[PAGE_FOUR],
                    mFragments[PAGE_FIVE])
        } else {
            // 这里库已经做了Fragment恢复,所有不需要额外的处理了, 不会出现重叠问题
            // 这里我们需要拿到mFragments的引用
            mFragments[PAGE_FIRST] = firstFragment
            mFragments[PAGE_SECOND] = findChildFragment(DeliverCarSecondFragment::class.java)
            mFragments[PAGE_THREE] = findChildFragment(DeliverCarThirdFragment::class.java)
            mFragments[PAGE_FOUR] = findChildFragment(DeliverCarContractFragment::class.java)
            mFragments[PAGE_FIVE] = findChildFragment(DeliverCarFourthTabFragment::class.java)
        }
    }

    override fun setOrderInfoWithSchool(result: OrderDetailResult) {
        findChildFragment(DeliverCarSchoolInfoFragment::class.java)?.setData(result)
        setOrderInfoWithoutSchool(result)
    }

    override fun setOrderInfoWithoutSchool(result: OrderDetailResult) {
        LogUtil.e("setOrderInfoWithoutSchool, result = $result")
        if (findChildFragment(DeliverCarFirstFragment::class.java) == null) {
            LogUtil.e("findChildFragment(DeliverCarFirstFragment::class.java) == null")
        }
        findChildFragment(DeliverCarFirstFragment::class.java)?.setData(result)
        findChildFragment(DeliverCarSecondFragment::class.java)?.setData(result)
        findChildFragment(DeliverCarThirdFragment::class.java)?.setData(result)
        findChildFragment(DeliverCarContractFragment::class.java)?.setData(result)
        findChildFragment(DeliverCarFourthTabFragment::class.java)?.setData(result)
    }

    private val mFragments = arrayOfNulls<BaseFragment>(5)
    private val mSchoolFragments = arrayOfNulls<BaseFragment>(6)

    companion object {
        const val PAGE_FIRST = 0
        const val PAGE_SECOND = 1
        const val PAGE_THREE = 2
        const val PAGE_FOUR = 3
        const val PAGE_FIVE = 4
        const val PAGE_SIX = 5

        fun newInstance(orderDetailResult: OrderDetailResult): DeliverCarMainFragment {
            val fragment = DeliverCarMainFragment()
            val args = Bundle()
            args.putSerializable(ConstantsUtil.ORDER_RESULT, orderDetailResult)

            fragment.arguments = args
            return fragment
        }
    }

    override fun initPresenter(): DeliverMainPresenter {
        return DeliverMainPresenter(_mActivity, this)
    }

    override fun getLayoutId(): Int {
        if (arguments != null)
            presenter.argumentsData(arguments!!)
        return R.layout.fragment_refund_car_main
    }

    override fun initViews(view: View?, savedInstanceState: Bundle?) {}

    override fun initToolbar(savedInstanceState: Bundle?) {}

    override fun initListeners() {}

    override fun initData() {
        presenter?.requestOrderInfo()

    }

    override fun updataFragment() {}


    fun onSelectPage(toIndex: Int, launchIndex: Int) {
        if (presenter.isStudent()) {
            showHideFragment(mSchoolFragments[toIndex], mSchoolFragments[launchIndex])
        } else {
            showHideFragment(mFragments[toIndex], mFragments[launchIndex])
        }

    }

}
