package com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.delivercar.fragments.schoolinfo

import android.app.Activity
import android.arch.lifecycle.Observer
import android.content.Intent
import android.os.Bundle
import android.support.v4.content.ContextCompat
import android.view.View
import com.bumptech.glide.Glide
import com.jeremyliao.livedatabus.LiveDataBus
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseFragment
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.delivercar.DeliverCarActivity
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.delivercar.FragmentListerner
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.delivercar.fragments.main.DeliverCarMainFragment
import com.jiaoyinbrother.library.bean.OrderDetailResult
import com.jiaoyinbrother.library.util.LogUtil
import com.jiaoyinbrother.library.util.TextViewUtil
import com.jiaoyinbrother.library.widget.GeneralBottomButton
import kotlinx.android.synthetic.main.deliver_car_timeline_student.*
import kotlinx.android.synthetic.main.fragment_deliver_school_info.*


class DeliverCarSchoolInfoFragment : MvpBaseFragment<DeliverCarSchoolInfoPresenter>(), IDeliverSchoolInfoContract.View, View.OnClickListener {

    override fun setTimeLine(type: Int, index: Int) {
        student_time_line.setStyleType(type)
        student_time_line.setSelectIndex(index)
    }

    override fun finishActivity() {
        LogUtil.e("DeliverCarFirstFragment, finishActivity")
        mActivity.finish()
    }

    override fun toNextPage() {
        val a = parentFragment as DeliverCarMainFragment
        a.onSelectPage(DeliverCarMainFragment.PAGE_SECOND, DeliverCarMainFragment.PAGE_FIRST)
    }

    override fun enableNext(b: Boolean) {
        if (b) onNext.normal() else onNext.disable()
    }

    override fun enableRenterSchoolApproveButton(enable: Boolean, visibility: Boolean) {
        if (visibility) {
            school_approval.visibility = View.VISIBLE
            if (enable) {
                TextViewUtil.setButtonStatus(school_approval, mActivity, TextViewUtil.BUTTON_ENABLE_IMPORTANT)
            } else {
                TextViewUtil.setButtonStatus(school_approval, mActivity, TextViewUtil.BUTTON_DISABLE)
            }
        } else {
            school_approval.visibility = View.GONE
        }
    }

    override fun enableRenterSchoolDenyButton(enable: Boolean, visibility: Boolean) {
        if (visibility) {
            school_reapply.visibility = View.VISIBLE
            if (enable) {
                TextViewUtil.setButtonStatus(school_reapply, mActivity, TextViewUtil.BUTTON_ENABLE_IMPORTANT)
            } else {
                TextViewUtil.setButtonStatus(school_reapply, mActivity, TextViewUtil.BUTTON_DISABLE)
            }
        } else {
            school_reapply.visibility = View.GONE
        }
    }

    override fun enableRenterSchoolDenyForeverButton(enable: Boolean, visibility: Boolean) {
        if (visibility) {
            school_deny.visibility = View.VISIBLE
            if (enable) {
                TextViewUtil.setButtonStatus(school_deny, mActivity, TextViewUtil.BUTTON_ENABLE_IMPORTANT)
            } else {
                TextViewUtil.setButtonStatus(school_deny, mActivity, TextViewUtil.BUTTON_DISABLE)
            }
        } else {
            school_deny.visibility = View.GONE
        }
    }

    override fun setUserSchool(name: String) {
        renter_school.text = name
    }

    override fun setUserSpecialty(name: String) {
        renter_speciality.text = name
    }

    override fun setUserEducation(name: String) {
        renter_education.text = name
    }

    override fun setUserEducationYear(name: String) {
        renter_school_year.text = name
    }

    override fun setUserSchoolStatus(name: String) {
        LogUtil.e("setUserSchoolStatus, name =$name")
        renter_school_auth_status.text = name
    }


    override fun showRenterSchoolPhotoLayout(b: Boolean) {
        if (b) {
            upload_student_info_layout.visibility = View.VISIBLE
        } else {
            upload_student_info_layout.visibility = View.GONE
        }
    }

    override fun setUserIDPhotoUrl(url: String) {
        LogUtil.e("setUserIDPhotoUrl, url =" + url)
        Glide.with(mActivity).load(url).into(student_ID_photo)
    }

    override fun setUserOneCarPhotoUrl(url: String) {
        LogUtil.e("setUserOneCarPhotoUrl, url =" + url)
        Glide.with(mActivity).load(url).into(student_one_card_photo)
    }

    override fun setOrderNum(num: String) {
        orderNum.text = num
    }

    override fun setOrderChannel(channel: String) {
        orderChannel.text = channel
    }

    override fun setCarNum(num: String) {
        carNum.text = num
    }


    companion object {
        fun newInstance(): DeliverCarSchoolInfoFragment {
            val args = Bundle()
            val fragment = DeliverCarSchoolInfoFragment()
            fragment.arguments = args
            return fragment
        }
    }

    override fun initListeners() {
        onNext.setListener(object : GeneralBottomButton.SubmitListener {
            override fun submit() {
                LogUtil.e("DeliverCarSchoolInfoFragment, onNext")
                presenter.onNext()
            }
        })
        school_approval.setOnClickListener(this)
        school_reapply.setOnClickListener(this)
        school_deny.setOnClickListener(this)

        student_ID_photo.setOnClickListener(this)
        student_one_card_photo.setOnClickListener(this)

    }

    override fun initPresenter(): DeliverCarSchoolInfoPresenter {
        return DeliverCarSchoolInfoPresenter(mActivity, this)
    }

    override fun getLayoutId(): Int {
        return R.layout.fragment_deliver_school_info
    }

    override fun initViews(view: View?, savedInstanceState: Bundle?) {


    }

    override fun initToolbar(savedInstanceState: Bundle?) {

    }

    override fun initData() {
//        timeline_not_student.visibility = View.GONE
//        img_state_1_student.setBackgroundResource(R.mipmap.h_1)
//        student_status_1_description.setTextColor(ContextCompat.getColor(mActivity, R.color.color_6))

        myListener?.showRefreshButton(true)
        LiveDataBus.get().with(DeliverCarActivity.DELIVER_CAR_REFRESH).observeSticky(mActivity, Observer {
            LogUtil.e("DeliverCarSchoolInfoFragment DELIVER_CAR_REFRESH ...")
            presenter.onRefreshButtonClicked()

        })
    }

    override fun onClick(v: View?) {
        when (v?.id) {
            R.id.school_approval -> presenter.onSchoolApproval(mActivity)
            R.id.school_deny -> presenter.onSchoolDeny(mActivity)
            R.id.school_reapply -> presenter.onSchoolReapply(mActivity)
            R.id.student_ID_photo -> presenter.onRenterIDPhoto(this)
            R.id.student_one_card_photo -> presenter.onRenterOneCarPhoto(this)

        }
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        LogUtil.e("onActivityResult*************************")
        presenter.onActivityResult(requestCode, resultCode, data)
    }

    private var myListener: FragmentListerner? = null
    override fun onAttach(activity: Activity?) {
        super.onAttach(activity)
        myListener = getActivity() as FragmentListerner?
    }

    fun setData(result: OrderDetailResult) {
        LogUtil.e("DeliverCarSchoolInfoFragment setData")
        presenter.getOrderInfo(result)
    }
}
