package com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.delivercar.fragments.schoolinfo

import android.content.Context
import android.content.Intent
import android.support.v4.app.Fragment
import com.jiaoyinbrother.library.base.IBasePresenter
import com.jiaoyinbrother.library.bean.OrderDetailResult
import com.jiaoyinbrother.library.view.IBaseView

class IDeliverSchoolInfoContract{
    interface View : IBaseView {

        fun setOrderNum(num: String)
        fun setOrderChannel(channel: String)
        fun setCarNum(num: String)

        //学籍信息
        fun setUserSchool(name:String)
        fun setUserSpecialty(name:String)
        fun setUserEducation(name:String)
        fun setUserEducationYear(name:String)
        fun setUserSchoolStatus(name: String)



        //学生控制button
        fun enableRenterSchoolApproveButton(enable:Boolean, visibility:Boolean)
        fun enableRenterSchoolDenyButton(enable:Boolean, visibility:Boolean)
        fun enableRenterSchoolDenyForeverButton(enable:Boolean, visibility:Boolean)

        //用户学校图片
        fun showRenterSchoolPhotoLayout(b:Boolean)
        fun setUserIDPhotoUrl(uri:String)
        fun setUserOneCarPhotoUrl(uri:String)

        fun enableNext(b:Boolean)
        fun toNextPage()

        fun  finishActivity()

        fun setTimeLine(type: Int, index: Int)
    }

    interface Presenter : IBasePresenter {
        fun getOrderInfo(result: OrderDetailResult)

        //同意，取消
        fun onSchoolApproval(context: Context)
        fun onSchoolDeny(context: Context)
        fun onSchoolReapply(context: Context)

        //图片
        fun onRenterIDPhoto(fragment: Fragment)
        fun onRenterOneCarPhoto(fragment: Fragment)
        fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?)

        //下一步
        fun onNext()

        //刷新
        fun onRefreshButtonClicked()
    }

}
