package com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.delivercar.fragments.second

import android.app.Activity
import android.content.Intent
import android.os.Bundle
import android.support.v4.content.ContextCompat
import android.text.*
import android.text.method.LinkMovementMethod
import android.text.style.ClickableSpan
import android.text.style.ForegroundColorSpan
import android.view.View
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseFragment
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.delivercar.FragmentListerner
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.delivercar.fragments.main.DeliverCarMainFragment
import com.jiaoyinbrother.library.bean.AuthBean
import com.jiaoyinbrother.library.bean.OrderDetailResult
import com.jiaoyinbrother.library.util.AuthUtil
import com.jiaoyinbrother.library.util.LogUtil
import com.jiaoyinbrother.library.util.PhotoUtils
import com.jiaoyinbrother.library.widget.GeneralBottomButton
import kotlinx.android.synthetic.main.deliver_car_timeline.*
import kotlinx.android.synthetic.main.deliver_car_timeline_student.*
import kotlinx.android.synthetic.main.fragment_deliver_car_second.*

class DeliverCarSecondFragment : MvpBaseFragment<DeliverCarSecondPresenter>(), IDeliverCarSecondContract.View, View.OnClickListener {


    private var myListener: FragmentListerner? = null

    override fun onAttach(activity: Activity?) {
        super.onAttach(activity)
        myListener = getActivity() as FragmentListerner?
    }

    override fun setTimeLine(type: Int, index: Int) {
        second_time_line.setStyleType(type)
        second_time_line.setSelectIndex(index)
    }

    override fun setIDSmallView(uri: String) {
        PhotoUtils.loadPicIntoImageViewNoCache(mActivity, uri, user_id_small_photo)
    }

    override fun setInfo1CheckBoxStatus(b: Boolean) {
        info_1_checkbox.isChecked = b
    }

    override fun setInfo2CheckBoxStatus(b: Boolean) {
        info_2_checkbox.isChecked = b
    }

    override fun setInfo3CheckBoxStatus(b: Boolean) {
        info_3_checkbox.isChecked = b
    }

    override fun setUserAuthStatus(status: AuthBean?) {
        AuthUtil(mActivity).updateUserStatusView(user_auth_status, status)
    }

    override fun setUserAuthStatus(status: String, name: String) {
        AuthUtil(mActivity).updateUserStatusView(user_auth_status, status, name)
    }

    override fun setUserLevelName(levelName: String) {
        user_level?.text = levelName
    }

    override fun setUserName(name: String) {
        user_name?.text = name
    }

    override fun setUserID(userID: String) {
        user_id?.text = userID
    }

    override fun setTakeClientVisible(b: Boolean) {
        cl_take_client.visibility = if (b) View.VISIBLE else View.GONE
    }

    override fun enableNext(b: Boolean) {
        if (b) onNext.normal() else onNext.disable()
    }

    override fun getInfo1CheckBoxStatus(): Boolean {
        LogUtil.e("info_1_checkbox.isEnabled =" + info_1_checkbox.isChecked)
        return info_1_checkbox.isChecked
    }

    override fun getInfo2CheckBoxStatus(): Boolean {
        LogUtil.e("info_2_checkbox.isEnabled =" + info_2_checkbox.isChecked)
        return info_2_checkbox.isChecked
    }

    override fun getInfo3CheckBoxStatus(): Boolean {
        LogUtil.e("info_3_checkbox.isEnabled =" + info_3_checkbox.isChecked)
        return info_3_checkbox.isChecked
    }

    companion object {
        fun newInstance(): DeliverCarSecondFragment {
            val args = Bundle()
            val fragment = DeliverCarSecondFragment()
            fragment.arguments = args
            return fragment
        }
    }

    fun setData(result: OrderDetailResult) {
        presenter.getOrderInfo(result)
    }

    override fun onClick(v: View?) {
        when (v?.id) {
            R.id.idcard_view -> presenter.onIDCard(this)
            R.id.driver_license_view -> presenter.onDriverLicense(this)
            R.id.info_1_checkbox, R.id.info_1_checkbox_text -> presenter.onInfo1CheckBoxChanged()
            R.id.info_2_checkbox, R.id.info_2_checkbox_text -> presenter.onInfo2CheckBoxChanged()
            R.id.info_3_checkbox -> presenter.onInfo3CheckBoxChanged()
        }
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        LogUtil.e("onActivityResult*************************")
        presenter.onActivityResult(requestCode, resultCode, data)
    }

    override fun setOrderNum(num: String) {
        orderNum.text = num
    }

    override fun setOrderChannel(channel: String) {
        orderChannel.text = channel
    }

    override fun setCarNum(num: String) {
        carNum.text = num
    }

    override fun setIDCardView(uri: String) {
        LogUtil.e("setIDCardView,uri =$uri")
        PhotoUtils.loadOSSPicIntoImageViewNoCache(mActivity, uri, idcard_view)

    }

    override fun setDriverLicenseView(uri: String) {
        LogUtil.e("setDriverLicenseView,uri =$uri")
        PhotoUtils.loadOSSPicIntoImageViewNoCache(mActivity, uri, driver_license_view)
    }

    override fun setInfo1CheckBox(text: SpannableStringBuilder) {
        info_1_checkbox_text.text = text
    }

    override fun setInfo2CheckBox(text: SpannableStringBuilder?) {
        if (text == null) {
            info_2_checkbox.visibility = View.GONE
            info_2_checkbox_text.visibility = View.GONE
        } else {
            info_2_checkbox.visibility = View.VISIBLE
            info_2_checkbox_text.visibility = View.VISIBLE
            info_2_checkbox_text.text = text
        }
    }

    override fun initPresenter(): DeliverCarSecondPresenter {
        return DeliverCarSecondPresenter(mActivity, this)
    }

    override fun getLayoutId(): Int {
        return R.layout.fragment_deliver_car_second
    }

    override fun initViews(view: View?, savedInstanceState: Bundle?) {}

    override fun initToolbar(savedInstanceState: Bundle?) {}

    override fun initListeners() {
        onNext.setListener(object : GeneralBottomButton.SubmitListener {
            override fun submit() {
                presenter?.onNext()
            }
        })
        idcard_view.setOnClickListener(this)
        driver_license_view.setOnClickListener(this)
        info_1_checkbox.setOnClickListener(this)
        info_1_checkbox_text.setOnClickListener(this)
        info_2_checkbox.setOnClickListener(this)
        info_2_checkbox_text.setOnClickListener(this)
        info_3_checkbox.setOnClickListener(this)
    }

    override fun initData() {
        val agreement = getString(R.string.client_agreement)
        val sp = SpannableString(agreement)
        // 第一部分
        sp.setSpan(object : ClickableSpan() {
            override fun updateDrawState(ds: TextPaint) {
                super.updateDrawState(ds)
                ds.isUnderlineText = false
            }

            override fun onClick(v: View) {
                presenter.onInfo3CheckBoxChanged()
            }
        }, 0, 19, Spanned.SPAN_EXCLUSIVE_EXCLUSIVE)
        sp.setSpan(ForegroundColorSpan(ContextCompat.getColor(mActivity, R.color.color_4)), 0, 19, Spannable.SPAN_EXCLUSIVE_EXCLUSIVE)
        // 第二部分 协议
        sp.setSpan(object : ClickableSpan() {
            override fun updateDrawState(ds: TextPaint) {
                super.updateDrawState(ds)
                ds.isUnderlineText = false
            }

            override fun onClick(v: View) {
                presenter.doMemberAgree()
            }
        }, 19, 28, Spanned.SPAN_EXCLUSIVE_EXCLUSIVE)
        sp.setSpan(ForegroundColorSpan(ContextCompat.getColor(mActivity, R.color.color_blue_f9)), 19, 28, Spannable.SPAN_EXCLUSIVE_EXCLUSIVE)
//        // 第三部分只能同第一部分
        sp.setSpan(ForegroundColorSpan(ContextCompat.getColor(mActivity, R.color.color_4)), 0, 19, Spannable.SPAN_EXCLUSIVE_EXCLUSIVE)
        // 第二部分 协议
        sp.setSpan(object : ClickableSpan() {
            override fun updateDrawState(ds: TextPaint) {
                super.updateDrawState(ds)
                ds.isUnderlineText = false
            }

            override fun onClick(v: View) {
                presenter.onInfo3CheckBoxChanged()
            }
        }, 28, sp.length, Spanned.SPAN_EXCLUSIVE_EXCLUSIVE)
        sp.setSpan(ForegroundColorSpan(ContextCompat.getColor(mActivity, R.color.color_4)), 28, sp.length, Spannable.SPAN_EXCLUSIVE_EXCLUSIVE)
        info_3_checkbox_text.text = sp
        info_3_checkbox_text.movementMethod = LinkMovementMethod.getInstance()
    }

    override fun updataFragment() {}

    override fun onBackPressedSupport(): Boolean {
        presenter.onBackPressed()
        return true
    }

    override fun toSchoolNextPage() {
        val a = parentFragment as DeliverCarMainFragment
        a.onSelectPage(DeliverCarMainFragment.PAGE_FOUR, DeliverCarMainFragment.PAGE_THREE)
    }

    override fun onSchoolBack() {
        val a = parentFragment as DeliverCarMainFragment
        a.onSelectPage(DeliverCarMainFragment.PAGE_SECOND, DeliverCarMainFragment.PAGE_THREE)
    }

    override fun toNormalNextPage() {
        val a = parentFragment as DeliverCarMainFragment
        a.onSelectPage(DeliverCarMainFragment.PAGE_THREE, DeliverCarMainFragment.PAGE_SECOND)
    }

    override fun onNormalBack() {
        val a = parentFragment as DeliverCarMainFragment
        a.onSelectPage(DeliverCarMainFragment.PAGE_FIRST, DeliverCarMainFragment.PAGE_SECOND)
    }

    override fun onSupportVisible() {
        super.onSupportVisible()
        myListener?.showRefreshButton(false)
        LogUtil.e("DeliverCarSecondFragment onSupportVisible")
    }

}
