package com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.delivercar.fragments.second

import android.Manifest
import android.app.Activity
import android.content.Context
import android.content.Intent
import android.support.v4.app.Fragment
import android.support.v4.app.FragmentActivity
import android.text.Spannable
import android.text.SpannableStringBuilder
import android.text.TextUtils
import android.text.style.ForegroundColorSpan
import com.jiaoyinbrother.monkeyking.manager.CarEntity
import com.jiaoyinbrother.monkeyking.manager.Constants
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.activity.ShowBigImageActivity
import com.jiaoyinbrother.monkeyking.manager.util.ImageSelectorUtils
import com.jiaoyinbrother.library.base.BasePresenterImpl
import com.jiaoyinbrother.library.bean.*
import com.jiaoyinbrother.library.impl.UploadListener
import com.jiaoyinbrother.library.retrofit.BaseObserver
import com.jiaoyinbrother.library.retrofit.RetrofitHelper
import com.jiaoyinbrother.library.util.*
import com.jiaoyinbrother.library.widget.BottomDialog
import com.jiaoyinbrother.monkeyking.manager.util.H5Utils
import com.jiaoyinbrother.monkeyking.manager.view.TakeAlsoCarTimeLine
import com.tbruyelle.rxpermissions2.RxPermissions
import io.reactivex.android.schedulers.AndroidSchedulers
import io.reactivex.disposables.Disposable
import io.reactivex.schedulers.Schedulers
import java.io.File
import java.util.concurrent.TimeUnit

class DeliverCarSecondPresenter(context: Context, view: IDeliverCarSecondContract.View)
    : BasePresenterImpl<IDeliverCarSecondContract.View>(context, view), IDeliverCarSecondContract.Presenter {

    companion object {
        private val ID_FILE_PATH = BitmapUtil.SYSTEM_BITMAP_PATH + "id_card.jpg"
        private val DRIVER_LICENSE_FILE_PATH = BitmapUtil.SYSTEM_BITMAP_PATH + "driver_license.jpg"
    }

    private var disposable: Disposable? = null
    private var mUploadUtil: AliYunPictureUtil? = null
    private var compressedImage: File? = null

    private var orderDetailResult: OrderDetailResult? = null
    private var info1CheckBoxStatus = false
    private var info2CheckBoxStatus = true
    private var info3CheckBoxStatus = false

    private var mIDCardUrl: String? = null
    private var mDriverLicenseUrl: String? = null

    private var mOriginIDCardUrl: String? = null
    private var mOriginDriverLicenseUrl: String? = null

    private var mIDCardFilePath = ""
    private var mDriverLicenseFilePath = ""

    private var isIDCard = true
    private var isAuthed = false
    private var isUserMember = false

    private var postImages = ArrayList<String>()
    private var memberID: String? = null


    override fun getOrderInfo(result: OrderDetailResult) {
        orderDetailResult = result

        initTimeLine(result)

        initCarNum(result)
        initCheckBox()
        val member = result.member
        // 是否委托取车人
        if (member == null) {
            //调用接口，更新user，ID，头像，认证状态
            isUserMember = false
            view.setTakeClientVisible(false)
            requestUserDetail(result)
        } else {
            isUserMember = true
            view.setTakeClientVisible(true)
            setUserMember(member)
        }
    }

    private fun initTimeLine(result: OrderDetailResult) {
        if (result.school_roll != null) {
            LogUtil.e("DeliverCarSecondFragment, school_roll!=null")
            // 0 否  1 是
            if (result.e_contract_status == 0) {
                view.setTimeLine(TakeAlsoCarTimeLine.DELIVER_SCHOOL, TakeAlsoCarTimeLine.INDEX_TWO)
            } else {
                view.setTimeLine(TakeAlsoCarTimeLine.DELIVER_CONTRACT_SCHOOL, TakeAlsoCarTimeLine.INDEX_TWO)
            }
        } else {
            LogUtil.e("DeliverCarSecondFragment, school_roll==null")
            if (result.e_contract_status == 0) {
                view.setTimeLine(TakeAlsoCarTimeLine.DELIVER_NORMAL, TakeAlsoCarTimeLine.INDEX_ONE)
            } else {
                view.setTimeLine(TakeAlsoCarTimeLine.DELIVER_CONTRACT_NORMAL, TakeAlsoCarTimeLine.INDEX_ONE)
            }
        }
    }

    private fun initCarNum(result: OrderDetailResult) {
        // 订单号
        view.setOrderNum("订单号：${result.getOrderShowID()}")
        // 订单渠道
        if (TextUtils.isEmpty(result.channel_name)) {
            view.setOrderChannel("")
        } else {
            view.setOrderChannel("(${result.channel_name})")
        }
        // 车牌号
        view.setCarNum(result.number ?: "")
    }

    private fun initCheckBox() {
        view?.setInfo1CheckBox(getInfo1CheckBoxText())
    }

    //checkbox内容生成
    private fun getInfo1CheckBoxText(): SpannableStringBuilder {
        val text = context.resources.getString(R.string.check_user_info_text1)
        val builder = SpannableStringBuilder(text)
        builder.setSpan(ForegroundColorSpan(ResourceUtil.getWKColor(context, R.color.color_6)), 0 + 2, 3 + 2, Spannable.SPAN_EXCLUSIVE_EXCLUSIVE)
        builder.setSpan(ForegroundColorSpan(ResourceUtil.getWKColor(context, R.color.color_4)), 3 + 2, 4 + 2, Spannable.SPAN_EXCLUSIVE_EXCLUSIVE)
        builder.setSpan(ForegroundColorSpan(ResourceUtil.getWKColor(context, R.color.color_6)), 4 + 2, 7 + 2, Spannable.SPAN_EXCLUSIVE_EXCLUSIVE)
        builder.setSpan(ForegroundColorSpan(ResourceUtil.getWKColor(context, R.color.color_4)), 7 + 2, text.length, Spannable.SPAN_EXCLUSIVE_EXCLUSIVE)
        return builder
    }

    private fun getInfo2CheckBoxText(comments: String): SpannableStringBuilder {
        val text = context.resources.getString(R.string.check_user_info_text2_part1) + comments + context.resources.getString(R.string.check_user_info_text2_part2)
        val num = 3
        val builder = SpannableStringBuilder(text)
        builder.setSpan(ForegroundColorSpan(ResourceUtil.getWKColor(context, R.color.color_4)), 0, num, Spannable.SPAN_EXCLUSIVE_EXCLUSIVE)
        builder.setSpan(ForegroundColorSpan(ResourceUtil.getWKColor(context, R.color.color_6)), num, comments.length + num, Spannable.SPAN_EXCLUSIVE_EXCLUSIVE)
        builder.setSpan(ForegroundColorSpan(ResourceUtil.getWKColor(context, R.color.color_4)), comments.length + num, text.length - 6, Spannable.SPAN_EXCLUSIVE_EXCLUSIVE)
        builder.setSpan(ForegroundColorSpan(ResourceUtil.getWKColor(context, R.color.color_6)), text.length - 6, text.length, Spannable.SPAN_EXCLUSIVE_EXCLUSIVE)
        return builder
    }

    //    租客是否认证
    private fun requestUserDetail(orderDetailResult: OrderDetailResult) {
        LogUtil.e("requestUserDetail ******************************")
        val request = UserDetailRequestBean()
        if (TextUtils.isEmpty(orderDetailResult.renter_user_id))
            return
        request.user_id = orderDetailResult.renter_user_id
        request.public_classification = "N"
        val mRetrofitService = RetrofitHelper.getInstance(context).service
        val hashMap = RetrofitHelper.getInstance(context).convertRequestToMap(request)
        val observable = mRetrofitService.userGetDetail(hashMap).debounce(1000, TimeUnit.MILLISECONDS)
        observable.subscribeOn(Schedulers.io()).doOnSubscribe {
            view.showLoadingDialog()
        }.observeOn(AndroidSchedulers.mainThread()).subscribe(object : BaseObserver<UserDetailResult>(context, this) {
            override fun onSuccess(response: UserDetailResult) {
                view.dismissLoadingDialog()
                if (!TextUtils.isEmpty(response.name)) {
                    view?.setUserName(response.name)
                }
                // renter id card
                if (!TextUtils.isEmpty(response.id_no)) {
                    view?.setUserID(response.id_no)
                }
                selectAuthStatus(response)
                // renter level
                if (!TextUtils.isEmpty(response.rolename))
                    view?.setUserLevelName(response.rolename)
                else
                    LogUtil.e("response.rolename == null")
                //renter url
                mOriginIDCardUrl = response.id_card
                mOriginDriverLicenseUrl = response.driver_card
                setDriverLicenseUrl(response.driver_card)
                setIDCardUrl(response.id_card)
                if (!TextUtils.isEmpty(response.photo_url))
                    view?.setIDSmallView(response.photo_url)
                LogUtil.e("After IDCarUrl")
                checkNextCondition()
            }
        })
    }

    private fun setUserMember(member: MemberBean) {
        memberID = member.member_id
        if (!TextUtils.isEmpty(member.name)) {
            view?.setUserName(member.name ?: "")
        }
        // renter id card
        if (!TextUtils.isEmpty(member.id_card_no)) {
            view?.setUserID(member.id_card_no ?: "")
        }
        setUserMemberAuth(member.auth_status, member.auth_status_name)
        // renter level
        if (!TextUtils.isEmpty(member.rate_name)) {
            view?.setUserLevelName(member.rate_name ?: "")
        } else {
            LogUtil.e("response.rolename == null")
        }
        //renter url
        mOriginIDCardUrl = member.id_card_url
        mOriginDriverLicenseUrl = member.drive_url
        setIDCardUrl(member.id_card_url)
        setDriverLicenseUrl(member.drive_url)
        LogUtil.e("After IDCarUrl")
        checkNextCondition()
    }

    private fun selectAuthStatus(result: UserDetailResult) {
        val userAuth = AuthUtil(context).getAuthStatus(result.auth)
        view?.setUserAuthStatus(result.auth)
        when (userAuth) {
            AuthUtil.USER_AUTHED -> {
                //已认证
                view?.setInfo2CheckBox(null)
                isAuthed = true
            }
            AuthUtil.USER_BLACKLIST -> {
                //认证未通过
                isAuthed = false
                var comments = ""
                if (result.auth != null && !TextUtils.isEmpty(result.auth.comments)) {
                    comments = result.auth.comments
                }
                view?.setInfo2CheckBox(getInfo2CheckBoxText(comments))
            }
            else -> {
                //未认证和认证中
                isAuthed = false
                val comments = context.resources.getString(R.string.check_user_info_text3)
                view?.setInfo2CheckBox(getInfo2CheckBoxText(comments))
            }
        }
    }

    private fun setUserMemberAuth(status: String?, name: String?) {
        view?.setUserAuthStatus(status ?: "", name ?: "")

        when (status) {
            "USER_AUTHED" -> {
                isAuthed = true
                view?.setInfo2CheckBox(null)
            }
            else -> {
                isAuthed = false
                view?.setInfo2CheckBox(getInfo2CheckBoxText("还未通过实名认证"))
            }
        }
    }

    private fun setDriverLicenseUrl(url: String?) {
        mDriverLicenseUrl = url
        LogUtil.e("setDriverLicenseUrl,mDriverLicenseUrl=$mDriverLicenseUrl")
        if (!TextUtils.isEmpty(url)) view?.setDriverLicenseView(url!!)
    }

    private fun setIDCardUrl(url: String?) {
        LogUtil.e("setIDCardUrl+url=$url")
        mIDCardUrl = url
        if (!TextUtils.isEmpty(url)) view?.setIDCardView(url!!)
    }

    private fun checkNextCondition() {
        LogUtil.e("checkNextCondition ")
        view?.enableNext(false)
        if (TextUtils.isEmpty(mDriverLicenseUrl) || TextUtils.isEmpty(mIDCardUrl))
            return
        LogUtil.e("Pic OK ")
        if (isUserMember) {
            if (isAuthed) {
                if (view.getInfo1CheckBoxStatus() && view.getInfo3CheckBoxStatus()) {
                    view?.enableNext(true)
                }
            } else {
                if (view.getInfo1CheckBoxStatus() && view.getInfo2CheckBoxStatus() && view.getInfo3CheckBoxStatus()) {
                    view?.enableNext(true)
                }
            }
        } else {
            if (isAuthed) {
                if (view.getInfo1CheckBoxStatus()) {
                    LogUtil.e("authed && checkbox OK ")
                    view?.enableNext(true)
                }
                LogUtil.e("authed && checkbox failed")
            } else {
                if (view.getInfo1CheckBoxStatus() && view.getInfo2CheckBoxStatus()) {
                    LogUtil.e("authed && checkbox OK ")
                    view?.enableNext(true)
                }
                LogUtil.e("authed && checkbox failed ")
            }
        }
    }

    /**
     *  图片处理逻辑
     */
    override fun onIDCard(fragment: Fragment) {
        // 1. 拍照/相册  2. uploadimage  3. user/update
        if (TextUtils.isEmpty(mOriginIDCardUrl)) {
            isIDCard = true
            //如果没有url,也没有file,不显示看大图
            if (TextUtils.isEmpty(mIDCardFilePath) && TextUtils.isEmpty(mIDCardUrl)) {
                showMenuWithoutBigImage(fragment)
            } else {
                showMenuWithBigImage(fragment)
            }
        } else {
            ShowBigImageActivity.newInstanceUri(context, mOriginIDCardUrl!!, false)
        }
    }

    override fun onDriverLicense(fragment: Fragment) {
        if (TextUtils.isEmpty(mOriginDriverLicenseUrl)) {
            isIDCard = false
            //如果没有url,也没有file,不显示看大图
            if (TextUtils.isEmpty(mDriverLicenseUrl) && TextUtils.isEmpty(mDriverLicenseFilePath)) {
                showMenuWithoutBigImage(fragment)
            } else {
                showMenuWithBigImage(fragment)
            }
        } else {
            ShowBigImageActivity.newInstanceUri(context, mOriginDriverLicenseUrl!!, false)
        }
    }

    override fun onInfo1CheckBoxChanged() {
        LogUtil.e("onInfo1CheckBoxChanged = $info1CheckBoxStatus")
        info1CheckBoxStatus = !info1CheckBoxStatus
        view.setInfo1CheckBoxStatus(info1CheckBoxStatus)
        checkNextCondition()
    }

    override fun onInfo2CheckBoxChanged() {
        LogUtil.e("onInfo2CheckBoxChanged = $info2CheckBoxStatus")
        info2CheckBoxStatus = !info2CheckBoxStatus
        view.setInfo2CheckBoxStatus(info2CheckBoxStatus)
        checkNextCondition()
    }

    override fun onInfo3CheckBoxChanged() {
        LogUtil.e("onInfo3CheckBoxChanged = $info3CheckBoxStatus")
        info3CheckBoxStatus = !info3CheckBoxStatus
        view.setInfo3CheckBoxStatus(info3CheckBoxStatus)
        checkNextCondition()
    }

    override fun onNext() {
        //初始有照片，不需要更新userX
        if (!TextUtils.isEmpty(mOriginDriverLicenseUrl) && !TextUtils.isEmpty(mOriginIDCardUrl)) {
            toNextPage()
            return
        }
        //用户选择照片。更新User
        val userID = orderDetailResult?.renter_user_id
        if (!TextUtils.isEmpty(mIDCardUrl) && !TextUtils.isEmpty(mDriverLicenseUrl) && userID != null) {
            if (isUserMember) {
                apiMemberUpdate()
            } else {
                postUserUpdateRequest(getUserUpdateRequest(userID, mIDCardUrl!!, mDriverLicenseUrl!!))
            }
        } else {
            LogUtil.e("onNext error")
        }
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        LogUtil.e("onActivityResult requestCode = $requestCode")
        if (data != null) LogUtil.e("onActivityResult data = $data")
        when (requestCode) {
            Constants.REQUEST_PIC -> {
                LogUtil.e("REQUEST_PIC=")
                if (data != null) {
                    //images返回的是照片路径
                    val images = data.getStringArrayListExtra(ImageSelectorUtils.SELECT_RESULT)
                    LogUtil.e("images=$images")
                    if (images != null && images.size > 0) {
                        LogUtil.e("images->$images")
                        if (images[0] == null)
                            return
                        handlePhoto(File(images[0]))
                    }
                }
            }
            CarEntity.REQUEST_CAMERA -> {
                if (resultCode == Activity.RESULT_OK) {
                    handlePhoto(File(getImageFilePath()))
                }
            }
        }
    }

    override fun onBackPressed() {
        if (orderDetailResult != null && orderDetailResult?.channel == "schoolapp") {
            view?.onSchoolBack()
        } else {
            view.onNormalBack()
        }
    }

    private fun showMenuWithoutBigImage(fragment: Fragment) {
        BottomDialog(context).builder().addItems(arrayOf("拍照", "相册")).setCancel("取消") {}.setItemClick { _, i ->
            when (i) {
                // 相机(单选) 跳转到调用系统相机
                0 -> handleTakePicture(context, fragment)
                // 跳转到调用系统图库
                1 -> ImageSelectorUtils.openPhoto(context as FragmentActivity, fragment, Constants.REQUEST_PIC, true, 1, null, "")
            }
        }.show()
    }

    private fun showMenuWithBigImage(fragment: Fragment) {
        BottomDialog(context).builder().addItems(arrayOf("查看大图", "拍照", "相册")).setCancel("取消") {}.setItemClick { _, i ->
            when (i) {
                // 查看大图
                0 -> handleBigImage()
                // 跳转到调用系统相机
                1 -> handleTakePicture(context, fragment)
                // 跳转到调用系统图库
                else -> ImageSelectorUtils.openPhoto(context as FragmentActivity, fragment, Constants.REQUEST_PIC, true, 1, null, "")
            }
        }.show()
    }

    private fun handleTakePicture(context: Context, fragment: Fragment) {
        disposable = RxPermissions(context as FragmentActivity).request(Manifest.permission.CAMERA,
                Manifest.permission.READ_EXTERNAL_STORAGE, Manifest.permission.WRITE_EXTERNAL_STORAGE).subscribe({ granted ->
            if (granted) { // Always true pre-M
                PhotoUtils.takePicture(context as Activity, fragment, File(getImageFilePath()), CarEntity.REQUEST_CAMERA)
            }
        }, { throwable ->
            LogUtil.e("RxJava throwable = $throwable")
        })
    }

    private fun getImageFilePath(): String {
        val filePath: String = if (isIDCard) ID_FILE_PATH else DRIVER_LICENSE_FILE_PATH
        LogUtil.e("getImageFilePath =$filePath")
        return filePath
    }

    /**
     * 查看大图功能
     */
    private fun handleBigImage() {
        val url = if (isIDCard) {
            if (!TextUtils.isEmpty(mIDCardUrl)) mIDCardUrl else mIDCardFilePath
        } else {
            if (!TextUtils.isEmpty(mDriverLicenseUrl)) mDriverLicenseUrl else mDriverLicenseFilePath
        }
        ShowBigImageActivity.newInstanceUri(context, url ?: "", false)
    }

    private fun handlePhoto(actualImage: File?) {
        LogUtil.e("handlePhoto")
        if (actualImage == null)
            return
        try {
            view?.showLoadingDialog()
            compressedImage = PhotoUtils.compressFile(context, actualImage)
            if (compressedImage != null) {
                LogUtil.e("compressedImage!=null")
                if (isIDCard) {
                    view.setIDCardView(compressedImage!!.absolutePath)
                    mIDCardFilePath = compressedImage!!.absolutePath
                    uploadALiCloudImage(mIDCardFilePath, AliYunPictureUtil.PRIVATE_USER_ID)
                } else {
                    view.setDriverLicenseView(compressedImage!!.absolutePath)
                    mDriverLicenseFilePath = compressedImage!!.absolutePath
                    uploadALiCloudImage(mDriverLicenseFilePath, AliYunPictureUtil.PRIVATE_USER_DRIVER)
                }
            }
        } catch (e: Exception) {
        }
    }

    private fun uploadALiCloudImage(filePath: String, remotePath: String) {
        if (TextUtils.isEmpty(filePath)) {
            view?.dismissLoadingDialog()
            return
        }
        //清除list,否在会有多张图片
        postImages.clear()
        postImages.add(filePath)
        mUploadUtil = AliYunPictureUtil.getInstance(context)
        mUploadUtil?.setDatas(AliYunPictureUtil.BUCKET_TYPE_PRIVATE, postImages, remotePath, uploadListenerOnePic)
    }

    private val uploadListenerOnePic = object : UploadListener {
        override fun onUploadComplete(success: HashMap<Int, String>, failure: HashMap<Int, String>) {
            view.dismissLoadingDialog()
            LogUtil.e("onUploadComplete， success.size=" + success.size)
            LogUtil.e("onUploadComplete， success=$success")
            if (success.size == 1) {
                if (isIDCard) {
                    setIDCardUrl(success[1].toString())
                } else {
                    setDriverLicenseUrl(success[1].toString())
                }
                checkNextCondition()
            } else {
                view.showToast("上传失败")
            }
        }

        override fun onUploadComplete(net: String?, local: String?) {}
    }

    private fun toNextPage() {
        if (orderDetailResult != null && orderDetailResult?.channel == "schoolapp") {
            view?.toSchoolNextPage()
        } else {
            view.toNormalNextPage()
        }
    }

    private fun getUserUpdateRequest(userID: String, idCarUrl: String, driverLicenseUrl: String): UserUpdataRequest {
        val request = UserUpdataRequest()
        request.id_card = idCarUrl
        request.driver_card = driverLicenseUrl
        request.user_id = userID
        return request
    }

    /**
     * 更新个人信息(身份证URL和驾驶证url)
     */
    private fun postUserUpdateRequest(request: UserUpdataRequest) {
        val service = RetrofitHelper.getInstance(context).service
        val params = RetrofitHelper.getInstance(context).convertRequestToMap(request)
        val observable = service.userUpdate(params).debounce(1000, TimeUnit.MILLISECONDS)
        observable.subscribeOn(Schedulers.io()).doOnSubscribe {
            view?.showLoadingDialog()
        }.observeOn(AndroidSchedulers.mainThread()).subscribe(object : BaseObserver<BaseResult>(context, this) {
            override fun onSuccess(response: BaseResult?) {
                view?.dismissLoadingDialog()
                if (response != null) {
                    view?.showToast("用户信息修改成功")
                    toNextPage()
                }
            }
        })
    }

    override fun apiMemberUpdate() {
        val request = getMemberRequest()
        val service = RetrofitHelper.getInstance(context).service
        val params = RetrofitHelper.getInstance(context).convertRequestToMap(request)
        val observable = service.memberUpdate(params).debounce(1000, TimeUnit.MILLISECONDS)
        observable.subscribeOn(Schedulers.io()).doOnSubscribe {
            view?.showLoadingDialog()
        }.observeOn(AndroidSchedulers.mainThread()).subscribe(object : BaseObserver<BaseResult>(context, this) {
            override fun onSuccess(response: BaseResult?) {
                view?.dismissLoadingDialog()
                if (response != null) {
                    view?.showToast("用户信息修改成功")
                    toNextPage()
                }
            }
        })
    }

    private fun getMemberRequest(): MemberUpdateRequest {
        val request = MemberUpdateRequest()
        request.member_id = memberID
        request.id_card_url = mIDCardUrl
        request.drive_url = mDriverLicenseUrl
        return request
    }


    fun doMemberAgree() {
        val name = orderDetailResult?.member?.name ?: ""
        val idNo = orderDetailResult?.member?.id_card_no ?: ""
        H5Utils.doMemberAgree(context, name, idNo, orderDetailResult?.orderid)
    }
}
