package com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.delivercar.fragments.second


import android.content.Intent
import android.support.v4.app.Fragment
import android.text.SpannableStringBuilder
import com.jiaoyinbrother.library.base.IBasePresenter
import com.jiaoyinbrother.library.bean.AuthBean
import com.jiaoyinbrother.library.bean.OrderDetailResult
import com.jiaoyinbrother.library.view.IBaseView

interface IDeliverCarSecondContract {
    interface View : IBaseView {
        fun setOrderNum(num: String)
        fun setOrderChannel(channel: String)
        fun setCarNum(num: String)

        //用户信息
        fun setUserName(name: String)

        fun setUserID(userID: String)
        fun setUserAuthStatus(status: AuthBean?)
        fun setUserAuthStatus(status: String, name: String)
        fun setUserLevelName(levelName: String)

        //        设置image
        fun setIDCardView(uri: String)

        fun setDriverLicenseView(uri: String)
        fun setIDSmallView(uri: String)

        fun setInfo1CheckBox(text: SpannableStringBuilder)
        fun setInfo2CheckBox(text: SpannableStringBuilder?)

        fun setInfo1CheckBoxStatus(b: Boolean)
        fun setInfo2CheckBoxStatus(b: Boolean)
        fun setInfo3CheckBoxStatus(b: Boolean)

        // 委托人
        fun setTakeClientVisible(b: Boolean)

        fun enableNext(b: Boolean)

        //getter
        fun getInfo1CheckBoxStatus(): Boolean

        fun getInfo2CheckBoxStatus(): Boolean
        fun getInfo3CheckBoxStatus(): Boolean


        //        fun toNextPage()
        fun toSchoolNextPage()

        fun toNormalNextPage()

        fun onSchoolBack()
        fun onNormalBack()
        fun setTimeLine(type: Int, index: Int)
    }

    interface Presenter : IBasePresenter {
        fun onIDCard(fragment: Fragment)
        fun onDriverLicense(fragment: Fragment)
        fun onInfo1CheckBoxChanged()
        fun onInfo2CheckBoxChanged()
        fun onInfo3CheckBoxChanged()

        fun onNext()
        fun onBackPressed()


        fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?)
        fun getOrderInfo(result: OrderDetailResult)

        fun apiMemberUpdate()
    }
}
