package com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.delivercar.fragments.third

import android.app.Activity
import android.arch.lifecycle.Observer
import android.content.Context
import android.content.Intent
import android.os.Bundle
import android.support.v7.widget.AppCompatEditText
import android.text.Editable
import android.text.TextUtils
import android.text.TextWatcher
import android.view.MotionEvent
import android.view.View
import android.view.inputmethod.InputMethodManager
import android.widget.EditText
import com.bumptech.glide.Glide
import com.jeremyliao.livedatabus.LiveDataBus
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseFragment
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.delivercar.FragmentListerner
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.delivercar.fragments.main.DeliverCarMainFragment
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.refundcar.adapter.IssuesAdapter
import com.jiaoyinbrother.monkeyking.manager.view.SeekBarView
import com.jiaoyinbrother.library.bean.CarValidatesBean
import com.jiaoyinbrother.library.bean.CheckImgBean
import com.jiaoyinbrother.library.bean.OrderDetailResult
import com.jiaoyinbrother.library.util.ConstantsUtil
import com.jiaoyinbrother.library.util.LogUtil
import com.jiaoyinbrother.library.widget.BottomDialog
import com.jiaoyinbrother.library.widget.GeneralBottomButton
import kotlinx.android.synthetic.main.fragment_deliver_car_third.*
import java.util.regex.Pattern

class DeliverCarThirdFragment : MvpBaseFragment<DeliverCarThirdPresenter>(), IDeliverCarThridContract.View, View.OnClickListener {


    override fun setTimeLine(type: Int, index: Int) {
        third_time_line.setStyleType(type)
        third_time_line.setSelectIndex(index)
    }

    private var myListener: FragmentListerner? = null

    override fun onAttach(activity: Activity?) {
        super.onAttach(activity)
        myListener = getActivity() as FragmentListerner?
    }

    override fun setTakeMiles(miles: String) {
        takeMiles.setText(miles)
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {

        view.setOnTouchListener(View.OnTouchListener { _, event ->

            LogUtil.e("onViewCreated  ")
            if (event.action === MotionEvent.ACTION_DOWN) {
                LogUtil.e("onViewCreated setOnTouchListener ")
                val v = view
                val v1 = _mActivity.currentFocus
                if (v1 != null && v != null && (v !is EditText || v !is AppCompatEditText)) {
                    val im = mActivity.getSystemService(Context.INPUT_METHOD_SERVICE) as InputMethodManager
                    im.hideSoftInputFromWindow(v1.windowToken, InputMethodManager.HIDE_NOT_ALWAYS)
                    return@OnTouchListener true
                }
            }
            false
        })
        super.onViewCreated(view, savedInstanceState)
    }

    override fun setSignImage(url: String) {
        Glide.with(_mActivity).load(url).into(signImage)
    }

    override fun getTakeCarItems(): ArrayList<String> {
        return itemView.getTakeData()
    }

    override fun getComment(): String {
        return etComment.text.toString()
    }

    override fun getTakeMiles(): String {
        return takeMiles?.text.toString()
    }

    private var isShowCarItems = false
    private var isShowSign = true
    private var oldAdapter: IssuesAdapter? = null
    private var newAdapter: IssuesAdapter? = null

    override fun setOrderNum(num: String) {
        orderNum.text = num
    }

    override fun setOrderChannel(channel: String) {
        orderChannel.text = channel
    }

    override fun setCarNum(num: String) {
        carNum.text = num
    }

    override fun setCarTypeName(name: String) {
        carTypeName.text = name
    }

    override fun setRealTakeTime(time: String) {
        realTakeCarTimeTitle.text = "预计取车时间：$time"
    }

    override fun setRealRefundTime(time: String) {
        realRefundCarTimeTitle.text = "预计还车时间：$time"
    }

    override fun hideOilShowElectric(isOil: Boolean) {
        electricLayout.visibility = if (isOil) View.VISIBLE else View.GONE
        oilLayout.visibility = if (isOil) View.GONE else View.VISIBLE
    }

    override fun setTakeOil(scale: Int, oilMass: String) {
        sbTakeOil.setProgress(scale)
        takeOil.text = oilMass
    }

    override fun setTakeElectric(electric: String) {
        takeElectric.setText(electric)
    }

    override fun setTakeItems(isClick: Boolean, states: ArrayList<String>) {
        itemView.setTakeData(isClick, states)
    }

    override fun setRefundItems(isClick: Boolean, states: ArrayList<String>) {
        itemView.setRefundData(isClick, states)
    }

//    override fun setGroupPhoto(url: String) {
//        Glide.with(_mActivity).load(url).into(groupPhoto)
//    }
//
//    override fun setTakeOilPhoto(url: String) {
//        Glide.with(_mActivity).load(url).into(takeOilPhoto)
//    }

    override fun hideOldIssue(hide: Boolean) {
        oldIssueLayout.visibility = if (hide) View.GONE else View.VISIBLE
    }

    override fun setOldIssues(validates: ArrayList<CarValidatesBean>) {
        oldAdapter?.list = validates
        oldAdapter?.notifyDataSetChanged()
    }

    override fun hideNewIssue(hide: Boolean) {
        newIssueLayout.visibility = if (hide) View.GONE else View.VISIBLE
    }

    override fun setNewIssues(validates: ArrayList<CarValidatesBean>) {
        newAdapter?.list = validates
        newAdapter?.notifyDataSetChanged()
    }

    override fun toSchoolNextPage(b: Boolean) {
        val a = parentFragment as DeliverCarMainFragment
        if (b) {
            a.onSelectPage(DeliverCarMainFragment.PAGE_SIX, DeliverCarMainFragment.PAGE_FOUR)
        } else {
            a.onSelectPage(DeliverCarMainFragment.PAGE_FIVE, DeliverCarMainFragment.PAGE_FOUR)
        }

    }

    override fun toNormalNextPage(b: Boolean) {
        val a = parentFragment as DeliverCarMainFragment
        if (b) {
            a.onSelectPage(DeliverCarMainFragment.PAGE_FIVE, DeliverCarMainFragment.PAGE_THREE)
        } else {
            a.onSelectPage(DeliverCarMainFragment.PAGE_FOUR, DeliverCarMainFragment.PAGE_THREE)
        }
    }

    override fun initPresenter(): DeliverCarThirdPresenter {
        return DeliverCarThirdPresenter(mActivity, this)
    }

    override fun onClick(p0: View?) {

    }

    companion object {
        fun newInstance(): DeliverCarThirdFragment {
            val args = Bundle()
            val fragment = DeliverCarThirdFragment()
            fragment.arguments = args
            return fragment
        }
    }

    override fun getLayoutId(): Int {
        return R.layout.fragment_deliver_car_third
    }

    override fun initViews(view: View?, savedInstanceState: Bundle?) {

    }

    override fun initToolbar(savedInstanceState: Bundle?) {

    }

    override fun initListeners() {
        onNext.setListener(object : GeneralBottomButton.SubmitListener {
            override fun submit() {
                presenter.onNext()
            }
        })

        takeMiles.addTextChangedListener(object : TextWatcher {
            override fun afterTextChanged(s: Editable?) {}
            override fun beforeTextChanged(s: CharSequence?, start: Int, count: Int, after: Int) {}

            override fun onTextChanged(s: CharSequence?, start: Int, before: Int, count: Int) {
                val words = s.toString()
                presenter.onTakeCarMileChanged(words)
            }
        })
        sbTakeOil.setListener(MyListeners())
        takeElectric.addTextChangedListener(MyListeners())
        carItemsLayout.setOnClickListener(MyListeners())
        carPicLayout.setOnClickListener {
            presenter.onCheckImage()
        }
        addIssue.setOnClickListener(MyListeners())
        signLayout.setOnClickListener(MyListeners())
        signImage.setOnClickListener(MyListeners())
        onNext.setListener(MyListeners())
        oldAdapter?.setOnItemClickListener { _, position ->
            val issue = oldAdapter?.getItem<CarValidatesBean>(position)
            issue?.let { presenter.onSeeNewIssue(it) }
        }
        newAdapter?.setOnItemClickListener { _, position ->
            val issue = newAdapter?.getItem<CarValidatesBean>(position)
            BottomDialog(context)
                    .builder()
                    .addItems(arrayOf("查看问题", "删除问题"))
                    .setCancel("取消") {}
                    .setItemClick { _, i ->
                        when (i) {
                            0 -> issue?.let { presenter.onSeeNewIssue(it) }
                            1 -> presenter.onDelNewIssue(position)
                        }
                    }.show()
        }
    }


    override fun initData() {
//        myListener?.showRefreshButton(false)

        // 取车验车图片
        oldAdapter = IssuesAdapter(_mActivity)
        oldIssueRv.adapter = oldAdapter
        // 新增问题
        newAdapter = IssuesAdapter(_mActivity)
        newIssueRv.adapter = newAdapter
        // 初始化新增问题隐藏
        hideNewIssue(true)
        // 添加新问题数据回传
        LiveDataBus.get().with(ConstantsUtil.VALIDATES).observe(_mActivity, Observer {
            val bean = it as CarValidatesBean
            presenter.onAddNewIssue(bean)
        })

        LiveDataBus.get().with("Take_Check_Image").observe(_mActivity, Observer {
            presenter.getCheckImage(it as ArrayList<CheckImgBean>)
        })
    }

    override fun updataFragment() {

    }

    fun setData(result: OrderDetailResult) {
        presenter.getOrderInfo(result)
    }


    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        LogUtil.e("onActivityResult*************************")
        presenter.onActivityResult(requestCode, resultCode, data)
    }

    override fun onBackPressedSupport(): Boolean {

        presenter.onBackPressed()
        return true
    }

    override fun onSchoolBack() {
        val a = parentFragment as DeliverCarMainFragment
        a.onSelectPage(DeliverCarMainFragment.PAGE_THREE, DeliverCarMainFragment.PAGE_FOUR)
    }

    override fun onNormalBack() {
        val a = parentFragment as DeliverCarMainFragment
        a.onSelectPage(DeliverCarMainFragment.PAGE_SECOND, DeliverCarMainFragment.PAGE_THREE)
    }

    /**
     * display 随车物品
     * */
    private fun onShowCarItems() {
        isShowCarItems = !isShowCarItems
        itemView.visibility = if (isShowCarItems) View.VISIBLE else View.GONE
        if (isShowCarItems) {
            itemsArrow.setBackgroundResource(R.mipmap.up_item)
        } else {
            itemsArrow.setBackgroundResource(R.mipmap.down_item)
        }
    }

    /**
     * display 签名
     * */
    private fun onShowSign() {
        isShowSign = !isShowSign
        signImage.visibility = if (isShowSign) View.VISIBLE else View.GONE
        if (isShowSign) {
            signArrow.setBackgroundResource(R.mipmap.up_item)
        } else {
            signArrow.setBackgroundResource(R.mipmap.down_item)
        }
    }


    private inner class MyListeners : View.OnClickListener, GeneralBottomButton.SubmitListener, TextWatcher, SeekBarView.OnSeekBarChangeListener {

        override fun onProgressChanged(progress: Int) {
            LogUtil.e("SeekBar onProgressChanged --->>> $progress")
            presenter.onTakeCarOilChanged(progress)
            onNext.disable()

        }

        override fun onStartTrackingTouch(bool: Boolean) {}

        override fun onStopTrackingTouch(bool: Boolean) {
            LogUtil.e("SeekBar onStopTrackingTouch --->>> $bool")
            onNext.normal()

        }

        private var outStr = ""

        override fun submit() {
            presenter.onNext()
        }

        override fun afterTextChanged(s: Editable?) {
            //这里的处理是不让输入0开头的值
            val words = s.toString()
            //首先内容进行非空判断，空内容（""和null）不处理
            if (!TextUtils.isEmpty(words)) {
                if (Integer.parseInt(s.toString()) <= 0) {
                    takeElectric.setText("")
                    showToast("电量:1-100%")
                }
            }
        }

        override fun beforeTextChanged(s: CharSequence?, start: Int, count: Int, after: Int) {
            val edit = s.toString()
            if (edit.length == 2 && Integer.parseInt(edit) >= 10) {
                outStr = edit
            }
        }

        override fun onTextChanged(s: CharSequence?, start: Int, before: Int, count: Int) {
            val words = s.toString()
            //首先内容进行非空判断，空内容（""和null）不处理
            if (!TextUtils.isEmpty(words)) {
                //1-100的正则验证
                val pattern = Pattern.compile("^(100|[1-9]\\d|\\d)$")
                val matcher = pattern.matcher(words)
                if (matcher.find() || ("") == words) {
                    //这个时候输入的是合法范围内的值
                    presenter.onTakeCarElectricChanged(words)
                } else {
                    if (words.length > 2) {
                        //若输入不合规，且长度超过2位，继续输入只显示之前存储的outStr
                        takeElectric.setText(outStr)
                        //重置输入框内容后默认光标位置会回到索引0的地方，要改变光标位置
                        takeElectric.setSelection(2)
                        showToast("电量:1-100%")
                    }
                }
            }
        }

        override fun onClick(v: View?) {
            when (v?.id) {
                R.id.carItemsLayout -> onShowCarItems()
                R.id.addIssue -> presenter.onAddIssue()
                R.id.signLayout -> onShowSign()
                R.id.signImage -> presenter.onSign(this@DeliverCarThirdFragment)
            }
        }
    }

    override fun onSupportVisible() {
        super.onSupportVisible()
        myListener?.showRefreshButton(false)
        LogUtil.e("DeliverCarThirdFragment onSupportVisible")
    }

}
