package com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.delivercar.fragments.third

import android.app.Activity
import android.content.Context
import android.content.Intent
import android.support.v4.app.Fragment
import android.text.TextUtils
import android.webkit.URLUtil
import com.jeremyliao.livedatabus.LiveDataBus
import com.jiaoyinbrother.monkeyking.manager.activity.HandWriteActivity
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.issuedetail.IssueDetailActivity
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.timefindissue.TimeFindIssueActivity
import com.jiaoyinbrother.monkeyking.manager.view.IOSdialog.IOSAlertDialog
import com.jiaoyinbrother.library.base.BasePresenterImpl
import com.jiaoyinbrother.library.bean.*
import com.jiaoyinbrother.library.util.*
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.uploadcheckimage.UploadCheckImageActivity
import com.jiaoyinbrother.monkeyking.manager.view.TakeAlsoCarTimeLine

class DeliverCarThirdPresenter(context: Context, view: IDeliverCarThridContract.View)
    : BasePresenterImpl<IDeliverCarThridContract.View>(context, view), IDeliverCarThridContract.Presenter {
    override fun onBackPressed() {
        if (orderDetailResult != null && orderDetailResult?.channel == "schoolapp") {
            view?.onSchoolBack()
        } else {
            view.onNormalBack()
        }
    }

    private var orderDetailResult: OrderDetailResult? = null
    private var orderID: String? = null
    private var carID: String? = null
    private var takeFuel: String? = null// 还车油（电）量
    private var newIssueList = ArrayList<CarValidatesBean>()// 发现新问题
    private var issueIds = ArrayList<String>()
    private var minTakeFuel = 0
    private var takeFuelProgress = 0
    private var minTakeFuelTips: String? = null

    override fun getOrderInfo(result: OrderDetailResult) {
        orderDetailResult = result

        initTimeLine(result)

        orderID = result.orderid
        carID = result.carid
        // 订单号
        view.setOrderNum("订单号：${result.getOrderShowID()}")
        // 订单渠道
        if (TextUtils.isEmpty(result.channel_name)) {
            view.setOrderChannel("")
        } else {
            view.setOrderChannel("(${result.channel_name})")
        }
        // 车牌号
        view.setCarNum(result.number ?: "")
        // 车型
        view.setCarTypeName(result.type ?: "")
        // 实际取车时间
        val bill = result.bill
        view.setRealTakeTime(bill?.real_start_time ?: "")
        // 实际还车时间
        view.setRealRefundTime(bill?.real_end_time ?: "")
        // 取车里程
        val usage = result.usage
        if (!TextUtils.isEmpty(usage?.take_miles))
            view.setTakeMiles(usage?.take_miles!!)

        // 取还车油量
        takeFuel = if (TextUtils.equals(result.transmission, "ET")) {
            // 电动车
            view.hideOilShowElectric(true)
            view.setTakeElectric(usage?.take_fuel ?: "")
            usage?.return_fuel ?: ""
        } else {
            // 油车
            view.hideOilShowElectric(false)
            view.setTakeOil(getOilScale(usage?.take_fuel), usage?.take_fuel ?: "0/16")
            usage?.return_fuel ?: "0/16"
        }
        // 随车物品 取车时
        view.setTakeItems(true, ArrayList())

        // 随车物品 还车时
        view.setRefundItems(false, ArrayList())

        view.hideOldIssue(false)
        // 已有问题
        if (!Util.isEmptyList(usage?.take_car?.validates ?: ArrayList<CarValidatesBean>())) {
            view.setOldIssues(usage?.take_car?.validates ?: ArrayList())

            for (i in usage?.take_car?.validates!!) {
                issueIds.add(i.car_validate_id ?: "")
            }
        }

        minTakeFuel = result.min_take_fuel ?: 0
        minTakeFuelTips = result.order_description?.take_fuel_tips

    }

    private fun initTimeLine(result: OrderDetailResult) {
        if (result.school_roll != null) {
            // 0 否  1 是
            if (result.e_contract_status == 0) {
                view.setTimeLine(TakeAlsoCarTimeLine.DELIVER_SCHOOL, TakeAlsoCarTimeLine.INDEX_THREE)
            } else {
                view.setTimeLine(TakeAlsoCarTimeLine.DELIVER_CONTRACT_SCHOOL, TakeAlsoCarTimeLine.INDEX_THREE)
            }
        } else {
            if (result.e_contract_status == 0) {
                view.setTimeLine(TakeAlsoCarTimeLine.DELIVER_NORMAL, TakeAlsoCarTimeLine.INDEX_TWO)
            } else {
                view.setTimeLine(TakeAlsoCarTimeLine.DELIVER_CONTRACT_NORMAL, TakeAlsoCarTimeLine.INDEX_TWO)
            }
        }
    }

    /**
     * 还车里程
     * */
    override fun onTakeCarMileChanged(mile: String) {

    }

    /**
     * 还车电量
     * */
    override fun onTakeCarElectricChanged(electric: String) {
        LogUtil.e("还车电量 ----->>> $electric%")
        takeFuel = electric
    }

    /**
     * 还车油量
     * */
    override fun onTakeCarOilChanged(progress: Int) {
        takeFuelProgress = progress
        LogUtil.e("还车油量 ----->>> $progress/16")
        takeFuel = "$progress/16"
        view.setTakeOil(progress, takeFuel ?: "0/16")
    }

    /**
     * 跳转发现新问题
     * */
    override fun onAddIssue() {
        TimeFindIssueActivity.newInstance(context as Activity, orderID ?: "", carID ?: "", true)
    }

    /**
     * 刷新新问题列表
     * */
    override fun onAddNewIssue(it: CarValidatesBean) {
        newIssueList.add(it)
        if (!Util.isEmptyList(newIssueList)) view.hideNewIssue(false)
        view.setNewIssues(newIssueList)
    }

    /**
     * 查看发现新问题
     * */
    override fun onSeeNewIssue(issue: CarValidatesBean) {
        LiveDataBus.get().with(ConstantsUtil.LIVEDATA_ORDER_ISSUE_DDTAIL).postValue(issue)
        context.startActivity(Intent(context, IssueDetailActivity::class.java))
    }


    /**
     * 删除发现新问题
     * @param position
     * */
    override fun onDelNewIssue(position: Int) {
        IOSAlertDialog(context)
                .builder()
                .setCancelable(false)
                .setTitle("确认删除")
                .setMsg("确认删除该问题？", true)
                .setRightButton("确认") {
                    newIssueList.removeAt(position)
                    if (Util.isEmptyList(newIssueList)) view.hideNewIssue(true)
                    view.setNewIssues(newIssueList)
                }
                .setLeftButton("取消") {}.show()
    }

    override fun onSign(fragment: Fragment) {
        fragment.startActivityForResult(Intent(context, HandWriteActivity::class.java), SIGN_ACTIVITY_REQUEST)
    }

    override fun onNext() {
        if (TextUtils.isEmpty(view?.getTakeMiles())) {
            view.showToast("请输入里程数")
            return
        }
        if (TextUtils.equals(orderDetailResult?.transmission, "ET") && TextUtils.isEmpty(takeFuel)) {
            view.showToast("请输入电量")
            return
        }
        if (checkBean.size == 0 || TextUtils.isEmpty(checkBean[0].url) || TextUtils.isEmpty(checkBean[1].url)) {
            view.showToast("请上传验车图片")
            return
        }

        if (takeFuelProgress < minTakeFuel && !TextUtils.equals(orderDetailResult?.transmission, "ET")) {
            view.showToast(minTakeFuelTips)
            return
        }

//        view?.toNextPage()
        if (orderDetailResult != null && orderDetailResult?.channel == "schoolapp") {
            // 0 否  1 是
            view?.toSchoolNextPage(orderDetailResult?.e_contract_status == 0)
        } else {
            view.toNormalNextPage(orderDetailResult?.e_contract_status == 0)
        }

        if (orderDetailResult?.e_contract_status == 1) {
            LiveDataBus.get().with(ConstantsUtil.CONTRACT_PRE).postValue(true)
        }
        LiveDataBus.get().with(ConstantsUtil.LIVEDATA_ORDER_EXCUTE_REQUEST).postValue(getOrderExecuteRequest())
    }

    /**
     * 油量截取
     * @param fuel
     * */
    private fun getOilScale(fuel: String?): Int {
        var scale = "0"
        if (!TextUtils.isEmpty(fuel)) {
            scale = fuel!!.split("/")[0]
        }
        LogUtil.e("scale == " + scale.toInt())
        takeFuelProgress = scale.toInt()
        return scale.toInt()
    }

    private fun getOrderExecuteRequest(): OrderExecuteRequest {
        val entity = OrderExecuteRequest()
        entity.orderid = orderID
        entity.fuel = takeFuel
        try {
            entity.miles = Integer.valueOf(view?.getTakeMiles()!!)
        } catch (e: Exception) {

        }
        entity.front_url = checkBean?.get(1)?.url
        entity.fuel_url = checkBean?.get(0)?.url
        entity.validates = newIssueList
        if (!Util.isEmptyList(issueIds)) {
            entity.validate_ids = issueIds
        }

        entity.accessories = view.getTakeCarItems()// 车内物品

        if (!TextUtils.isEmpty(view.getComment())) {
            entity.comments = view.getComment()// 备注
        }
        if (!TextUtils.isEmpty(signUrl) && URLUtil.isNetworkUrl(signUrl)) {
            entity.sign_url = signUrl// 签名url
        }

        entity.inspection_pic = getInspectionPicBean()

        return entity
    }

    private fun getInspectionPicBean(): InspectionPicBean? {
        val bean = InspectionPicBean()
        for (entity in checkBean) {
            when (entity.index) {
                2 -> {
                    bean.left_front = entity.url
                }
                3 -> {
                    bean.left_side = entity.url
                }
                4 -> {
                    bean.left_rear = entity.url
                }
                5 -> {
                    bean.right_rear = entity.url
                }
                6 -> {
                    bean.right_side = entity.url
                }
                7 -> {
                    bean.right_front = entity.url
                }
            }
        }
        return bean
    }


    private val SIGN_ACTIVITY_REQUEST = 101

    private var signUrl: String? = null

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        LogUtil.e("onActivityResult requestCode = $requestCode")
        if (data != null)
            LogUtil.e("onActivityResult data = $data")
        when (requestCode) {
            SIGN_ACTIVITY_REQUEST -> {
                if (data != null) {
                    signUrl = data.getStringExtra("sign_url")
                    if (!TextUtils.isEmpty(signUrl))
                        view.setSignImage(signUrl!!)
                }
            }
        }
    }

    private var checkBean = ArrayList<CheckImgBean>()


    override fun getCheckImage(it: ArrayList<CheckImgBean>) {
        checkBean = it
    }

    fun onCheckImage() {
        UploadCheckImageActivity.newInstance(context, orderDetailResult?.status ?: 0, checkBean)
    }
}

