package com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.delivercar.fragments.third

import android.content.Intent
import android.support.v4.app.Fragment
import com.jiaoyinbrother.library.base.IBasePresenter
import com.jiaoyinbrother.library.bean.CarValidatesBean
import com.jiaoyinbrother.library.bean.CheckImgBean
import com.jiaoyinbrother.library.bean.OrderDetailResult
import com.jiaoyinbrother.library.view.IBaseView

interface IDeliverCarThridContract {
    interface View : IBaseView {
        fun setOrderNum(num: String)
        fun setOrderChannel(channel: String)
        fun setCarNum(num: String)
        fun setCarTypeName(name: String)

        fun setRealTakeTime(time: String)
        fun setRealRefundTime(time: String)

        fun hideOilShowElectric(isOil: Boolean)
        fun setTakeOil(scale: Int, oilMass: String)

        fun setTakeElectric(electric: String)

        fun setTakeItems(isClick: Boolean, states: ArrayList<String>)
        fun setRefundItems(isClick: Boolean, states: ArrayList<String>)

//        fun setGroupPhoto(url: String)
//        fun setTakeOilPhoto(url: String)
        fun setSignImage(url: String)

        fun hideOldIssue(hide: Boolean)
        fun setOldIssues(validates: ArrayList<CarValidatesBean>)
        fun hideNewIssue(hide: Boolean)
        fun setNewIssues(validates: ArrayList<CarValidatesBean>)
//        fun toNextPage()

        fun toSchoolNextPage(b: Boolean)
        fun toNormalNextPage(b: Boolean)

        fun onSchoolBack()
        fun onNormalBack()


        fun setTakeMiles(miles: String)

        //getter
        fun getTakeMiles(): String

        fun getComment(): String
        fun getTakeCarItems(): ArrayList<String>

        fun setTimeLine(type: Int, index: Int)

    }

    interface Presenter : IBasePresenter {
        fun getOrderInfo(result: OrderDetailResult)
        fun onTakeCarMileChanged(mile: String)
        fun onTakeCarOilChanged(progress: Int)
        fun onTakeCarElectricChanged(electric: String)

        fun getCheckImage(it : ArrayList<CheckImgBean>)

        fun onAddIssue()
        fun onAddNewIssue(it: CarValidatesBean)
        fun onSeeNewIssue(issue: CarValidatesBean)
        fun onDelNewIssue(position: Int)
        fun onSign(fragment: Fragment)
        fun onNext()
        fun onBackPressed()

        fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?)
    }
}
