package com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.detail

import android.content.Intent
import android.opengl.Visibility
import android.support.v7.app.AppCompatActivity
import com.jiaoyinbrother.library.base.IBasePresenter
import com.jiaoyinbrother.library.bean.AuthBean
import com.jiaoyinbrother.library.bean.OrderDetailResult
import com.jiaoyinbrother.library.view.IBaseView

interface IOrderDetailContract {

    interface View : IBaseView {
        fun showPage()
        fun setRefreshEnd()
        fun setOrderNum(num: String)
        fun setOrderChannel(channel: String)
        fun setOrderState(state: String, isShowReletStatus: Boolean)
        fun setCarPic(pic: String)
        fun setCarType(type: String)
        fun setCarInfo(info: String)
        fun setCarNum(num: String)
        fun setCarRemote(show: Boolean)
        fun setOrderTimeInfo(result: OrderDetailResult)
        fun setTakeExpectTime(time: String)
        fun setTakeActualTime(time: String)
        fun setTakeSiteName(name: String)
        fun setTakeAddress(address: String)
        fun setReturnExpectTime(time: String)
        fun setReturnActualTime(time: String)
        fun setReturnSiteName(name: String)
        fun setReturnAddress(address: String)
        fun setRenterName(name: String)
        fun setRenterPhone(phone: String)
        fun setRenterIDCard(id: String)
        fun setRenterAuthDisplay(hide: Boolean)
        fun setRenterAuthState(state: AuthBean?)
        fun setRenterLevel(level: String)
        fun setDepositForCar(title: String, amount: String, state: String, desc: String)
        fun setDepositForIllegal(title: String, amount: String, state: String, desc: String)
        fun setOrderCost(isShowDesc: Boolean, amount: String)
        fun setOrderDiscount(isShow: Boolean, discount: String)
        fun setOrderService(services: ArrayList<String>)
        fun setStoreOptionalService(storeService: ArrayList<String>)
        fun setBottomButton(result: OrderDetailResult)
        fun setStateColor(color: Int)
        fun setRentTimes(times: String?)

        //        学籍相关接口
        fun showUserSchool(b: Boolean)

        fun setUserSchool(name: String)
        fun setUserSpecialty(name: String)
        fun setUserEducation(name: String)
        fun setUserEducationYear(name: String)
        fun setUserEducationAuth(status: String?, desc: String?)

        fun setTakeCarFromDoor(b: Boolean, info: String)
        fun setReturnCarToDoor(b: Boolean, info: String)

        //是否显示取车人
        fun setTakeCarPersonCard(b: Boolean)
        fun setMemberName(name: String)
        fun setMemberPhone(phone: String)
        fun setMemberID(id: String)
        fun setMemberAuth(status: String, statusName: String)
        fun setMemberRate(rate: String)

        //是否显示查看合同条目
        fun setShowContract(visibility: Int)

        fun setReletButton(visibility: Int)

        fun setReletCancelButton(visibility: Int)

        //是否显示出险
        fun setShowCallPoliceLayout(visibility: Int, url: String)

        /**
         * 安飞士
         */
        fun setPlatFormContent(content: ArrayList<String>)

        // 是否结算异常单弹窗
        fun setDepositPayedFailDialog()
        fun setDepositPayedTip(show: Boolean, tip: String)
        fun setFlightAndTrainsNote(show: Boolean, note: String)
    }

    interface Presenter : IBasePresenter {
        fun getOrderInfoReceiver()
        fun onDestroy()

        // intent data
        fun getIntentData(i: Intent)

        // order info
        fun requestOrderInfo()

        // renter info
        fun requestUserDetail()

        // site info
        fun onSiteInfo(isTake: Boolean)

        //        fun onRenterPhone()
        fun onRefundTips()
        fun onCostInfo()
        fun onServiceTips()
        fun onCheckCarInfo()
        fun onRecordsInfo()
//        fun onSmallOne(state: Int)
//        fun onSmallTwo(state: Int)

        fun onRentNumberClicked(activity: AppCompatActivity)


        //办理取车
        fun onConfirmTakeCar()

        //办理还车
        fun onConfirmReturnCar()

        //确认结算
        fun onSettlementForOwner()

        //换车
        fun onChangeCar()

        //出发取车
        fun onTakeCarBackFromDoor()

        //出发送车
        fun onSendCarToDoor()

        //确认出发取车
        fun onConfirmTakeCarBackFromDoor()

        //确认出发送车
        fun onConfirmSendCarToDoor()

        //查看合同
        fun onGoContract()

        //跳转续租
        fun goRelet()

        //取消续租
        fun cancelRelet()

        fun onSuspendOrderConfirm()

        // 订单操作记录
        fun onOperatingData()

    }
}