package com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.detail

import android.arch.lifecycle.Observer
import android.content.Intent
import android.support.v4.content.ContextCompat
import android.text.Html
import android.text.TextUtils
import android.view.View
import com.bumptech.glide.Glide
import com.jeremyliao.livedatabus.LiveDataBus
import com.jiaoyinbrother.library.bean.AuthBean
import com.jiaoyinbrother.library.bean.OrderDetailResult
import com.jiaoyinbrother.library.util.*
import com.jiaoyinbrother.library.widget.OrderButtonNew
import com.jiaoyinbrother.monkeyking.manager.CarEntity
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseActivity
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.detail.adapter.ServiceAdapter
import com.jiaoyinbrother.monkeyking.manager.util.H5Utils
import com.jiaoyinbrother.monkeyking.manager.view.IOSdialog.IOSAlertDialog
import kotlinx.android.synthetic.main.activity_order_detail.*
import kotlinx.android.synthetic.main.order_detail_bar.*
import kotlinx.android.synthetic.main.order_detail_car.*
import kotlinx.android.synthetic.main.order_detail_site.*
import kotlinx.android.synthetic.main.order_detail_buyer.*
import kotlinx.android.synthetic.main.order_detail_deposit.*
import kotlinx.android.synthetic.main.order_detail_cost.*
import kotlinx.android.synthetic.main.order_detail_store_service.*
import kotlinx.android.synthetic.main.order_detail_select_service.*
import kotlinx.android.synthetic.main.order_detail_avis_service.*
import kotlinx.android.synthetic.main.order_detail_note.*
import kotlinx.android.synthetic.main.take_car_person_layout.*

class OrderDetailActivity : MvpBaseActivity<OrderDetailPresenter>(), IOrderDetailContract.View,
        View.OnClickListener {


    override fun setDepositPayedTip(show: Boolean, tip: String) {
        cost_deposit_tip.visibility = if (show) View.VISIBLE else View.GONE
        cost_deposit_tip.text = tip
    }

    override fun setFlightAndTrainsNote(show: Boolean, note: String) {
        order_flight_trains_note_layout?.visibility = if (show) View.VISIBLE else View.GONE
        order_flight_trains_info?.text = note
    }

    override fun setDepositPayedFailDialog() {
        IOSAlertDialog(this)
                .builder()
                .setCancelable(false)
                .setTitle("结算异常提醒")
                .setMsg("该订单结算环节扣款失败，请尽快与客户沟通处理！结算异常订单，客户可前往“订单详情-＞确认结算“页面中重新选择支付方式进行支付！", true)
                .setRightButton("我知道了") {}
                .show()
    }


    override fun setShowCallPoliceLayout(visibility: Int, url: String) {
        call_police_layout.visibility = visibility
        call_police_layout?.setOnClickListener {
            H5Utils.showInsuranceUrl(this@OrderDetailActivity, url)
//            H5Utils.showInsuranceUrl(this@OrderDetailActivity, "https://dev-m.wkzuche.com/#/insure_apply/merchant?orderid=10042354")
        }
    }

    override fun setPlatFormContent(content: ArrayList<String>) {

        avis_service.visibility = View.VISIBLE

        carType_plat_form.visibility = View.VISIBLE
        mPlatFormAdapter?.list = content
        mPlatFormAdapter?.notifyDataSetChanged()
    }

    override fun setReletButton(visibility: Int) {
        bottomButton.setDetailRelet(visibility)
        carType_plat_form.visibility = View.GONE
        avis_service.visibility = View.GONE
    }

    override fun setReletCancelButton(visibility: Int) {
        bottomButton.setDetailCancelRelet(visibility)
    }

    override fun setShowContract(visibility: Int) {
        contractLayout.visibility = visibility
    }

    override fun setMemberName(name: String) {
        take_car_person_name_textview.text = name
    }

    override fun setMemberPhone(phone: String) {
        take_car_person_phone_textview.text = TextUtil.getHiddenPhone(phone)
    }

    override fun setMemberID(id: String) {
        take_car_person_IDCard_textview.text = id
    }

    override fun setMemberAuth(status: String, statusName: String) {
        AuthUtil(this).updateUserStatusView(take_car_person_auth_textview, status, statusName)
    }

    override fun setMemberRate(rate: String) {
        take_car_person_level_textview.text = rate
    }

    override fun setTakeCarPersonCard(b: Boolean) {
        if (b)
            take_car_person_layout?.visibility = View.VISIBLE
        else
            take_car_person_layout?.visibility = View.GONE
    }

    override fun setTakeCarFromDoor(b: Boolean, info: String) {
        LogUtil.e("setTakeCarFromDoor, b = $b")
        get_car_from_door.text = info
        if (b)
            get_car_from_door.visibility = View.VISIBLE
        else
            get_car_from_door.visibility = View.GONE
    }

    override fun setReturnCarToDoor(b: Boolean, info: String) {
        LogUtil.e("setReturnCarToDoor, b = $b")
        return_car_to_door.text = info
        if (b)
            return_car_to_door.visibility = View.VISIBLE
        else
            return_car_to_door.visibility = View.GONE
    }

    override fun setStoreOptionalService(storeService: ArrayList<String>) {
        LogUtil.e("setStoreOptionalService, storeService = $storeService")

        if (storeService.isEmpty()) {
            store_service_layout.visibility = View.GONE
        } else {
            store_service_layout.visibility = View.VISIBLE
            mStoreAdapter?.list = storeService
            mStoreAdapter?.notifyDataSetChanged()
        }

    }

    override fun setRentTimes(times: String?) {
        if (TextUtils.isEmpty(times)) {
            layout_rent_number.visibility = View.GONE
//            img_arrow_2.visibility = View.GONE
        } else {
            layout_rent_number.visibility = View.VISIBLE
            rent_number_textview.text = Html.fromHtml(times)
        }

    }

    override fun showUserSchool(b: Boolean) {
        if (b) {
            school_info_textview?.visibility = View.VISIBLE
            renter_school_Layout?.visibility = View.VISIBLE
            renter_speciality_Layout?.visibility = View.VISIBLE
            renter_education_Layout?.visibility = View.VISIBLE
            renter_school_year_Layout?.visibility = View.VISIBLE
            renter_education_auth?.visibility = View.VISIBLE
        } else {
            school_info_textview?.visibility = View.GONE
            renter_school_Layout?.visibility = View.GONE
            renter_speciality_Layout?.visibility = View.GONE
            renter_education_Layout?.visibility = View.GONE
            renter_school_year_Layout?.visibility = View.GONE
            renter_education_auth?.visibility = View.GONE

        }
    }

    override fun setUserEducationAuth(status: String?, desc: String?) {
        AuthUtil(this@OrderDetailActivity).updateSchoolStatusView(
                status,
                desc,
                renter_education_auth
        )
    }

    override fun setUserSchool(name: String) {
        renter_school?.text = name
    }

    override fun setUserSpecialty(name: String) {
        renter_speciality?.text = name
    }

    override fun setUserEducation(name: String) {
        renter_education?.text = name
    }

    override fun setUserEducationYear(name: String) {
        renter_school_year?.text = name
    }

    private var mAdapter: ServiceAdapter? = null
    private var mStoreAdapter: ServiceAdapter? = null
    private var mPlatFormAdapter: ServiceAdapter? = null

    override fun initPresenter(): OrderDetailPresenter {
        return OrderDetailPresenter(this, this)
    }

    override fun getLayoutId(): Int {
        return R.layout.activity_order_detail
    }

    override fun initView() {
        val drawable = this.resources.getDrawable(R.mipmap.my_question1)
        drawable.setBounds(0, 0, drawable.minimumWidth * 2 / 5, drawable.minimumHeight * 2 / 5)
        refundTips.setCompoundDrawables(null, null, drawable, null)

        mAdapter = ServiceAdapter(this)
        serviceRv.adapter = mAdapter

        mStoreAdapter = ServiceAdapter(this)
        store_service_recyclerview.adapter = mStoreAdapter
        mPlatFormAdapter = ServiceAdapter(this)
        plat_form_rv.adapter = mPlatFormAdapter
    }

    override fun initToolBar() {
        mainTitle.text = getString(R.string.title_order_detail)
    }

    override fun initData() {
        presenter.getIntentData(intent)
        presenter.getOrderInfoReceiver()
        presenter.requestOrderInfo()
        LiveDataBus.get().with(CarEntity.BROADCAST_JPUSH_ORDER_STATUS_CHANGED)
                .observeSticky(this, Observer {
                    presenter.requestOrderInfo()
                })

    }

    override fun initListeners() {
        takeCarSiteName.setOnClickListener(this)
        takeCarAddress.setOnClickListener(this)
        returnCarSiteName.setOnClickListener(this)
        returnCarAddress.setOnClickListener(this)
        renterName.setOnClickListener(this)
        renterPhone.setOnClickListener(this)
        refundTips.setOnClickListener(this)
        costLayout.setOnClickListener(this)
        serviceTips.setOnClickListener(this)
        checkCarLayout.setOnClickListener(this)
        recordsLayout.setOnClickListener(this)
        contractLayout.setOnClickListener(this)
        take_car_person_phone_layout.setOnClickListener(this)
        take_car_person_contract_layout.setOnClickListener(this)
        order_operating_data_ll?.setOnClickListener(this)
        bottomButton.setListener(object : OrderButtonNew.OrderButtonListener {

            override fun onTakeSelfCheckCar() {
                presenter.onSelfCheck()
            }

            override fun onReturnSelfCheckCar() {
                presenter.onSelfCheck()
            }

            override fun onSuspendOrderConfirm() {
                presenter.onSuspendOrderConfirm()
            }

            override fun onConfirmRelet() {
                presenter.goRelet()
            }

            override fun onCancelRelet() {
                presenter.cancelRelet()
            }

            override fun onConfirmTakeCar() {
                presenter?.onConfirmTakeCar()
            }

            override fun onConfirmReturnCar() {
                presenter?.onConfirmReturnCar()
            }

            override fun onSettlementForOwner() {
                presenter?.onSettlementForOwner()
            }

            override fun onChangeCar() {
                presenter?.onChangeCar()
            }

            override fun onTakeCarBackFromDoor() {
                presenter?.onTakeCarBackFromDoor()
            }

            override fun onSendCarToDoor() {
                presenter?.onSendCarToDoor()
            }

            override fun onConfirmTakeCarBackFromDoor() {
                presenter?.onConfirmTakeCarBackFromDoor()
            }

            override fun onConfirmSendCarToDoor() {
                presenter?.onConfirmSendCarToDoor()
            }

        })

        refreshLayout.setRefreshListener { presenter.requestOrderInfo() }
        layout_rent_number.setOnClickListener {
            presenter.onRentNumberClicked(this)
        }
    }

    override fun onClick(v: View?) {
        when (v?.id) {
            R.id.takeCarSiteName, R.id.takeCarAddress -> presenter.onSiteInfo(true)
            R.id.returnCarSiteName, R.id.returnCarAddress -> presenter.onSiteInfo(false)
            R.id.renterPhone -> presenter.onRenterPhone()
            R.id.refundTips -> presenter.onRefundTips()
            R.id.costLayout -> presenter.onCostInfo()
            R.id.serviceTips -> presenter.onServiceTips()
            R.id.checkCarLayout -> presenter.onCheckCarInfo()
            R.id.recordsLayout -> presenter.onRecordsInfo()
            R.id.take_car_person_phone_layout -> presenter.onMemberPhone()
            R.id.take_car_person_contract_layout -> presenter.doMemberAgree()
            R.id.contractLayout -> presenter.onGoContract()
            R.id.order_operating_data_ll -> presenter.onOperatingData()
        }
    }

    override fun showPage() {
        refreshLayout.visibility = View.VISIBLE
    }

    override fun setOrderNum(num: String) {
        scrollview.scrollTo(0, 0)
        orderNum.text = num
    }

    override fun setOrderChannel(channel: String) {
        orderChannel.text = channel
    }

    override fun setOrderState(state: String, isShowReletStatus: Boolean) {
        orderState_origin.text = state

        LogUtil.e("setOrderState ， " + (if (isShowReletStatus) "(暂缓）" else ""))
        orderState.text = if (isShowReletStatus) "(暂缓）" else ""
    }

    override fun setCarPic(pic: String) {
        Glide.with(this@OrderDetailActivity).load(pic).into(carPic)
    }

    override fun setCarType(type: String) {
        carType.text = type
    }

    override fun setCarInfo(info: String) {
        carInfo.text = info
    }

    override fun setCarNum(num: String) {
        carNum.visibility = if (TextUtils.isEmpty(num)) View.GONE else View.VISIBLE
        carNum.text = num
    }

    override fun setCarRemote(show: Boolean) {
//        carRemote.visibility = if (show) View.VISIBLE else View.GONE
    }

    override fun setOrderTimeInfo(result: OrderDetailResult) {
        orderTimeLine.setData(result)
    }

    override fun setTakeExpectTime(time: String) {
        expectTakeCarTime.text = time
    }

    override fun setTakeActualTime(time: String) {
        actualTakeCarTime.text = time
    }

    override fun setTakeSiteName(name: String) {
        takeCarSiteName.text = name
    }

    override fun setTakeAddress(address: String) {
        takeCarAddress.text = address
    }

    override fun setReturnExpectTime(time: String) {
        expectReturnCarTime.text = time
    }

    override fun setReturnActualTime(time: String) {
        actualReturnCarTime.text = time
    }

    override fun setReturnSiteName(name: String) {
        returnCarSiteName.text = name
    }

    override fun setReturnAddress(address: String) {
        returnCarAddress.text = address
    }

    override fun setRenterName(name: String) {
        renterName.text = name
    }

    override fun setRenterPhone(phone: String) {
        renterPhone.text = TextUtil.getHiddenPhone(phone)
    }

    override fun setRenterIDCard(id: String) {
        renterIDCard.text = id
    }

    override fun setRenterAuthDisplay(hide: Boolean) {
        renterAuth.visibility = if (hide) View.GONE else View.VISIBLE
        renterLevel.visibility = if (hide) View.GONE else View.VISIBLE
    }

    override fun setRenterAuthState(state: AuthBean?) {
        AuthUtil(this@OrderDetailActivity).updateUserStatusView(renterAuth, state)
    }

    override fun setRenterLevel(level: String) {
        renterLevel.text = level
    }

    override fun setDepositForCar(title: String, amount: String, state: String, desc: String) {
        val sp = "$title $amount"
        depositForCar.text = TextUtil.setForegroundColor(
                sp,
                ContextCompat.getColor(this, R.color.color_6),
                title.length,
                sp.length
        )
        depositStateForCar.text = state
        depositDescForCar.text = desc
    }

    override fun setDepositForIllegal(title: String, amount: String, state: String, desc: String) {
        val sp = "$title $amount"
        depositForIllegal.text = TextUtil.setForegroundColor(
                sp,
                ContextCompat.getColor(this, R.color.color_6),
                title.length,
                sp.length
        )
        depositStateForIllegal.text = state
        depositDescForIllegal.text = desc
    }

    override fun setOrderCost(isShowDesc: Boolean, amount: String) {
        costDesc.visibility = if (isShowDesc) View.VISIBLE else View.GONE
        costAmount.text = amount
    }

    override fun setOrderDiscount(isShow: Boolean, discount: String) {
        discountLayout.visibility = if (isShow) View.VISIBLE else View.GONE
        discountName.text = discount
    }

    override fun setOrderService(services: ArrayList<String>) {
        mAdapter?.list = services
        mAdapter?.notifyDataSetChanged()
    }

    override fun setBottomButton(result: OrderDetailResult) {
        bottomButton.setDetailInfo(result)
    }

    override fun setRefreshEnd() {
        refreshLayout.refreshIsEnd()
    }

    override fun setStateColor(color: Int) {
        recordsTitle.setTextColor(ContextCompat.getColor(this, color))
        checkCarTitle.setTextColor(ContextCompat.getColor(this, color))
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        LogUtil.e("onActivityResult ----------------------------$requestCode; $resultCode; $data")
        if (resultCode == ConstantsUtil.ORDER_REFRESH_CODE) {
            presenter.requestOrderInfo()
        }
    }

    override fun onDestroy() {
        presenter.onDestroy()
        super.onDestroy()
    }
}