package com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.list.fragment

import android.os.Bundle
import com.jiaoyinbrother.library.base.IBasePresenter
import com.jiaoyinbrother.library.bean.OrdersBean
import com.jiaoyinbrother.library.view.IBaseView

class IOrdersContract {

    interface View : IBaseView {
        fun finishRefreshWithNoMoreData()
        fun finishLoadMoreWithNoMoreData()
        fun finishRefresh()
        fun finishLoadMore()
        fun setEnableLoadMore(b: Boolean)
        fun showNoDataView()
        fun showNetErrView(b: Boolean)
        fun setOrdersData(data: ArrayList<OrdersBean>)
        fun onOrderInfo(orderId:String)
        fun onDropInTheCar(order: OrdersBean)
        fun onDeliverTheCar(order: OrdersBean)
        fun onConfirmTheCar(order: OrdersBean)
    }

    interface Presenter : IBasePresenter {
        var mStatus: Int
        var isHidden:Boolean
        fun getData(arguments: Bundle?)
        fun onRefresh()
        fun onLoadMore()
//        fun onResume()
        fun onHiddenChanged(hidden: Boolean)
        fun onSort(type: Int, isAsc: Boolean)
        fun getInfo(type: String, order: OrdersBean)
    }
}