package com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.operatingdata

import android.content.Context
import android.content.Intent
import com.jiaoyinbrother.library.bean.OperatingDataBean
import com.jiaoyinbrother.library.util.ConstantsUtil
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.adapter.OperatingDataAdapter
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseActivity
import kotlinx.android.synthetic.main.activity_operating_data.*
import kotlinx.android.synthetic.main.fragment_workflow_list.*


class OrderOperatingDataActivity : MvpBaseActivity<OperatingDataPresenter>(),
    IOperatingDataContract.View {

    private var mAdapter: OperatingDataAdapter? = null

    companion object {
        fun newInstance(context: Context, orderId: String?): Intent {
            return Intent(context, OrderOperatingDataActivity::class.java)
                .putExtra(ConstantsUtil.ORDER_ID, orderId)
        }
    }

    override fun initPresenter(): OperatingDataPresenter {
        return OperatingDataPresenter(this, this)
    }

    override fun getLayoutId(): Int {
        return R.layout.activity_operating_data
    }

    override fun initToolBar() {
        mainTitle.text = getString(R.string.title_operaing_data)
    }

    override fun initView() {
        mAdapter = OperatingDataAdapter()
        operating_data_rv?.adapter = mAdapter

        operating_data_loading?.setEmptyText("您还没有订单操作记录")
    }

    override fun initData() {
        presenter.getData(intent)
    }

    override fun initListeners() {
        operating_data_refresh?.setOnRefreshListener {
            presenter.onRefresh()
        }

        operating_data_refresh?.setOnLoadMoreListener {
            presenter.onLoadMore()
        }
    }

    override fun setOperatingData(data: ArrayList<OperatingDataBean>) {
        operating_data_loading?.showContent()
        mAdapter?.list = data
        mAdapter?.notifyDataSetChanged()
    }

    override fun finishRefreshWithNoMoreData() {
        operating_data_refresh?.finishRefreshWithNoMoreData()
    }

    override fun finishLoadMoreWithNoMoreData() {
        operating_data_refresh?.finishLoadMoreWithNoMoreData()
    }

    override fun finishRefresh() {
        operating_data_refresh?.finishRefresh()
    }

    override fun finishLoadMore() {
        operating_data_refresh?.finishLoadMore()
    }

    override fun setEnableLoadMore(b: Boolean) {
        operating_data_refresh?.setEnableLoadMore(b)
    }

    override fun showNoDataView() {
        setEnableLoadMore(false)
        operating_data_loading?.showEmpty()
    }

    override fun showNetErrView(b: Boolean) {
        setEnableLoadMore(false)
        operating_data_loading?.showError()
    }

}