package com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.refundcar

import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.refundcar.fragment.main.RefundMainFragment
import com.jiaoyinbrother.monkeyking.manager.view.IOSdialog.IOSAlertDialog
import com.jiaoyinbrother.library.base.BaseActivity
import com.jiaoyinbrother.library.bean.BillApplyRequest
import com.jiaoyinbrother.library.bean.CalcResult
import com.jiaoyinbrother.library.util.ConstantsUtil
import com.jiaoyinbrother.library.util.Util

class RefundTheCarActivity : BaseActivity() {

    override fun getLayoutId(): Int {
        return R.layout.activity_refund_car
    }

    override fun initView() {
        val orderID = intent.getStringExtra(ConstantsUtil.ORDER_ID)

        if (findFragment(RefundMainFragment::class.java) == null) {
            loadRootFragment(R.id.fl_container, RefundMainFragment.newInstance(orderID))
        }
    }

    override fun initToolBar() {
        mainTitle.text = getString(R.string.title_refund_car)
    }

    override fun initData() {}

    override fun initListeners() {

    }

    override fun onBackPressedSupport() {
        IOSAlertDialog(this).builder().setTitle("温馨提示").setMsg("确认退出办理还车流程，确认后不保存之前填写信息", true)
                .setRightButton("确认") {
                    setResult(ConstantsUtil.ORDER_REFRESH_CODE)
                    super.onBackPressedSupport()
                }.setLeftButton("取消") {}.show()
    }


    companion object {
        fun buildRequest(request: BillApplyRequest?, result: CalcResult): BillApplyRequest? {
            request?.plan_id = result.plan_id
            request?.rent_amount = result.rent_amount
            request?.insurance_amount = result.insurance_amount
            request?.poundage_amount = result.poundage_amount
            request?.overtime_rent_amount = result.overtime_rent_amount
            request?.overtime_insurance_amount = result.overtime_insurance_amount
            var amount = 0
            if (Util.isEmptyList(result.optional_service)) {
                amount += result.optional_service_amount?.toInt() ?: 0
            } else {
                for (os in result.optional_service) {
                    amount += os.amount?.toInt() ?: 0
                }
            }
            request?.optional_service_amount = amount.toString()
            request?.send_service_amount = result.send_service_amount
            request?.return_service_amount = result.return_service_amount
            request?.crosscity_service_amount = result.crosscity_service_amount
            request?.night_service_amount = result.night_service_amount
            request?.miles_amount = result.miles_amount
            request?.fuel_amount = result.fuel_amount
            request?.penalty_amount = result.penalty_amount
            request?.other_amount = result.other_amount
            request?.discount_amount = result.discount_amount.toString()
            request?.total_amount = result.total_amount




            return request
        }


    }
}