package com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.refundcar.fragment.contract

import android.arch.lifecycle.Observer
import android.os.Bundle
import android.os.CountDownTimer
import android.support.v4.content.ContextCompat
import android.view.View
import com.jeremyliao.livedatabus.LiveDataBus
import com.jiaoyinbrother.library.bean.BillApplyRequest
import com.jiaoyinbrother.library.bean.ContractPreRequest
import com.jiaoyinbrother.library.bean.ContractPreResult
import com.jiaoyinbrother.library.bean.OrderDetailResult
import com.jiaoyinbrother.library.util.ConstantsUtil
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseFragment
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.refundcar.fragment.main.RefundMainFragment
import com.jiaoyinbrother.monkeyking.manager.view.IOSdialog.IOSAlertDialog
import kotlinx.android.synthetic.main.fragment_deliver_car_contract.*

class RefundContractFragment : MvpBaseFragment<RefundContractPresenter>(), IRefundContractModel.View {


    private var isCountDownTimeEnd: Boolean = false

    override fun initPresenter(): RefundContractPresenter {
        return RefundContractPresenter(_mActivity, this)
    }

    override fun getLayoutId(): Int {
        return R.layout.fragment_deliver_car_contract
    }

    override fun initViews(view: View?, savedInstanceState: Bundle?) {
    }

    override fun initToolbar(savedInstanceState: Bundle?) {
    }

    override fun initData() {
//        contract_electronic?.disable()
//        contract_submit?.disable()

        LiveDataBus.get().with(ConstantsUtil.REFUND_CONTRACT_PRE).observeSticky(this, Observer {
            if (it as Boolean) presenter.initPreContract()
        })

        LiveDataBus.get().with(ConstantsUtil.CONTRACT_BACK).observe(this, Observer {
            if (it as Boolean) presenter.doContractSignBack()
        })

        LiveDataBus.get().with("ThirdFragment").observeSticky(_mActivity, Observer {
            presenter.getApplyRequest(it as BillApplyRequest)
        })

        LiveDataBus.get().with("CONTRACT_SUCCESS").observe(this, Observer {
            presenter.doContractSuccess()
        })
        val timer = object : CountDownTimer(5*60*1000, 1000) {
            override fun onTick(millisUntilFinished: Long) {}

            override fun onFinish() {

                isCountDownTimeEnd = true
            }
        }.start()
    }

    override fun initListeners() {
        // 电子合同
        contract_electronic_msg.setOnClickListener {
            presenter.doContractElectronic(null)
        }

        contract_electronic_face.setOnClickListener {
            presenter.doContractElectronic("FACE")
        }

        // 纸质合同 & 完成
        contract_submit.setOnClickListener {
            presenter.doContractSubmit()
        }

        loadingLayout?.setRetryListener {
            presenter.initPreContract()
        }

    }

    override fun onBackPressedSupport(): Boolean {
//        val parent = parentFragment as RefundMainFragment
//        parent.onSelectPage(RefundMainFragment.THIRD, RefundMainFragment.FOUR)
        return true
    }


    override fun setTimeLine(type: Int, index: Int) {
        contract_time_line.setStyleType(type)
        contract_time_line.setSelectIndex(index)
    }

    override fun setErrorPager(b: Boolean) {
        if (b) loadingLayout?.showError() else loadingLayout?.showContent()
    }

    override fun setContractState(state: String, type: Int) {
        when (state) {
            ContractPreResult.SUCCESS -> {
                // 签署成功
                ll_contract_success.visibility = View.VISIBLE
                ll_contract_state.visibility = View.GONE
//                contract_submit.text = "完成"
//                contract_submit.normal()
                contract_submit.visibility = View.GONE
                contract_submit_done.visibility = View.VISIBLE
            }
            ContractPreResult.SIGN_FAILED -> {
                // 签署失败
                ll_contract_success.visibility = View.GONE
                ll_contract_state.visibility = View.VISIBLE
                contract_state.text = "签署失败"
//                contract_state.setTextColor(ContextCompat.getColor(_mActivity, R.color.color_6))
                contract_desc.visibility = View.VISIBLE
//                contract_electronic.normal()
//                contract_submit.text = "签署纸质合同"
//                contract_submit.normal()
                contract_submit.visibility = View.VISIBLE
                contract_submit_done.visibility = View.GONE
            }
            ContractPreResult.CERTIFICATION_FAILED -> {
                // 认证失败
                ll_contract_success.visibility = View.GONE
                ll_contract_state.visibility = View.VISIBLE
                contract_state.text = "签署失败"
//                contract_state.setTextColor(ContextCompat.getColor(_mActivity, R.color.color_6))
                contract_desc.visibility = View.VISIBLE
//                contract_electronic.disable()
//                contract_submit.text = "签署纸质合同"
//                contract_submit.normal()
                contract_submit.visibility = View.VISIBLE
                contract_submit_done.visibility = View.GONE
            }
            else -> {
                // 未签署
                ll_contract_success.visibility = View.GONE
                ll_contract_state.visibility = View.VISIBLE
                contract_state.text = "未签署"
//                contract_state.setTextColor(ContextCompat.getColor(_mActivity, R.color.color_282828))
                contract_desc.visibility = View.VISIBLE
                contract_submit_done.visibility = View.GONE
//                contract_electronic.normal()
                if (type == ContractPreRequest.RETAIN && isCountDownTimeEnd) {
                    IOSAlertDialog(context).builder().setTitle("温馨提示").setMsg("您签署过程中是否遇到问题，如遇到问题可线下签署纸质合同！是否继续签署电子合同？", true)
                                .setRightButton("是") {
//                                    contract_submit.text = "完成"
//                                    contract_submit.disable()
                                    contract_submit.visibility = View.GONE
                                }
                                .setLeftButton("否") {
//                                    contract_submit.text = "签署纸质合同"
//                                    contract_submit.normal()
                                    contract_submit.visibility = View.VISIBLE
                                }.show()
                } else {
//                    contract_submit.text = "完成"
//                    contract_submit.disable()
                    contract_submit.visibility = View.GONE
                }
            }
        }
    }

    override fun setContractPaper() {
//        val a = parentFragment as RefundMainFragment
//        a.onSelectPage(RefundMainFragment.FIVE, RefundMainFragment.FOUR)
    }

    override fun setActivityFinish() {
        _mActivity.setResult(ConstantsUtil.ORDER_REFRESH_CODE)
        activity?.finish()
    }

    fun setData(result: OrderDetailResult) {
        presenter.getOrderInfo(result)
    }

    companion object {
        fun newInstance(): RefundContractFragment {
            val args = Bundle()
            val fragment = RefundContractFragment()
            fragment.arguments = args
            return fragment
        }
    }
}