package com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.refundcar.fragment.first

import android.content.Intent
import android.os.Bundle
import android.support.v4.content.ContextCompat
import android.text.SpannableStringBuilder
import android.view.View
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseFragment
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.refundcar.fragment.main.RefundMainFragment
import com.jiaoyinbrother.library.bean.OrderDetailResult
import com.jiaoyinbrother.library.util.TextUtil
import com.jiaoyinbrother.library.widget.GeneralBottomButton
import kotlinx.android.synthetic.main.fragment_refund_car_first.*

class RefundFirstTabFragment : MvpBaseFragment<RefundFirstPresenter>(), IRefundFirstContract.View, View.OnClickListener {

    companion object {
        fun newInstance(): RefundFirstTabFragment {
            val fragment = RefundFirstTabFragment()
            val args = Bundle()
            fragment.arguments = args
            return fragment
        }
    }

    fun setData(result: OrderDetailResult) {
        presenter.getOrderInfo(result)
    }

    override fun initPresenter(): RefundFirstPresenter {
        return RefundFirstPresenter(_mActivity, this)
    }

    override fun getLayoutId(): Int {
        return R.layout.fragment_refund_car_first
    }

    override fun initViews(view: View?, savedInstanceState: Bundle?) {}

    override fun initToolbar(savedInstanceState: Bundle?) {}

    override fun initData() {
        onNext.disable()
    }

    override fun initListeners() {
        onNext.setListener(object : GeneralBottomButton.SubmitListener {
            override fun submit() {
                presenter.handleSensorData()
                presenter.onPostApplyRequest(cbFreezeDepositForCar.isChecked)
                val a = parentFragment as RefundMainFragment
                a.onSelectPage(RefundMainFragment.SECOND, RefundMainFragment.FIRST)
            }
        })
        depositPayOfflineForIllegal.setOnClickListener(this)
        depositPayScanForIllegal.setOnClickListener(this)
    }

    override fun onClick(v: View?) {
        when (v?.id) {
            R.id.depositPayOfflineForIllegal -> presenter.onOfflinePay()
            R.id.depositPayScanForIllegal -> presenter.onScanPay(this)
        }
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        presenter.onActivityResult(requestCode, resultCode, data)
    }

    override fun updataFragment() {
    }

    override fun setOrderNum(num: String) {
        orderNum.text = num
    }

    override fun setOrderChannel(channel: String) {
        orderChannel.text = channel
    }

    override fun setCarNum(num: String) {
        carNum.text = num
    }

    override fun setDepositCostForCar(name: String, num: String) {
        val sp = "$name $num"
        depositCostForCar.text = TextUtil.setForegroundColor(sp, ContextCompat.getColor(_mActivity, R.color.color_6), name.length, sp.length)
    }

    override fun setDepositStateForCar(state: String) {
        depositStateForCar.text = state
    }

    override fun setDepositDescForCar(desc: String) {
        depositDescForCar.text = desc
    }

    override fun setDepositCostForIllegal(name: String, num: String) {
        val sp = "$name $num"
        depositCostForIllegal.text = TextUtil.setForegroundColor(sp, ContextCompat.getColor(_mActivity, R.color.color_6), name.length, sp.length)
    }

    override fun setDepositForIllegalOffline(visible: Int, state: String, click: Boolean) {
        depositPayOfflineForIllegal.visibility = visible
        depositPayOfflineForIllegal.text = state
        depositPayOfflineForIllegal.isEnabled = click
    }

    override fun setDepositForIllegalScan(visible: Int, state: String, click: Boolean) {
        depositPayScanForIllegal.visibility = visible
        depositPayScanForIllegal.text = state
        depositPayScanForIllegal.isEnabled = click
    }

    override fun setDepositForIllegalState(visible: Int, state: String) {
        depositStateForIllegal.visibility = visible
        depositStateForIllegal.text = state
    }

    override fun setDepositDescForIllegal(desc: String) {
        depositDescForIllegal.text = desc
    }

    override fun setFreezeDepositVisibilityForCar(visible: Int) {
        freezeDepositForCarLayout.visibility = visible
    }

    override fun setFreezeDepositDescForCar(desc: SpannableStringBuilder) {
        freezeDepositDescForCar.text = desc
    }

    override fun setCanNext(b: Boolean) {
        if (b) onNext.normal() else onNext.disable()
    }


    override fun setTimeLine(type: Int, index: Int) {
        refund_first_time_line.setStyleType(type)
        refund_first_time_line.setSelectIndex(index)
    }
}