package com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.refundcar.fragment.main

import android.os.Bundle
import android.view.View
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseFragment
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.refundcar.fragment.first.RefundFirstTabFragment
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.refundcar.fragment.second.RefundSecondTabFragment
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.refundcar.fragment.third.RefundThirdTabFragment
import com.jiaoyinbrother.library.base.BaseFragment
import com.jiaoyinbrother.library.bean.OrderDetailResult
import com.jiaoyinbrother.library.util.ConstantsUtil

class RefundMainFragment : MvpBaseFragment<RefundMainPresenter>(), IRefundMainContract.View {

    private val mFragments = arrayOfNulls<BaseFragment>(5)

    companion object {
        const val FIRST = 0
        const val SECOND = 1
        const val THIRD = 2
//        const val FOUR = 3
//        const val FIVE = 4

        fun newInstance(orderId: String): RefundMainFragment {
            val fragment = RefundMainFragment()
            val args = Bundle()
            args.putString(ConstantsUtil.ORDER_ID, orderId)
            fragment.arguments = args
            return fragment
        }
    }

    override fun initPresenter(): RefundMainPresenter {
        return RefundMainPresenter(_mActivity, this)
    }

    override fun getLayoutId(): Int {
        if (arguments != null)
            presenter.argumentsData(arguments!!)
        return R.layout.fragment_refund_car_main
    }

    override fun initViews(view: View?, savedInstanceState: Bundle?) {}

    override fun initToolbar(savedInstanceState: Bundle?) {}

    override fun initListeners() {}

    override fun initData() {
        presenter.requestOrderInfo()
    }

    override fun updataFragment() {}

    override fun onActivityCreated(savedInstanceState: Bundle?) {
        super.onActivityCreated(savedInstanceState)
        val firstFragment = findChildFragment(RefundFirstTabFragment::class.java)
        if (firstFragment == null) {
            mFragments[FIRST] = RefundFirstTabFragment.newInstance()
            mFragments[SECOND] = RefundSecondTabFragment.newInstance()
            mFragments[THIRD] = RefundThirdTabFragment.newInstance()
            loadMultipleRootFragment(R.id.fl_tab_container, FIRST,
                    mFragments[FIRST],
                    mFragments[SECOND],
                    mFragments[THIRD])
        } else {
            // 这里库已经做了Fragment恢复,所有不需要额外的处理了, 不会出现重叠问题
            // 这里我们需要拿到mFragments的引用
            mFragments[FIRST] = firstFragment
            mFragments[SECOND] = findChildFragment(RefundSecondTabFragment::class.java)
            mFragments[THIRD] = findChildFragment(RefundThirdTabFragment::class.java)
        }
    }

    fun onSelectPage(toIndex: Int, launchIndex: Int) {
        showHideFragment(mFragments[toIndex], mFragments[launchIndex])
    }

    override fun setOrderInfo(result: OrderDetailResult) {
        findChildFragment(RefundFirstTabFragment::class.java)?.setData(result)
        findChildFragment(RefundSecondTabFragment::class.java)?.setData(result)
        findChildFragment(RefundThirdTabFragment::class.java)?.setData(result)
    }

}