package com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.refundcar.fragment.main

import android.content.Context
import android.os.Bundle
import android.util.Log
import com.jiaoyinbrother.library.base.BasePresenterImpl
import com.jiaoyinbrother.library.bean.OrderDetailRequest
import com.jiaoyinbrother.library.bean.OrderDetailResult
import com.jiaoyinbrother.library.retrofit.BaseObserver
import com.jiaoyinbrother.library.retrofit.RetrofitHelper
import com.jiaoyinbrother.library.util.ConstantsUtil
import com.jiaoyinbrother.library.util.LogUtil
import com.jiaoyinbrother.library.util.UserUtil
import io.reactivex.android.schedulers.AndroidSchedulers
import io.reactivex.schedulers.Schedulers
import java.util.concurrent.TimeUnit

class RefundMainPresenter(context: Context, view: IRefundMainContract.View)
    : BasePresenterImpl<IRefundMainContract.View>(context, view), IRefundMainContract.Presenter {


    private var orderID: String? = null

    override fun argumentsData(b: Bundle) {
        orderID = b.getString(ConstantsUtil.ORDER_ID)
    }

    override fun requestOrderInfo() {
        val request = OrderDetailRequest()
        request.uid = UserUtil(context).uid
        request.orderid = orderID
        val service = RetrofitHelper.getInstance(context).service
        val params = RetrofitHelper.getInstance(context).convertRequestToMap(request)
        val observable = service.getOrderDetail(params).debounce(1000, TimeUnit.MILLISECONDS)
        observable.subscribeOn(Schedulers.io()).doOnSubscribe {
            view.showLoadingDialog()
        }.observeOn(AndroidSchedulers.mainThread()).subscribe(object : BaseObserver<OrderDetailResult>(context,this) {
            override fun onSuccess(response: OrderDetailResult) {
                view.dismissLoadingDialog()

                view.setOrderInfo(response)
            }
        })
    }
}