package com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.refundcar.fragment.second

import android.content.Intent
import android.support.v4.app.Fragment
import com.jiaoyinbrother.library.base.IBasePresenter
import com.jiaoyinbrother.library.bean.BillApplyRequest
import com.jiaoyinbrother.library.bean.CalcResult
import com.jiaoyinbrother.library.bean.CarValidatesBean
import com.jiaoyinbrother.library.bean.OrderDetailResult
import com.jiaoyinbrother.library.view.IBaseView

interface IRefundSecondContract {

    interface View : IBaseView {
        fun setOrderNum(num: String)
        fun setOrderChannel(channel: String)
        fun setCarNum(num: String)
        fun setCarTypeName(name: String)
        fun setRealTakeTime(time: String)
        fun setRealRefundTime(time: String)
        fun setTakeMiles(miles: String)
        fun setRefundMiles(miles: String)
        fun hideOilShowElectric(isOil: Boolean)
        fun setTakeOil(scale: Int, oilMass: String)
        fun setRefundOil(scale: Int, oilMass: String)
        fun setRefundDesc(desc: String)
        fun setTakeElectric(electric: String)
        fun setRefundElectric(electric: String)
        fun setTakeItems(isClick: Boolean, states: ArrayList<String>)
        fun setRefundItems(isClick: Boolean, states: ArrayList<String>)
//        fun setGroupPhoto(url: String)
//        fun setTakeOilPhoto(url: String)
//        fun setRefundOilPhoto(url: String)
        fun hideOldIssue(hide: Boolean)
        fun setOldIssues(validates: ArrayList<CarValidatesBean>)
        fun hideNewIssue(hide: Boolean)
        fun setNewIssues(validates: ArrayList<CarValidatesBean>)
        fun setCalcInfo(result: CalcResult)
        fun setNextPage()
        fun setComments(comment: String)
        fun setSignImage(url: String)
        fun setCanNext()
        fun setRefuelTips(b: Boolean, tip: String)
        // 获取数据
        fun getRefundCarItems(): ArrayList<String>

        fun getComments(): String
        fun setTimeLine(type: Int, index: Int)

        fun setOilFeeDialog(prompt:String?)
    }

    interface Presenter : IBasePresenter {
        fun getOrderInfo(result: OrderDetailResult)
        fun getApplyRequest(request: BillApplyRequest)
        fun requestOrderCalc()
        fun onRealStartTime()
        fun onRealEndTime()
        fun onRefundMileChanged(mile: String)
        fun onRefundOilChanged(progress: Int)
        fun onRefundElectricChanged(electric: String)
        fun onAddIssue()
        fun onAddNewIssue(it: CarValidatesBean)
        fun onSeeNewIssue(issue: CarValidatesBean)
        fun onDelNewIssue(position: Int)
        fun onSign(fragment: Fragment)
        fun onNextPage()
        fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?)
        fun onPostApplyRequest()
    }
}