package com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.refundcar.fragment.second

import android.app.Activity
import android.content.Context
import android.content.Intent
import android.support.v4.app.Fragment
import android.text.TextUtils
import com.jeremyliao.livedatabus.LiveDataBus
import com.jiaoyinbrother.monkeyking.manager.activity.HandWriteActivity
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.issuedetail.IssueDetailActivity
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.refundcar.RefundTheCarActivity
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.timefindissue.TimeFindIssueActivity
import com.jiaoyinbrother.monkeyking.manager.view.IOSdialog.IOSAlertDialog
import com.jiaoyinbrother.monkeyking.manager.view.date.SelectDateTimeDialog
import com.jiaoyinbrother.library.base.BasePresenterImpl
import com.jiaoyinbrother.library.bean.*
import com.jiaoyinbrother.library.retrofit.BaseObserver
import com.jiaoyinbrother.library.retrofit.RetrofitHelper
import com.jiaoyinbrother.library.util.*
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.uploadcheckimage.UploadCheckImageActivity
import com.jiaoyinbrother.monkeyking.manager.view.TakeAlsoCarTimeLine
import io.reactivex.android.schedulers.AndroidSchedulers
import io.reactivex.schedulers.Schedulers
import java.util.concurrent.TimeUnit

class RefundSecondPresenter(context: Context, view: IRefundSecondContract.View)
    : BasePresenterImpl<IRefundSecondContract.View>(context, view), IRefundSecondContract.Presenter {

    private var orderInfo: OrderDetailResult? = null
    private var orderID: String? = null
    private var carID: String? = null
    private var realStartTime: String? = null// 实际取车时间
    private var realEndTime: String? = null// 实际还车时间
    private var refundMile: String? = null// 还车里程
    private var refundFuel: String? = null// 还车油（电）量
    private var newIssueList = ArrayList<CarValidatesBean>()// 发现新问题
    private var signURL: String? = null
    private var validateIds = ArrayList<String>()
    private var isCanNext = false
    private var postApplyRequest: BillApplyRequest? = null

    override fun getOrderInfo(result: OrderDetailResult) {

        initTimeLine(result)
        orderInfo = result
        orderID = result.orderid
        carID = result.carid
        // 订单号
        view.setOrderNum("订单号：${result.getOrderShowID()}")
        // 订单渠道
        if (TextUtils.isEmpty(result.channel_name)) {
            view.setOrderChannel("")
        } else {
            view.setOrderChannel("(${result.channel_name})")
        }
        // 车牌号
        view.setCarNum(result.number ?: "")
        // 车型
        view.setCarTypeName(result.type ?: "")
        // 实际取车时间
        val bill = result.bill
        realStartTime = bill?.real_start_time
        view.setRealTakeTime(realStartTime ?: "")
        // 实际还车时间
        realEndTime = bill?.real_end_time
        view.setRealRefundTime(realEndTime ?: "")
        // 取车里程
        val usage = result.usage
        view.setTakeMiles(usage?.take_miles ?: "")
        // 还车里程
        refundMile = usage?.return_miles ?: ""
        view.setRefundMiles(usage?.return_miles ?: "")
        // 取还车油量
        refundFuel = if (TextUtils.equals(result.transmission, "ET")) {
            // 电动车
            view.hideOilShowElectric(true)
            view.setTakeElectric(usage?.take_fuel ?: "0")
            view.setRefundElectric(usage?.take_fuel ?: "")
            usage?.take_fuel ?: ""
        } else {
            // 油车
            view.hideOilShowElectric(false)
            view.setTakeOil(getOilScale(usage?.take_fuel), usage?.take_fuel ?: "0/16")
            view.setRefundOil(getOilScale(usage?.take_fuel), usage?.take_fuel ?: "0/16")
            usage?.take_fuel ?: "0/16"
        }
        // 随车物品 取车时
        if (usage?.take_car != null && !Util.isEmptyList(usage.take_car?.accessories)) {
            view.setTakeItems(false, usage.take_car?.accessories ?: ArrayList())
        }
        // 随车物品 还车时
        if (usage?.return_car != null && !Util.isEmptyList(usage.return_car?.accessories)) {
            view.setRefundItems(true, usage.return_car?.accessories ?: ArrayList())
        }
        // 已有问题
        view.hideOldIssue(false)
        if (!Util.isEmptyList(usage?.take_car?.validates ?: ArrayList<CarValidatesBean>())) {
            view.setOldIssues(usage?.take_car?.validates ?: ArrayList())
            for (u in usage?.take_car?.validates!!) {
                validateIds.add(u.car_validate_id ?: "")
            }
        }
        view.setComments(usage?.take_car?.comments ?: "")

        requestOrderCalc()
    }

    override fun getApplyRequest(request: BillApplyRequest) {
        postApplyRequest = request
    }

    /**
     * 实际取车时间
     * */
    override fun onRealStartTime() {
        SelectDateTimeDialog.Builder(context)
                .setType(SelectDateTimeDialog.TYPE_REAL_START_TIME)
                .setStartTime(realStartTime)
                .needLastYearData(true)
                .setOnResultListener { resultTime ->
                    if (!TextUtils.isEmpty(resultTime)) {
                        realStartTime = resultTime
                        view.setRealTakeTime(resultTime)
                        requestOrderCalc()
                    }
                }.show()
    }

    /**
     * 实际还车时间
     * */
    override fun onRealEndTime() {
        SelectDateTimeDialog.Builder(context)
                .setType(SelectDateTimeDialog.TYPE_REAL_END_TIME)
                .setStartTime(realStartTime)
                .setEndTime(realEndTime)
                .setOnResultListener { resultTime ->
                    if (!TextUtils.isEmpty(resultTime)) {
                        realEndTime = resultTime
                        view.setRealRefundTime(resultTime)
                        requestOrderCalc()
                    }
                }.show()
    }

    /**
     * 还车里程
     * */
    override fun onRefundMileChanged(mile: String) {
        refundMile = mile
    }

    /**
     * 还车电量
     * */
    override fun onRefundElectricChanged(electric: String) {
        refundFuel = electric
    }

    /**
     * 还车油量
     * */
    override fun onRefundOilChanged(progress: Int) {
        refundFuel = "$progress/16"
        view.setRefundOil(progress, refundFuel ?: "0/16")
    }

    /**
     * 跳转发现新问题
     * */
    override fun onAddIssue() {
        TimeFindIssueActivity.newInstance(context as Activity, orderID ?: "", carID ?: "", true)
    }

    /**
     * 刷新新问题列表
     * */
    override fun onAddNewIssue(it: CarValidatesBean) {
        newIssueList.add(it)
        if (!Util.isEmptyList(newIssueList)) view.hideNewIssue(false)
        view.setNewIssues(newIssueList)
    }

    /**
     * 查看发现新问题
     * @param issue
     * */
    override fun onSeeNewIssue(issue: CarValidatesBean) {
        LiveDataBus.get().with(ConstantsUtil.LIVEDATA_ORDER_ISSUE_DDTAIL).postValue(issue)
        context.startActivity(Intent(context, IssueDetailActivity::class.java))
    }


    /**
     * 删除发现新问题
     * @param position
     * */
    override fun onDelNewIssue(position: Int) {
        IOSAlertDialog(context)
                .builder()
                .setCancelable(false)
                .setTitle("确认删除")
                .setMsg("确认删除该问题？", true)
                .setRightButton("确认") {
                    newIssueList.removeAt(position)
                    if (Util.isEmptyList(newIssueList)) view.hideNewIssue(true)
                    view.setNewIssues(newIssueList)
                }
                .setLeftButton("取消") {}.show()
    }

    override fun onSign(fragment: Fragment) {
        fragment.startActivityForResult(Intent(context, HandWriteActivity::class.java), 101)
    }

    override fun onNextPage() {
        if (TextUtils.isEmpty(refundMile)) {
            view.showToast("请输入里程数")
            return
        }
        if (TextUtils.equals(orderInfo?.transmission, "ET") && TextUtils.isEmpty(refundFuel)) {
            view.showToast("请输入电量")
            return
        }
        if (checkBean.size == 0 || TextUtils.isEmpty(checkBean[0].url) || TextUtils.isEmpty(checkBean[1].url)) {
            view.showToast("请上传验车图片")
            return
        }
        isCanNext = true
        requestOrderCalc()
    }

    /**
     * 油量截取
     * @param fuel
     * */
    private fun getOilScale(fuel: String?): Int {
        var scale = "0"
        if (!TextUtils.isEmpty(fuel)) {
            scale = fuel!!.split("/")[0]
        }
        return scale.toInt()
    }

    private var isOnSeek = false
    fun onSeek() {
        isOnSeek = true
    }

    /**
     * 订单计算
     * */
    override fun requestOrderCalc() {
        val request = CalcRequest()
        request.type = "APPLY"
        request.channel = ChannelUtil.getAppChannel(context)
        request.orderid = orderID
        request.real_start_time = realStartTime
        request.real_end_time = realEndTime
        if (!TextUtils.isEmpty(refundFuel)) request.fuel = refundFuel
        if (!TextUtils.isEmpty(refundMile)) request.miles = refundMile
        val service = RetrofitHelper.getInstance(context).service
        val params = RetrofitHelper.getInstance(context).convertRequestToMap(request)
        val observable = service.orderCalc(params).debounce(1000, TimeUnit.MILLISECONDS)
        observable.subscribeOn(Schedulers.io()).doOnSubscribe {
            view.showLoadingDialog()
        }.observeOn(AndroidSchedulers.mainThread()).subscribe(object : BaseObserver<CalcResult>(context, this) {
            override fun onSuccess(response: CalcResult) {
                view.dismissLoadingDialog()
                view.setCanNext()

                view.setRefundDesc(response.fuel_description ?: "")

                view.setRefuelTips(response.refueling_amount?.toInt() ?: 0 > 0, "取车时满油，但还车时不满油，需向客户收取 ¥${response.refueling_amount}加油服务费")

                // 油量弹窗。只有操作了滑动条才显示弹窗
                if (!TextUtils.isEmpty(response.oilfee_prompt) && isOnSeek) {
                    view.setOilFeeDialog(response.oilfee_prompt)
                }
                isOnSeek = false

                view.setCalcInfo(response)

                postApplyRequest = RefundTheCarActivity.buildRequest(postApplyRequest, response)

                if (isCanNext) {
                    isCanNext = false
                    view.setNextPage()
                }
            }
        })
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        if (data != null)
            LogUtil.e("onActivityResult data = $data")
        when (requestCode) {
            101 -> {
                if (resultCode == 101) {
                    if (data != null) {
                        signURL = data.getStringExtra("sign_url")
                        view.setSignImage(signURL ?: "")
                    }
                }
            }
        }
    }

    override fun onPostApplyRequest() {
        postApplyRequest?.real_start_time = realStartTime
        postApplyRequest?.real_end_time = realEndTime
        postApplyRequest?.miles = refundMile
        postApplyRequest?.fuel = refundFuel
        postApplyRequest?.accessories = view.getRefundCarItems()
        postApplyRequest?.fuel_url = checkBean[0].url
        postApplyRequest?.front_url = checkBean[1].url
        postApplyRequest?.inspection_pic = getInspectionPicBean()
        if (!Util.isEmptyList(validateIds)) {
            postApplyRequest?.validate_ids = validateIds
        }
        if (!Util.isEmptyList(newIssueList)) {
            postApplyRequest?.validates = newIssueList
        }
        if (!TextUtils.isEmpty(view.getComments())) {
            postApplyRequest?.comments = view.getComments()
        }
        if (!TextUtils.isEmpty(signURL)) {
            postApplyRequest?.sign_url = signURL
        }
        LiveDataBus.get().with("SecondFragment").postValue(postApplyRequest)
    }


    private fun initTimeLine(result: OrderDetailResult) {
        if (result.e_contract_status == 1 && result.is_e_contract == 1) {
            view.setTimeLine(TakeAlsoCarTimeLine.REFUND_CONTRACT, TakeAlsoCarTimeLine.INDEX_ONE)
        } else {
            view.setTimeLine(TakeAlsoCarTimeLine.REFUND_NORMAL, TakeAlsoCarTimeLine.INDEX_ONE)
        }
    }

    private var checkBean = ArrayList<CheckImgBean>()

    fun getCheckImage(it: ArrayList<CheckImgBean>) {
        checkBean = it
    }

    fun onCheckImage() {
        UploadCheckImageActivity.newInstance(context, orderInfo?.status ?: 0, checkBean)
    }

    private fun getInspectionPicBean(): InspectionPicBean? {
        val bean = InspectionPicBean()
        for (entity in checkBean) {
            when (entity.index) {
                2 -> {
                    bean.left_front = entity.url
                }
                3 -> {
                    bean.left_side = entity.url
                }
                4 -> {
                    bean.left_rear = entity.url
                }
                5 -> {
                    bean.right_rear = entity.url
                }
                6 -> {
                    bean.right_side = entity.url
                }
                7 -> {
                    bean.right_front = entity.url
                }
            }
        }
        return bean
    }
}