package com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.refundcar.fragment.second

import android.arch.lifecycle.Observer
import android.content.Intent
import android.os.Bundle
import android.text.Editable
import android.text.TextUtils
import android.text.TextWatcher
import android.view.View
import android.view.inputmethod.EditorInfo
import com.bumptech.glide.Glide
import com.jeremyliao.livedatabus.LiveDataBus
import com.jiaoyinbrother.library.bean.*
import com.jiaoyinbrother.library.util.ConstantsUtil
import com.jiaoyinbrother.library.widget.BottomDialog
import com.jiaoyinbrother.library.widget.GeneralBottomButton
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseFragment
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.refundcar.adapter.IssuesAdapter
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.refundcar.fragment.main.RefundMainFragment
import com.jiaoyinbrother.monkeyking.manager.view.IOSdialog.IOSAlertDialog
import com.jiaoyinbrother.monkeyking.manager.view.SeekBarView
import kotlinx.android.synthetic.main.fragment_refund_car_second.*
import net.yslibrary.android.keyboardvisibilityevent.KeyboardVisibilityEvent
import net.yslibrary.android.keyboardvisibilityevent.Unregistrar
import java.util.regex.Pattern

class RefundSecondTabFragment : MvpBaseFragment<RefundSecondPresenter>(), IRefundSecondContract.View {


    override fun setOilFeeDialog(prompt: String?) {
        IOSAlertDialog(mActivity).builder().setCancelable(false).setMsg(prompt, true)
                .setRightButton("我知道了") {  }.show()
    }

    private var isShowCarItems = false
    private var isShowSign = true
    private var oldAdapter: IssuesAdapter? = null
    private var newAdapter: IssuesAdapter? = null
    private var mKeyBoard: Unregistrar? = null

    fun setData(result: OrderDetailResult) {
        presenter.getOrderInfo(result)
    }

    override fun getRefundCarItems(): ArrayList<String> {
        return itemView.getRefundData()
    }

    override fun getComments(): String {
        return etComment.text.toString()
    }

    override fun initPresenter(): RefundSecondPresenter {
        return RefundSecondPresenter(_mActivity, this)
    }

    override fun getLayoutId(): Int {
        return R.layout.fragment_refund_car_second
    }

    override fun initViews(view: View?, savedInstanceState: Bundle?) {}

    override fun initToolbar(savedInstanceState: Bundle?) {}

    override fun initData() {
        // 禁用取车油量只显示不操作
        sbTakeOil.isEnabled = false
        // 取车验车图片
        oldAdapter = IssuesAdapter(_mActivity)
        oldIssueRv.adapter = oldAdapter
        // 新增问题
        newAdapter = IssuesAdapter(_mActivity)
        newIssueRv.adapter = newAdapter
        // 初始化新增问题隐藏
        hideNewIssue(true)
        LiveDataBus.get().with("FirstFragment").observe(_mActivity, Observer {
            presenter.getApplyRequest(it as BillApplyRequest)
        })
        // 添加新问题数据回传
        LiveDataBus.get().with(ConstantsUtil.VALIDATES).observe(_mActivity, Observer {
            presenter.onAddNewIssue(it as CarValidatesBean)
        })

        LiveDataBus.get().with("Return_Check_Image").observe(_mActivity, Observer {
            presenter.getCheckImage(it as ArrayList<CheckImgBean>)
        })
    }

    override fun onPause() {
        hideSoftInput()
        onNext.visibility = View.VISIBLE
        super.onPause()
    }

    override fun onDestroy() {
        mKeyBoard?.unregister()
        super.onDestroy()
    }

    override fun initListeners() {
        realTakeCarTime.setOnClickListener(MyListeners())
        realRefundCarTime.setOnClickListener(MyListeners())
        sbRefundOil.setListener(MyListeners())
        refundElectric.addTextChangedListener(MyListeners())
        carItemsLayout.setOnClickListener(MyListeners())
        addIssue.setOnClickListener(MyListeners())
        signLayout.setOnClickListener(MyListeners())
        signImage.setOnClickListener(MyListeners())
        onNext.setListener(MyListeners())
        oldAdapter?.setOnItemClickListener { _, position ->
            val issue = oldAdapter?.getItem<CarValidatesBean>(position)
            issue?.let { presenter.onSeeNewIssue(it) }
        }
        newAdapter?.setOnItemClickListener { _, position ->
            val issue = newAdapter?.getItem<CarValidatesBean>(position)
            BottomDialog(context)
                    .builder()
                    .addItems(arrayOf("查看问题", "删除问题"))
                    .setCancel("取消") {}
                    .setItemClick { _, i ->
                        when (i) {
                            0 -> issue?.let { presenter.onSeeNewIssue(it) }
                            1 -> presenter.onDelNewIssue(position)
                        }
                    }.show()
        }
        refundMiles.addTextChangedListener(object : TextWatcher {
            override fun afterTextChanged(s: Editable?) {
                //这里的处理是不让输入0开头的值
                val words = s.toString()
                //首先内容进行非空判断，空内容（""和null）不处理
                if (!TextUtils.isEmpty(words)) {
                    if (Integer.parseInt(s.toString()) <= 0) {
                        refundMiles.setText("")
                    } else {
                        presenter.onRefundMileChanged(s.toString())
                    }
                }
            }

            override fun beforeTextChanged(s: CharSequence?, start: Int, count: Int, after: Int) {}
            override fun onTextChanged(s: CharSequence?, start: Int, before: Int, count: Int) {}
        })
        refundMiles.setOnEditorActionListener { _, actionId, _ ->
            if (actionId == EditorInfo.IME_ACTION_SEND)
                presenter.requestOrderCalc()
            return@setOnEditorActionListener false
        }
        refundElectric.setOnEditorActionListener { _, actionId, _ ->
            if (actionId == EditorInfo.IME_ACTION_SEND)
                presenter.requestOrderCalc()
            return@setOnEditorActionListener false
        }
        mKeyBoard = KeyboardVisibilityEvent.registerEventListener(_mActivity) { isOpen ->
            if (!isVisible) return@registerEventListener
            onNext.visibility = if (isOpen) View.INVISIBLE else View.VISIBLE
            if (!isOpen) presenter.requestOrderCalc()
        }
        carPicLayout.setOnClickListener {
            presenter.onCheckImage()
        }
    }

    private inner class MyListeners : View.OnClickListener, GeneralBottomButton.SubmitListener,
            TextWatcher, SeekBarView.OnSeekBarChangeListener {

        override fun onProgressChanged(progress: Int) {
            if (!isVisible) return
            presenter.onRefundOilChanged(progress)
        }

        override fun onStartTrackingTouch(bool: Boolean) {
            onNext.disable()
        }

        override fun onStopTrackingTouch(bool: Boolean) {
            if (!isVisible) return
            if (bool) {
                presenter.onSeek()
                presenter.requestOrderCalc()
            }
        }

        private var outStr = ""

        override fun submit() {
            //  sbRefundOil 按住滑动bug待解决
//            sbRefundOil.isEnabled = false
//            sbRefundOil.onTouchEvent(MotionEvent.obtain())
//            sbRefundOil.clearFocus()
//            sbRefundOil.isFocusableInTouchMode = false
            presenter.onNextPage()
        }

        override fun afterTextChanged(s: Editable?) {
            //这里的处理是不让输入0开头的值
            val words = s.toString()
            //首先内容进行非空判断，空内容（""和null）不处理
            if (!TextUtils.isEmpty(words)) {
                if (Integer.parseInt(s.toString()) <= 0) {
                    refundElectric.setText("")
                    showToast("电量:1-100%")
                }
            }
        }

        override fun beforeTextChanged(s: CharSequence?, start: Int, count: Int, after: Int) {
            val edit = s.toString()
            if (edit.length == 2 && Integer.parseInt(edit) >= 10) {
                outStr = edit
            }
        }

        override fun onTextChanged(s: CharSequence?, start: Int, before: Int, count: Int) {
            val words = s.toString()
            //首先内容进行非空判断，空内容（""和null）不处理
            if (!TextUtils.isEmpty(words)) {
                //1-100的正则验证
                val pattern = Pattern.compile("^(100|[1-9]\\d|\\d)$")
                val matcher = pattern.matcher(words)
                if (matcher.find() || ("") == words) {
                    //这个时候输入的是合法范围内的值
                    presenter.onRefundElectricChanged(words)
                } else {
                    if (words.length > 2) {
                        //若输入不合规，且长度超过2位，继续输入只显示之前存储的outStr
                        refundElectric.setText(outStr)
                        //重置输入框内容后默认光标位置会回到索引0的地方，要改变光标位置
                        refundElectric.setSelection(2)
                        showToast("电量:1-100%")
                    }
                }
            }
        }

        override fun onClick(v: View?) {
            when (v?.id) {
                R.id.realTakeCarTime -> presenter.onRealStartTime()
                R.id.realRefundCarTime -> presenter.onRealEndTime()
                R.id.carItemsLayout -> onShowCarItems()
//                R.id.groupPhotoTips -> presenter.onGroupPhotoTip()
//                R.id.groupPhoto -> presenter.onGroupPhoto()
//                R.id.takeOilPhotoTips -> presenter.onTakeOilPhotoTip()
//                R.id.takeOilPhoto -> presenter.onTakeOilPhoto()
//                R.id.refundOilPhotoTips -> presenter.onRefundOilPhotoTip()
//                R.id.refundOilPhoto -> presenter.onRefundOilPhoto(this@RefundSecondTabFragment)
                R.id.addIssue -> presenter.onAddIssue()
                R.id.signLayout -> onShowSign()
                R.id.signImage -> presenter.onSign(this@RefundSecondTabFragment)
            }
        }
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        presenter.onActivityResult(requestCode, resultCode, data)
    }

    override fun onBackPressedSupport(): Boolean {
        val parent = parentFragment as RefundMainFragment
        parent.onSelectPage(RefundMainFragment.FIRST, RefundMainFragment.SECOND)
        return true
    }

    /**
     * display 随车物品
     * */
    private fun onShowCarItems() {
        isShowCarItems = !isShowCarItems
        itemView.visibility = if (isShowCarItems) View.VISIBLE else View.GONE
        if (isShowCarItems) {
            itemsArrow.setBackgroundResource(R.mipmap.up_item)
        } else {
            itemsArrow.setBackgroundResource(R.mipmap.down_item)
        }
    }

    /**
     * display 签名
     * */
    private fun onShowSign() {
        isShowSign = !isShowSign
        signImage.visibility = if (isShowSign) View.VISIBLE else View.GONE
        if (isShowSign) {
            signArrow.setBackgroundResource(R.mipmap.up_item)
        } else {
            signArrow.setBackgroundResource(R.mipmap.down_item)
        }
    }

    override fun setOrderNum(num: String) {
        orderNum.text = num
    }

    override fun setOrderChannel(channel: String) {
        orderChannel.text = channel
    }

    override fun setCarNum(num: String) {
        carNum.text = num
    }

    override fun setCarTypeName(name: String) {
        carTypeName.text = name
    }

    override fun setRealTakeTime(time: String) {
        realTakeCarTime.text = time
    }

    override fun setRealRefundTime(time: String) {
        realRefundCarTime.text = time
    }

    override fun setTakeMiles(miles: String) {
        takeMiles.text = miles
    }

    override fun setRefundMiles(miles: String) {
        refundMiles.setText(miles)
    }

    override fun hideOilShowElectric(isOil: Boolean) {
        electricLayout.visibility = if (isOil) View.VISIBLE else View.GONE
        oilLayout.visibility = if (isOil) View.GONE else View.VISIBLE
    }

    override fun setTakeOil(scale: Int, oilMass: String) {
        sbTakeOil.setProgress(scale)
        takeOil.text = oilMass
    }

    override fun setRefundOil(scale: Int, oilMass: String) {
        sbRefundOil.setProgress(scale)
        refundOil.text = oilMass
    }

    override fun setRefundDesc(desc: String) {
        refundOilDesc.text = desc
    }

    override fun setTakeElectric(electric: String) {
        takeElectric.text = electric
    }

    override fun setRefundElectric(electric: String) {
        refundElectric.setText(electric)
    }

    override fun setTakeItems(isClick: Boolean, states: ArrayList<String>) {
        itemView.setTakeData(isClick, states)
    }

    override fun setRefundItems(isClick: Boolean, states: ArrayList<String>) {
        itemView.setRefundData(isClick, states)
    }

    override fun hideOldIssue(hide: Boolean) {
        oldIssueLayout.visibility = if (hide) View.GONE else View.VISIBLE
    }

    override fun setOldIssues(validates: ArrayList<CarValidatesBean>) {
        oldAdapter?.list = validates
        oldAdapter?.notifyDataSetChanged()
    }

    override fun hideNewIssue(hide: Boolean) {
        newIssueLayout.visibility = if (hide) View.GONE else View.VISIBLE
    }

    override fun setNewIssues(validates: ArrayList<CarValidatesBean>) {
        newAdapter?.list = validates
        newAdapter?.notifyDataSetChanged()
    }

    override fun setComments(comment: String) {
        etComment.setText(comment)
    }

    override fun setSignImage(url: String) {
        Glide.with(_mActivity).load(url).into(signImage)
    }

    override fun setCalcInfo(result: CalcResult) {
        LiveDataBus.get().with(ConstantsUtil.FLAG_CALC_RESULT).postValue(result)
    }

    override fun setNextPage() {
        presenter.onPostApplyRequest()
        val a = parentFragment as RefundMainFragment
        a.onSelectPage(RefundMainFragment.THIRD, RefundMainFragment.SECOND)
    }

    override fun setCanNext() {
        onNext.normal()
    }

    override fun setRefuelTips(b: Boolean, tip: String) {
        refuelingTips.visibility = if (b) View.VISIBLE else View.GONE
        refuelingTips.text = tip
    }

    companion object {
        fun newInstance(): RefundSecondTabFragment {
            val fragment = RefundSecondTabFragment()
            val args = Bundle()
            fragment.arguments = args
            return fragment
        }
    }

    override fun setTimeLine(type: Int, index: Int) {
        refund_second_time_line.setStyleType(type)
        refund_second_time_line.setSelectIndex(index)
    }

}