package com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.refundcar.fragment.third

import android.arch.lifecycle.Observer
import android.os.Bundle
import android.view.View
import com.jeremyliao.livedatabus.LiveDataBus
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseFragment
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.order.refundcar.fragment.main.RefundMainFragment
import com.jiaoyinbrother.monkeyking.manager.util.H5Utils
import com.jiaoyinbrother.library.bean.BillApplyRequest
import com.jiaoyinbrother.library.bean.CalcResult
import com.jiaoyinbrother.library.bean.OrderDetailResult
import com.jiaoyinbrother.library.util.ConstantsUtil
import com.jiaoyinbrother.library.util.LogUtil
import com.jiaoyinbrother.library.widget.CostCheckInfoView
import com.jiaoyinbrother.library.widget.GeneralBottomButton
import kotlinx.android.synthetic.main.fragment_refund_car_third.*
import net.yslibrary.android.keyboardvisibilityevent.KeyboardVisibilityEvent
import net.yslibrary.android.keyboardvisibilityevent.Unregistrar

class RefundThirdTabFragment : MvpBaseFragment<RefundThirdPresenter>(), IRefundThirdContract.View, View.OnClickListener {


    private var mKeyBoard: Unregistrar? = null

    companion object {
        fun newInstance(): RefundThirdTabFragment {
            val args = Bundle()
            val fragment = RefundThirdTabFragment()
            fragment.arguments = args
            return fragment
        }
    }

    fun setData(result: OrderDetailResult) {
        presenter.getOrderInfo(result)
    }

    override fun initPresenter(): RefundThirdPresenter {
        return RefundThirdPresenter(_mActivity, this)
    }

    override fun getLayoutId(): Int {
        return R.layout.fragment_refund_car_third
    }

    override fun initViews(view: View?, savedInstanceState: Bundle?) {}

    override fun initToolbar(savedInstanceState: Bundle?) {}

    override fun initData() {
        LiveDataBus.get().with("SecondFragment").observe(_mActivity, Observer {
            presenter.getApplyRequest(it as BillApplyRequest)
        })
        LiveDataBus.get().with(ConstantsUtil.FLAG_CALC_RESULT).observe(_mActivity, Observer {
            presenter.getCalcInfo(it as CalcResult)
        })
    }


    override fun onPause() {
        hideSoftInput()
        onNext.visibility = View.VISIBLE
        super.onPause()
    }

    override fun onDestroy() {
        mKeyBoard?.unregister()
        super.onDestroy()
    }

    override fun initListeners() {
        costCheckView.setListener(object : CostCheckInfoView.CheckInterface {
            override fun setAmount(other: String) {
                presenter.getAmount(other)
            }

            override fun serviceHelp() {
                H5Utils.onInsurance(_mActivity)
            }

        })
        onNext.setListener(object : GeneralBottomButton.SubmitListener {
            override fun submit() {
                costCheckView.getData()
                presenter.onNextPage()
            }
        })

        mKeyBoard = KeyboardVisibilityEvent.registerEventListener(_mActivity) { isOpen ->
            if (!isVisible) return@registerEventListener
            onNext.visibility = if (isOpen) View.INVISIBLE else View.VISIBLE
            if (!isOpen) costCheckView.getData()
        }
    }

    override fun onBackPressedSupport(): Boolean {
        val parent = parentFragment as RefundMainFragment
        parent.onSelectPage(RefundMainFragment.SECOND, RefundMainFragment.THIRD)
        LogUtil.e("third back onBackPressedSupport")
        return true
    }

    override fun updataFragment() {}

    override fun onClick(v: View?) {
        when (v?.id) {

        }
    }

    override fun setCostInfo(result: OrderDetailResult) {
        costCheckView.setData(result)
    }

    override fun setCouponAmount(hide: Boolean, amount: String) {
        couponLayout.visibility = if (hide) View.GONE else View.VISIBLE
        couponCost.text = amount
    }

    override fun setWkCoinAmount(hide: Boolean, amount: String) {
        wkCoinLayout.visibility = if (hide) View.GONE else View.VISIBLE
        wkCoinCost.text = amount
    }

    override fun setOildPayAmount(hide: Boolean, amount: String) {
        oil_pay_layout.visibility = if (hide) View.GONE else View.VISIBLE
        oil_pay_amount.text = amount
    }


    override fun setDeductAmount(hide: Boolean, amount: String) {
        deductionLayout.visibility = if (hide) View.GONE else View.VISIBLE
        deductionCost.text = amount
    }

    override fun setCostCalcInfo(result: CalcResult) {
        costCheckView.setCalcData(result)
    }

    override fun setNextPage(b: Boolean) {
        val a = parentFragment as RefundMainFragment
//        if (b) {
//            a.onSelectPage(RefundMainFragment.FOUR, RefundMainFragment.THIRD)
//        } else {
//            a.onSelectPage(RefundMainFragment.FIVE, RefundMainFragment.THIRD)
//        }
    }

    override fun setTimeLine(type: Int, index: Int) {
        refund_third_time_line.setStyleType(type)
        refund_third_time_line.setSelectIndex(index)
    }

    override fun setApplySuccess() {

        _mActivity.setResult(ConstantsUtil.ORDER_REFRESH_CODE)
        activity?.finish()
    }
}