package com.jiaoyinbrother.monkeyking.manager.mvpactivity.ordercancelworkflowlist

import android.os.Bundle
import android.view.View
import com.alibaba.android.arouter.facade.annotation.Autowired
import com.alibaba.android.arouter.facade.annotation.Route
import com.alibaba.android.arouter.launcher.ARouter
import com.jiaoyinbrother.library.bean.OrderCancelWorkListRequest
import com.jiaoyinbrother.library.bean.OrderReletApplyListRowsBean
import com.jiaoyinbrother.library.util.ARouterConstantUtil
import com.jiaoyinbrother.library.util.LogUtil
import com.jiaoyinbrother.library.widget.OrderListSortView
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.adapter.MyFragmentAdapter
import com.jiaoyinbrother.monkeyking.manager.fragment.ordercancelworkflowlist.OrderCancelWorkFlowListFragment
import com.jiaoyinbrother.monkeyking.manager.fragment.workflowlist.WorkflowListPresenter
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseActivity
import kotlinx.android.synthetic.main.activity_order_cancel_work_flow_list.*

@Route(path = ARouterConstantUtil.ACTIVITY_ORDER_CANCEL_FLOW_LIST)
class OrderCancelWorkFlowListActivity: MvpBaseActivity<OrderCancelWorkFlowPresenter>(), IOrderCancelWorkFlowListContract.view {

    @Autowired(name = ARouterConstantUtil.PARAM_ORDER_CANCEL_INIT_TAB_NUM)
    @JvmField
    var initTabNum = 0

    private var mAdapter: MyFragmentAdapter? = null
    
    private var pendingListFragment: OrderCancelWorkFlowListFragment? = null
    private var approvedListFragment: OrderCancelWorkFlowListFragment? = null
    private var cancelListFragment: OrderCancelWorkFlowListFragment? = null

    override fun initListeners() {
        managerTitleBack?.setOnClickListener {
            finish()
        }


        //tab 点击事件
        auditing_radio_button.setOnClickListener {
            LogUtil.e("auditing_radio_button clicked")
            managerOrderViewPage.currentItem = 0
            pendingListFragment?.updataFragment()
        }

        approved_radio_button?.setOnClickListener {
            LogUtil.e("approved_radio_button clicked")
            managerOrderViewPage.currentItem = 1
            approvedListFragment?.updataFragment()
        }

        canceled_radio_button?.setOnClickListener {
            LogUtil.e("canceled_radio_button clicked")
            managerOrderViewPage.currentItem = 2
            cancelListFragment?.updataFragment()
        }


        // 排序
        managerOrderSortView.setListener(object : OrderListSortView.OrderSortListener {
            override fun onDefault(sort: Int) {
                onSortOrder(sort, false)
            }

            override fun onTakeCar(sort: Int, isASC: Boolean) {
                onSortOrder(sort, isASC)
            }

            override fun onReturnCar(sort: Int, isASC: Boolean) {
                onSortOrder(sort, isASC)
            }
        })
    }

    override fun initPresenter(): OrderCancelWorkFlowPresenter {
        return OrderCancelWorkFlowPresenter(this, this)
    }

    override fun getLayoutId(): Int {
        return R.layout.activity_order_cancel_work_flow_list
    }

    override fun initView() {
        ARouter.getInstance().inject(this)

        LogUtil.e("initView initTabNum = $initTabNum")

    }

    override fun initToolBar() {

    }

    override fun initData() {
        managerOrderSortView.visibility = View.VISIBLE

        managerOrderViewPage.offscreenPageLimit = 3

        //初始化Adapter---------------------
        mAdapter = MyFragmentAdapter(this, supportFragmentManager)

        //续租工单
        pendingListFragment = OrderCancelWorkFlowListFragment()
        val bundle1 = Bundle()
        bundle1.putInt(WorkflowListPresenter.WORK_LIST_APPLY_STATUS_KEY,
                OrderCancelWorkListRequest.STATUS_PENDING)
        pendingListFragment?.arguments = bundle1
        mAdapter?.addFragment(pendingListFragment)

        //处理
        approvedListFragment = OrderCancelWorkFlowListFragment()
        val bundle2 = Bundle()
        bundle2.putInt(WorkflowListPresenter.WORK_LIST_APPLY_STATUS_KEY,
                OrderCancelWorkListRequest.STATUS_PROCESSED)
        approvedListFragment?.arguments = bundle2
        mAdapter?.addFragment(approvedListFragment)

        //取消
        cancelListFragment = OrderCancelWorkFlowListFragment()
        val bundle4 = Bundle()
        bundle4.putInt(WorkflowListPresenter.WORK_LIST_APPLY_STATUS_KEY,
                OrderCancelWorkListRequest.STATUS_CANCELLED)
        cancelListFragment?.arguments = bundle4
        mAdapter?.addFragment(cancelListFragment)

        //设置adapter----------------
        managerOrderViewPage.adapter = mAdapter

        setPageNo(initTabNum)
    }

    private fun setPageNo(tabNum:Int){
        when(tabNum){
            0 ->{
                managerOrderViewPage.currentItem = 0
                auditing_radio_button.isChecked = true
            }
            1 ->{
                //定位fragment
                managerOrderViewPage.currentItem = 1
                approved_radio_button.isChecked = true
            }
            2 ->{
                //定位fragment
                managerOrderViewPage.currentItem = 2
                canceled_radio_button.isChecked = true
            }
        }
    }

    private fun onSortOrder(sortType: Int, isASC: Boolean) {
        pendingListFragment?.onSort(sortType, isASC)
        approvedListFragment?.onSort(sortType, isASC)
        cancelListFragment?.onSort(sortType, isASC)
    }
}
