package com.jiaoyinbrother.monkeyking.manager.mvpactivity.ordercontract

import android.content.Context
import android.content.Intent
import android.support.v7.app.AppCompatActivity
import android.os.Bundle
import android.text.Editable
import android.text.TextWatcher
import android.view.View
import com.jiaoyinbrother.library.bean.ContractItemBean
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseActivity
import com.jiaoyinbrother.monkeyking.mvpactivity.ordercontract.IOrderContract
import com.jiaoyinbrother.monkeyking.mvpactivity.ordercontract.OrderContractPresenter
import kotlinx.android.synthetic.main.activity_order_contract.*

class OrderContractActivity : MvpBaseActivity<OrderContractPresenter>(), IOrderContract.IOrderContractView {

    override fun onGetEmailListSuccess(list: ArrayList<ContractItemBean>?) {
        mAdapter?.list = list
        mAdapter?.notifyDataSetChanged()
    }

    override fun onSendEmailSuccess() {
        mAdapter?.setSendContractSuccess(mOnSendContractPosition)
    }

    private var mOnSendContractPosition = 0

    override fun initListeners() {

        mAdapter?.setOnSendContractSuccess(object : OrderContractAdapter.OnSendContractSuccess{
            override fun onSuccess(position: Int,email : String?,type : String?) {
                mOnSendContractPosition = position
                presenter.sendEmailType(email,type?:"")
            }

        })
    }

    override fun initPresenter(): OrderContractPresenter {
        return OrderContractPresenter(this,this)
    }

    override fun getLayoutId(): Int {
        return R.layout.activity_order_contract
    }

    private var mAdapter : OrderContractAdapter ?= null
    override fun initView() {
        mAdapter = OrderContractAdapter(this@OrderContractActivity)
        order_contract_recycler.adapter = mAdapter
    }

    override fun initToolBar() {
        mainTitle.text = "合同"
    }

    override fun initData() {

        presenter.initData(intent)
    }

    companion object{

        const val ORDER_CONTRACT_STATUS = "ORDER_CONTRACT_STATUS"
        const val ORDER_CONTRACT_ORDER_ID = "ORDER_CONTRACT_ORDER_ID"
        const val RENT_CONTRACT = "RENT_CONTRACT"
        const val RETURN_CONTRACT = "RETURN_CONTRACT"

        fun newInstance(context: Context, orderStatus : Int, orderId : String){
            val intent = Intent(context,OrderContractActivity::class.java)
            intent.putExtra(ORDER_CONTRACT_STATUS,orderStatus)
            intent.putExtra(ORDER_CONTRACT_ORDER_ID,orderId)
            context.startActivity(intent)
        }
    }
}
