package com.jiaoyinbrother.monkeyking.manager.mvpactivity.ordercontract

import android.content.Context
import android.content.Intent
import android.text.Editable
import android.text.TextWatcher
import android.view.View
import android.widget.EditText
import android.widget.TextView
import com.camnter.easyrecyclerview.adapter.EasyRecyclerViewAdapter
import com.camnter.easyrecyclerview.holder.EasyRecyclerViewHolder
import com.jiaoyinbrother.library.bean.ContractItemBean
import com.jiaoyinbrother.library.bean.WebViewConfigEntity
import com.jiaoyinbrother.library.util.UrlUtil
import com.jiaoyinbrother.monkeyking.manager.CarEntity
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.activity.GeneralWebViewActivity
import com.wk.common.button.WkButton

class OrderContractAdapter(val context: Context) : EasyRecyclerViewAdapter(){

    override fun getRecycleViewItemType(position: Int): Int {
        return 0
    }

    override fun onBindRecycleViewHolder(viewHolder: EasyRecyclerViewHolder?, position: Int) {

        val mEditEmail = viewHolder?.findViewById<EditText>(R.id.order_contract_rent_email_et)
        val mEmailWatch = viewHolder?.findViewById<WkButton>(R.id.order_contract_rent_watch)
        val mEmailTitle = viewHolder?.findViewById<TextView>(R.id.order_contract_rent_title)
        val mEmailSend = viewHolder?.findViewById<TextView>(R.id.order_contract_rent_email_send)

        val bean = list[position] as ContractItemBean

        mEmailTitle?.text = bean.contract_type_name

        mEmailWatch?.setOnClickListener{

            val webViewConfigEntity = WebViewConfigEntity()
            webViewConfigEntity.title = bean.contract_type_name
            webViewConfigEntity.isNeedProgressBar = true
            webViewConfigEntity.url = bean.viewpdf_url
            webViewConfigEntity.isNeedShareButton = false
            val intent = Intent(context, GeneralWebViewActivity::class.java)
            intent.putExtra(CarEntity.FEATURE_ITEM, webViewConfigEntity)
            context.startActivity(intent)
        }

        if (mSendPosition == position){
            mEditEmail?.setText("")
        }

        mEmailSend?.setOnClickListener{

            onSendContractSuccess?.onSuccess(position,mEditEmail?.text.toString(),bean.contract_type)
        }

        //租赁合同文本框
        mEditEmail?.addTextChangedListener(object : TextWatcher {
            override fun afterTextChanged(p0: Editable?) {
                mEmailSend?.isEnabled = mEditEmail.text.toString().isNotEmpty()
            }

            override fun beforeTextChanged(p0: CharSequence?, p1: Int, p2: Int, p3: Int) {
            }

            override fun onTextChanged(p0: CharSequence?, p1: Int, p2: Int, p3: Int) {
            }

        })
    }

    override fun getItemLayouts(): IntArray {
        return intArrayOf(R.layout.item_order_contract)
    }

    interface OnSendContractSuccess{
        fun onSuccess(position: Int,email : String?,type : String?)
    }

    private var onSendContractSuccess : OnSendContractSuccess ?= null

    fun setOnSendContractSuccess(onSendContractSuccess: OnSendContractSuccess){
        this.onSendContractSuccess = onSendContractSuccess
    }

    private var mSendPosition : Int ?= null

    fun setSendContractSuccess(position: Int){
        mSendPosition = position
        notifyItemChanged(position)
    }

}