package com.jiaoyinbrother.monkeyking.manager.mvpactivity.payforother

import android.content.Intent
import com.jiaoyinbrother.library.base.IBasePresenter
import com.jiaoyinbrother.library.bean.CostBean
import com.jiaoyinbrother.library.bean.OrderDetailResult
import com.jiaoyinbrother.library.view.IBaseView

interface IPayForOtherContract {

    interface View : IBaseView {
        fun setRentInfo(desc: String, amount: String)
        fun setRentAmountInfo(result: OrderDetailResult)
        fun setInsuranceInfo(name: String, desc: String, amount: String)
        fun setInsuranceDesc(b: Boolean, desc: String)
        fun setOthersInfo(amount: String)
        fun setCostDetailData(data: ArrayList<CostBean>)
        fun setPackingAmount(amount: String)
        fun setDiscountAmount(amount: String)
        fun setTotalAmount(amount: String)
        fun setShowRentInfo(b: Boolean)
        fun setShowOtherInfo(b: Boolean)

        fun setChannelVisibility(b: Boolean, name: String)
        fun setPreRentPay(b: Boolean, amount: String)
        fun setPreDepositPay(b: Boolean, amount: String)
        fun setPreCouponPay(b: Boolean, amount: String)
        fun setPreWkCoinPay(b: Boolean, amount: String)
        fun setPrePay(b: Boolean)
        fun setOtherAccountAvai(s: String)
        fun setOtherWkCoinAvai(s: String)
        fun setOtherAccountPay(check: Boolean, amount: String)
        fun setOtherWkCoinPay(check: Boolean, amount: String)
        fun setMorePay(amount: String)
        fun setActiveOnPay(b: Boolean)
        fun setChecked(check: ArrayList<String>)
        fun pageClose()

        fun getBalanceCheckStatus(): Boolean
        fun getWkCoinCheckStatus(): Boolean
        fun getPreRentCheckStatus(): Boolean
        fun getDepositCheckStatus(): Boolean
        fun getCouponCheckStatus(): Boolean
    }


    interface Presenter : IBasePresenter {
        fun getData(intent: Intent)
        fun doShowRentInfo()
        fun doShowOthers()
        fun apiCalc()
        fun apiAccept()
    }
}