package com.jiaoyinbrother.monkeyking.manager.mvpactivity.payforother

import android.support.v4.content.ContextCompat
import android.view.View
import com.jiaoyinbrother.library.adapter.OrderDetailPriceAdapter
import com.jiaoyinbrother.library.bean.CostBean
import com.jiaoyinbrother.library.bean.OrderDetailResult
import com.jiaoyinbrother.library.util.ConstantsUtil
import com.jiaoyinbrother.library.widget.GeneralBottomButton
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.adapter.CostDetailAdapter
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseActivity
import com.jiaoyinbrother.monkeyking.manager.util.H5Utils
import kotlinx.android.synthetic.main.activity_pay_for_other.*
import kotlinx.android.synthetic.main.layout_renter_discount.*

class PayForOtherActivity : MvpBaseActivity<PayForOtherPresenter>(), IPayForOtherContract.View, View.OnClickListener {


    private var mAdapter: CostDetailAdapter? = null

    override fun initPresenter(): PayForOtherPresenter {
        return PayForOtherPresenter(this, this)
    }

    override fun getLayoutId(): Int {
        return R.layout.activity_pay_for_other
    }

    override fun initView() {}

    override fun initToolBar() {
        mainTitle.text = "代客支付"
    }

    override fun initData() {
        onPay.disable()
        cope_with_describe.visibility = View.INVISIBLE
        presenter.getData(intent)
        presenter.apiCalc()
    }

    override fun initListeners() {
        ll_insurance.setOnClickListener(this)
        ll_open_rent_info.setOnClickListener(this)
        ll_open_others.setOnClickListener(this)
        ll_account_pay.setOnClickListener(this)
        ll_wkcoin_pay.setOnClickListener(this)
        onPay.setListener(object : GeneralBottomButton.SubmitListener {
            override fun submit() {
                presenter.apiAccept()
            }
        })
    }

    override fun onClick(v: View?) {
        when (v?.id) {
            R.id.ll_insurance -> H5Utils.onInsurance(this)
            R.id.ll_open_rent_info -> presenter.doShowRentInfo()
            R.id.ll_open_others -> presenter.doShowOthers()
            R.id.ll_account_pay -> {
                cb_account_pay.isChecked = !cb_account_pay.isChecked
                presenter.apiCalc()
            }
            R.id.ll_wkcoin_pay -> {
                cb_wkcoin_pay.isChecked = !cb_wkcoin_pay.isChecked
                presenter.apiCalc()
            }
        }
    }

    override fun setRentInfo(desc: String, amount: String) {
        tv_rent_desc.text = desc
        tv_rent_amount.text = amount
    }

    override fun setRentAmountInfo(result: OrderDetailResult) {
        val mAdapter = OrderDetailPriceAdapter(this@PayForOtherActivity, result)
        priceGv.adapter = mAdapter
    }

    override fun setInsuranceInfo(name: String, desc: String, amount: String) {
        tv_insurance_name.text = name
        tv_insurance_desc.text = desc
        tv_insurance_amount.text = amount
    }

    override fun setInsuranceDesc(b: Boolean, desc: String) {
        tv_insurance_info_desc.visibility = if (b) View.VISIBLE else View.GONE
        tv_insurance_info_desc.text = desc
    }

    override fun setOthersInfo(amount: String) {
        tv_others_amount.text = amount
    }

    override fun setCostDetailData(data: ArrayList<CostBean>) {
        mAdapter = CostDetailAdapter(this)
        mAdapter?.addData(data)
        costInfoRv.adapter = mAdapter
    }

    override fun setPackingAmount(amount: String) {
        tv_packaging_amount.text = amount
    }

    override fun setDiscountAmount(amount: String) {
        tv_discount_amount.text = amount
    }

    override fun setTotalAmount(amount: String) {
        cope_with_amount.text = amount
    }

    override fun setShowRentInfo(b: Boolean) {
        priceGv.visibility = if (b) View.VISIBLE else View.GONE
        iv_open_rent_info.setBackgroundResource(if (b) R.mipmap.up_item else R.mipmap.down_item)
    }

    override fun setShowOtherInfo(b: Boolean) {
        costInfoRv.visibility = if (b) View.VISIBLE else View.GONE
        iv_others.setBackgroundResource(if (b) R.mipmap.up_item else R.mipmap.down_item)
    }

    override fun setChannelVisibility(b: Boolean, name: String) {
        cost_end_bottom_channel.visibility = if (b) View.VISIBLE else View.INVISIBLE
        cost_end_bottom_channel.text = name
    }

    override fun setPreRentPay(b: Boolean, amount: String) {
        cost_end_bottom_rent1_layout.visibility = if (b) View.VISIBLE else View.GONE
        discount_rent.text = amount
    }

    override fun setPreDepositPay(b: Boolean, amount: String) {
        cost_end_bottom_deposit_layout.visibility = if (b) View.VISIBLE else View.GONE
        discount_deposit.text = amount
    }

    override fun setPreCouponPay(b: Boolean, amount: String) {
        cost_end_bottom_coupon_layout.visibility = if (b) View.VISIBLE else View.GONE
        discount_coupon.text = amount
    }

    override fun setPreWkCoinPay(b: Boolean, amount: String) {
        cost_end_bottom_wkcoin_layout.visibility = if (b) View.VISIBLE else View.GONE
        discount_monkey_coin.text = amount
    }

    override fun setPrePay(b: Boolean) {
        layout_renter_discount.visibility = if (b) View.GONE else View.VISIBLE
    }

    override fun setOtherAccountAvai(s: String) {
        tv_account_desc.text = s
    }

    override fun setOtherWkCoinAvai(s: String) {
        tv_wkcoin_desc.text = s
    }

    override fun setOtherAccountPay(check: Boolean, amount: String) {
        cb_account_pay.isChecked = check
        tv_account_amount.text = amount
    }

    override fun setOtherWkCoinPay(check: Boolean, amount: String) {
        cb_wkcoin_pay.isChecked = check
        tv_wkcoin_amount.text = amount
    }

    override fun setMorePay(amount: String) {
        other_payment_amount_cost.text = amount
    }

    override fun setActiveOnPay(b: Boolean) {
        if (b) onPay.normal() else onPay.disable()
    }

    override fun setChecked(check: ArrayList<String>) {
        for (id in check) {
            when (id) {
                "coupon_pay", "deposit_pay", "third_pay" -> {

                }
                "account_pay" -> {
                    ll_account_pay.isEnabled = false
                    tv_account_title.setBackgroundColor(ContextCompat.getColor(this, R.color.color_3))
                    tv_account_desc.setBackgroundColor(ContextCompat.getColor(this, R.color.color_3))
                }
                "wkcoin_pay" -> {
                    ll_wkcoin_pay.isEnabled = false
                    tv_wkcoin_title.setBackgroundColor(ContextCompat.getColor(this, R.color.color_3))
                    tv_wkcoin_desc.setBackgroundColor(ContextCompat.getColor(this, R.color.color_3))
                }
            }
        }
    }

    override fun pageClose() {
        setResult(ConstantsUtil.ORDER_REFRESH_CODE)
        finish()
    }

    override fun getBalanceCheckStatus(): Boolean {
        return cb_account_pay.isChecked
    }

    override fun getWkCoinCheckStatus(): Boolean {
        return cb_wkcoin_pay.isChecked
    }

    override fun getPreRentCheckStatus(): Boolean {
        return false
    }

    override fun getDepositCheckStatus(): Boolean {
        return false
    }

    override fun getCouponCheckStatus(): Boolean {
        return false
    }
}