package com.jiaoyinbrother.monkeyking.manager.mvpactivity.payforother

import android.content.Context
import android.content.Intent
import android.text.TextUtils
import com.jiaoyinbrother.library.base.BasePresenterImpl
import com.jiaoyinbrother.library.bean.*
import com.jiaoyinbrother.library.retrofit.BaseObserver
import com.jiaoyinbrother.library.retrofit.RetrofitHelper
import com.jiaoyinbrother.library.util.MoneyUtil
import com.jiaoyinbrother.library.util.UserUtil
import com.jiaoyinbrother.library.util.Util
import io.reactivex.android.schedulers.AndroidSchedulers
import io.reactivex.schedulers.Schedulers
import java.util.concurrent.TimeUnit

class PayForOtherPresenter(context: Context, view: IPayForOtherContract.View)
    : BasePresenterImpl<IPayForOtherContract.View>(context, view), IPayForOtherContract.Presenter {

    private var mOrderInfo: OrderDetailResult? = null
    private var isOpenRent = false
    private var isOpenOthers = false
    private var isAutoCalc = true
    private var mOrderId: String? = null
    private var mPlanID: String? = null
    private var chooseCouponsIds = ArrayList<String>()
    // 预付租金
    private var tempRent = 0
    // 押金
    private var tempDeposit = 0
    // 优惠券
    private var tempCoupon = 0
    // 悟空币
    private var tempWkCoin = 0
    //
    private var tempOtherAccountPay = 0
    private var tempOtherWkCoinPay = 0
    // 还需支付
    private var tempMorePay = 0


    private var oilPay = "0"

    override fun getData(intent: Intent) {
        mOrderInfo = intent.getSerializableExtra("order_detail") as OrderDetailResult?
        setInfoData(mOrderInfo)
    }

    private fun setInfoData(result: OrderDetailResult?) {
        mOrderId = result?.orderid
        val bill = result?.bill ?: return
        /*  租金 */
        view.setRentInfo(getDesc(result.hour_price, result.avg_price),
                MoneyUtil().getMoneyText(bill.rent_amount ?: "0"))
        view.setRentAmountInfo(result)
        /*  基本保障服务 */

        view.setInsuranceInfo(bill.insurance_amount_name ?: "",
                getDesc(result.hour_insurance.toString(), (result.basic_insurance + result.additional_insurance).toString()),
                MoneyUtil().getMoneyText(bill.insurance_amount ?: "0"))
        view.setInsuranceDesc(!TextUtils.isEmpty(bill.insurance_amount_description),
                bill.insurance_amount_description ?: "")
        /* 费用明细 */
        val detailList = ArrayList<CostBean>()
        /* 手续费 */
        if (bill.poundage_amount?.toInt() ?: 0 != 0) {
            val bean = CostBean(bill.poundage_amount_name, bill.poundage_amount, "")
            detailList.add(bean)
        }
        /* 超时租金 */
        if (bill.overtime_rent_amount?.toInt() ?: 0 != 0) {
            val bean = CostBean(bill.overtime_rent_amount_name, bill.overtime_rent_amount, "")
            detailList.add(bean)
        }
        /*超时保险*/
        if (bill.overtime_insurance_amount?.toInt() ?: 0 != 0) {
            val bean = CostBean(bill.overtime_insurance_amount_name, bill.overtime_insurance_amount, "")
            detailList.add(bean)
        }
        /*可选服务费*/
        if (!Util.isEmptyList(result.order_insurance_service)) {
            for (it in result.order_insurance_service!!) {
                if (it.amount != 0) {
                    val bean = CostBean(it.name, it.amount.toString(), "")
                    detailList.add(bean)
                }
            }
        }
        if (!Util.isEmptyList(result.order_optional_service)) {
            for (it in result.order_optional_service!!) {
                val bean = CostBean(it.name, it.amount.toString(), "")
                detailList.add(bean)
            }
        }
        /* 送车上门费 */
        if (bill.send_service_amount?.toInt() ?: 0 != 0) {
            val bean = CostBean(bill.send_service_amount_name, bill.send_service_amount, "")
            detailList.add(bean)
        }
        /* 上门取车费 */
        if (bill.return_service_amount?.toInt() ?: 0 != 0) {
            val bean = CostBean(bill.return_service_amount_name, bill.return_service_amount, "")
            detailList.add(bean)
        }
        /* 异地服务费 */
        if (bill.crosscity_service_amount?.toInt() ?: 0 != 0) {
            val bean = CostBean(bill.crosscity_service_amount_name, bill.crosscity_service_amount, "")
            detailList.add(bean)
        }
        /*夜间服务费*/
        if (bill.night_service_amount?.toInt() ?: 0 != 0) {
            val bean = CostBean(bill.night_service_amount_name, bill.night_service_amount, "")
            detailList.add(bean)
        }
        /*超里程费*/
        if (bill.miles_amount?.toInt() ?: 0 != 0) {
            val bean = CostBean(bill.miles_amount_name, bill.miles_amount, "")
            detailList.add(bean)
        }
        /*加油服务费*/
        if (bill.refueling_amount?.toInt() ?: 0 != 0) {
            val bean = CostBean(bill.refueling_amount_name, bill.refueling_amount, "")
            detailList.add(bean)
        }
        /*油(电)费*/
        if (bill.fuel_amount?.toInt() ?: 0 != 0) {
            val bean = CostBean(bill.fuel_amount_name, bill.fuel_amount, "")
            detailList.add(bean)
        }
        /*退改费*/
        if (bill.penalty_amount?.toInt() ?: 0 != 0) {
            val bean = CostBean(bill.penalty_amount_name, bill.penalty_amount, "")
            detailList.add(bean)
        }
        /*其他费*/
        if (bill.other_amount?.toInt() ?: 0 != 0) {
            val bean = CostBean(bill.other_amount_name, bill.other_amount, "")
            detailList.add(bean)
        }
        var amount = 0
        amount += bill.poundage_amount?.toInt() ?: 0
        amount += bill.overtime_rent_amount?.toInt() ?: 0
        amount += bill.overtime_insurance_amount?.toInt() ?: 0
        amount += bill.send_service_amount?.toInt() ?: 0
        amount += bill.return_service_amount?.toInt() ?: 0
        amount += bill.crosscity_service_amount?.toInt() ?: 0
        amount += bill.night_service_amount?.toInt() ?: 0
        amount += bill.miles_amount?.toInt() ?: 0
        amount += result.refueling_amount ?: 0
        amount += bill.fuel_amount?.toInt() ?: 0
        amount += bill.penalty_amount?.toInt() ?: 0
        amount += bill.other_amount?.toInt() ?: 0
        if (!Util.isEmptyList(result.order_insurance_service)) {
            for (it in result.order_insurance_service!!) {
                amount += it.amount ?: 0
            }
        }
        if (!Util.isEmptyList(result.order_optional_service)) {
            for (it in result.order_optional_service!!) {
                amount += it.amount ?: 0
            }
        }
        view.setOthersInfo(MoneyUtil().getMoneyText(amount.toString()))

        view.setCostDetailData(detailList)

        view.setPackingAmount(MoneyUtil().getMoneyText(bill.packing_amount ?: "0"))

        view.setDiscountAmount(MoneyUtil().getMoneyText(bill.discount_amount ?: "0"))

        view.setTotalAmount(MoneyUtil().getMoneyText(bill.total_amount ?: "0"))

    }

    private fun getDesc(hour: String?, avg: String?): String {
        val sb = StringBuilder()
        sb.append("(")
        if (!TextUtils.isEmpty(hour)) {
            sb.append("¥$hour/小时 ")
        }
        if (!TextUtils.isEmpty(avg)) {
            sb.append("¥$avg/日均")
        }
        sb.append(")")
        return sb.toString()
    }

    override fun doShowRentInfo() {
        isOpenRent = !isOpenRent
        view.setShowRentInfo(isOpenRent)
    }

    override fun doShowOthers() {
        isOpenOthers = !isOpenOthers
        view.setShowOtherInfo(isOpenOthers)
    }

    override fun apiCalc() {
        val request = OrderCalcRequest()
        request.orderid = mOrderId
        request.uid = UserUtil(context).uid
        request.id_type = "MOBILE"
        request.auto_calc = if (isAutoCalc) 1 else 0
        if (view.getPreRentCheckStatus()) request.third_pay = tempRent.toString()
        if (view.getDepositCheckStatus()) request.deposit_pay = tempDeposit.toString()
        if (view.getCouponCheckStatus()) request.coupons = chooseCouponsIds
        if (view.getBalanceCheckStatus()) request.account_pay = tempOtherAccountPay.toString()
        if (view.getWkCoinCheckStatus()) request.wkcoin_pay = tempOtherWkCoinPay.toString()

        val service = RetrofitHelper.getInstance(context).service
        val params = RetrofitHelper.getInstance(context).convertRequestToMap(request)
        val observable = service.orderBillCalc(params).debounce(1000, TimeUnit.MILLISECONDS)
        observable.subscribeOn(Schedulers.io()).doOnSubscribe {
            view.showLoadingDialog()
        }.observeOn(AndroidSchedulers.mainThread()).subscribe(object : BaseObserver<OrderCalcResult>(context, this) {
            override fun onSuccess(response: OrderCalcResult) {
                view.dismissLoadingDialog()
                isAutoCalc = false
                mPlanID = response.plan_id
//                mOrderCalc = response

                chooseCouponsIds.clear()
                if (!Util.isEmptyList(response.coupons)) {
                    chooseCouponsIds.addAll(response.coupons)
                }
                tempRent = 0
                tempDeposit = 0
                tempCoupon = 0
                tempWkCoin = 0
                tempOtherAccountPay = 0
                tempOtherWkCoinPay = 0

                oilPay =response.oil_pay?:"0"

                setPayForOther(response)

                if (!Util.isEmptyList(response.checked)) {
                    view.setChecked(response.checked)
                }
            }
        })
    }


    private fun setPayForOther(result: OrderCalcResult) {
        if (mOrderInfo == null) return
        // 渠道名(用户)
        if (!TextUtils.isEmpty(mOrderInfo?.channel_name)) {
            view.setChannelVisibility(true, mOrderInfo?.channel_name ?: "")
        } else {
            view.setChannelVisibility(false, "")
        }
        // 预付租金(用户)
        tempRent = MoneyUtil().getMoneyInt(result.third_pay ?: "0")
        if (tempRent != 0) {
            view.setPreRentPay(true, MoneyUtil().getMoneyText(result.third_pay ?: "0"))
        } else {
            view.setPreRentPay(false, "0")
        }
        // 押金(用户)
        tempDeposit = MoneyUtil().getMoneyInt(result.deposit_pay ?: "0")
        if (tempDeposit != 0) {
            view.setPreDepositPay(true, MoneyUtil().getMoneyText(result.deposit_pay ?: "0"))
        } else {
            view.setPreDepositPay(false, "0")
        }
        // 优惠券(用户)
        chooseCouponsIds.clear()
        chooseCouponsIds.addAll(result.coupons)
        tempCoupon = MoneyUtil().getMoneyInt(result.coupon_pay ?: "0")
        if (tempCoupon != 0) {
            view.setPreCouponPay(true, MoneyUtil().getMoneyText(result.coupon_pay ?: "0"))
        } else {
            view.setPreCouponPay(false, "0")
        }
        // 悟空币(用户)
        tempWkCoin = MoneyUtil().getMoneyInt(result.wkcoin_pay ?: "0")
        if (tempWkCoin != 0) {
            view.setPreWkCoinPay(true, MoneyUtil().getMoneyText(result.wkcoin_pay ?: "0"))
        } else {
            view.setPreWkCoinPay(false, "0")
        }
        view.setPrePay(tempCoupon == 0 && tempWkCoin == 0 && tempDeposit == 0 && tempRent == 0)

        // 专员账户余额
        tempOtherAccountPay = MoneyUtil().getMoneyInt(result.other_account_pay ?: "0")
        view.setOtherAccountAvai(if (TextUtils.isEmpty(result.other_account_avai_pay)) "(可用¥0)" else "(可用¥${result.other_account_avai_pay})")
        if (tempOtherAccountPay > 0) {
            view.setOtherAccountPay(true, MoneyUtil().getMoneyText(result.other_account_pay ?: "0"))
        } else {
            view.setOtherAccountPay(false, "￥0")
        }
        // 专员悟空币
        tempOtherWkCoinPay = MoneyUtil().getMoneyInt(result.other_wkcoin_pay ?: "0")
        view.setOtherWkCoinAvai(if (TextUtils.isEmpty(result.other_wkcoin_avai_pay)) "(可用¥0)" else "(可用¥${result.other_wkcoin_avai_pay})")
        if (tempOtherWkCoinPay > 0) {
            view.setOtherWkCoinPay(true, MoneyUtil().getMoneyText(result.other_wkcoin_pay ?: "0"))
        } else {
            view.setOtherWkCoinPay(false, "￥0")
        }
        // 还需支付
        tempMorePay = MoneyUtil().getMoneyInt(result.more_pay ?: "0")

        view.setMorePay(MoneyUtil().getMoneyText(result.more_pay ?: "0"))
        if (tempMorePay != 0 && tempMorePay == (tempOtherAccountPay + tempOtherWkCoinPay)) {
            view.setActiveOnPay(true)
        } else {
            view.setActiveOnPay(false)
        }
    }


    override fun apiAccept() {
        val request = AcceptForOtherBean()
        request.orderid = mOrderId
        request.uid = UserUtil(context).uid
        request.accept = 1
        request.plan_id = mPlanID
        request.type = "CONFIRM"
        request.account_pay = 0
        request.wkcoin_pay = if (tempWkCoin > 0) tempWkCoin else 0
        request.third_pay = if (tempRent > 0) tempRent else 0
        request.deposit_pay = if (tempDeposit > 0) tempDeposit else 0
        request.coupon_pay = if (tempCoupon > 0) tempCoupon else 0
        request.coupons = chooseCouponsIds
        request.other_account_pay = if (tempOtherAccountPay > 0) tempOtherAccountPay else 0
        request.other_wkcoin_pay = if (tempOtherWkCoinPay > 0) tempOtherWkCoinPay else 0
        request.oil_pay = oilPay

        val service = RetrofitHelper.getInstance(context).service
        val params = RetrofitHelper.getInstance(context).convertRequestToMap(request)
        val observable = service.orderAccept(params).debounce(1000, TimeUnit.MILLISECONDS)
        observable.subscribeOn(Schedulers.io()).doOnSubscribe {
            view.showLoadingDialog()
        }.observeOn(AndroidSchedulers.mainThread()).subscribe(object : BaseObserver<BaseResult>(context, this) {
            override fun onSuccess(response: BaseResult) {
                view.dismissLoadingDialog()
                isAutoCalc = false
                view.showToast("代客支付成功")
                view.pageClose()
            }
        })

    }
}