package com.jiaoyinbrother.monkeyking.manager.mvpactivity.price.batch

import android.content.Context
import android.content.Intent
import com.jiaoyinbrother.library.base.BasePresenterImpl
import com.jiaoyinbrother.library.bean.PriceBatchItemBean
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.price.batch.PriceBatchActivity.Companion.AC_PRICE_BATCH_LIST

/**
 * @author zhangbo
 * @date 2020/7/24
 * Email : b.zhang@wkzuche.com
 * Describe:
 */
class PriceBatchPresenter(context: Context, view: IPriceBatchContract.View) : BasePresenterImpl<IPriceBatchContract.View>(context, view),
        IPriceBatchContract.Presenter {

    private var list: ArrayList<PriceBatchItemBean> = ArrayList()

    private var getIntentList: ArrayList<PriceBatchItemBean> = ArrayList()

    override fun initIntent(intent: Intent) {

        val initList = intent.getSerializableExtra(AC_PRICE_BATCH_LIST) as? ArrayList<PriceBatchItemBean>

        if (initList != null){

            getIntentList.addAll(initList)
        }

        if (getIntentList.size > 0){

            for (item in getIntentList){

                val bean = PriceBatchItemBean()
                bean.startTime = item.startTime
                bean.endTime = item.endTime
                bean.price = item.price

                list.add(bean)
            }
        }else {

            list.add(PriceBatchItemBean())
            getIntentList.add(PriceBatchItemBean())
        }

        list.add(PriceBatchItemBean())
        getIntentList.add(PriceBatchItemBean())

        view.setList(list)

    }

    fun isSame():Boolean {
        if (getIntentList === list) return true
        val e1: ListIterator<PriceBatchItemBean> = list.listIterator()
        val e2 = getIntentList.listIterator()
        while (e1.hasNext() && e2.hasNext()) {
            val o1: PriceBatchItemBean = e1.next()
            val o2 = e2.next()
            if (o1 != o2) return false
        }
        return !(e1.hasNext() || e2.hasNext())
    }
}