package com.jiaoyinbrother.monkeyking.manager.mvpactivity.price.fragment.based

import com.jiaoyinbrother.library.base.IBasePresenter
import com.jiaoyinbrother.library.bean.PriceDetailResult
import com.jiaoyinbrother.library.bean.PriceUpdateRequest
import com.jiaoyinbrother.library.view.IBaseView

interface IPriceBasedContract {

    interface View : IBaseView {

        fun setCarImage(image: String?)
        fun setCarType(type: String?)
        fun setCarInfo(info: String?)
        fun setCarDeposit(amount: String)
        fun setIllegalDeposit(amount: String)
        fun setDayInsurance(amount: String)
        fun setHourInsurance(amount: String)
        fun setPoundage(amount: String)
        fun setCarService(amount: String)
        fun setDayRent(amount: String)
        fun setHourRent(amount: String)

        fun setShowAlert(title: String, content: String)

        fun setUpdateDone()

        fun setFirstAfter()

        fun setActiveSubmit(b: Boolean)

        /**
         * get fun
         *
         */
        fun getDepositCar(): String?
        fun getDepositIllegal(): String?
        fun getInsuranceDay(): String?
        fun getInsuranceHour(): String?
        fun getPoundage(): String?
        fun getAdditional(): String?
        fun getRentDay(): String?
        fun getRentHour(): String?
    }

    interface Presenter : IBasePresenter {

        var siteCarTypeId:Int
        var limitCheck :Int


        fun getData(data: PriceDetailResult?)
        fun checkBasedPrice()
        fun sureBasedPrice()

        fun onChangeRentDay(amount: String?)
        fun onChangeRange(type:String)
        fun onTipsDialog()

    }
}