package com.jiaoyinbrother.monkeyking.manager.mvpactivity.price.fragment.calendar

import android.content.Intent
import android.support.v4.app.Fragment
import com.jiaoyinbrother.library.base.IBasePresenter
import com.jiaoyinbrother.library.bean.HolidaysBean
import com.jiaoyinbrother.library.bean.OtherBean
import com.jiaoyinbrother.library.bean.PriceDetailResult
import com.jiaoyinbrother.library.view.IBaseView
import com.monkey.datetimelibrary.entity.PriceDateEntity
import com.monkey.datetimelibrary.entity.PriceMonthEntity

interface IPriceCalendarContract {

    interface View : IBaseView {
        fun setCalendarData(data: ArrayList<PriceMonthEntity>?)
        fun setCarImage(image: String)
        fun setCarType(type: String)
        fun setCarInfo(info: String)
        fun setAbnormalTips(desc: String)
        fun setAbnormalTipVisible(visible: Boolean)
        fun setShowAlert(title: String, content: String)
        fun setUpdateDone()
        fun setActiveSubmit(b: Boolean)
        fun setFirstAfter()
    }

    interface Presenter : IBasePresenter {
        fun init()
        fun getData(data: PriceDetailResult?)
        fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?)
        fun onAbnormalModify(fragment: Fragment)
        fun onBatchModify(fragment: Fragment)
        fun onWeekModify(fragment: Fragment)
        fun onHolidayModify(fragment: Fragment)
        fun apiSpiderDeal(siteCarTypeId: Int, status: String)
        fun checkPriceUpdate()
        fun surePriceUpdate()
    }
}