package com.jiaoyinbrother.monkeyking.manager.mvpactivity.price.fragment.calendar

import android.arch.lifecycle.Observer
import android.content.Intent
import android.os.Bundle
import android.view.View
import com.bumptech.glide.Glide
import com.jeremyliao.livedatabus.LiveDataBus
import com.jiaoyinbrother.library.bean.PriceDetailResult
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseFragment
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.price.PriceSetActivity
import com.jiaoyinbrother.monkeyking.manager.view.IOSdialog.IOSAlertDialog
import com.monkey.datetimelibrary.entity.PriceMonthEntity
import kotlinx.android.synthetic.main.fragment_calendar_price.*

class PriceCalendarFragment : MvpBaseFragment<PriceCalendarPresenter>(), IPriceCalendarContract.View {


    companion object {
        fun newInstance(): PriceCalendarFragment {
            return PriceCalendarFragment()
        }
    }

    override fun initPresenter(): PriceCalendarPresenter {
        return PriceCalendarPresenter(requireContext(), this)
    }

    override fun getLayoutId(): Int {
        return R.layout.fragment_calendar_price
    }

    override fun initToolbar(savedInstanceState: Bundle?) {}

    override fun initViews(view: View?, savedInstanceState: Bundle?) {}

    override fun initData() {
        // 初始化日历
        presenter.init()

        setActiveSubmit(false)

        LiveDataBus.get().with(PriceSetActivity.PRICE_INFO, PriceDetailResult::class.java).observe(this, Observer {
            presenter.getData(it)
        })
    }

    override fun initListeners() {
        rb_based_price?.setOnClickListener {
            LiveDataBus.get().with(PriceSetActivity.SWITCH_RADIO).setValue(false)
        }
        // 修改异常价格
        tips_dispose?.setOnClickListener {
            presenter.onAbnormalModify(this)
        }

        // 批量修改价格
        change_batch?.setOnClickListener {
            presenter.onBatchModify(this)
        }

        // 按周修改价格
        change_week?.setOnClickListener {
            presenter.onWeekModify(this)
        }

        // 按节日修改价格
        change_holiday?.setOnClickListener {
            presenter.onHolidayModify(this)
        }

        on_submit_calendar?.setOnClickListener {
            presenter.checkPriceUpdate()
        }
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        presenter.onActivityResult(requestCode, resultCode, data)
    }

    override fun setCalendarData(data: ArrayList<PriceMonthEntity>?) {
        price_date_view?.setData(PriceCalendarPresenter.NUM_MONTH_OF_CALENDAR, data)
    }

    override fun setCarImage(image: String) {
        carPic?.let {
            Glide.with(requireContext())
                    .load(image)
                    .placeholder(R.mipmap.bg_place_image)
                    .error(R.mipmap.bg_place_image)
                    .into(it)
        }
    }

    override fun setCarType(type: String) {
        carType?.text = type
    }

    override fun setCarInfo(info: String) {
        carInfo?.text = info
    }

    override fun setAbnormalTips(desc: String) {
        abnormal_price_tip?.text = desc
    }

    override fun setAbnormalTipVisible(visible: Boolean) {
        tips_layout?.visibility = if (visible) View.VISIBLE else View.GONE
    }

    override fun setShowAlert(title: String, content: String) {
        IOSAlertDialog(requireContext())
                .builder()
                .setTitle(title)
                .setMsg(content, true)
                .setRightButton("执行调价") {
                    presenter.surePriceUpdate()
                }
                .setLeftButton("取消调价") {}
                .show()
    }

    override fun setUpdateDone() {
        IOSAlertDialog(requireContext())
                .builder()
                .setCancelable(false)
                .setMsg("设置成功", true)
                .setRightButton("确定") {
                    LiveDataBus.get().with(PriceSetActivity.REFRESH_PRICE).setValue(true)
                    setActiveSubmit(false)
                }.show()
    }

    override fun setActiveSubmit(b: Boolean) {
        if (b) on_submit_calendar?.normal() else on_submit_calendar?.disable()
    }

    override fun setFirstAfter() {
        presenter.setEditState(false)
        on_submit_calendar?.disable()
    }
}
