package com.jiaoyinbrother.monkeyking.manager.mvpactivity.price.week

import android.app.Activity
import android.content.Context
import android.content.Intent
import android.support.v7.app.AlertDialog
import android.text.TextUtils
import android.view.View
import com.jiaoyinbrother.library.bean.PriceWeekBean
import com.jiaoyinbrother.library.util.TextUtil
import com.jiaoyinbrother.library.util.doOnTextChanged
import com.jiaoyinbrother.library.widget.GeneralBottomButton
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseActivity
import com.jiaoyinbrother.monkeyking.manager.mvpdialog.selectdate.SelectDateMVPDialog
import com.jiaoyinbrother.monkeyking.manager.view.IOSdialog.IOSAlertDialog
import kotlinx.android.synthetic.main.activity_price_week.*
import java.text.SimpleDateFormat
import java.util.*

class PriceWeekActivity : MvpBaseActivity<PriceWeekPresenter>(), PriceWeekContract.View, SelectDateMVPDialog.OnResultListener {
    override fun initListeners() {
        ac_price_week_start_time_tv.setOnClickListener(::click)
        ac_price_week_end_time_tv.setOnClickListener(::click)
        ac_price_week_save_tv.setListener(object : GeneralBottomButton.SubmitListener {
            override fun submit() {
                saveTime()
            }
        })
        ac_price_week_monday_et.doOnTextChanged { s: CharSequence?,
                                                  _: Int,
                                                  _: Int,
                                                  _: Int ->
            if (TextUtil.isZeroBegin(s.toString())) {
                ac_price_week_monday_et?.setText("")
            }
        }

        ac_price_week_tuesday_et.doOnTextChanged { s: CharSequence?,
                                                   _: Int,
                                                   _: Int,
                                                   _: Int ->
            if (TextUtil.isZeroBegin(s.toString())) {
                ac_price_week_tuesday_et?.setText("")
            }
        }
        ac_price_week_wednesday_et.doOnTextChanged { s: CharSequence?,
                                                     _: Int,
                                                     _: Int,
                                                     _: Int ->
            if (TextUtil.isZeroBegin(s.toString())) {
                ac_price_week_wednesday_et?.setText("")
            }
        }
        ac_price_week_thursday_et.doOnTextChanged { s: CharSequence?,
                                                    _: Int,
                                                    _: Int,
                                                    _: Int ->
            if (TextUtil.isZeroBegin(s.toString())) {
                ac_price_week_thursday_et?.setText("")
            }
        }
        ac_price_week_friday_et.doOnTextChanged { s: CharSequence?,
                                                  _: Int,
                                                  _: Int,
                                                  _: Int ->
            if (TextUtil.isZeroBegin(s.toString())) {
                ac_price_week_friday_et?.setText("")
            }
        }
        ac_price_week_saturday_et.doOnTextChanged { s: CharSequence?,
                                                    _: Int,
                                                    _: Int,
                                                    _: Int ->
            if (TextUtil.isZeroBegin(s.toString())) {
                ac_price_week_saturday_et?.setText("")
            }
        }
        ac_price_week_sunday_et.doOnTextChanged { s: CharSequence?,
                                                  _: Int,
                                                  _: Int,
                                                  _: Int ->
            if (TextUtil.isZeroBegin(s.toString())) {
                ac_price_week_sunday_et?.setText("")
            }
        }

    }

    override fun initPresenter(): PriceWeekPresenter {
        return PriceWeekPresenter(this, this)
    }

    override fun initToolBar() {
        mainTitle.text = "按周修改"
    }

    override fun initData() {
        presenter.getIntent(intent)
    }

    override fun getLayoutId(): Int {
        return R.layout.activity_price_week
    }

    override fun initView() {}

    private fun saveTime() {
        val monday = ac_price_week_monday_et?.text?.toString()
        val tuesday = ac_price_week_tuesday_et?.text?.toString()
        val wednesday = ac_price_week_wednesday_et?.text?.toString()
        val thursday = ac_price_week_thursday_et?.text?.toString()
        val friday = ac_price_week_friday_et?.text?.toString()
        val saturday = ac_price_week_saturday_et?.text?.toString()
        val sunday = ac_price_week_sunday_et?.text?.toString()
        if (
                TextUtils.isEmpty(monday)
                && TextUtils.isEmpty(tuesday)
                && TextUtils.isEmpty(wednesday)
                && TextUtils.isEmpty(thursday)
                && TextUtils.isEmpty(friday)
                && TextUtils.isEmpty(saturday)
                && TextUtils.isEmpty(sunday)
        ) {
            showToast("请至少填写一天的租金")
            return
        }
        presenter.getData(monday,
                tuesday,
                wednesday,
                thursday,
                friday,
                saturday,
                sunday,
                ac_price_week_start_time_tv.text.toString(),
                ac_price_week_end_time_tv.text.toString()
        )
        setResult(Activity.RESULT_OK, Intent().putExtra(KEY_PRICE_WEEK_BEAN, presenter.newPriceWeekBean)
                .putExtra(NEED_MODIFY, true))
        finish()
    }


    private fun click(v: View) {
        SelectDateMVPDialog.newMainDialog(
                ac_price_week_start_time_tv?.text?.toString(),
                ac_price_week_end_time_tv?.text?.toString(),
                if (v.id == ac_price_week_start_time_tv.id) {
                    SelectDateMVPDialog.SELECT_DATE_TAB_START
                } else {
                    SelectDateMVPDialog.SELECT_DATE_TAB_END
                },
                this,
                supportFragmentManager)
    }

    override fun onBackPressed() {
        presenter.getData(ac_price_week_monday_et?.text?.toString(),
                ac_price_week_tuesday_et?.text?.toString(),
                ac_price_week_wednesday_et?.text?.toString(),
                ac_price_week_thursday_et?.text?.toString(),
                ac_price_week_friday_et?.text?.toString(),
                ac_price_week_saturday_et?.text?.toString(),
                ac_price_week_sunday_et?.text?.toString(),
                ac_price_week_start_time_tv?.text?.toString(),
                ac_price_week_end_time_tv?.text?.toString()
        )
        if (presenter.newPriceWeekBean == intent.getSerializableExtra(KEY_PRICE_WEEK_BEAN)) {
            finish()
        } else {
            IOSAlertDialog(this)
                    .builder()
                    .setTitle("温馨提示")
                    .setMsg("存在未保存的设置，请确认是否仍要离开", true)
                    .setRightButton("不离开") {
                    }
                    .setLeftButton("离开") {
                        setResult(Activity.RESULT_OK, Intent().putExtra(KEY_PRICE_WEEK_BEAN, presenter.newPriceWeekBean)
                                .putExtra(NEED_MODIFY, false))
                        super.onBackPressed()
                    }
                    .show()
        }
    }

    companion object {
        const val KEY_PRICE_WEEK_BEAN = "KEY_PRICE_WEEK_BEAN"
        const val NEED_MODIFY = "NEED_MODIFY"
        fun newInstance(context: Context, priceWeekBean: PriceWeekBean?) = Intent().apply {
            setClass(context, PriceWeekActivity::class.java)
            putExtra(KEY_PRICE_WEEK_BEAN, priceWeekBean)
        }
    }

    override fun onConfirm(startDate: Date?, endDate: Date?) {
        val simpleDateFormat = SimpleDateFormat("yyyy-MM-dd", Locale.CHINA)
        val startDateString = simpleDateFormat.format(startDate)
        val endDateString = simpleDateFormat.format(endDate)
        setDateUI(startDateString, endDateString)
    }

    override fun setDateUI(startDateString: String?, endDateString: String?) {
        ac_price_week_start_time_tv?.text = startDateString
        ac_price_week_end_time_tv?.text = endDateString
    }

    override fun setPriceUI(mondayPrice: Int?, tuesdayPrice: Int?, wednesdayPrice: Int?, thursdayPrice: Int?, fridayPrice: Int?, saturdayPrice: Int?, sundayPrice: Int?) {
        ac_price_week_monday_et.setText(mondayPrice?.toString() ?: "")
        ac_price_week_tuesday_et.setText(tuesdayPrice?.toString() ?: "")
        ac_price_week_wednesday_et.setText(wednesdayPrice?.toString() ?: "")
        ac_price_week_thursday_et.setText(thursdayPrice?.toString() ?: "")
        ac_price_week_friday_et.setText(fridayPrice?.toString() ?: "")
        ac_price_week_saturday_et.setText(saturdayPrice?.toString() ?: "")
        ac_price_week_sunday_et.setText(sundayPrice?.toString() ?: "")
    }

}
