package com.jiaoyinbrother.monkeyking.manager.mvpactivity.price.week

import android.content.Context
import android.content.Intent
import android.text.TextUtils
import com.jiaoyinbrother.library.base.BasePresenterImpl
import com.jiaoyinbrother.library.bean.PriceWeekBean
import com.jiaoyinbrother.library.util.DateTimeUtil
import java.text.SimpleDateFormat
import java.util.*

class PriceWeekPresenter(context: Context, view: PriceWeekContract.View) : BasePresenterImpl<PriceWeekContract.View>(context, view),
        PriceWeekContract.Presenter {

    override fun getIntent(intent: Intent?) {

        var bean = intent?.getSerializableExtra(PriceWeekActivity.KEY_PRICE_WEEK_BEAN) as? PriceWeekBean
        if (bean == null){
            bean = PriceWeekBean()
            intent?.putExtra(PriceWeekActivity.KEY_PRICE_WEEK_BEAN,bean)
        }
        val simpleDateFormat = SimpleDateFormat("yyyy-MM-dd", Locale.CHINA)
        bean.startTime = if (TextUtils.isEmpty(bean.startTime)) simpleDateFormat.format(Date()) else bean.startTime
        bean.endTime = if (TextUtils.isEmpty(bean.endTime)) simpleDateFormat.format(DateTimeUtil.getTheLastDayAfterMonths(5)) else bean.endTime
        newPriceWeekBean.startTime = bean.startTime
        newPriceWeekBean.endTime = bean.endTime
        newPriceWeekBean.weekPrice.putAll(bean.weekPrice)
        view.setDateUI(newPriceWeekBean.startTime, newPriceWeekBean.endTime)
        view.setPriceUI(
                newPriceWeekBean.weekPrice[PriceWeekBean.MONDAY],
                newPriceWeekBean.weekPrice[PriceWeekBean.TUESDAY],
                newPriceWeekBean.weekPrice[PriceWeekBean.WEDNESDAY],
                newPriceWeekBean.weekPrice[PriceWeekBean.THURSDAY],
                newPriceWeekBean.weekPrice[PriceWeekBean.FRIDAY],
                newPriceWeekBean.weekPrice[PriceWeekBean.SATURDAY],
                newPriceWeekBean.weekPrice[PriceWeekBean.SUNDAY]
        )
    }


    override fun getData(
            monday: String?,
            tuesday: String?,
            wednesday: String?,
            thursday: String?,
            friday: String?,
            saturday: String?,
            sunday: String?,
            start_time: String?,
            end_time: String?
    ) {
        putPrice(PriceWeekBean.MONDAY, monday)
        putPrice(PriceWeekBean.TUESDAY, tuesday)
        putPrice(PriceWeekBean.WEDNESDAY, wednesday)
        putPrice(PriceWeekBean.THURSDAY, thursday)
        putPrice(PriceWeekBean.FRIDAY, friday)
        putPrice(PriceWeekBean.SATURDAY, saturday)
        putPrice(PriceWeekBean.SUNDAY, sunday)
        newPriceWeekBean.startTime = start_time
        newPriceWeekBean.endTime = end_time
    }

    private fun putPrice(monday: Int, price: String?) {
        if (price == null || price.isEmpty()) {
            newPriceWeekBean.weekPrice.remove(monday)
        } else {
            newPriceWeekBean.weekPrice[monday] = price.toInt()
        }
    }

    override var newPriceWeekBean: PriceWeekBean = PriceWeekBean()
}