package com.jiaoyinbrother.monkeyking.manager.mvpactivity.price.worry

import android.app.Activity
import android.content.Intent
import android.view.View
import com.jiaoyinbrother.library.bean.OtherBean
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseActivity
import com.jiaoyinbrother.monkeyking.manager.view.IOSdialog.IOSAlertDialog
import kotlinx.android.synthetic.main.activity_price_worry.*

class PriceWorryActivity : MvpBaseActivity<PriceWorryPresenter>(), IPriceWorryContract.View {
    private val adapter: PriceWorryAdapter by lazy {
        PriceWorryAdapter()
    }

    override fun initListeners() {
        ac_price_worry_leave_tv.setOnClickListener(::onLeave)
        ac_price_worry_save_tv.setOnClickListener {
            val list = presenter.list ?: ArrayList<OtherBean>()
            var over = false
            for (index in list.indices) {
                val otherBean = list[index]
                if (otherBean.abnormal == null || otherBean.abnormal == 0) {
                    adapter.showErrorBg = true
                    adapter.notifyItemChanged(index)
                    over = true
                }
            }
            if (over) {
                showToast("请完善空白处的价格信息")
                return@setOnClickListener
            }
            setResult(Activity.RESULT_OK, Intent().putExtra(NEED_MODIFY, true).putExtra(WORRY_PRICE_LIST_KEY, list))
            finish()
        }
    }

    private fun onLeave(v: View) {
        IOSAlertDialog(this)
                .builder()
                .setTitle("温馨提示")
                .setMsg("是否确认不处理今日的异常价格数据", true)
                .setRightButton("去处理") {
                }
                .setLeftButton("暂不处理") {
                    setResult(Activity.RESULT_OK, Intent().putExtra(NEED_MODIFY, false).putExtra(NEED_GONE, true))
                    super.onBackPressed()
                }
                .show()
    }

    override fun initPresenter(): PriceWorryPresenter {
        return PriceWorryPresenter(this, this)
    }

    override fun initToolBar() {
        mainTitle?.text = "异常价格处理"
    }

    override fun initData() {
        presenter.getData(intent)
    }

    override fun getLayoutId(): Int {
        return R.layout.activity_price_worry
    }

    override fun initView() {
        ac_price_worry_rv.adapter = adapter
    }

    override fun onBackPressed() {
        if (isSame()) {
            super.onBackPressed()
        } else {
            IOSAlertDialog(this)
                    .builder()
                    .setTitle("温馨提示")
                    .setMsg("存在未保存的设置，请确认是否仍要离开", true)
                    .setRightButton("不离开") {
                    }
                    .setLeftButton("离开") {
                        setResult(Activity.RESULT_OK, Intent()
                                .putExtra(NEED_MODIFY, false)
                                .putExtra(NEED_GONE, false)
                                .putExtra(WORRY_PRICE_LIST_KEY, presenter.list))
                        super.onBackPressed()
                    }
                    .show()
        }
    }

    private fun isSame():Boolean {
        val o = (intent?.getSerializableExtra(WORRY_PRICE_LIST_KEY) as? ArrayList<OtherBean>) ?:ArrayList<OtherBean>()
        val list = presenter.list?:ArrayList<OtherBean>()
        if (o === list) return true
        val e1 = list.listIterator()
        val e2 = o.listIterator()
        while (e1.hasNext() && e2.hasNext()) {
            val o1 = e1.next()
            val o2 = e2.next()
            if (o1 != o2) return false
        }
        return !(e1.hasNext() || e2.hasNext())
    }

    companion object {
        const val NEED_MODIFY = "NEED_MODIFY"
        const val NEED_GONE = "NEED_GONE"
        const val WORRY_PRICE_LIST_KEY = "WORRY_PRICE_LIST_KEY"
    }

    override fun updateList() {
        adapter.list = presenter.list
    }
}