package com.jiaoyinbrother.monkeyking.manager.mvpactivity.price.worry

import android.text.Editable
import android.text.TextWatcher
import android.widget.EditText
import android.widget.TextView
import com.camnter.easyrecyclerview.adapter.EasyRecyclerViewAdapter
import com.camnter.easyrecyclerview.holder.EasyRecyclerViewHolder
import com.jiaoyinbrother.library.bean.OtherBean
import com.jiaoyinbrother.library.util.TextUtil
import com.jiaoyinbrother.monkeyking.manager.R

class PriceWorryAdapter : EasyRecyclerViewAdapter() {
    var showErrorBg = false
    override fun getRecycleViewItemType(position: Int): Int {
        return 0
    }

    override fun onBindRecycleViewHolder(viewHolder: EasyRecyclerViewHolder?, position: Int) {
        viewHolder?.let { holder ->
            val otherBean = list[position] as? OtherBean
            val tv_time = holder.findViewById<TextView>(R.id.item_price_worry_time_tv)
            val tv_before_price = holder.findViewById<TextView>(R.id.item_price_worry_before_price_tv)
            val et_after_price = holder.findViewById<EditText>(R.id.item_price_worry_after_price_et)
            tv_time?.text = otherBean?.start_time ?: ""
            tv_before_price?.text = "¥${otherBean?.day}"
            val abnormal = otherBean?.abnormal
            et_after_price?.setText(if (abnormal == 0) "" else abnormal.toString())

            if (showErrorBg) {
                et_after_price?.setBackgroundResource(
                        if (abnormal == null || abnormal == 0) {
                            R.drawable.shape_price_week_et_error_bg
                        } else {
                            R.drawable.shape_price_week_et_bg
                        })
            } else {
                et_after_price?.setBackgroundResource(R.drawable.shape_price_week_et_bg)
            }
            et_after_price?.addTextChangedListener(object : TextWatcher {
                override fun afterTextChanged(s: Editable?) {
                    holder.findViewById<EditText>(R.id.item_price_worry_after_price_et)?.setBackgroundResource(R.drawable.shape_price_week_et_bg)
                    val toString = s.toString()
                    (list[holder.adapterPosition] as? OtherBean)?.abnormal = if (toString.isEmpty()) 0 else toString.toInt()

                }

                override fun beforeTextChanged(s: CharSequence?, start: Int, count: Int, after: Int) {}

                override fun onTextChanged(s: CharSequence?, start: Int, before: Int, count: Int) {
                    if (TextUtil.isZeroBegin(s.toString())) {
                        holder.findViewById<EditText>(R.id.item_price_worry_after_price_et)?.setText("")
                    }
                }

            })

        }
    }

    override fun getItemLayouts(): IntArray {
        return intArrayOf(R.layout.item_price_worry)
    }
}