package com.jiaoyinbrother.monkeyking.manager.mvpactivity.store.list

import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.TextView
import com.camnter.easyrecyclerview.holder.EasyRecyclerViewHolder
import com.jiaoyinbrother.library.bean.SiteBean
import com.jiaoyinbrother.monkeyking.manager.R
import com.wk.common.button.WkButton
import kotlinx.android.parcel.TypeParceler

class StoreListAdapter(private val list: List<SiteBean>, private val type: Int) : RecyclerView.Adapter<EasyRecyclerViewHolder>() {

    companion object {
        const val STORE_ENTITY = 0
        const val STORE_VIRTUAL = 1
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): EasyRecyclerViewHolder {
        return EasyRecyclerViewHolder(LayoutInflater.from(parent.context).inflate(R.layout.item_store_list, parent, false))
    }

    override fun onBindViewHolder(holder: EasyRecyclerViewHolder, position: Int) {
        val siteBean = list[position]
        holder.findViewById<TextView>(R.id.tv_store_name)?.text = siteBean.name ?: ""
        holder.findViewById<TextView>(R.id.tv_store_time)?.text = "营业时间：${getShortTime(siteBean.from_time ?: "")}-${getShortTime(siteBean.to_time ?: "")}"
        holder.findViewById<TextView>(R.id.tv_store_contact)?.text = "联系方式：${siteBean.contact ?: ""} ${siteBean.site_phone ?: ""}"

        holder.findViewById<WkButton>(R.id.btn_virtual_store)?.visibility =
                if (type == STORE_ENTITY && siteBean.virtual_site_count > 0) View.VISIBLE else View.GONE

        holder.findViewById<WkButton>(R.id.btn_virtual_store)?.setOnClickListener {
            listener?.onVirtualStore(position, siteBean)
        }
        holder.findViewById<WkButton>(R.id.btn_base_rule)?.setOnClickListener {
            listener?.onBaseRule(position, siteBean)
        }
    }

    private fun getShortTime(time: String): String {
        return if (time.length < 5) {
            time
        } else {
            time.subSequence(0, 5).toString()
        }
    }

    override fun getItemCount(): Int {
        return list.size
    }


    private var listener: StoreListListener? = null

    fun setListener(listener: StoreListListener) {
        this.listener = listener
    }

    interface StoreListListener {
        fun onVirtualStore(position: Int, data: SiteBean)
        fun onBaseRule(position: Int, data: SiteBean)
    }
}