package com.jiaoyinbrother.monkeyking.manager.mvpactivity.store.modify

import android.content.Intent
import android.support.v4.app.FragmentManager
import com.jiaoyinbrother.library.base.IBasePresenter
import com.jiaoyinbrother.library.bean.SiteResult
import com.jiaoyinbrother.library.view.IBaseView

interface IStoreModifyInfoContract {

    interface View : IBaseView {
        /**
         * 显示内容
         */
        fun restoreData(siteResult: SiteResult?)

        /**
         * 关闭编辑
         */
        fun closeView()

        /**
         * 更新夜间服务费
         */
        fun updateNightServiceAmount(text: String)

        /**
         * 更新营业时间
         */
        fun showBusinessTime(startDate: String, endDate: String)
        /**
         * 虚拟网店同步网点信息开关
         */
        fun getSyncSiteStatus():Boolean
    }

    interface Presenter : IBasePresenter {

        var isVirtualSite:Boolean
        /**
         * 网络获取门店详情
         */
        fun apiSiteDetail()

        /**
         * 初始化intent
         */
        fun initIntent(intent: Intent?)

        /**
         * 重置数据展示
         */
        fun restoreData()

        /**
         * 提交门店信息修改
         */
        fun apiModifySite(contact: String,
                          phone: String,
                          fromTime: String,
                          toTime: String,
                          intervalTime: Int,
                          prepareTime: Int,
                          minimum: Int,
                          nightServiceAmount: String)

        /**
         * 检查数据是否修改，返回true则表示数据有修改
         */
        fun checkChange(contact: String,
                        phone: String,
                        fromTime: String,
                        toTime: String,
                        intervalTime: String,
                        prepareTime: String,
                        minimum: String,
                        nightServiceAmount: String
        ): Boolean

        /**
         * 显示夜间服务费弹窗
         */
        fun showServiceAmountDialog(text: String)

        /**
         * 显示营业时间弹窗
         */
        fun showTimeDialog(supportFragmentManager: FragmentManager, time: String)
    }
}