package com.jiaoyinbrother.monkeyking.manager.mvpactivity.store.modify

import android.app.Activity
import android.content.Context
import android.content.Intent
import android.text.TextUtils
import android.view.View
import com.jiaoyinbrother.library.bean.SiteResult
import com.jiaoyinbrother.library.listeners.TextWatcherListener
import com.jiaoyinbrother.library.util.DensityUtil
import com.jiaoyinbrother.library.util.Util
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseActivity
import com.jiaoyinbrother.monkeyking.manager.view.IOSdialog.IOSAlertDialog
import kotlinx.android.synthetic.main.activity_store_modify_info.*
import java.lang.Exception
import java.lang.NumberFormatException

class StoreModifyInfoActivity : MvpBaseActivity<StoreModifyInfoPresenter>(), IStoreModifyInfoContract.View {

    override fun getLayoutId(): Int {
        return R.layout.activity_store_modify_info
    }

    override fun initView() {
        closeView()
    }

    override fun initToolBar() {
        presenter.isVirtualSite = intent?.getBooleanExtra(ISVIRTUAL, false) ?: false
        mainTitle?.text = getPageTitle()
        subTitle?.text = "修改"
        subTitle?.setOnClickListener {
            openView()
            presenter.restoreData()
        }

        if (presenter.isVirtualSite){
            tv_12?.setCompoundDrawables(null,null,null,null);
            tv_15?.setCompoundDrawables(null,null,null,null);
        }
    }


    private fun getPageTitle(): String {
        return if (presenter.isVirtualSite) "虚拟网点信息" else "门店信息"

    }

    private fun openView() {
        presenter.restoreData()
        mainTitle?.text = "修改${getPageTitle()}"
        subTitle?.text = ""
        tv_store_code?.isEnabled = true
        tv_site_name?.isEnabled = true
        tv_site_city?.isEnabled = true
        tv_site_address?.isEnabled = true
        val dip11 = DensityUtil.dip2px(this, 11F)
        val dip8 = DensityUtil.dip2px(this, 8F)
        et_site_contact?.isEnabled = true
        et_site_contact?.setHint("请输入")
        et_site_contact?.setPadding(dip11, dip8, dip11, dip8)
        et_site_phone?.isEnabled = true
        et_site_phone?.setHint("请输入")
        et_site_phone?.setPadding(dip11, dip8, dip11, dip8)
        etwu_prepare_time?.isEnabled = true
        etwu_prepare_time?.setHint("请输入")
        etwu_prepare_time?.setPadding(dip11, dip8, dip11, dip8)
        etwu_minimum?.isEnabled = true
        etwu_minimum?.setHint("请输入")
        etwu_minimum?.setPadding(dip11, dip8, dip11, dip8)
        wk_btn_submit?.visibility = View.VISIBLE
        layout_rule_tip?.visibility = View.VISIBLE
        // 虚拟网点不能修改营业时间 & 订单间隔时间 & 夜间服务费
        if (presenter.isVirtualSite){
            tv_16?.visibility = View.VISIBLE
            btn_sync_site?.visibility = View.VISIBLE
            modify_tips?.text = "设置虚拟网点规则信息前，请点击上方规则查看说明"
        } else{
            // 营业时间
            tv_business_time?.isEnabled = true
            tv_business_time?.setHint("请输入")
            tv_business_time?.setPadding(dip11, dip8, dip11, dip8)
            // 订单间隔时间
            etwu_interval_time?.isEnabled = true
            etwu_interval_time?.setHint("请输入")
            etwu_interval_time?.setPadding(dip11, dip8, dip11, dip8)
            // 夜间服务费
            etwu_night_service_amount?.isEnabled = true
            etwu_night_service_amount?.setHint("请输入")
            etwu_night_service_amount?.setPadding(dip11, dip8, dip11, dip8)
            modify_tips?.text = "设置门店规则信息前，请点击上方规则查看说明"
        }
    }

    override fun closeView() {
        presenter.restoreData()
        mainTitle?.text = getPageTitle()
        subTitle?.text = "修改"
        tv_store_code?.isEnabled = false
        tv_site_name?.isEnabled = false
        tv_site_city?.isEnabled = false
        tv_site_address?.isEnabled = false
        val dip8 = DensityUtil.dip2px(this, 8F)
        et_site_contact?.isEnabled = false
        et_site_contact?.setHint(et_site_contact?.text)
        et_site_contact?.setText("")
        et_site_contact?.setPadding(0, dip8, 0, dip8)
        et_site_phone?.isEnabled = false
        et_site_phone?.setHint("")
        et_site_phone?.setPadding(0, dip8, 0, dip8)
        tv_business_time?.isEnabled = false
        tv_business_time?.setHint("")
        tv_business_time?.setPadding(0, dip8, 0, dip8)
        etwu_interval_time?.isEnabled = false
        etwu_interval_time?.setHint("")
        etwu_interval_time?.setPadding(0, dip8, 0, dip8)
        etwu_prepare_time?.isEnabled = false
        etwu_prepare_time?.setHint("")
        etwu_prepare_time?.setPadding(0, dip8, 0, dip8)
        etwu_minimum?.isEnabled = false
        etwu_minimum?.setHint("")
        etwu_minimum?.setPadding(0, dip8, 0, dip8)
        etwu_night_service_amount?.isEnabled = false
        etwu_night_service_amount?.setHint("")
        etwu_night_service_amount?.setPadding(0, dip8, 0, dip8)
        wk_btn_submit?.visibility = View.GONE
        et_site_contact?.setBackgroundResource(R.drawable.select_store_modify_edittext_bg)
        et_site_phone?.setBackgroundResource(R.drawable.select_store_modify_edittext_bg)
        tv_business_time?.setBackgroundResource(R.drawable.select_store_modify_edittext_bg)
        etwu_interval_time?.setBackgroundResource(R.drawable.select_store_modify_edittext_bg)
        etwu_prepare_time?.setBackgroundResource(R.drawable.select_store_modify_edittext_bg)
        etwu_minimum?.setBackgroundResource(R.drawable.select_store_modify_edittext_bg)
        etwu_night_service_amount?.setBackgroundResource(R.drawable.select_store_modify_edittext_bg)
        layout_rule_tip?.visibility = View.GONE
        tv_16?.visibility = View.GONE
        btn_sync_site?.visibility = View.GONE
        btn_sync_site?.isChecked = false
    }

    override fun updateNightServiceAmount(text: String) {
        etwu_night_service_amount?.setText(text)
        checkButton()
    }

    override fun showBusinessTime(startDate: String, endDate: String) {
        tv_business_time?.text = "${startDate}${TIME_JOINER}${endDate}"
        checkButton()
    }

    override fun onBackPressed() {
        if (TextUtils.isEmpty(subTitle?.text)) {
            closeView()
        } else {
            val intent = Intent()
                    .putExtra(CONTACT, et_site_contact?.hint?.toString() ?: "")
                    .putExtra(PHONE, et_site_phone?.text?.toString() ?: "")
                    .putExtra(TIME, tv_business_time?.text?.toString() ?: "")
                    .putExtra(POSITION, intent?.getIntExtra(POSITION, -1) ?: -1)
            setResult(Activity.RESULT_OK, intent)
            super.onBackPressed()
        }
    }

    override fun initData() {
        presenter.initIntent(intent)
        presenter.apiSiteDetail()
    }

    override fun initListeners() {
        wk_btn_submit?.setOnClickListener {
            val showData = getShowData()
            val phone = showData[PHONE] ?: ""
            if (!Util.isPhoneNumber(phone)) {
                showToast("请输入正确的手机号/座机号")
                return@setOnClickListener
            }
            val intervalTime = try {
                (showData[INTERVAL_TIME] ?: "").toInt()
            } catch (e: Exception) {
                -1
            }
            if (intervalTime < 0 || intervalTime > 180) {
                showToast("订单时间间隔只允许输入0-180之间的整数")
                return@setOnClickListener
            }
            val prepareTime = try {
                (showData[PREPARE_TIME] ?: "").toInt()
            } catch (e: Exception) {
                -1
            }
            if (prepareTime < 0 || prepareTime > 1440) {
                showToast("准备时间只允许输入0~1440之间的整数")
                return@setOnClickListener
            }
            val minimum = try {
                (showData[MINIMUM] ?: "").toInt()
            } catch (e: Exception) {
                -1
            }
            if (minimum < 1 || minimum > 7) {
                showToast("起租时间只允许输入1-7之间的整数")
                return@setOnClickListener
            }

            if (presenter.isVirtualSite && getSyncSiteStatus()){

                IOSAlertDialog(this).builder()
                        .setTitle("修改提示")
                        .setMsg("您已选择将其他虚拟网点也做上述修改，包括“网点电话、联系人、准备时间、起租时间”四处信息，请确认是否执行修改", false)
                        .setRightButton("确认") {
                            presenter.apiModifySite(
                                    showData[CONTACT] ?: "",
                                    phone,
                                    showData[FROM_TIME] ?: "",
                                    showData[TO_TIME] ?: "",
                                    intervalTime,
                                    prepareTime,
                                    minimum,
                                    showData[NIGHT_SERVICE_AMOUNT] ?: ""
                            )
                        }
                        .setLeftButton("取消"){}
                        .show()
            } else{
                presenter.apiModifySite(
                        showData[CONTACT] ?: "",
                        phone,
                        showData[FROM_TIME] ?: "",
                        showData[TO_TIME] ?: "",
                        intervalTime,
                        prepareTime,
                        minimum,
                        showData[NIGHT_SERVICE_AMOUNT] ?: ""
                )
            }
        }
        tv_12?.setOnClickListener {
            IOSAlertDialog(this).builder()
                    .setTitle("订单时间间隔")
                    .setMsg("同一辆车的两个订单之间的最短间隔时间为X分钟，请设置0-180分钟之间的时间", false)
                    .setRightButton("知道了") {}
                    .show()
        }
        tv_13?.setOnClickListener {
            IOSAlertDialog(this).builder()
                    .setTitle("准备时间")
                    .setMsg("车辆准备时间，用户只能提前X分钟预订，请设置0-1440分钟之间的时间", false)
                    .setRightButton("知道了") {}
                    .show()
        }
        tv_14?.setOnClickListener {
            IOSAlertDialog(this).builder()
                    .setTitle("起租时间")
                    .setMsg("用户只能预订租期≥X小时的订单，请设置1-7小时之间的时间", false)
                    .setRightButton("知道了") {}
                    .show()
        }
        tv_15?.setOnClickListener {
            IOSAlertDialog(this).builder()
                    .setTitle("夜间服务费")
                    .setMsg("此费用为单次（取车或还车）服务费用", false)
                    .setRightButton("知道了") {}
                    .show()
        }
        et_site_contact?.addTextChangedListener(object : TextWatcherListener() {

            override fun onTextChanged(s: CharSequence?, start: Int, before: Int, count: Int) {
                et_site_contact?.setBackgroundResource(
                        if (s?.length ?: 0 == 0) {
                            R.drawable.bg_item_price_batch_et_error
                        } else {
                            R.drawable.select_store_modify_edittext_bg
                        }
                )
                checkButton()
            }

        })
        et_site_phone?.addTextChangedListener(object : TextWatcherListener() {
            override fun onTextChanged(s: CharSequence?, start: Int, before: Int, count: Int) {
                et_site_phone?.setBackgroundResource(
                        if (s?.length ?: 0 == 0 || Util.isPhoneNumber(et_site_phone?.text.toString()).not()) {
                            R.drawable.bg_item_price_batch_et_error
                        } else {
                            R.drawable.select_store_modify_edittext_bg
                        }
                )
                checkButton()
            }
        })
        etwu_interval_time?.addTextChangedListener(object : TextWatcherListener() {
            override fun onTextChanged(s: CharSequence?, start: Int, before: Int, count: Int) {
                etwu_interval_time?.setBackgroundResource(
                        if (s?.length ?: 0 == 0) {
                            R.drawable.bg_item_price_batch_et_error
                        } else {
                            val time = try {
                                Integer.parseInt(etwu_interval_time?.getText() ?: "-1")
                            } catch (e: NumberFormatException) {
                                -1
                            }
                            if (time < 0 || time > 180) {
                                R.drawable.bg_item_price_batch_et_error
                            } else {
                                R.drawable.select_store_modify_edittext_bg
                            }
                        })
                checkButton()
            }
        })
        etwu_prepare_time?.addTextChangedListener(object : TextWatcherListener() {
            override fun onTextChanged(s: CharSequence?, start: Int, before: Int, count: Int) {
                etwu_prepare_time?.setBackgroundResource(
                        if (s?.length ?: 0 == 0) {
                            R.drawable.bg_item_price_batch_et_error
                        } else {
                            val time = try {
                                Integer.parseInt(etwu_prepare_time?.getText() ?: "-1")
                            } catch (e: NumberFormatException) {
                                -1
                            }
                            if (time < 0 || time > 1440) {
                                R.drawable.bg_item_price_batch_et_error
                            } else {
                                R.drawable.select_store_modify_edittext_bg
                            }
                        })
                checkButton()
            }

        })
        etwu_minimum?.addTextChangedListener(object : TextWatcherListener() {
            override fun onTextChanged(s: CharSequence?, start: Int, before: Int, count: Int) {
                etwu_minimum?.setBackgroundResource(
                        if (s?.length ?: 0 == 0) {
                            R.drawable.bg_item_price_batch_et_error
                        } else {
                            val time = try {
                                Integer.parseInt(etwu_minimum?.getText() ?: "-1")
                            } catch (e: NumberFormatException) {
                                -1
                            }
                            if (time < 1 || time > 7) {
                                R.drawable.bg_item_price_batch_et_error
                            } else {
                                R.drawable.select_store_modify_edittext_bg
                            }
                        })
                checkButton()
            }

        })
        etwu_night_service_amount?.setOnClickListener {
            presenter.showServiceAmountDialog(etwu_night_service_amount?.getText() ?: "")
        }
        tv_business_time?.setOnClickListener {
            presenter.showTimeDialog(supportFragmentManager, tv_business_time?.text?.toString()
                    ?: "00:00${TIME_JOINER}00:00")
        }
    }

    private fun getShowData(): Map<String, String> {
        val contact = et_site_contact?.text?.toString() ?: ""
        val phone = et_site_phone?.text?.toString() ?: ""
        val businessTime = tv_business_time?.text?.toString() ?: ""
        val intervalTime = etwu_interval_time.getText()
        val prepareTime = etwu_prepare_time.getText()
        val minimum = etwu_minimum.getText()
        val nightServiceAmount = etwu_night_service_amount.getText()
        val split = businessTime.split(TIME_JOINER)
        val (fromTime, toTime) = if (split.size < 2) {
            Pair("", "")
        } else {
            Pair(
                    if (TextUtils.isEmpty(split[0].trim())) "" else "${split[0].trim()}:00",
                    if (TextUtils.isEmpty(split[1].trim())) "" else "${split[1].trim()}:00"
            )
        }
        return mapOf(
                CONTACT to contact,
                PHONE to phone,
                FROM_TIME to fromTime,
                TO_TIME to toTime,
                INTERVAL_TIME to intervalTime,
                PREPARE_TIME to prepareTime,
                MINIMUM to minimum,
                NIGHT_SERVICE_AMOUNT to nightServiceAmount
        )
    }

    private fun checkButton() {
        val showData = getShowData()
        val contact = showData[CONTACT] ?: ""
        val phone = showData[PHONE] ?: ""
        val fromTime = showData[FROM_TIME] ?: ""
        val toTime = showData[TO_TIME] ?: ""
        val intervalTime = showData[INTERVAL_TIME] ?: ""
        val prepareTime = showData[PREPARE_TIME] ?: ""
        val minimum = showData[MINIMUM] ?: ""
        val nightServiceAmount = showData[NIGHT_SERVICE_AMOUNT] ?: ""
        if (
                TextUtils.isEmpty(contact) ||
                TextUtils.isEmpty(phone) ||
                TextUtils.isEmpty(fromTime) ||
                TextUtils.isEmpty(toTime) ||
                TextUtils.isEmpty(intervalTime) ||
                TextUtils.isEmpty(prepareTime) ||
                TextUtils.isEmpty(minimum) ||
                TextUtils.isEmpty(nightServiceAmount)
        ) {
            wk_btn_submit?.isEnabled = false
            return
        }
        wk_btn_submit?.isEnabled = presenter.checkChange(contact,
                phone,
                fromTime,
                toTime,
                intervalTime,
                prepareTime,
                minimum,
                nightServiceAmount)

    }

    override fun initPresenter(): StoreModifyInfoPresenter {
        return StoreModifyInfoPresenter(this, this)
    }


    companion object {
        const val TIME_JOINER = "-"
        const val SITE_ID = "SITE_ID"
        const val CONTACT = "contact"
        const val PHONE = "phone"
        private const val FROM_TIME = "fromTime"
        private const val TO_TIME = "toTime"
        private const val INTERVAL_TIME = "intervalTime"
        private const val PREPARE_TIME = "prepareTime"
        private const val MINIMUM = "minimum"
        private const val NIGHT_SERVICE_AMOUNT = "nightServiceAmount"
        const val TIME = "time"
        const val POSITION = "position"
        const val ISVIRTUAL = "isVirtual"

        fun newIntent(context: Context, id: String, isVirtualStore: Boolean, position: Int = -1): Intent {
            return Intent(context, StoreModifyInfoActivity::class.java).putExtra(SITE_ID, id).putExtra(POSITION, position).putExtra(ISVIRTUAL, isVirtualStore)
        }
    }

    override fun restoreData(siteResult: SiteResult?) {
        tv_store_code?.text = siteResult?.id ?: ""
        tv_site_name?.text = siteResult?.name ?: ""
        tv_site_city?.text = siteResult?.city ?: ""
        tv_site_address?.text = siteResult?.address ?: ""
        et_site_contact?.setText(siteResult?.contact ?: "")
        et_site_phone.setText(siteResult?.site_phone ?: "")
        tv_business_time?.text = "${getShortTime(siteResult?.from_time ?: "")}${TIME_JOINER}${getShortTime(siteResult?.to_time ?: "")}"
        etwu_interval_time?.setText("${siteResult?.order_interval_time ?: "0"}")
        etwu_prepare_time?.setText("${siteResult?.prepare_time ?: "0"}")
        etwu_minimum?.setText("${siteResult?.minimum ?: "0"}")
        etwu_night_service_amount?.setText("${siteResult?.night_service_amount ?: "0"}")
    }

    private fun getShortTime(time: String): String {
        return if (time.length < 5) {
            time
        } else {
            time.subSequence(0, 5).toString()
        }
    }

    override fun getSyncSiteStatus(): Boolean {
        return btn_sync_site?.isChecked ?: false
    }
}