package com.jiaoyinbrother.monkeyking.manager.mvpactivity.storeinfo

import android.content.Context
import com.jiaoyinbrother.library.base.IBasePresenter
import com.jiaoyinbrother.library.bean.LocationBean
import com.jiaoyinbrother.library.bean.RereplyBean
import com.jiaoyinbrother.library.view.IBaseView
import java.lang.StringBuilder

interface IStoreInfoContract {

    interface IStoreInfoView : IBaseView {
        fun getDataError()
        fun getDataSuccess()
        fun setStoreIcon(url: String?)
        fun setStoreName(name: String?)
        fun setStoreContent(content: StringBuilder?)
        fun setStoreTime(time: StringBuilder?)
        fun setStoreCall(call: String?)
        fun setStoreCommentScore(score: Double)
        fun setStoreCommentState(state: String?)
        fun setStoreCommentHardware(hardware: Double)
        fun setStoreCommentService(service: Double)
        fun setStoreCommentClean(clean: Double)
        fun setStoreCommentConvenient(convenient: Double)
        fun setCommentIsNull()
        fun setShowBrandJM(title: String?)
        fun setStoreAddress(address: String?)
        fun setStoreLocation(location: LocationBean?)

        //底部显示评论内容相关
        fun setStoreCommentShowAvatar(url: String?)

        fun setStoreCommentShowName(name: String?)
        fun setStoreCommentShowTime(time: String?)
        fun setStoreCommentShowScore(score: String?)
        fun setStoreCommentShowContent(content: String?)
        fun setStoreCommentShowImages(images: List<String>)
        fun setStoreCommentShowReplay(list: List<RereplyBean>)
    }

    interface IStoreInfoPresenter : IBasePresenter {
        fun getStoreInfo()
        fun initLiveDataBus(activity: StoreInfoActivity)
        fun goCommentListActivity(context: Context)
    }
}