package com.jiaoyinbrother.monkeyking.manager.mvpactivity.storeinfo

import android.graphics.Canvas
import android.graphics.Paint
import android.graphics.drawable.Drawable
import android.support.v7.widget.GridLayoutManager
import android.text.SpannableString
import android.text.SpannableStringBuilder
import android.text.TextUtils
import android.text.style.ImageSpan
import android.view.View
import android.widget.TextView
import com.bumptech.glide.Glide
import com.bumptech.glide.load.resource.bitmap.CircleCrop
import com.bumptech.glide.request.RequestOptions
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseActivity
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.commentlist.NineImageAdapter
import com.jiaoyinbrother.library.bean.LocationBean
import com.jiaoyinbrother.library.bean.RereplyBean
import com.jiaoyinbrother.library.bean.SiteBean
import com.jiaoyinbrother.library.util.DensityUtil
import com.jiaoyinbrother.library.util.SpaceItemDecoration
import kotlinx.android.synthetic.main.activity_store_info.*
import kotlinx.android.synthetic.main.item_newcomment_list.*
import java.lang.StringBuilder
import java.util.regex.Pattern

class StoreInfoActivity : MvpBaseActivity<StoreInfoPresenter>(), IStoreInfoContract.IStoreInfoView,
        View.OnClickListener {
    override fun getDataError() {

    }

    override fun getDataSuccess() {
        store_info_no_data.visibility = View.GONE
    }

    override fun setStoreIcon(url: String?) {
        if (url == null || url.isEmpty()) {
            Glide.with(this).load(R.mipmap.icon_store_normal).into(store_info_logo)
        } else {
//            if (isAlive)
            Glide.with(this).load(url).into(store_info_logo)
        }
    }

    override fun setStoreName(name: String?) {
        store_info_name.text = name
    }

    override fun setStoreContent(content: StringBuilder?) {
        store_info_content.text = content
    }


    override fun setStoreTime(time: StringBuilder?) {
        store_info_info_time_content.text = time
    }

    private var mStoreCall: String? = null
    override fun setStoreCall(call: String?) {
        mStoreCall = call
        store_info_info_call_content.text = call
    }

    override fun setStoreCommentScore(score: Double) {
        comment_info_num.text = "" + score
    }

    override fun setStoreCommentState(state: String?) {
        comment_info_desc.text = state
    }

    override fun setStoreCommentHardware(hardware: Double) {
        comment_info_car_hardware_title.text = "车辆硬件 $hardware"
        comment_info_car_hardware_ratingbar.progress = (hardware * 10).toInt()

    }

    override fun setStoreCommentService(service: Double) {
        comment_info_service_title.text = "服务水平 $service"
        comment_info_service_ratingbar.progress = (service * 10).toInt()
    }

    override fun setStoreCommentClean(clean: Double) {
        comment_info_car_clean_title.text = "车辆清洁 $clean"
        comment_info_car_clean_ratingbar.progress = (clean * 10).toInt()
    }

    override fun setStoreCommentConvenient(convenient: Double) {
        comment_info_convenient_title.text = "取还便捷 $convenient"
        comment_info_convenient_ratingbar.progress = (convenient * 10).toInt()
    }

    override fun setCommentIsNull() {
        store_info_bottom_layout.visibility = View.GONE
        store_info_comment_null.visibility = View.VISIBLE
    }


    override fun setShowBrandJM(title: String?) {
        if (title != null)
            store_info_name.text = setStoreName(title)
    }

    private var mStoreAddress: String? = null
    override fun setStoreAddress(address: String?) {
        mStoreAddress = address
        store_info_info_address_content.text = address
    }

    private var mStoreLocation: LocationBean? = null
    override fun setStoreLocation(location: LocationBean?) {
        mStoreLocation = location
    }

    override fun setStoreCommentShowAvatar(url: String?) {

//        if (isAlive)
        Glide.with(this).load(url).apply(
                RequestOptions
                        .bitmapTransform(CircleCrop())
                        .placeholder(R.mipmap.icon_default_head)
                        .error(R.mipmap.icon_default_head)
        ).into(item_comment_avatar)
    }

    override fun setStoreCommentShowName(name: String?) {
        item_comment_phone.text = name
    }

    override fun setStoreCommentShowTime(time: String?) {
        item_comment_date.text = time
    }

    override fun setStoreCommentShowScore(score: String?) {
        item_comment_state.text = score
    }

    override fun setStoreCommentShowContent(content: String?) {
        item_comment_content.text = content
    }

    override fun setStoreCommentShowImages(images: List<String>) {
        if (images.isEmpty()) {
            item_comment_images_recycler.visibility = View.GONE
        } else {
            item_comment_images_recycler.visibility = View.VISIBLE
            val layoutManager = GridLayoutManager(this, 3, GridLayoutManager.VERTICAL, false)
            item_comment_images_recycler?.layoutManager = layoutManager
            item_comment_images_recycler?.addItemDecoration(SpaceItemDecoration(this, 7, 3))
            val mImageAdapter = NineImageAdapter(this)
            mImageAdapter.list = images
            item_comment_images_recycler?.adapter = mImageAdapter
        }
    }

    override fun setStoreCommentShowReplay(list: List<RereplyBean>) {
        if (list.isEmpty()) {
            item_comment_store_msg?.visibility = View.GONE
        } else {
            item_comment_store_msg?.visibility = View.VISIBLE
            item_comment_store_msg_type1?.visibility = View.GONE
            item_comment_store_msg_time1?.visibility = View.GONE
            item_comment_store_msg_content1?.visibility = View.GONE
            val rereplyBean = list[0]
            item_comment_store_msg_type0?.text = rereplyBean.title
            item_comment_store_msg_time0?.text = rereplyBean.time
            item_comment_store_msg_content0?.text = rereplyBean.comment
            if (list.size > 1) {
                item_comment_store_msg_type1?.visibility = View.VISIBLE
                item_comment_store_msg_time1?.visibility = View.VISIBLE
                item_comment_store_msg_content1?.visibility = View.VISIBLE
                val rereplyBean1 = list[1]
                item_comment_store_msg_type1?.text = rereplyBean1.title
                item_comment_store_msg_time1?.text = rereplyBean1.time
                item_comment_store_msg_content1?.text = rereplyBean1.comment
            }
        }
    }

    private var mToolBarTitle: TextView? = null
    private var site: SiteBean? = null
    private var siteid = ""
    private var mFromType = 0

    companion object {
        //        网点详情类型
//        提交订单页 更换
        val TYPE_FROM_BOOK = 1

        //        选车列表，更换网点 预订
        val TYPE_FROM_CARLIST_CHANGE_SITE = 2

        //        列表页点击网点；和车辆详情，类型一致 gone
        val TYPE_FROM_CAR_DETAIL = 3

        //        主页搜索地址 预订
        val TYPE_FROM_MAIN_SEARCH_ADDRESS = 4

        //        主页网点 预订
        val TYPE_FROM_MAIN_SITES = 5
    }


    override fun initListeners() {
        store_info_comment_more.setOnClickListener(this)
    }

    override fun initPresenter(): StoreInfoPresenter {
        return StoreInfoPresenter(this, this)
    }

    override fun getLayoutId(): Int {
        return R.layout.activity_store_info
    }

    override fun initView() {
        mToolBarTitle = findViewById(R.id.ivTitleName)
    }

    override fun initToolBar() {
        mToolBarTitle?.text = "门店主页"
    }

    override fun initData() {
        mFromType = intent.getIntExtra("SiteDetailFromType", 0)
        if (intent.getSerializableExtra("siteDetail") != null) {
            site = intent.getSerializableExtra("siteDetail") as SiteBean
        }
        siteid = intent.getStringExtra("siteDetailId")


        presenter.initLiveDataBus(this)
    }

    override fun onClick(v: View?) {
        when (v?.id) {
            R.id.store_info_comment_more -> {//评论查看更多
                presenter.goCommentListActivity(this)
            }
        }
    }

    private fun setStoreName(name: String): SpannableStringBuilder {
        val titleSp = SpannableStringBuilder()
        titleSp.append(name)
        val logoTag = "★"
        titleSp.append(logoTag)
        val patternLogo = Pattern.compile(logoTag)
        val matcherLogo = patternLogo.matcher(titleSp)
        if (matcherLogo.find()) {
            val drawable = resources.getDrawable(R.mipmap.icon_store_info_name_mark)
            drawable.setBounds(0, 0, DensityUtil.dip2px(this, 24f), DensityUtil.dip2px(this, 14f))
            titleSp.setSpan(
                    CustomImageSpan(drawable),
                    matcherLogo.start(),
                    matcherLogo.end(),
                    SpannableString.SPAN_EXCLUSIVE_EXCLUSIVE
            )//SPAN_EXCLUSIVE_EXCLUSIVE代表只对所选范围内文字生效
        }
        return titleSp
    }

    class CustomImageSpan(drawable: Drawable) : ImageSpan(drawable) {

        override fun getSize(paint: Paint, text: CharSequence?, start: Int, end: Int, fm: Paint.FontMetricsInt?): Int {
            val drawable = drawable
            val rect = drawable.bounds

            if (fm != null) {
                val fmPaint = paint.fontMetricsInt
                val fontHeight = fmPaint.bottom - fmPaint.top
                val drawableHeight = rect.bottom - rect.top

                val top = drawableHeight / 2 - fontHeight / 4
                val bottom = drawableHeight / 2 + fontHeight / 4

                // ascent: 字体最上端到基线的距离，为负值。
                // descent：字体最下端到基线的距离，为正值。
                fm.ascent = -bottom
                fm.top = -bottom
                fm.bottom = top
                fm.descent = top
            }
            return rect.right
//            return super.getSize(paint, text, start, end, fm)
        }

        override fun draw(
                canvas: Canvas,
                text: CharSequence?,
                start: Int,
                end: Int,
                x: Float,
                top: Int,
                y: Int,
                bottom: Int,
                paint: Paint
        ) {
            canvas.save()
            val drawable = drawable
            val transY = ((bottom - top) - drawable.bounds.bottom) / 2 + top + 3
            canvas.translate(x + 10, transY.toFloat())
            drawable.draw(canvas)
            canvas.restore()
        }
    }


}

