package com.jiaoyinbrother.monkeyking.manager.mvpactivity.systemnotification


import android.view.View
import android.widget.TextView
import com.jiaoyinbrother.library.bean.BaseResult
import com.jiaoyinbrother.library.bean.BulletinsBean
import com.jiaoyinbrother.library.bean.BulletinsResult
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.adapter.SystNotificationAdapter
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseActivity
import kotlinx.android.synthetic.main.activity_syst_notification.*
import kotlinx.android.synthetic.main.main_title.*

class SystNotificationActivity : MvpBaseActivity<SysNotificationPresenter>(), SysNotiffcationContract.view {


    override fun onSuccessMessageStatus(result: BaseResult?) {
        mMessage?.unread = 0
        mAdapter?.notifyDataSetChanged()
        if (mMessage != null) {
            presenter?.onMessageDetail(mMessage!!)
        }
    }


    override fun onSuccessMessageList(result: BulletinsResult?) {
        refresh_layout?.refreshIsEnd()
        refresh_layout?.loadMoreIsEnd()
        if (result?.bulletins?.size ?: 0 > 0) {
            if (pageNo == 1) {
                mAdapter?.list = result?.bulletins
                mAdapter?.notifyDataSetChanged()
            } else {
                mAdapter?.list?.addAll(result?.bulletins!!)
                mAdapter?.notifyDataSetChanged()
            }
            pageNo++
        } else {
            //完全没有数据时候，不弹
            if (mAdapter?.itemCount ?: 0 > 0)
                showToast("没有更多数据")
        }
        handleNoData()
    }

    override fun onFailedMessageList() {
        refresh_layout?.refreshIsEnd()
        refresh_layout?.loadMoreIsEnd()
        handleNoData()
    }


    private var mAdapter: SystNotificationAdapter? = null
    private var pageNo = 1
    private var mMessage: BulletinsBean? = null

    override fun initListeners() {
        refresh_layout?.setRefreshListener {
            pageNo = 1
            presenter?.getSysTipList(pageNo)
        }
        refresh_layout?.setMoreListener {
            presenter?.getSysTipList(pageNo)
        }

        mAdapter?.setOnItemClickListener { v, position ->
            val list = mAdapter?.list as List<BulletinsBean>?
            val messageORMBean = list?.get(position)
            mMessage = messageORMBean
            if (mMessage != null) {
                if (mMessage?.unread ?: 0 == 1) {
                    //未读消息
                    presenter?.requestMessageStatus(mMessage!!)
                } else {
                    presenter?.onMessageDetail(mMessage!!)
                }
            }
        }

    }

    override fun initPresenter(): SysNotificationPresenter {
        return SysNotificationPresenter(this, this)
    }

    override fun getLayoutId(): Int {
        return R.layout.activity_syst_notification
    }

    override fun initView() {
        mAdapter = SystNotificationAdapter(this)
        rv_announcement?.adapter = mAdapter
        refresh_layout?.setFooter()
    }

    override fun initToolBar() {
        ivTitleName?.text = resources.getString(R.string.system_notification)
        ivTitleBtnRight_ll?.visibility = View.VISIBLE
        ivTitleRightText?.text = "全标已读"
    }

    override fun initData() {
        presenter?.getSysTipList(pageNo)
    }

    private fun handleNoData() {
        if (mAdapter?.itemCount ?: 0 > 0) {
            refresh_layout?.visibility = View.VISIBLE
            systnotification_no_list?.visibility = View.GONE
        } else {
            refresh_layout?.visibility = View.GONE
            systnotification_no_list?.visibility = View.VISIBLE
            systnotification_no_list?.setTitleContent("竟然一条消息都没有")
        }
    }

    /**
     * 全标已读点击事件
     */
    fun onTitleRight_ll(view: View) {
        if (mAdapter?.itemCount?:0 > 0) {
            presenter?.requestMessageAllRead()
        }
    }


    override fun onAllReadRefresh() {
        val list = mAdapter?.list as? List<BulletinsBean>?
        if (list != null && list?.size?:0 > 0) {
            for (item in list) {
                item.unread = 0
            }
            mAdapter?.notifyDataSetChanged()
        }
    }

}
