package com.jiaoyinbrother.monkeyking.manager.mvpactivity.timebooksuccess

import android.content.Context
import com.jiaoyinbrother.library.base.BasePresenterImpl
import com.jiaoyinbrother.library.bean.*
import com.jiaoyinbrother.library.retrofit.BaseObserver
import com.jiaoyinbrother.library.retrofit.RetrofitHelper
import com.jiaoyinbrother.library.retrofit.RetrofitHelper2
import com.jiaoyinbrother.library.util.LogUtil
import io.reactivex.android.schedulers.AndroidSchedulers
import io.reactivex.schedulers.Schedulers
import java.util.concurrent.TimeUnit

/**
 * Created by admin on 2018/7/12.
 */
class TimeBookSuccessPresenter(context: Context, view: TimeBookSuccessView) : BasePresenterImpl<TimeBookSuccessView>(context, view) {

    fun requestOrderDetail(request: TimeOrderDetailRequest) {
        LogUtil.e("TimeBookSuccessPresenter    ---------------")
        val service = RetrofitHelper.getInstance(context).service

        val params = RetrofitHelper.getInstance(context).convertRequestToMap(request)

        val observable = service.timeOrderDetail(params).debounce(1000, TimeUnit.MILLISECONDS)

        observable.subscribeOn(Schedulers.io()).doOnSubscribe {

            view.showLoadingDialog()

        }.observeOn(AndroidSchedulers.mainThread()).subscribe(object : BaseObserver<TimeOrderDetailResult>(context,this) {
            override fun onSuccess(response: TimeOrderDetailResult?) {
                view.dismissLoadingDialog()

                if(response!=null)
                    view.onOrderDetail(response)

            }
        })
    }

    fun requestStartUnlock(request: TimeUnlockingRequest) {

        val service = RetrofitHelper2.getInstance(context).service

        val params = RetrofitHelper2.getInstance(context).convertRequestToMap(request)

        val observable = service.timeUnlocking(params).debounce(1000, TimeUnit.MILLISECONDS)

        observable.subscribeOn(Schedulers.io()).doOnSubscribe {

            view.showLoadingDialog()

        }.observeOn(AndroidSchedulers.mainThread()).subscribe(object : BaseObserver<BaseResult>(context,this) {
            override fun onSuccess(response: BaseResult?) {
                view.dismissLoadingDialog()

                view.onStartUnlockSuccess()
            }
        })
    }

    fun getOrderCancelCheck(request: TimeCheckCancelRequest) {
        val service = RetrofitHelper.getInstance(context).service

        val params = RetrofitHelper.getInstance(context).convertRequestToMap(request)

        val observable = service.timeCheckCancel(params).debounce(1000, TimeUnit.MILLISECONDS)

        observable.subscribeOn(Schedulers.io()).doOnSubscribe {

            view.showLoadingDialog()

        }.observeOn(AndroidSchedulers.mainThread()).subscribe(object : BaseObserver<TimeCheckCancelResult>(context,this) {
            override fun onSuccess(response: TimeCheckCancelResult?) {
                view.dismissLoadingDialog()

                view.setCheckCancel(response)
            }

        })
    }

    fun postTimeUserRequest(request: UserDetailRequestBean) {

        val service = RetrofitHelper.getInstance(context).service

        val params = RetrofitHelper.getInstance(context).convertRequestToMap(request)

        val observable = service.timeUserGetDetail(params).debounce(1000, TimeUnit.MILLISECONDS)

        observable.subscribeOn(Schedulers.io()).doOnSubscribe {
            view.showLoadingDialog()
        }.observeOn(AndroidSchedulers.mainThread()).subscribe(object : BaseObserver<UserDetailResult>(context,this) {
            override fun onSuccess(response: UserDetailResult?) {
                view.dismissLoadingDialog()
                if(response!=null)
                    view.onUserDetail(response)


            }
        })

    }

    fun requestCarControl(request: TimeCarControlRequest) {
        val service = RetrofitHelper2.getInstance(context).service
        val params = RetrofitHelper2.getInstance(context).convertRequestToMap(request)
        val observable = service.timeCarControl(params).debounce(1000, TimeUnit.MILLISECONDS)
        observable
                .subscribeOn(Schedulers.io())
                .doOnSubscribe {
                    view.showLoadingDialog()
                }
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(object : BaseObserver<BaseResult>(context,this) {
                    override fun onSuccess(response: BaseResult) {
                        view.dismissLoadingDialog()
                        view.onCarControlSuccess()
                    }
                })
    }
}