package com.jiaoyinbrother.monkeyking.manager.mvpactivity.timecancelorder

import android.content.Context
import com.jiaoyinbrother.library.base.BasePresenterImpl
import com.jiaoyinbrother.library.bean.BaseResult
import com.jiaoyinbrother.library.bean.TimeOrderCancelRequest
import com.jiaoyinbrother.library.retrofit.ApiException
import com.jiaoyinbrother.library.retrofit.BaseObserver
import com.jiaoyinbrother.library.retrofit.RetrofitHelper2
import io.reactivex.android.schedulers.AndroidSchedulers
import io.reactivex.schedulers.Schedulers
import java.util.concurrent.TimeUnit

/**
 * Created by Administrator on 2018/7/26.
 */

class TimeCancelOrderPresenter(context: Context, view: TimeCancelOrderContract.View) : BasePresenterImpl<TimeCancelOrderContract.View>(context, view),
        TimeCancelOrderContract.Presenter {


    override fun orderCancel(request: TimeOrderCancelRequest) {
        val service = RetrofitHelper2.getInstance(context).service

        val params = RetrofitHelper2.getInstance(context).convertRequestToMap(request)

        val observable = service.timeOrderCancel(params).debounce(1000, TimeUnit.MILLISECONDS)

        observable.subscribeOn(Schedulers.io()).doOnSubscribe {

            view.showLoadingDialog()

        }.observeOn(AndroidSchedulers.mainThread()).subscribe(object : BaseObserver<BaseResult>(context,this) {
            override fun onSuccess(response: BaseResult?) {
                view.dismissLoadingDialog()
                view.onOrderCancelSuccess()

            }

        })
    }

    override fun handleException(apiExcpetion: ApiException?) {
        super.handleException(apiExcpetion)
        view.onOrderCancelFail()
    }


}
