package com.jiaoyinbrother.monkeyking.manager.mvpactivity.timecashierdesk

import android.content.Context
import com.jiaoyinbrother.library.base.BasePresenterImpl
import com.jiaoyinbrother.library.bean.OrderPayRequest
import com.jiaoyinbrother.library.bean.OrderPayResult
import com.jiaoyinbrother.library.bean.RechargeRequest
import com.jiaoyinbrother.library.retrofit.BaseObserver
import com.jiaoyinbrother.library.retrofit.RetrofitHelper
import io.reactivex.android.schedulers.AndroidSchedulers
import io.reactivex.schedulers.Schedulers
import java.util.concurrent.TimeUnit

/**
 * Created by Administrator on 2018/8/9.
 */

class TimeCashierDeskPresenter(context: Context, view: TimeCashierDeskContract.View) :
        BasePresenterImpl<TimeCashierDeskContract.View>(context, view), TimeCashierDeskContract.Presenter{

    override fun postTimeDepositPay(request: RechargeRequest) {
        val service = RetrofitHelper.getInstance(context).service

        val params = RetrofitHelper.getInstance(context).convertRequestToMap(request)

        val observable = service.timeDepositPay(params).debounce(1000, TimeUnit.MILLISECONDS)

        observable.subscribeOn(Schedulers.io()).doOnSubscribe {

            view.showLoadingDialog()

        }.observeOn(AndroidSchedulers.mainThread()).subscribe(object : BaseObserver<OrderPayResult>(context,this) {
            override fun onSuccess(response: OrderPayResult?) {
                view.dismissLoadingDialog()
                if(response!=null)
                    view.updateTimeDepositResult(response)
            }

        })
    }

    override fun postTimeOrderPay(request: OrderPayRequest) {
        val service = RetrofitHelper.getInstance(context).service

        val params = RetrofitHelper.getInstance(context).convertRequestToMap(request)

        val observable = service.timeOrderPay(params).debounce(1000, TimeUnit.MILLISECONDS)

        observable.subscribeOn(Schedulers.io()).doOnSubscribe {

            view.showLoadingDialog()

        }.observeOn(AndroidSchedulers.mainThread()).subscribe(object : BaseObserver<OrderPayResult>(context,this) {
            override fun onSuccess(response: OrderPayResult?) {
                view.dismissLoadingDialog()
                if(response!=null)
                    view.updateTimeDepositResult(response)
            }

        })

    }

}
