package com.jiaoyinbrother.monkeyking.manager.mvpactivity.timedepositdetail

import android.app.Activity
import android.content.Intent
import android.text.TextUtils
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseActivity
import com.jiaoyinbrother.monkeyking.manager.util.DialogUtil
import com.jiaoyinbrother.monkeyking.manager.util.MKUtil
import com.jiaoyinbrother.monkeyking.manager.view.IOSdialog.IOSAlertDialog
import com.jiaoyinbrother.library.bean.TimeDriverLicenseUploadRequest
import com.jiaoyinbrother.library.bean.TimeRefundCheckResult
import com.jiaoyinbrother.library.util.ConstantsUtil
import com.jiaoyinbrother.library.util.StatisticsUtil
import com.jiaoyinbrother.library.util.UserUtil
import com.jiaoyinbrother.library.widget.GeneralBottomButton
import kotlinx.android.synthetic.main.activity_time_deposit_detail.*
import org.json.JSONObject

class TimeDepositDetailActivity : MvpBaseActivity<TimeDepositDetailPresenter>(), TimeDepositDetailContract.View {

    private var amount = 0
    private var timeRefundCheckResult:TimeRefundCheckResult?= null

    companion object {
        private const val DEPOSIT_AMOUNT = "DEPOSIT_AMOUNT"
        fun startTimeDespositDetail(activity: Activity, param: Int){
            val intent = Intent(activity, TimeDepositDetailActivity::class.java)
            intent.putExtra(DEPOSIT_AMOUNT, param)
            activity.startActivity(intent)
        }
    }

    override fun handleTimeRefundSuccess(response: TimeRefundCheckResult) {
        timeRefundCheckResult = response

        if(response.refund_enabed == 1)
            button_submit.normal()
        else
            button_submit.disable()

        if(response.tips !=null)
            textview_tips.text = response.tips
    }

    private fun getTimeRefundRequest(): TimeDriverLicenseUploadRequest {
        var timeDriverLicenseUploadRequest= TimeDriverLicenseUploadRequest()
        timeDriverLicenseUploadRequest.user_id = UserUtil(this@TimeDepositDetailActivity).userId.toString()
        return timeDriverLicenseUploadRequest
    }

    override fun initPresenter(): TimeDepositDetailPresenter {
        return TimeDepositDetailPresenter(this@TimeDepositDetailActivity,this)
    }

    override fun getLayoutId(): Int {
        return R.layout.activity_time_deposit_detail
    }

    override fun initView() {

    }

    override fun initToolBar() {
        mainTitle?.text = "分时押金"
    }

    override fun initData() {
        try{
            amount = intent?.getIntExtra(DEPOSIT_AMOUNT,0) as Int
        }catch (e:Exception){

        }

        button_submit.setText("申请退回")
        textview_title.text = "当前已缴纳押金"+amount.toString()+"元"

        presenter.postTimeRefundCheck(getTimeRefundRequest())

    }

    override fun initListeners() {
        button_submit.setListener(object : GeneralBottomButton.SubmitListener {
            override fun submit() {
                onSensorWithdrawDeposit(amount.toFloat())

                if(timeRefundCheckResult!=null && !TextUtils.isEmpty(timeRefundCheckResult?.applied_msg)){
                    IOSAlertDialog(this@TimeDepositDetailActivity).builder().setMsg(timeRefundCheckResult?.applied_msg, true)
                            .setRightButton("订单列表") {
                                MKUtil.goBackMainPage(this@TimeDepositDetailActivity, MKUtil.GO_MAIN_ORDER_LIST)

                            }.setLeftButton("取消") { }.show()
                }else{

                    DialogUtil.onMainServiceDial(this@TimeDepositDetailActivity, "申请退回请拨打客服电话")
                }
            }
        })

    }

    private fun onSensorWithdrawDeposit(amount:Float){

        var jsonObject = JSONObject()
        try {
            jsonObject.put("refund_payment_type", "支付分时押金")
            jsonObject.put("is_deposit", true)
            jsonObject.put("refund_amount", amount)
            StatisticsUtil.onSensorsDataTrack(ConstantsUtil.E_ApplyRefund, jsonObject)

        } catch (e: Exception) {

        }

    }


}
