package com.jiaoyinbrother.monkeyking.manager.mvpactivity.timedepositdetail

import android.content.Context
import com.jiaoyinbrother.library.base.BasePresenterImpl
import com.jiaoyinbrother.library.bean.TimeDriverLicenseUploadRequest
import com.jiaoyinbrother.library.bean.TimeRefundCheckResult
import com.jiaoyinbrother.library.retrofit.BaseObserver
import com.jiaoyinbrother.library.retrofit.RetrofitHelper
import io.reactivex.android.schedulers.AndroidSchedulers
import io.reactivex.schedulers.Schedulers
import java.util.concurrent.TimeUnit

/**
 * Created by Administrator on 2018/7/31.
 */

class TimeDepositDetailPresenter(context:Context, view:TimeDepositDetailContract.View ):
        BasePresenterImpl<TimeDepositDetailContract.View>(context, view), TimeDepositDetailContract.Presenter{
    override fun postTimeRefundCheck(request: TimeDriverLicenseUploadRequest){

        val service = RetrofitHelper.getInstance(context).service

        val params = RetrofitHelper.getInstance(context).convertRequestToMap(request)

        val observable = service.timeRefundCheck(params).debounce(1000, TimeUnit.MILLISECONDS)

        observable.subscribeOn(Schedulers.io()).doOnSubscribe {

            view.showLoadingDialog()

        }.observeOn(AndroidSchedulers.mainThread()).subscribe(object : BaseObserver<TimeRefundCheckResult>(context,this) {
            override fun onSuccess(response: TimeRefundCheckResult?) {
                view.dismissLoadingDialog()
                if(response!=null)
                    view.handleTimeRefundSuccess(response)
            }

        })

    }

}
