package com.jiaoyinbrother.monkeyking.manager.mvpactivity.timedrivelicenseresult

import android.app.Activity
import android.view.View
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseActivity
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.timecashierdesk.TimeCashierDeskActivity
import com.jiaoyinbrother.monkeyking.manager.util.MKUtil
import com.jiaoyinbrother.library.bean.UserDetailRequestBean
import com.jiaoyinbrother.library.bean.UserDetailResult
import com.jiaoyinbrother.library.util.*
import io.reactivex.Flowable
import io.reactivex.android.schedulers.AndroidSchedulers
import io.reactivex.disposables.Disposable
import kotlinx.android.synthetic.main.activity_driver_licence_result.*
import org.json.JSONObject
import java.util.concurrent.TimeUnit


class TimeDriverLicenceResultActivity :MvpBaseActivity<TimeDriverLicenseResultPresenter>(),
        TimeDriverLicenseResultContract.View {

    private var mAPITimer: Disposable? = null

    companion object {
        const val TIME_INTERVAL = 10L
    }

    override fun updateView(userDetailResult: UserDetailResult) {
        var status = AuthUtil(this@TimeDriverLicenceResultActivity).getTimeDriverLicenseStatus(userDetailResult.driver_card_info)

        when (status) {
            AuthUtil.CERT_AUTHING -> {
                //认证进行中
                view_result_data.setEmptyData(R.mipmap.icon_authenticating, "正在审核中", "您的申请已提交，审核可能需要几分钟。 请耐心等待，如有问题请联系客服。", "")
                view_result_data.setPositiveButton("返回分时主页", View.OnClickListener {
                    MKUtil.goBackMainPage(this@TimeDriverLicenceResultActivity)
                })
            }
            AuthUtil.CERT_AUTHED -> {
                // 认证通过
                onSensorDriverLicenseResult(true)

                view_result_data.setEmptyData(R.mipmap.icon_xiaobai_success, "审核成功", "", "")
                view_result_data.setPositiveButton("确定", View.OnClickListener {
                    //        分时押金
                    startTimeCashierActivity(userDetailResult)

                })

            }
            AuthUtil.CERT_AUTH_EMPTY,AuthUtil.CERT_NOAUTH ->{
                // 认证失败
                onSensorDriverLicenseResult(false)

                view_result_data.setEmptyData(R.mipmap.icon_xiaobai_fail, "审核失败", "审核失败，请检查后重新提交", "")
                view_result_data.setPositiveButton("确定", View.OnClickListener {
                    setResult(Activity.RESULT_OK)
                    finish()
                })

            }

        }
    }

    private fun startTimeCashierActivity(userDetailResult: UserDetailResult) {
        if (userDetailResult?.remote_deposit != null || userDetailResult?.remote_deposit?.pay_method_avai != null) {

            LogUtil.e("remoteDeposit=" + userDetailResult?.remote_deposit!!)
            var remoteDeposit = userDetailResult?.remote_deposit!!
            when (remoteDeposit.enabled) {

                UserUtil.DEPOSIT_PAY_ENABLED -> {
                    var param = TimeCashierDeskActivity.CashierDeskParamBean()
                    param.amount = remoteDeposit.amount.toFloat()
                    param.entrance = mainTitle?.text.toString()
                    param.description = "分时押金"
                    param.warmPrompt = remoteDeposit.warm_prompt ?: ""
                    param.payMethodAvailable = remoteDeposit.pay_method_avai
                    param.typeAPI = TimeCashierDeskActivity.TYPE_DEPOSIT_PAY
                    TimeCashierDeskActivity.startTimeCashierDesk(this@TimeDriverLicenceResultActivity, param)
                }
                UserUtil.DEPOSIT_PAY_DISABLED -> {
                    MKUtil.goBackMainPage(this@TimeDriverLicenceResultActivity,MKUtil.GO_MAIN_TIME)
                }

            }

        }
    }

    override fun initPresenter(): TimeDriverLicenseResultPresenter {
        return TimeDriverLicenseResultPresenter(this@TimeDriverLicenceResultActivity,this)
    }

    override fun initView() {

    }

    override fun initToolBar() {
        mainTitle?.text = "驾驶证认证"
        view_result_data.visibility = View.VISIBLE
    }

    override fun initListeners() {

    }

    override fun initData() {
        val mUserUtil = UserUtil(this@TimeDriverLicenceResultActivity)
        presenter.postTimeUserRequest(mUserUtil.getUserRequest())
        mAPITimer = Flowable.interval(TIME_INTERVAL, TimeUnit.SECONDS)
                .onBackpressureDrop()
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe({ _ ->
                    presenter.postTimeUserRequest(mUserUtil.getUserRequest())
                })

    }

    override fun getLayoutId(): Int {
        return R.layout.activity_driver_licence_result;
    }


    override fun onDestroy() {
        mAPITimer?.dispose()

        super.onDestroy()
    }

    private fun onSensorDriverLicenseResult(status:Boolean){
        var jsonObject = JSONObject()
        try {
            jsonObject.put("is_success", status)
            StatisticsUtil.onSensorsDataTrack(ConstantsUtil.E_Auth_DL, jsonObject)

        } catch (e: Exception) {

        }

    }


    override fun onBackPressed() {
        MKUtil.goBackMainPage(this@TimeDriverLicenceResultActivity, MKUtil.GO_MAIN_TIME)
        super.onBackPressed()
    }


}
