package com.jiaoyinbrother.monkeyking.manager.mvpactivity.timedrivelicenseresult

import android.content.Context
import com.jiaoyinbrother.library.base.BasePresenterImpl
import com.jiaoyinbrother.library.bean.UserDetailRequestBean
import com.jiaoyinbrother.library.bean.UserDetailResult
import com.jiaoyinbrother.library.retrofit.BaseObserver
import com.jiaoyinbrother.library.retrofit.RetrofitHelper
import com.jiaoyinbrother.library.util.LogUtil
import io.reactivex.android.schedulers.AndroidSchedulers
import io.reactivex.schedulers.Schedulers
import java.util.concurrent.TimeUnit

/**
 * Created by Administrator on 2018/8/8.
 */

class TimeDriverLicenseResultPresenter(context: Context, view: TimeDriverLicenseResultContract.View) :
        BasePresenterImpl<TimeDriverLicenseResultContract.View>(context, view), TimeDriverLicenseResultContract.Presenter {
    override fun postTimeUserRequest(request: UserDetailRequestBean) {

        val service = RetrofitHelper.getInstance(context).service

        LogUtil.e("request = " + request.toString())
        val params = RetrofitHelper.getInstance(context).convertRequestToMap(request)

        val observable = service.timeUserGetDetail(params).debounce(1000, TimeUnit.MILLISECONDS)

        observable.subscribeOn(Schedulers.io()).doOnSubscribe {
            view.showLoadingDialog()
        }.observeOn(AndroidSchedulers.mainThread()).subscribe(object : BaseObserver<UserDetailResult>(context,this) {
            override fun onSuccess(response: UserDetailResult?) {
                view.dismissLoadingDialog()
                if(response!=null)
                    view.updateView(response)


            }
        })

    }


}
