package com.jiaoyinbrother.monkeyking.manager.mvpactivity.timedriverlicense

import android.app.Activity
import android.content.Intent
import android.view.View
import com.bumptech.glide.Glide
import com.jiaoyinbrother.monkeyking.manager.CarEntity
import com.jiaoyinbrother.monkeyking.manager.Constants
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.activity.ShowBigImageActivity
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseActivity
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.timedrivelicenseresult.TimeDriverLicenceResultActivity
import com.jiaoyinbrother.monkeyking.manager.util.ImageSelectorUtils
import com.jiaoyinbrother.monkeyking.manager.util.MKUtil
import com.jiaoyinbrother.library.util.*
import com.jiaoyinbrother.library.widget.BottomDialog
import com.jiaoyinbrother.library.widget.GeneralBottomButton
import kotlinx.android.synthetic.main.activity_driver_license.*
import java.io.File

class TimeDriverLicenseActivity : MvpBaseActivity<TimeDriverLicensePresenter>(), TimeDriverLicenseContract.View, View.OnClickListener {
    private var frontImgFilePath: String? = null
    private var backImgFilePath: String? = null

    private var PIC_FLAG = FRONT

    override fun uploadFileSucceed() {
        var intent = Intent(this@TimeDriverLicenseActivity, TimeDriverLicenceResultActivity::class.java)
        startActivity(intent)
        finish()
    }

    override fun onClick(v: View?) {
        when (v) {
            iv_car_img_front -> {
                // 行驶证正页
                PIC_FLAG = FRONT
                showBottomDialog();
            }
            iv_car_img_back -> {
                // 行驶证副页
                PIC_FLAG = BACK
                showBottomDialog()
            }
        }
    }

    override fun initView() {

    }

    override fun initData() {
        doInitData()
    }

    override fun initPresenter(): TimeDriverLicensePresenter {
        return TimeDriverLicensePresenter(this@TimeDriverLicenseActivity, this)
    }

    override fun getLayoutId(): Int {
        return R.layout.activity_driver_license
    }

    override fun initToolBar() {
        mainTitle?.text = "驾驶证认证"
    }

    override fun initListeners() {
        iv_car_img_front.setOnClickListener(this)
        iv_car_img_back.setOnClickListener(this)
        button_submit.setListener(object : GeneralBottomButton.SubmitListener {
            override fun submit() {
                onPost()
            }
        })
        button_submit.setText("提交")
        button_submit.disable()
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)

        when (requestCode) {
            Constants.REQUEST_PIC -> {
                if (data != null) {
                    //images返回的是照片路径
                    val images = data.getStringArrayListExtra(ImageSelectorUtils.SELECT_RESULT)
                    if (images != null && images.size > 0) {
                        LogUtil.e("images->" + images.toString())
                        if (images[0] == null)
                            return

                        handlePhoto(File(images[0]))
                    }
                }
            }
            CarEntity.REQUEST_CAMERA -> {
                if (resultCode == Activity.RESULT_OK) {
                    var tempPath = if (PIC_FLAG == FRONT) {
                        IMG_FRONT_PATH
                    } else {
                        IMG_BACK_PATH
                    }
                    val actualImage = File(tempPath)
                    LogUtil.e("BankCardActivity.IMG_BANKCARD_PATH =" + tempPath)

                    handlePhoto(actualImage)

                }
            }

        }

    }


    private fun handlePhoto(actualImage: File?) {
        if (actualImage == null)
            return

        try {
            showLoadingDialog()

            val compressedImage = PhotoUtils.compressFile(this, actualImage)
            var path = compressedImage.absolutePath
            LogUtil.e("path = " + path)

            if (PIC_FLAG == FRONT) {
                frontImgFilePath = path
                PhotoUtils.loadPicIntoImageViewNoCache(this@TimeDriverLicenseActivity, frontImgFilePath, iv_car_img_front)
            } else {
                backImgFilePath = path
                PhotoUtils.loadPicIntoImageViewNoCache(this@TimeDriverLicenseActivity, backImgFilePath, iv_car_img_back)
            }

            if (frontImgFilePath != null && backImgFilePath != null) {
                button_submit.normal()
            }

            dismissLoadingDialog()
        } catch (e: Exception) {

        }
    }

    private fun doInitData() {
        frontImgFilePath = null
        backImgFilePath = null
        button_submit.disable()
        Glide.with(this).load(R.mipmap.bg_driver_license_back).into(iv_car_img_back)
        Glide.with(this).load(R.mipmap.bg_driver_license_front).into(iv_car_img_front)
    }


    private fun showBottomDialog() {

        if (PIC_FLAG == FRONT) {
            if (frontImgFilePath != null) {
                showMenuWithBigImage()
            } else {
                showMenuWithoutBigImage()
            }
        } else {
            if (backImgFilePath != null) {
                showMenuWithBigImage()
            } else {
                showMenuWithoutBigImage()
            }
        }

    }


    private fun showMenuWithoutBigImage() {
        BottomDialog(this@TimeDriverLicenseActivity).builder().addItems(arrayOf("拍照", "相册")).setCancel("取消", {}).setItemClick { _, i ->
            when (i) {
                // 相机(单选)
                0 -> {
                    // 跳转到调用系统相机
                    handleTakePicture()

                }
                1 -> {
                    // 跳转到调用系统图库
                    ImageSelectorUtils.openPhoto(this@TimeDriverLicenseActivity, Constants.REQUEST_PIC, true, 1, null, "")
                }
            }
        }.show()
    }


    private fun showMenuWithBigImage() {
        BottomDialog(this@TimeDriverLicenseActivity).builder().addItems(arrayOf("查看大图", "拍照", "相册")).setCancel("取消", {}).setItemClick { _, i ->
            when (i) {
                // 相机(单选)
                0 -> {
                    //                    查看大图
                    handleBigImage()
                }
                1 -> {
                    // 跳转到调用系统相机
                    handleTakePicture()
                }
                else -> {
                    // 跳转到调用系统图库
                    ImageSelectorUtils.openPhoto(this@TimeDriverLicenseActivity, Constants.REQUEST_PIC, true, 1, null, "")
                }
            }
        }.show()
    }

    private fun handleTakePicture() {
        // 调用照相机返回图片临时文件
        var tempFilePath = if (PIC_FLAG == FRONT) {
            IMG_FRONT_PATH
        } else {
            IMG_BACK_PATH
        }
        MKUtil.handleTakePicture(this@TimeDriverLicenseActivity, tempFilePath)
    }

    private fun handleBigImage() {
        if (PIC_FLAG == FRONT) {
            if (frontImgFilePath != null) {
                LogUtil.e("frontImgFilePath = " + frontImgFilePath)
                showBigImage(frontImgFilePath!!)
            }
        } else {
            if (backImgFilePath != null) {
                LogUtil.e("backImgFilePath = " + backImgFilePath)
                showBigImage(backImgFilePath!!)
            }

        }
    }

    private fun onPost() {
        if (!NetUtil.isNetConnected(this@TimeDriverLicenseActivity)) {
            OldToastUtil.showerror(this@TimeDriverLicenseActivity, OldToastUtil.TIMEOUT_EXCEPTION)
            return
        }

        if (frontImgFilePath != null && backImgFilePath != null) {
            presenter.uploadFile(frontImgFilePath!!, backImgFilePath!!)
        }

    }

    private fun showBigImage(uriString: String) {
        ShowBigImageActivity.newInstanceUri(this@TimeDriverLicenseActivity, uriString, false)
//        val intent = Intent(this@TimeDriverLicenseActivity, ShowBigImageActivity::class.java)
//        intent.putExtra(ShowBigImageActivity.IMG_URI, uriString)
//        intent.putExtra("UNNEED", "UNNEED")
//        startActivity(intent)
    }

    companion object {
        private val IMG_FRONT_PATH = BitmapUtil.SYSTEM_BITMAP_PATH + "img_driving_front.jpg"
        private val IMG_BACK_PATH = BitmapUtil.SYSTEM_BITMAP_PATH + "img_driving_back.jpg"

        private val FRONT = "FRONT"
        private val BACK = "BACK"
    }

}

