package com.jiaoyinbrother.monkeyking.manager.mvpactivity.timedriverlicense

import android.content.Context
import com.jiaoyinbrother.library.base.BasePresenterImpl
import com.jiaoyinbrother.library.bean.BaseResult
import com.jiaoyinbrother.library.bean.UserCertAddRequest
import com.jiaoyinbrother.library.impl.UploadListener
import com.jiaoyinbrother.library.retrofit.BaseObserver
import com.jiaoyinbrother.library.retrofit.RetrofitHelper
import com.jiaoyinbrother.library.util.AliYunPictureUtil
import com.jiaoyinbrother.library.util.LogUtil
import com.jiaoyinbrother.library.util.UserUtil
import io.reactivex.android.schedulers.AndroidSchedulers
import io.reactivex.schedulers.Schedulers
import java.util.HashMap
import java.util.concurrent.TimeUnit
import kotlin.collections.ArrayList

/**
 * Created by Administrator on 2018/7/27.
 */

class TimeDriverLicensePresenter(context:Context, view: TimeDriverLicenseContract.View):BasePresenterImpl<TimeDriverLicenseContract.View>(context,view),
TimeDriverLicenseContract.Presenter{

    /** 上传照片至阿里云 */
    override fun uploadFile(frontURI:String, backURI:String) {
        view.showLoadingDialog()
        LogUtil.e("uploadFile")

        var mUploadUtil = AliYunPictureUtil.getInstance(context)

        var postImages = ArrayList<String>()
        postImages.add(frontURI)
        postImages.add(backURI)

//        mUploadUtil?.setDatas(AliYunPictureUtil.BUCKET_TYPE_PUBLIC,postImages, AliYunPictureUtil.USER_DRIVER, uploadListener)
//        mUploadUtil?.setDatas(AliYunPictureUtil.BUCKET_TYPE_PRIVATE,postImages, AliYunPictureUtil.PRIVATE_USER_DRIVER, uploadListener)
    }

    private val uploadListener = object : UploadListener {
        override fun onUploadComplete(success: HashMap<Int, String>, failure: HashMap<Int, String>) {

            LogUtil.e("onUploadComplete， success.size=" + success.size)
            if (success.size == 2) {
                uploadFileToAPI(success[1].toString(), success[2].toString())
            } else {
                view.dismissLoadingDialog()
                view.showToast("上传失败")
            }
        }

        override fun onUploadComplete(net: String?, local: String?) {}
    }

    private fun uploadFileToAPI(frontUrl:String, backUrl:String){
        LogUtil.e("uploadFileToAPI， backUrl=" + backUrl + "frontUrl=" + frontUrl)
        var request = UserCertAddRequest()
        try{
            request.user_id = UserUtil(context).userId.toString()
            val certBeanList = ArrayList<UserCertAddRequest.CertsBean>()
            var certBean = UserCertAddRequest.CertsBean()
            certBean.pic_url = frontUrl
            certBean.type = "13"
            certBeanList.add(certBean)

            var certBean2 = UserCertAddRequest.CertsBean()
            certBean2.pic_url = backUrl
            certBean2.type = "14"
            certBeanList.add(certBean2)
            request.certs = certBeanList

            val service = RetrofitHelper.getInstance(context).service

            LogUtil.e("request = " + request.toString())
            val params = RetrofitHelper.getInstance(context).convertRequestToMap(request)

            val observable = service.userCertAdd(params).debounce(1000, TimeUnit.MILLISECONDS)

            observable.subscribeOn(Schedulers.io()).doOnSubscribe {

            }.observeOn(AndroidSchedulers.mainThread()).subscribe(object : BaseObserver<BaseResult>(context,this) {
                override fun onSuccess(response: BaseResult?) {
                    view.dismissLoadingDialog()
                    view.showToast("提交成功")
                    view.uploadFileSucceed()

                }
            })
        }catch (e:Exception){
            LogUtil.e("uploadFileToAPI exception="+e.toString())
            view.dismissLoadingDialog()
            view.showToast("上传失败")
            return
        }

    }


}
