package com.jiaoyinbrother.monkeyking.manager.mvpactivity.timefeesdetail

import android.annotation.SuppressLint
import android.app.Activity
import android.content.Intent
import android.view.View
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.activity.CouponsManageActivity
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseActivity
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.timecashierdesk.TimeCashierDeskActivity
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.timeorderdetail.TimeOrderDetailActivity
import com.jiaoyinbrother.monkeyking.manager.util.DialogUtil
import com.jiaoyinbrother.monkeyking.manager.util.H5Utils
import com.jiaoyinbrother.library.bean.*
import com.jiaoyinbrother.library.util.*
import com.jiaoyinbrother.library.widget.GeneralBottomButton
import com.sensorsdata.analytics.android.sdk.SensorsDataAPI
import kotlinx.android.synthetic.main.activity_time_fees_detail.*
import org.json.JSONException
import org.json.JSONObject

class TimeFeesDetailActivity : MvpBaseActivity<TimeFeesDetailPresenter>(), ITimeFeesDetailContract.view {


    private var orderID: String? = null
    private var userUtil: UserUtil? = null
    private var coupons = ArrayList<String>()
    private var avaiCoupons: ArrayList<CouponBean>? = null
    private var payMethods: ArrayList<PayMethodAvaiBean>? = null
    private var morePay: Float = 0.0f
    private var couponPay: Float = 0.0f
    private var planID: String? = null
    private var mOrderInfo: TimeOrderDetailResult? = null
    private var entrance: String? = null
    private var isAuto= 1

    override fun initPresenter(): TimeFeesDetailPresenter? {
        return TimeFeesDetailPresenter(this@TimeFeesDetailActivity, this)
    }

    override fun getLayoutId(): Int {
        entrance = intent.getStringExtra("entrance")
        orderID = intent.getStringExtra(ConstantsUtil.ORDER_ID)
        return R.layout.activity_time_fees_detail
    }

    override fun initView() {}

    override fun initToolBar() {
        mainTitle.text = "费用明细"
        subTitle.text = "计价规则"
    }

    override fun initData() {
        onSure.disable()
        userUtil = UserUtil(this@TimeFeesDetailActivity)
        presenter.requestOrderInfo(getOrderInfoRequest())
        costQuestion.visibility  = if (userUtil?.userRole == UserUtil.USER_ROLE_RENTER) View.VISIBLE else View.GONE
    }

    override fun initListeners() {
        subTitle.setOnClickListener {
            //            SensorsDataAPI.sharedInstance().setViewID(subtitel_rv, "order_sc_cost_rule")
            H5Utils.onTimeChargingRule(this)
        }

        couponLayout.setOnClickListener {
            // 专员 不能点击优惠券
            if (userUtil?.userRole == UserUtil.USER_ROLE_OWNER)
                return@setOnClickListener
            if (Util.isEmptyList(avaiCoupons))
                return@setOnClickListener
            val intent = Intent(this@TimeFeesDetailActivity, CouponsManageActivity::class.java)
            intent.putExtra(ConstantsUtil.BUNDLE_EXTRA_KEY, "FeedsDetail")
            intent.putExtra("CouponsList", avaiCoupons)
            intent.putExtra("defSelectedCoupon", coupons)
            LogUtil.e("to--------------->>>>>>>>>${coupons}")
            startActivityForResult(intent, ConstantsUtil.CHOOSE_COUPONS)
        }

        costQuestion.setOnClickListener({
            DialogUtil.setMainServiceDialog(this@TimeFeesDetailActivity, {})

            SensorsDataAPI.sharedInstance().setViewID(costQuestion, "order_sc_cost_question")
        })

        onSure.setListener(object : GeneralBottomButton.SubmitListener {
            override fun submit() {
                if (mOrderInfo?.bill?.is_short_rent == ConstantsUtil.RENT_TIME) sensorsData() else sensorsData1()
                presenter.requestOrderAccept(getOrderAcceptRequest())
            }
        })
    }

    /**
     * 获取订单详情
     *
     * @return TimeOrderDetailRequest
     * */
    private fun getOrderInfoRequest(): TimeOrderDetailRequest {
        val request = TimeOrderDetailRequest()
        request.order_id = orderID
        request.user_id = userUtil?.userId.toString()
        return request
    }

    /**
     * 获取订单计算
     *
     * @return TimeBillCalcRequest
     * */
    private fun getBillCalcRequest(): TimeBillCalcRequest {
        val request = TimeBillCalcRequest()
        request.order_id = orderID
        request.coupons = coupons
        request.auto_calc = isAuto
        return request
    }

    /**
     * 获取订单确认账单
     *
     * @return TimeBillCalcRequest
     * */
    private fun getOrderAcceptRequest(): TimeOrderAcceptRequest {
        val request = TimeOrderAcceptRequest()
        request.order_id = orderID
        request.plan_id = planID
        return request
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        if (requestCode == ConstantsUtil.CHOOSE_COUPONS && data != null) {
            val selectCoupon = data.getSerializableExtra("selectedCoupon") as ArrayList<CouponBean>
            coupons.clear()
            if (!Util.isEmptyList(selectCoupon)) {
                coupons.add(selectCoupon[0].id.toString())
            }
            presenter.requestBillCalc(getBillCalcRequest())
        }
    }

    @SuppressLint("SetTextI18n")
    override fun setOrderSuccess(result: TimeOrderDetailResult) {
        couponArrow.visibility = View.GONE
        mOrderInfo = result
        val bill = result.bill
        if (bill?.coupon_pay ?: 0.0f > 0) {
            couponCost.text = "-${MoneyUtil().getMoneyText(bill?.coupon_pay.toString())}"
        } else {
            couponCost.text = "未使用"
        }
        if (bill?.more_pay ?: 0.0f > 0) {
            copeWithCost.text = MoneyUtil().getMoneyText(bill?.more_pay.toString())
        }

        dailyRentView.setData(result)

        if (userUtil?.userRole == UserUtil.USER_ROLE_RENTER && TimeOrderUtil(this).orderBillApplied(result.status)) {
            presenter.requestBillCalc(getBillCalcRequest())
            onSure.visibility = View.VISIBLE
        } else {
            onSure.visibility = View.GONE
        }
    }

    @SuppressLint("SetTextI18n")
    override fun setBillCalcSuccess(result: TimeBillCalcResult) {
        isAuto = 0
        planID = result.plan_id
        morePay = result.more_pay ?: 0.0f
        payMethods = result.pay_method_avai
        avaiCoupons = result.avai_coupons
        couponPay = result.coupon_pay ?: 0.0f
        if (Util.isEmptyList(result.coupons)) {
            coupons.clear()
        } else {
            coupons = result.coupons!!
        }
        LogUtil.e("get--------------->>>>>>>>>${coupons}")
        //左侧  1选取优惠券时不显示， 2不选取且优惠券张数大于0 显示张数
        if (Util.isEmptyList(avaiCoupons)) {
            couponCost.text = "暂无可用"
            couponArrow.visibility = View.GONE
        } else {
            couponArrow.visibility = View.VISIBLE
            if (couponPay > 0) {
                couponCost.text = "-${MoneyUtil().getMoneyText(couponPay.toString())}"
            } else {
                couponCost.text = "可用${avaiCoupons?.size}张"
            }
        }
        copeWithCost.text = MoneyUtil().getMoneyText(morePay.toString())
        onSure.normal()
    }

    override fun setAcceptSuccess() {
        sensorsData2()
        val bean = TimeCashierDeskActivity.CashierDeskParamBean()
        if (morePay == 0.0f) {
            val intent = Intent(this, TimeOrderDetailActivity::class.java)
            intent.putExtra(TimeOrderDetailActivity.ODRER_ID, orderID)
            startActivity(intent)
            finish()
        } else {
            bean.description = "分时用车费用"
            bean.entrance = mainTitle?.text.toString()
            bean.typeAPI = TimeCashierDeskActivity.TYPE_ORDER_PAY
            bean.orderPayType = TimeCashierDeskActivity.ORDER_PAY_RENTAL_FEE
            bean.amount = morePay
            bean.payMethodAvailable = payMethods ?: ArrayList()
            bean.orderId = orderID
            TimeCashierDeskActivity.startTimeCashierDesk(this@TimeFeesDetailActivity, bean)
        }
    }

    companion object {
        fun newInstance(activity: Activity, orderId: String, entrance: String) {
            val intent = Intent(activity, TimeFeesDetailActivity::class.java)
            intent.putExtra(ConstantsUtil.ORDER_ID, orderId)
            intent.putExtra("entrance", entrance)
            activity.startActivity(intent)
        }
    }

    /**
     * 神策埋点 分时
     * */
    private fun sensorsData() {
        val properties = JSONObject()
        try {
            val bill = mOrderInfo?.bill
//            订单信息
            properties.put("order_id", orderID)
//            车辆信息
            properties.put("car_id",mOrderInfo?.car?.car_id)
//            是否是短租
            properties.put("is_short_rent", bill?.is_short_rent)
//            日间行驶时长
            properties.put("day_times", bill?.day_times)
//            夜间行驶时长
            properties.put("night_times", bill?.night_times)
//            行驶里程（KM）
            properties.put("miles", bill?.miles)
//            车费合计
            properties.put("total_amount", bill?.total_amount)
//            优惠券名称
            properties.put("coupon_name", "")
//            优惠券金额
            properties.put("coupon_amount", couponPay)
//            应付费用
            properties.put("final_total_amount", morePay)
            StatisticsUtil.onSensorsDataTrack(ConstantsUtil.E_SC_RETURNCAR_STEP3, properties)
        } catch (e: JSONException) {
            e.printStackTrace()
        }
    }

    /**
     * 神策埋点 日租
     * */
    private fun sensorsData1() {
        val properties = JSONObject()
        try {
            val bill = mOrderInfo?.bill
//            订单信息
            properties.put("order_id", orderID)
//            车辆信息
            properties.put("car_id",mOrderInfo?.car?.car_id)
//            是否是短租
            properties.put("is_short_rent", bill?.is_short_rent)
//            行驶里程（KM）
            properties.put("miles", bill?.miles)
//            租金
            properties.put("rent_amount", bill?.rent_amount)
//            基本保障服务费
            properties.put("basic_insurance_fee", mOrderInfo?.basic_insurance)
//            车费合计
            properties.put("total_amount", bill?.total_amount)
//            优惠券名称
            properties.put("coupon_name", "")
//            优惠券金额
            properties.put("coupon_amount", couponPay)
//            应付费用
            properties.put("final_total_amount", morePay)
            StatisticsUtil.onSensorsDataTrack(ConstantsUtil.E_SC_RETURNCAR_STEP3, properties)
        } catch (e: JSONException) {
            e.printStackTrace()
        }
    }


    /**
     * 神策埋点 日租
     * */
    private fun sensorsData2() {
        val properties = JSONObject()
        try {
            properties.put("entrance", entrance)
            properties.put("order_id", orderID)
            properties.put("payment_type", "支付分时用车费用")
            properties.put("is_deposit", false)
            properties.put("is_offline", false)
            properties.put("order_amount", mOrderInfo?.bill?.total_amount)
            StatisticsUtil.onSensorsDataTrack(ConstantsUtil.E_PAYMENT, properties)
        } catch (e: JSONException) {
            e.printStackTrace()
        }
    }
}
