package com.jiaoyinbrother.monkeyking.manager.mvpactivity.timefindissue

import android.Manifest
import android.annotation.SuppressLint
import android.app.Activity
import android.content.BroadcastReceiver
import android.content.Context
import android.content.Intent
import android.content.IntentFilter
import android.os.Environment
import android.support.v7.widget.GridLayoutManager
import android.text.Editable
import android.text.TextUtils
import android.text.TextWatcher
import com.jeremyliao.livedatabus.LiveDataBus
import com.jiaoyinbrother.monkeyking.manager.CarEntity
import com.jiaoyinbrother.monkeyking.manager.Constants
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.activity.ShowBigImageActivity
import com.jiaoyinbrother.monkeyking.manager.adapter.BillPhotoAdapter
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseActivity
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.timecheckcar.TimeCheckCarActivity
import com.jiaoyinbrother.monkeyking.manager.util.ImageSelectorUtils
import com.jiaoyinbrother.library.bean.CarValidatesBean
import com.jiaoyinbrother.library.bean.FilesBean
import com.jiaoyinbrother.library.bean.PositionsBean
import com.jiaoyinbrother.library.bean.TimeFindIssueRequest
import com.jiaoyinbrother.library.impl.UploadListener
import com.jiaoyinbrother.library.listeners.ViewImageListener
import com.jiaoyinbrother.library.util.*
import com.jiaoyinbrother.library.widget.BottomDialog
import com.jiaoyinbrother.library.widget.FindIssueImageView
import com.jiaoyinbrother.library.widget.GeneralBottomButton
import com.jiaoyinbrother.library.widget.IssueDialog
import com.tbruyelle.rxpermissions2.RxPermissions
import io.reactivex.disposables.Disposable
import kotlinx.android.synthetic.main.activity_time_find_issue.*
import java.io.File
import java.lang.Exception
import java.util.*

class TimeFindIssueActivity : MvpBaseActivity<TimeFindIssuePresenter>(), ITimeFindIssueContract.view {
    private var carID: String? = null
    private var orderID: String? = null
    private var userUtil: UserUtil? = null

    private val mTop = ArrayList<PositionsBean>()
    private val mAhead = ArrayList<PositionsBean>()
    private val mBehind = ArrayList<PositionsBean>()
    private val mLeft = ArrayList<PositionsBean>()
    private val mRight = ArrayList<PositionsBean>()
    private val mInside = ArrayList<PositionsBean>()
    private var mType: ArrayList<PositionsBean.TypesBean>? = null
    // body
    private var mIssueBody: String? = null
    // type
    private var mIssueType: String? = null
    // addPhoto
    private var mIssueUrl: String? = null
    private var mAdapter: BillPhotoAdapter? = null
    private var mIssueImage = ArrayList<FilesBean>()
    // aliyun util
    private var mUploadUtil: AliYunPictureUtil? = null

    private var mBodyIndex = 0
    private var positionName = ""
    private var typeName = ""

    private val fileUri = File(Environment.getExternalStorageDirectory().path + "/photo_time_find_issue.jpg")

    val mRxPermissions = RxPermissions(this@TimeFindIssueActivity)
    var mDisposable: Disposable? = null

    private var isRental = false

    override fun initPresenter(): TimeFindIssuePresenter {
        return TimeFindIssuePresenter(this, this)
    }

    override fun getLayoutId(): Int {
        orderID = intent.getStringExtra(ConstantsUtil.ORDER_ID)
        carID = intent.getStringExtra(ConstantsUtil.CAR_ID)
        isRental = intent.getBooleanExtra(ConstantsUtil.IS_RENTAL, false)
        return R.layout.activity_time_find_issue
    }

    override fun initView() {}

    override fun initToolBar() {
        mainTitle.text = "更多验车信息"
    }

    override fun initData() {
        userUtil = UserUtil(this)
        mUploadUtil = AliYunPictureUtil.getInstance(this@TimeFindIssueActivity)
        // addPhoto
        val manager = GridLayoutManager(this@TimeFindIssueActivity, 2, GridLayoutManager.VERTICAL, false)
        addPhotoRv.layoutManager = manager
        mAdapter = BillPhotoAdapter(this@TimeFindIssueActivity)
        mIssueImage.add(FilesBean())
        mAdapter?.list = mIssueImage
        addPhotoRv.adapter = mAdapter
        mAdapter?.setEditing(true)
        onSubmit.disable()

        registerReceiver()

        presenter.requestPosition()
    }

    override fun initListeners() {
        /** 提交 */
        onSubmit.setListener(object : GeneralBottomButton.SubmitListener {
            override fun submit() {
                showLoadingDialog()
                mUploadUtil?.setData(AliYunPictureUtil.BUCKET_TYPE_PUBLIC,mIssueImage[0].file_uri, AliYunPictureUtil.REMOTE, uploadListener)
            }
        })
        /** 点选您发现问题的部位 */
        findIssueImg.setListener {
            IssueDialog(this)
                    .builder()
                    .setTitle("请选择详细部位")
                    .setIndex(it)
                    .setPositions(getPositions(it))
                    .setListener(object : IssueDialog.onSureListener {

                        override fun onCancel() {
                            findIssueImg.updateImages(mBodyIndex)
                        }

                        override fun onSure(index: Int, position: PositionsBean) {
                            mBodyIndex = index
                            mType = position.types
                            issueBody.text = position.position_name
                            positionName = position.position_name ?: ""
                            mIssueBody = position.position
                            issueType.text = "请选择"
                            mIssueType = ""
                            activateSubmit()
                        }

                        override fun onSure(type: PositionsBean.TypesBean?) {}
                    }).show()
        }
        // 问题类型
        issueType.setOnClickListener {
            if (TextUtils.isEmpty(mIssueBody)) {
                showToast("请先选择问题部位")
                return@setOnClickListener
            }
            if (mType != null) {
                IssueDialog(this)
                        .builder()
                        .setTitle("请选择问题类型")
                        .setTypes(mType)
                        .setListener(object : IssueDialog.onSureListener {
                            override fun onCancel() {}

                            override fun onSure(index: Int, position: PositionsBean?) {}

                            override fun onSure(type: PositionsBean.TypesBean) {
                                issueType.text = type.type_name
                                typeName = type.type_name ?: ""
                                mIssueType = type.type
                                activateSubmit()
                            }
                        }).show()
            }
        }


        // 添加照片
        mAdapter?.setListener(object : ViewImageListener {
            override fun showBigImage(position: Int) {
                if (mIssueImage[position].file_uri != null) {
                    ShowBigImageActivity.newInstanceUri(this@TimeFindIssueActivity,  mIssueImage[position].file_uri, false)
//                    val intent = Intent(this@TimeFindIssueActivity, ShowBigImageActivity::class.java)
//                    intent.putExtra("UNNEED", "UNNEED")
//                    intent.putExtra("IMG_URI", mIssueImage[position].file_uri)
//                    startActivity(intent)
                }
            }

            override fun showDialog(position: Int) {
                BottomDialog(this@TimeFindIssueActivity)
                        .builder()
                        .addItems(arrayOf("拍照", "相册"))
                        .setCancel("取消") {}
                        .setItemClick { _, i ->
                            if (i == 0) { // 相机(单选)

                                autoObtainCameraPermission()
                            } else { // 相册(支持多选)
                                ImageSelectorUtils.openPhoto(this@TimeFindIssueActivity, Constants.REQUEST_PIC, false, 1, ArrayList<String>(), "")
                            }
                        }.show()
            }

            override fun deleteImage(position: Int) {
                mIssueImage.clear()
                mIssueImage.add(FilesBean())
                mAdapter?.list = mIssueImage
                addPhotoRv.adapter = mAdapter
                onSubmit.disable()
            }
        })
        // 补充问题描述
        etAddIssue.addTextChangedListener(object : TextWatcher {
            @SuppressLint("SetTextI18n")
            override fun afterTextChanged(s: Editable?) {
                val length = s?.length ?: 0
                limitCount.text = "还可输入${100 - length}个字"
            }

            override fun beforeTextChanged(s: CharSequence?, start: Int, count: Int, after: Int) {}

            override fun onTextChanged(s: CharSequence?, start: Int, before: Int, count: Int) {}
        })
    }

    private fun getPositions(i: Int): ArrayList<PositionsBean>? {
        return when (i) {
            FindIssueImageView.IMG1 -> mTop
            FindIssueImageView.IMG2 -> mInside
            FindIssueImageView.IMG3 -> mRight
            FindIssueImageView.IMG4 -> mAhead
            FindIssueImageView.IMG5 -> mLeft
            FindIssueImageView.IMG6 -> mBehind
            else -> ArrayList()
        }
    }

    private fun getDataRequest(): TimeFindIssueRequest {
        val request = TimeFindIssueRequest()
        request.car_id = carID
        request.order_id = orderID
        request.user_id = userUtil?.userId.toString()
        request.position = mIssueBody
        request.type = mIssueType
        request.image = mIssueUrl
        if (!TextUtils.isEmpty(etAddIssue.text.toString()))
            request.comments = etAddIssue.text.toString()
        return request
    }

    private fun activateSubmit() {
        if (!TextUtils.isEmpty(mIssueBody) && !TextUtils.isEmpty(mIssueType) && mIssueImage[0].file_uri != null) onSubmit.normal() else onSubmit.disable()
    }

    private fun setImages(image: String) {
        LogUtil.e("setImage")
        mIssueImage[0].file_uri = image
        mAdapter?.list = mIssueImage
        addPhotoRv.adapter = mAdapter
        activateSubmit()
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)

        when (requestCode) {
            Constants.REQUEST_PIC -> {
                if (data != null) {
                    val images = data!!.getStringArrayListExtra(ImageSelectorUtils.SELECT_RESULT)
                    if (images[0] != null)
                        setImages(images[0])
                }
            }
            CarEntity.REQUEST_CAMERA -> {
                if (resultCode == Activity.RESULT_OK) {
                    LogUtil.e("fileUri--->" + fileUri.toString())
                    val file = PhotoUtils.compressFile(this@TimeFindIssueActivity, fileUri)
                    setImages(file.absolutePath)
                }

            }
        }
    }

    private val uploadListener = object : UploadListener {
        override fun onUploadComplete(success: HashMap<Int, String>, failure: HashMap<Int, String>) {}

        override fun onUploadComplete(net: String?, local: String?) {
            if (!TextUtils.isEmpty(net)) {
                mIssueUrl = net
                if (isRental) {
                    val v = CarValidatesBean()
                    v.car_id = carID
                    v.order_id = orderID
                    v.user_id = userUtil?.userId.toString()
                    v.position_name = positionName
                    v.position = mIssueBody
                    v.type_name = typeName
                    v.type = mIssueType
                    v.image = net
                    v.comments = etAddIssue.text.toString()
                    try {
                        LiveDataBus.get().with(ConstantsUtil.VALIDATES).postValue(v)
                        finish()
                    } catch (e: Exception) {
                        LogUtil.e("e  --------------- $e")
                    }

                } else {
                    LogUtil.e("onUploadComplete !rental--------->>>> $net")
                    presenter.requestData(getDataRequest())
                }

            } else {
                showToast("提交失败，请稍后重试！")
                dismissLoadingDialog()
            }
        }
    }

    override fun onDestroy() {

        if (mDisposable != null && !mDisposable?.isDisposed!!) {
            mDisposable!!.dispose()
        }
        super.onDestroy()
        unregisterReceiver(receiver)
    }

    private fun registerReceiver() {
        val intentFilter = IntentFilter()
        intentFilter.addAction(TimeCheckCarActivity.CHECK_FINISH)
        registerReceiver(receiver, intentFilter)
    }

    private val receiver = object : BroadcastReceiver() {
        override fun onReceive(context: Context?, intent: Intent?) {
            if (intent?.action == TimeCheckCarActivity.CHECK_FINISH) {
                finish()
            }
        }
    }

    override fun onTop(top: ArrayList<PositionsBean>) {
        mTop.clear()
        mTop.addAll(top)
    }

    override fun onAhead(ahead: ArrayList<PositionsBean>) {
        mAhead.clear()
        mAhead.addAll(ahead)
    }

    override fun onBehind(behind: ArrayList<PositionsBean>) {
        mBehind.clear()
        mBehind.addAll(behind)
    }

    override fun onLeft(left: ArrayList<PositionsBean>) {
        mLeft.clear()
        mLeft.addAll(left)
    }

    override fun onRight(right: ArrayList<PositionsBean>) {
        mRight.clear()
        mRight.addAll(right)
    }

    override fun onInside(inside: ArrayList<PositionsBean>) {
        mInside.clear()
        mInside.addAll(inside)
    }

    override fun onSuccess() {
        setResult(RESULT_SUCC, Intent())
        finish()
    }

    companion object {
        const val RESULT_SUCC = 9999

        fun newInstance(activity: Activity, orderId: String, carId: String, isRental: Boolean) {
            val intent = Intent(activity, TimeFindIssueActivity::class.java)
            intent.putExtra(ConstantsUtil.ORDER_ID, orderId)
            intent.putExtra(ConstantsUtil.CAR_ID, carId)
            intent.putExtra(ConstantsUtil.IS_RENTAL, isRental)
            activity.startActivityForResult(intent, RESULT_SUCC)
        }
    }

    /** .compose(rxPermissions.ensureEach(permission.CAMERA))
     * 自动获取相机权限
     */
    private fun autoObtainCameraPermission() {
        mDisposable = mRxPermissions.request(Manifest.permission.CAMERA, Manifest.permission.READ_EXTERNAL_STORAGE, Manifest.permission.WRITE_EXTERNAL_STORAGE).subscribe { granted ->
            if (granted) { // Always true pre-M
                // I can control the camera now
                PhotoUtils.takePicture(this@TimeFindIssueActivity, fileUri, CarEntity.REQUEST_CAMERA)
            } else {
                // Oups permission denied
                showToast("权限被拒绝")
            }
        }

    }
}