package com.jiaoyinbrother.monkeyking.manager.mvpactivity.timeinvoiceapply

import android.app.Activity
import android.content.Intent
import android.support.v4.content.ContextCompat
import android.text.Editable
import android.text.TextUtils
import android.text.TextWatcher
import android.view.View
import com.bigkoo.pickerview.builder.OptionsPickerBuilder
import com.bigkoo.pickerview.listener.OnOptionsSelectListener
import com.bigkoo.pickerview.view.OptionsPickerView
import com.google.gson.Gson
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseActivity
import com.jiaoyinbrother.monkeyking.manager.view.IOSdialog.IOSAlertDialog
import com.jiaoyinbrother.library.bean.ProvinceCityAreaBean
import com.jiaoyinbrother.library.bean.TimeInvoiceApplyRequest
import com.jiaoyinbrother.library.bean.TimeInvoiceBean
import com.jiaoyinbrother.library.util.*
import com.jiaoyinbrother.library.widget.GeneralBottomButton
import kotlinx.android.synthetic.main.activity_invoice_apply.*
import org.json.JSONArray

class TimeInvoiceApplyActivity : MvpBaseActivity<TimeInvoiceApplyPresenter>(), TimeInvoiceApplyContract.View,
        View.OnClickListener {
    override fun onInvoiceApplySuccess() {
        IOSAlertDialog(this@TimeInvoiceApplyActivity).builder()
                .setTitle("提示").setMsg(("发票信息已提交成功"), true)
                .setRightButton("知道了") {
                    //切换城市，更新城市地址
                    val intent = Intent()
                    intent.putExtra("setResult", "setResult")
                    setResult(Activity.RESULT_OK, intent)
                    finish()
                }.show()
    }

    private var timeInvoiceBean: TimeInvoiceBean? = null
    private var orderID: String? = null

    private var options1Items = ArrayList<ProvinceCityAreaBean>()
    private val options2Items = ArrayList<ArrayList<String>>()
    private val options3Items = ArrayList<ArrayList<ArrayList<String>>>()


    override fun initPresenter(): TimeInvoiceApplyPresenter {
        return TimeInvoiceApplyPresenter(this@TimeInvoiceApplyActivity, this)
    }


    override fun onClick(v: View?) {
        when (v) {
            textview_recipient_province -> {
                showLoadingDialog()
                loadProvinceUI()
                showPickerView()
                dismissLoadingDialog()
            }
        }
    }

    override fun getLayoutId(): Int {
        return R.layout.activity_invoice_apply
    }

    override fun initView() {

    }

    override fun initToolBar() {
        mainTitle?.text = "开具发票"

    }

    override fun initData() {
        try {
            val b = intent.extras
            timeInvoiceBean = b?.getSerializable(INVOICE_INFO) as? TimeInvoiceBean
            orderID = intent.getStringExtra(ConstantsUtil.ORDER_ID)
        } catch (e: Exception) {

        }
        if (timeInvoiceBean == null || orderID == null) {
            finish()
            return
        }

        textview_invoice_type.text = timeInvoiceBean?.type_name
        textview_invoice_content.text = timeInvoiceBean?.item
        textview_invoice_amount.text = MoneyUtil().getMoneyText(timeInvoiceBean?.amount.toString())

        button_submit.setText("提交")
        button_submit.disable()
    }


    override fun initListeners() {
        button_submit.setListener(object : GeneralBottomButton.SubmitListener {
            override fun submit() {
                presenter.invoiceApply(getTimeVoiceApplyRequest())
            }
        })

        edittext_invoice_name.addTextChangedListener(textWatcher)
        edittext_tax_number.addTextChangedListener(textWatcher)

        edittext_recipient_name.addTextChangedListener(textWatcher)
        edittext_recipient_phone.addTextChangedListener(textWatcher)
        edittext_recipient_address.addTextChangedListener(textWatcher)
        textview_recipient_province.addTextChangedListener(textWatcher)

        textview_recipient_province.setOnClickListener(this)
    }

    private fun getTimeVoiceApplyRequest(): TimeInvoiceApplyRequest {
        var timeInvoiceApplyRequest = TimeInvoiceApplyRequest()


        timeInvoiceApplyRequest.user_id = UserUtil(this@TimeInvoiceApplyActivity).userId.toString()

//        接口传递部分
        timeInvoiceApplyRequest.type = timeInvoiceBean?.type
        timeInvoiceApplyRequest.item = timeInvoiceBean?.item
        timeInvoiceApplyRequest.amount = timeInvoiceBean?.amount!!
        var orderList = ArrayList<String>()
        orderList.add(orderID!!)
        timeInvoiceApplyRequest.order_ids = orderList

//        用户填写部分
        timeInvoiceApplyRequest.title = edittext_invoice_name.text.toString()
        timeInvoiceApplyRequest.duty_code = edittext_tax_number.text.toString()
        timeInvoiceApplyRequest.recipients = edittext_recipient_name.text.toString()
        timeInvoiceApplyRequest.phone = edittext_recipient_phone.text.toString()
        timeInvoiceApplyRequest.address = textview_recipient_province.text.toString() + edittext_recipient_address.text.toString()


        return timeInvoiceApplyRequest
    }

    private var textWatcher = object : TextWatcher {
        override fun onTextChanged(s: CharSequence, start: Int, before: Int, count: Int) {
            checkInput()
        }

        override fun beforeTextChanged(s: CharSequence, start: Int, count: Int, after: Int) {}

        override fun afterTextChanged(s: Editable) {

        }
    }

    private fun checkInput() {
        if (TextUtils.isEmpty(edittext_invoice_name.text) || TextUtils.isEmpty(edittext_tax_number.text) ||
                TextUtils.isEmpty(edittext_recipient_name.text) || TextUtils.isEmpty(edittext_recipient_phone.text) ||
                TextUtils.isEmpty(textview_recipient_province.text) || TextUtils.isEmpty(edittext_recipient_address.text)) {
            button_submit.disable()
            return;
        }


        if (edittext_recipient_phone.text.length < 11) {
            button_submit.disable()
            return;
        }

        button_submit.normal()

    }

    private fun showPickerView() {// 弹出选择器
        val pvOptions: OptionsPickerView<Any> = OptionsPickerBuilder(this, OnOptionsSelectListener { options1, options2, options3, _ ->
            //返回的分别是三个级别的选中位置
            val text = options1Items[options1].pickerViewText +
                    options2Items[options1][options2] +
                    options3Items[options1][options2][options3]

            textview_recipient_province.text = text
        })
//                .setTitleText("城市选择")
                .setTitleText("")
                .setDividerColor(ContextCompat.getColor(this@TimeInvoiceApplyActivity, R.color.color_2))
                .setSubmitColor(ContextCompat.getColor(this@TimeInvoiceApplyActivity, R.color.color_6))
                .setCancelColor(ContextCompat.getColor(this@TimeInvoiceApplyActivity, R.color.color_3))
                .setTextColorCenter(ContextCompat.getColor(this@TimeInvoiceApplyActivity, R.color.color_5)) //设置选中项文字颜色
                .setContentTextSize(20)
                .build()

        var convertedItem1 = options1Items as List<Any>
        var convertedItem2 = options2Items as List<List<Any>>
        var convertedItem3 = options3Items as List<List<List<Any>>>
        pvOptions.setPicker(convertedItem1, convertedItem2, convertedItem3)//三级选择器
        pvOptions.show()
    }


    private fun loadProvinceUI() {
        var jsonData = FileUtils.getJsonFromFile(this@TimeInvoiceApplyActivity, "province.json")

        val provinceCityAreaBean = parseData(jsonData)//用Gson 转成实体

        /**
         * 添加省份数据
         *
         * 注意：如果是添加的JavaBean实体，则实体类需要实现 IPickerViewData 接口，
         * PickerView会通过getPickerViewText方法获取字符串显示出来。
         */
        options1Items = provinceCityAreaBean

        for (i in provinceCityAreaBean.indices) {//遍历省份
            val cityList = ArrayList<String>()//该省的城市列表（第二级）
            val provinceAreaList = ArrayList<ArrayList<String>>()//该省的所有地区列表（第三极）

            for (c in 0 until provinceCityAreaBean[i].cityList.size) {//遍历该省份的所有城市
                val cityName = provinceCityAreaBean[i].cityList[c].name
                cityList.add(cityName)//添加城市
                val cityAreaList = ArrayList<String>()//该城市的所有地区列表

                //如果无地区数据，建议添加空字符串，防止数据为null 导致三个选项长度不匹配造成崩溃
                if (provinceCityAreaBean[i].cityList[c].area == null || provinceCityAreaBean[i].cityList[c].area.size === 0) {
                    cityAreaList.add("")
                } else {
                    cityAreaList.addAll(provinceCityAreaBean[i].cityList[c].area)
                }
                provinceAreaList.add(cityAreaList)//添加该省所有地区数据
            }

            /**
             * 添加城市数据
             */
            options2Items.add(cityList)

            /**
             * 添加地区数据
             */
            options3Items.add(provinceAreaList)
        }
    }


    private fun parseData(result: String): ArrayList<ProvinceCityAreaBean> {//Gson 解析
        val detail = ArrayList<ProvinceCityAreaBean>()
        try {
            val data = JSONArray(result)
            val gson = Gson()
            for (i in 0 until data.length()) {
                val entity = gson.fromJson<ProvinceCityAreaBean>(data.optJSONObject(i).toString(), ProvinceCityAreaBean::class.java)
                detail.add(entity)
            }
        } catch (e: Exception) {
            LogUtil.e("exception, e= " + e.toString())
        }

        return detail
    }

    companion object {
        const val INVOICE_INFO = "INVOICE_INFO"

        fun startInvoiceApply(activity: Activity, orderId: String, timeInvoiceBean: TimeInvoiceBean, requestCode: Int) {
            val intent = Intent(activity, TimeInvoiceApplyActivity::class.java)
            intent.putExtra(ConstantsUtil.ORDER_ID, orderId)
            intent.putExtra(INVOICE_INFO, timeInvoiceBean)
            activity.startActivityForResult(intent, requestCode)
        }

    }


}
