package com.jiaoyinbrother.monkeyking.manager.mvpactivity.timeinvoiceapply

import android.content.Context
import com.jiaoyinbrother.library.base.BasePresenterImpl
import com.jiaoyinbrother.library.bean.BaseResult
import com.jiaoyinbrother.library.bean.TimeInvoiceApplyRequest
import com.jiaoyinbrother.library.retrofit.BaseObserver
import com.jiaoyinbrother.library.retrofit.RetrofitHelper
import io.reactivex.android.schedulers.AndroidSchedulers
import io.reactivex.schedulers.Schedulers
import java.util.concurrent.TimeUnit

/**
 * Created by Administrator on 2018/8/2.
 */

class TimeInvoiceApplyPresenter(context:Context, view: TimeInvoiceApplyContract.View): BasePresenterImpl<TimeInvoiceApplyContract.View>(context, view),
TimeInvoiceApplyContract.Presenter{
    override fun invoiceApply(request: TimeInvoiceApplyRequest) {
        val service = RetrofitHelper.getInstance(context).service

        val params = RetrofitHelper.getInstance(context).convertRequestToMap(request)

        val observable = service.timeInvoiceApply(params).debounce(1000, TimeUnit.MILLISECONDS)

        observable.subscribeOn(Schedulers.io()).doOnSubscribe {

            view.showLoadingDialog()

        }.observeOn(AndroidSchedulers.mainThread()).subscribe(object : BaseObserver<BaseResult>(context,this) {
            override fun onSuccess(response: BaseResult?) {
                view.dismissLoadingDialog()
                view.onInvoiceApplySuccess()

            }
        })
    }


}
