package com.jiaoyinbrother.monkeyking.manager.mvpactivity.timeknownissue

import android.app.Activity
import android.content.BroadcastReceiver
import android.content.Context
import android.content.Intent
import android.content.IntentFilter
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.activity.ShowBigImageActivity
import com.jiaoyinbrother.monkeyking.manager.adapter.KnownIssueAdapter
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseActivity
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.timecheckcar.TimeCheckCarActivity
import com.jiaoyinbrother.library.bean.CarValidatesBean
import com.jiaoyinbrother.library.bean.TimeKnownIssueRequest
import com.jiaoyinbrother.library.util.ConstantsUtil
import com.jiaoyinbrother.library.util.Util
import kotlinx.android.synthetic.main.activity_known_issue.*
import java.util.*

class TimeKnownIssueActivity : MvpBaseActivity<TimeKnownIssuePresenter>(), ITimeKnownIssueContract.view {


    private var carID: String? = null
    private var orderID: String? = null
    private var page = 1
    private var mAdapter: KnownIssueAdapter? = null
    private var mData = ArrayList<CarValidatesBean>()

    override fun initPresenter(): TimeKnownIssuePresenter {
        return TimeKnownIssuePresenter(this, this)
    }

    override fun getLayoutId(): Int {
        orderID = intent.getStringExtra(ConstantsUtil.ORDER_ID)
        carID = intent.getStringExtra(ConstantsUtil.CAR_ID)
        return R.layout.activity_known_issue
    }

    override fun initView() {}

    override fun initToolBar() {
        mainTitle.text = "已有问题"
    }

    override fun initData() {
        refreshLayout.setFooter()
        mAdapter = KnownIssueAdapter(this@TimeKnownIssueActivity)
        mAdapter?.list = mData
        issueRv.adapter = mAdapter

        presenter.requestData(getDataRequest())
    }

    override fun initListeners() {
        refreshLayout.setRefreshListener {
            page = 1
            presenter.requestData(getDataRequest())
            refreshLayout.refreshIsEnd()
        }
        refreshLayout.setMoreListener {
            presenter.requestData(getDataRequest())
            refreshLayout.loadMoreIsEnd()
        }
        mAdapter?.setOnItemClickListener { _, position ->
            val entity = mAdapter?.getItem<CarValidatesBean>(position)
            ShowBigImageActivity.newInstanceUri(this@TimeKnownIssueActivity, entity?.image
                    ?: "", false)
//            val intent = Intent(this@TimeKnownIssueActivity, ShowBigImageActivity::class.java)
//            intent.putExtra("UNNEED", "UNNEED")
//            intent.putExtra("IMG_URI", entity?.image)
//            startActivity(intent)
        }
    }

    override fun onStart() {
        super.onStart()
        registerReceiver()
    }

    private fun getDataRequest(): TimeKnownIssueRequest {
        val request = TimeKnownIssueRequest()
        request.car_id = carID
        request.stauts = ArrayList(Arrays.asList("ACCEPT"))
        request.page = page
        request.page_size = PAGE_SIZE
        return request
    }

    override fun onDestroy() {
        super.onDestroy()
        unregisterReceiver(receiver)
    }

    private fun registerReceiver() {
        val intentFilter = IntentFilter()
        intentFilter.addAction(TimeCheckCarActivity.CHECK_FINISH)
        registerReceiver(receiver, intentFilter)
    }

    private val receiver = object : BroadcastReceiver() {
        override fun onReceive(context: Context?, intent: Intent?) {
            if (intent?.action == TimeCheckCarActivity.CHECK_FINISH) {
                finish()
            }
        }
    }

    override fun setKnownIssues(issues: ArrayList<CarValidatesBean>) {
        if (!Util.isEmptyList(issues)) {
            if (page == 1) mData.clear()
            mData.addAll(issues)
            mAdapter?.list = mData
            mAdapter?.notifyDataSetChanged()
            page++
        }
    }

    companion object {
        const val PAGE_SIZE = 10

        fun newInstance(activity: Activity, orderId: String, carId: String) {
            val intent = Intent(activity, TimeKnownIssueActivity::class.java)
            intent.putExtra(ConstantsUtil.ORDER_ID, orderId)
            intent.putExtra(ConstantsUtil.CAR_ID, carId)
            activity.startActivity(intent)
        }
    }

}