package com.jiaoyinbrother.monkeyking.manager.mvpactivity.timeknownissue

import android.content.Context
import com.jiaoyinbrother.library.base.BasePresenterImpl
import com.jiaoyinbrother.library.bean.TimeKnownIssueRequest
import com.jiaoyinbrother.library.bean.TimeKnownIssueResult
import com.jiaoyinbrother.library.retrofit.BaseObserver
import com.jiaoyinbrother.library.retrofit.RetrofitHelper
import io.reactivex.android.schedulers.AndroidSchedulers
import io.reactivex.schedulers.Schedulers
import java.util.concurrent.TimeUnit

class TimeKnownIssuePresenter(context: Context, view: ITimeKnownIssueContract.view) :
        BasePresenterImpl<ITimeKnownIssueContract.view>(context, view), ITimeKnownIssueContract.presenter {


    override fun requestData(request: TimeKnownIssueRequest) {

        val service = RetrofitHelper.getInstance(context).service

        val params = RetrofitHelper.getInstance(context).convertRequestToMap(request)

        val observable = service.timeGetIssueList(params).debounce(1000, TimeUnit.MILLISECONDS)

        observable.subscribeOn(Schedulers.io()).doOnSubscribe {

            view.showLoadingDialog()

        }.observeOn(AndroidSchedulers.mainThread()).subscribe(object : BaseObserver<TimeKnownIssueResult>(context,this) {
            override fun onSuccess(response: TimeKnownIssueResult?) {
                view.dismissLoadingDialog()

                view.setKnownIssues(response?.car_validates)
            }
        })
    }

}