package com.jiaoyinbrother.monkeyking.manager.mvpactivity.timeorderdetail

import android.content.BroadcastReceiver
import android.content.Context
import android.content.Intent
import android.content.IntentFilter
import android.support.v7.widget.GridLayoutManager
import android.text.TextUtils
import android.view.View
import android.widget.Button
import com.bumptech.glide.Glide
import com.camnter.easyrecyclerview.holder.EasyRecyclerViewHolder
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.adapter.RuleAdapter
import com.jiaoyinbrother.monkeyking.manager.adapter.TimeOrderFeesAdapter
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseActivity
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.timecashierdesk.TimeCashierDeskActivity
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.timefeesdetail.TimeFeesDetailActivity
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.timeinvoiceapply.TimeInvoiceApplyActivity
import com.jiaoyinbrother.monkeyking.manager.util.H5Utils
import com.jiaoyinbrother.library.bean.TimeOrderDetailRequest
import com.jiaoyinbrother.library.bean.TimeOrderDetailResult
import com.jiaoyinbrother.library.util.*
import com.jiaoyinbrother.library.widget.GeneralBottomButton
import com.jiaoyinbrother.library.widget.SimpleItemDecoration
import com.sensorsdata.analytics.android.sdk.SensorsDataAPI
import kotlinx.android.synthetic.main.activity_time_order_detail.*

class TimeOrderDetailActivity : MvpBaseActivity<TimeOrderDetailPresenter>(), TimeOrderDetailContract.View, View.OnClickListener, EasyRecyclerViewHolder.OnItemClickListener {
    private var orderID = ""
    private var timeOrderFeesAdapter: TimeOrderFeesAdapter? = null
    private var mRuleAdapter: RuleAdapter? = null
    private var timeOrderDetailResult: TimeOrderDetailResult? = null

    override fun initPresenter(): TimeOrderDetailPresenter {
        return TimeOrderDetailPresenter(this@TimeOrderDetailActivity, this)
    }

    override fun getLayoutId(): Int {
        return R.layout.activity_time_order_detail
    }

    override fun initView() {

    }

    override fun initToolBar() {
        mainTitle?.text = "订单详情"


    }

    override fun initData() {

        try {
            orderID = intent.getStringExtra(ODRER_ID)
        } catch (e: Exception) {

        }
        if (TextUtils.isEmpty(orderID)) {
            finish()
            return
        }

        subTitle?.visibility = View.GONE

//       底部提示初始化
        mRuleAdapter = RuleAdapter(this@TimeOrderDetailActivity)
        val manager = GridLayoutManager(this, 2)
        rulesRv.layoutManager = manager
        mRuleAdapter?.list = getRules()
        val decoration = SimpleItemDecoration(this@TimeOrderDetailActivity, R.color.color_1)
        rulesRv.addItemDecoration(decoration)
        rulesRv.adapter = mRuleAdapter

        orderBottomBtn.setText("确认结算")


        LogUtil.e("initData, orderID= " + orderID)
        presenter.getOrderDetail(getOrderRequest())

    }

    override fun initListeners() {
        subTitle?.setOnClickListener(View.OnClickListener {
            //如果已经开具返回，
            if (timeOrderDetailResult == null || timeOrderDetailResult?.invoice == null || timeOrderDetailResult?.invoice?.exist == 1)
                return@OnClickListener

            SensorsDataAPI.sharedInstance().setViewID(subTitle, "order_sc_detail_invoice")
            TimeInvoiceApplyActivity.startInvoiceApply(this@TimeOrderDetailActivity, orderID, timeOrderDetailResult?.invoice!!, REQUEST_INVOICE_APPLY)
        })

        refreshLayout.setRefreshListener { presenter.getOrderDetail(getOrderRequest()) }

        timeContactService.setOnClickListener(this)
        costAndActivityLayout.setOnClickListener(this)
        mRuleAdapter?.setOnItemClickListener(this)

        orderBottomBtn.setListener(object : GeneralBottomButton.SubmitTimeListener {
            override fun submit(mButton: Button) {
                SensorsDataAPI.sharedInstance().setViewID(mButton, "order_sc_detail_confirmbill")
                TimeFeesDetailActivity.newInstance(this@TimeOrderDetailActivity, orderID, "订单详情")
            }
        })
    }

    override fun handleOrderDetailFailed() {
        refreshLayout.refreshIsEnd()
    }


    override fun handleOrderDetailSuccess(orderDetail: TimeOrderDetailResult) {
        refreshLayout.refreshIsEnd()

        if (orderDetail?.invoice != null && orderDetail.invoice?.exist == 0) {
            subTitle?.text = "开具发票"
        } else {
            subTitle?.text = ""
        }


        timeOrderDetailResult = orderDetail
//        更新订单信息部分
        updateOrderBasicInfo(orderDetail)

//        更新取还车部分
        time_order_takereturn_view.setData(orderDetail)

        // 费用部分
        costAmount.text = MoneyUtil().getMoneyText(orderDetail.bill?.total_amount.toString())

//        更新user/owener不同部分
        if (UserUtil(this@TimeOrderDetailActivity).userRole == UserUtil.USER_ROLE_RENTER) {
            handleOrderStatusUser(orderDetail.status)

            // 押金部分
            updateOtherFeesUser(orderDetail)
        } else {
            handleOrderStatusOwner(orderDetail.status)

            // 押金部分
            updateOtherFeesOwner(orderDetail)

        }

    }

    private fun handleOrderStatusUser(status: String?) {
        if (status == null) {
            finish()
            return
        }

        when (status) {
            TimeOrderUtil.TIME_ORDER_ACCEPTED, TimeOrderUtil.TIME_ORDER_UNLOCKING, TimeOrderUtil.TIME_ORDER_CAR_VALIDATE,
            TimeOrderUtil.TIME_ORDER_EXECUTING, TimeOrderUtil.TIME_ORDER_ILLEGAL_DEPOSIT_WAIT_PAYED -> {
                finish()
            }
            TimeOrderUtil.TIME_ORDER_BILL_APPLIED -> {
                subTitle?.visibility = View.GONE
                orderBottomBtn.visibility = View.VISIBLE
                costAndActivityLayout.visibility = View.VISIBLE
            }
            TimeOrderUtil.TIME_ORDER_BILL_ACCEPTED -> {
                subTitle?.visibility = View.VISIBLE
                orderBottomBtn.visibility = View.GONE
                costAndActivityLayout.visibility = View.VISIBLE
            }
            TimeOrderUtil.TIME_ORDER_FINISTHED -> {
                subTitle?.visibility = View.VISIBLE
                orderBottomBtn.visibility = View.GONE
                costAndActivityLayout.visibility = View.VISIBLE
            }
            TimeOrderUtil.TIME_ORDER_CANCELED -> {
                subTitle?.visibility = View.GONE
                orderBottomBtn.visibility = View.GONE
                costAndActivityLayout.visibility = View.GONE
            }

        }
    }

    private fun handleOrderStatusOwner(status: String?) {
        subTitle?.visibility = View.GONE
        orderBottomBtn.visibility = View.GONE
        costAndActivityLayout.visibility = View.VISIBLE
        when (status) {
            TimeOrderUtil.TIME_ORDER_ILLEGAL_DEPOSIT_WAIT_PAYED -> {
                finish()
            }
            TimeOrderUtil.TIME_ORDER_ACCEPTED, TimeOrderUtil.TIME_ORDER_UNLOCKING, TimeOrderUtil.TIME_ORDER_CAR_VALIDATE,
            TimeOrderUtil.TIME_ORDER_CANCELED, TimeOrderUtil.TIME_ORDER_EXECUTING -> {
                costAndActivityLayout.visibility = View.GONE
            }

        }
    }

    override fun onClick(v: View?) {
        when (v) {

        // 费用明细
            costAndActivityLayout -> {
//                StatisticsUtil.onEvent(this@TimeOrderDetailActivity, ConstantsUtil.ORDER_DETAIL_BILL, ConstantsUtil.ORDER_DETAIL_BILL)
                TimeFeesDetailActivity.newInstance(this@TimeOrderDetailActivity, orderID, "订单详情")
            }
        // 联系客服
            timeContactService -> {
//                StatisticsUtil.onEvent(this, ConstantsUtil.ORDER_DETAIL_CUSTOMER_SERVICE, ConstantsUtil.ORDER_DETAIL_CUSTOMER_SERVICE)
                H5Utils.contactService(this@TimeOrderDetailActivity)
                SensorsDataAPI.sharedInstance().setViewID(timeContactService, "order_sc_detail_contact_customer_service")
            }


        }
    }

    override fun onItemClick(convertView: View?, position: Int) {
        when (position) {
            0 -> { // 限行说明
//                StatisticsUtil.onEvent(this, ConstantsUtil.ORDER_DETAIL_RESTRICT_DRIVING, ConstantsUtil.ORDER_DETAIL_RESTRICT_DRIVING)
                H5Utils.onTimeLimitLine(this@TimeOrderDetailActivity)
                SensorsDataAPI.sharedInstance().setViewID(convertView, "order_sc_detail_carlimit_rule")
            }
            1 -> { // 油电费说明
//                StatisticsUtil.onEvent(this, ConstantsUtil.ORDER_DETAIL_OIL_ELE_FEE, ConstantsUtil.ORDER_DETAIL_OIL_ELE_FEE)
                H5Utils.onTimeCostsInfo(this@TimeOrderDetailActivity)
            }
            2 -> { // 出险理赔
//                StatisticsUtil.onEvent(this, ConstantsUtil.ORDER_DETAIL_CLAIM, ConstantsUtil.ORDER_DETAIL_CLAIM)
                H5Utils.onTimeClaims(this@TimeOrderDetailActivity)
                SensorsDataAPI.sharedInstance().setViewID(convertView, "order_sc_detail_claim")
            }
            3 -> { // 违章处理
//                StatisticsUtil.onEvent(this, ConstantsUtil.ORDER_DETAIL_LLLEGAL, ConstantsUtil.ORDER_DETAIL_LLLEGAL)
                H5Utils.onTimeIllegalProcessing(this@TimeOrderDetailActivity)
                SensorsDataAPI.sharedInstance().setViewID(convertView, "order_sc_detail_violation")
            }
        }
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        when (requestCode) {
            REQUEST_INVOICE_APPLY -> {
                if (data != null)
                    presenter.getOrderDetail(getOrderRequest())
            }
        }

    }

    private fun updateOtherFeesUser(orderDetail: TimeOrderDetailResult) {
        if (orderDetail.deposit == null || orderDetail.deposit!!.isEmpty()) {
            linearlayout_other_fees.visibility = View.GONE
            return
        }

        timeOrderFeesAdapter = TimeOrderFeesAdapter(TimeOrderFeesAdapter.TYPE_USER, this@TimeOrderDetailActivity)

        timeOrderFeesAdapter?.list = orderDetail.deposit
        timeOrderFeesAdapter?.setOnItemClickListener { _, position ->
            val bean = TimeCashierDeskActivity.CashierDeskParamBean()
            if (orderDetail.deposit != null) {

                val timeOthersFeeBean = orderDetail.deposit!![position]
                if (timeOthersFeeBean == null || timeOthersFeeBean.enabled != UserUtil.DEPOSIT_PAY_ENABLED)
                    return@setOnItemClickListener
                if (timeOthersFeeBean.type_name != null)
                    bean.description = timeOthersFeeBean.type_name!!
                bean.typeAPI = TimeCashierDeskActivity.TYPE_ORDER_PAY
                bean.entrance = mainTitle?.text.toString()
                bean.orderPayType = timeOthersFeeBean.type_code
                bean.amount = timeOthersFeeBean.amount
                bean.payMethodAvailable = timeOthersFeeBean.pay_method_avai!!
                bean.orderId = orderDetail.order_id
                TimeCashierDeskActivity.startTimeCashierDesk(this@TimeOrderDetailActivity, bean)
            }

        }
        recycler_other_fees.adapter = timeOrderFeesAdapter

    }


    private fun updateOtherFeesOwner(orderDetail: TimeOrderDetailResult) {
        if (orderDetail.deposit == null || orderDetail.deposit!!.isEmpty()) {
            linearlayout_other_fees.visibility = View.GONE
            return
        }
        timeOrderFeesAdapter = TimeOrderFeesAdapter(TimeOrderFeesAdapter.TYPE_OWNER, this@TimeOrderDetailActivity)
        timeOrderFeesAdapter?.list = orderDetail.deposit

        recycler_other_fees.adapter = timeOrderFeesAdapter

    }

    private fun getRules(): ArrayList<String> {
        val rules = ArrayList<String>()
        rules.add("限行规则&车辆限行查询说明")
        rules.add("油费说明&油费用计算须知")
        rules.add("出险理赔&用车保险说明")
        rules.add("违章处理&车辆租赁期违章处理")
        return rules
    }


    private fun updateOrderBasicInfo(orderDetail: TimeOrderDetailResult) {
        // 订单号
        orderNo.text = "订单号：${orderDetail.order_id}"
        // 订单状态
        orderStatus.text = orderDetail.status_name

        if (orderDetail.car != null) {
            // 车辆图片
            Glide.with(this@TimeOrderDetailActivity).load(orderDetail.car?.pic_url).into(carImg)
            // 车辆类型
            carType.text = orderDetail.car?.car_type_name
            // 车辆相关（SUV/1.5L自动/5座）
            carInfo.text = orderDetail.car?.description
            // 车牌号
            carNumber.text = orderDetail.car?.number
        }
    }

    /**
     * 获取订单详情
     *
     * @return TimeOrderDetailRequest
     * */
    private fun getOrderRequest(): TimeOrderDetailRequest {
        val request = TimeOrderDetailRequest()
        request.order_id = orderID
        request.user_id = UserUtil(this@TimeOrderDetailActivity).userId.toString()
        return request
    }

    override fun onStart() {
        super.onStart()
        registerReceiver()
    }

    override fun onDestroy() {
        unregisterReceiver(receiver)
        super.onDestroy()
    }

    /**
     * 接收广播刷新订单
     * */
    private fun registerReceiver() {
        val intentFilter = IntentFilter()
        intentFilter.addAction(ConstantsUtil.ORDER_REFRESH)
        registerReceiver(receiver, intentFilter)
    }

    private val receiver = object : BroadcastReceiver() {
        override fun onReceive(context: Context?, intent: Intent?) {
            if (intent?.action == ConstantsUtil.ORDER_REFRESH) {
                presenter.getOrderDetail(getOrderRequest())
            }
        }
    }


    companion object {
        const val ODRER_ID = "ODRER_ID"
        private val REQUEST_INVOICE_APPLY = 100
    }
}
