package com.jiaoyinbrother.monkeyking.manager.mvpactivity.timeorderdetail

import android.content.Context
import com.jiaoyinbrother.library.base.BasePresenterImpl
import com.jiaoyinbrother.library.bean.TimeOrderDetailRequest
import com.jiaoyinbrother.library.bean.TimeOrderDetailResult
import com.jiaoyinbrother.library.retrofit.ApiException
import com.jiaoyinbrother.library.retrofit.BaseObserver
import com.jiaoyinbrother.library.retrofit.RetrofitHelper
import io.reactivex.android.schedulers.AndroidSchedulers
import io.reactivex.schedulers.Schedulers
import java.util.concurrent.TimeUnit

/**
 * Created by Administrator on 2018/8/6.
 */

class TimeOrderDetailPresenter(context: Context, view: TimeOrderDetailContract.View) : BasePresenterImpl<TimeOrderDetailContract.View>(context, view),
        TimeOrderDetailContract.Presenter{
    override fun getOrderDetail(request: TimeOrderDetailRequest) {

        val service = RetrofitHelper.getInstance(context).service

        val params = RetrofitHelper.getInstance(context).convertRequestToMap(request)

        val observable = service.timeOrderDetail(params).debounce(1000, TimeUnit.MILLISECONDS)

        observable.subscribeOn(Schedulers.io()).doOnSubscribe {

            view.showLoadingDialog()

        }.observeOn(AndroidSchedulers.mainThread()).subscribe(object : BaseObserver<TimeOrderDetailResult>(context,this) {
            override fun onSuccess(response: TimeOrderDetailResult?) {
                view.dismissLoadingDialog()

                if(response!=null)
                    view.handleOrderDetailSuccess(response)
                else
                    view.handleOrderDetailFailed()

            }
        })
    }

    override fun handleException(apiExcpetion: ApiException?) {
        super.handleException(apiExcpetion)
        view.handleOrderDetailFailed()
    }

}
