package com.jiaoyinbrother.monkeyking.manager.mvpactivity.timepayresult

import android.content.Intent
import android.text.TextUtils
import android.view.View
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.util.MKUtil
import com.jiaoyinbrother.library.base.BaseActivity
import com.jiaoyinbrother.library.util.ConstantsUtil
import kotlinx.android.synthetic.main.activity_driver_licence_result.*

class TimePayResultActivity : BaseActivity() {

    private var type = ""

    companion object {
        const val ORDER_PAY_SUCCESS = "PAY_SUCCESS"
        const val ORDER_PAY_FAIL = "PAY_FAIL"

        const val DEPOSIT_PAY_FAIL = "DEPOSIT_PAY_FAIL"
        const val DEPOSIT_PAY_SUCCESS = "DEPOSIT_PAY_SUCCESS"
    }

    override fun getLayoutId(): Int {
        try {
            type = intent.getStringExtra(ConstantsUtil.ACTIVITY_TYPE)
        } catch (e: Exception) {

        }
        if (TextUtils.isEmpty(type)) {
            finish()
            return R.layout.activity_driver_licence_result
        }

        return R.layout.activity_driver_licence_result
    }

    override fun initView() {

    }

    override fun initToolBar() {
        when (type) {
            ORDER_PAY_SUCCESS, DEPOSIT_PAY_SUCCESS -> {
                //成功
                mainTitle?.text = "支付成功"
            }

            ORDER_PAY_FAIL, DEPOSIT_PAY_FAIL -> {
                //失败
                mainTitle?.text = "支付失败"
            }

        }
    }

    override fun initData() {
        view_result_data.visibility = View.VISIBLE
        when (type) {
            ORDER_PAY_SUCCESS -> {
                //成功
                view_result_data.setEmptyData(R.mipmap.icon_pay_success, "支付成功", "", "")
                view_result_data.setPositiveButton("查看订单", View.OnClickListener {
                    MKUtil.goBackMainPage(this@TimePayResultActivity, MKUtil.GO_MAIN_ORDER_LIST)
                })
            }

            ORDER_PAY_FAIL -> {
                //失败
                view_result_data.setEmptyData(R.mipmap.icon_pay_fail, "支付失败", "", "")
            }

            DEPOSIT_PAY_SUCCESS -> {
                //成功
                view_result_data.setEmptyData(R.mipmap.icon_pay_success, "支付成功", "", "")
                view_result_data.setPositiveButton("去用车", View.OnClickListener {
                    MKUtil.goBackMainPage(this@TimePayResultActivity, MKUtil.GO_MAIN_TIME)
                })
            }

            DEPOSIT_PAY_FAIL -> {
                //失败
                view_result_data.setEmptyData(R.mipmap.icon_pay_fail, "支付失败", "", "")
            }

        }

    }

    override fun initListeners() {

    }


    override fun onBackPressed() {
        sendBroadcast()
        super.onBackPressed()
    }

    private fun sendBroadcast() {
        val intent = Intent()
        intent.action = ConstantsUtil.ORDER_REFRESH
        intent.putExtra(ConstantsUtil.ORDER_REFRESH, ConstantsUtil.ORDER_REFRESH)
        this.sendBroadcast(intent)
    }
}
