package com.jiaoyinbrother.monkeyking.manager.mvpactivity.timereturncar

import android.app.Activity
import android.content.Context
import android.content.Intent
import android.text.TextUtils
import android.view.WindowManager
import android.widget.LinearLayout
import com.bumptech.glide.Glide
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseActivity
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.timefeesdetail.TimeFeesDetailActivity
import com.jiaoyinbrother.monkeyking.manager.util.MKUtil
import com.jiaoyinbrother.library.bean.TimeApplyCarRequest
import com.jiaoyinbrother.library.bean.TimeApplyCarResult
import com.jiaoyinbrother.library.util.ConstantsUtil
import com.jiaoyinbrother.library.util.DensityUtil
import com.jiaoyinbrother.library.util.StatisticsUtil
import com.jiaoyinbrother.library.widget.GeneralBottomButton
import kotlinx.android.synthetic.main.activity_time_return_car.*
import org.json.JSONException
import org.json.JSONObject

class TimeReturnCarActivity : MvpBaseActivity<TimeReturnCarPresenter>(), ITimeReturnCarContract.view {

    private var orderID = ""
    override fun initPresenter(): TimeReturnCarPresenter {
        return TimeReturnCarPresenter(this, this)
    }

    override fun getLayoutId(): Int {
        orderID = intent.getStringExtra(ConstantsUtil.ORDER_ID)
        return R.layout.activity_time_return_car
    }

    override fun initView() {}

    override fun initToolBar() {
        mainTitle.text = "确认还车"
    }

    override fun initData() {
        val wm = getSystemService(Context.WINDOW_SERVICE) as WindowManager
        val width = (wm.defaultDisplay.width - DensityUtil.dip2px(this@TimeReturnCarActivity, 15f) * 3) / 2
        val height = (width / 1.64).toInt()
        closeLamp.layoutParams = LinearLayout.LayoutParams(width, height)
        pullOutKey.layoutParams = LinearLayout.LayoutParams(width, height)
        putBackKey.layoutParams = LinearLayout.LayoutParams(width, height)
        closeDoors.layoutParams = LinearLayout.LayoutParams(width, height)

        Glide.with(this@TimeReturnCarActivity).load(R.mipmap.bg_close_car_lamp).into(closeLamp)
        Glide.with(this@TimeReturnCarActivity).load(R.mipmap.bg_pull_out_key).into(pullOutKey)
        Glide.with(this@TimeReturnCarActivity).load(R.mipmap.bg_put_back_key).into(putBackKey)
        Glide.with(this@TimeReturnCarActivity).load(R.mipmap.bg_close_car_doors).into(closeDoors)

    }

    override fun initListeners() {
        onReturnCar.setListener(object : GeneralBottomButton.SubmitListener {
            override fun submit() {

                Glide.with(this@TimeReturnCarActivity).load(R.mipmap.bg_close_car_lamp).into(closeLamp)
                Glide.with(this@TimeReturnCarActivity).load(R.mipmap.bg_pull_out_key).into(pullOutKey)
                Glide.with(this@TimeReturnCarActivity).load(R.mipmap.bg_put_back_key).into(putBackKey)
                Glide.with(this@TimeReturnCarActivity).load(R.mipmap.bg_close_car_doors).into(closeDoors)

                presenter.requestApplyCar(getApplyRequest())
            }
        })
    }

    private fun getApplyRequest(): TimeApplyCarRequest {
        val request = TimeApplyCarRequest()
        request.order_id = orderID
        return request
    }


    override fun onSuccess(result: TimeApplyCarResult) {
        if (TextUtils.isEmpty(result.warning)) {
            sensorsData(true, "")
            MKUtil.goBackMainPage(this)
            TimeFeesDetailActivity.newInstance(this@TimeReturnCarActivity, orderID,"确认还车")
        } else {
            showToast(result.toast)
            sensorsData(true, result.toast?:"")
            when (result.warning) {
                LIGHT_OFF -> Glide.with(this@TimeReturnCarActivity).load(R.mipmap.bg_close_car_lamp_selected).into(closeLamp)
                KEY_OUT -> Glide.with(this@TimeReturnCarActivity).load(R.mipmap.bg_pull_out_key_selected).into(pullOutKey)
                KEY_PUT -> Glide.with(this@TimeReturnCarActivity).load(R.mipmap.bg_put_back_key_selected).into(putBackKey)
                DOOR_CLOSE -> Glide.with(this@TimeReturnCarActivity).load(R.mipmap.bg_close_car_door_selected).into(closeDoors)

            }
        }
    }


    companion object {

        const val LIGHT_OFF = "LIGHT_OFF"
        const val KEY_OUT = "KEY_OUT"
        const val KEY_PUT = "KEY_PUT"
        const val DOOR_CLOSE = "DOOR_CLOSE"

        fun newInstance(activity: Activity, orderId: String) {
            val intent = Intent(activity, TimeReturnCarActivity::class.java)
            intent.putExtra(ConstantsUtil.ORDER_ID, orderId)
            activity.startActivity(intent)
        }
    }

    /**
     * 神策埋点
     * */
    private fun sensorsData(success: Boolean, reason: String) {
        val properties = JSONObject()
        try {
            properties.put("order_id", orderID)
            properties.put("is_success", success)
            properties.put("fail_reason", reason)
            StatisticsUtil.onSensorsDataTrack(ConstantsUtil.E_SC_RETURNCAR_STEP2, properties)
        } catch (e: JSONException) {
            e.printStackTrace()
        }
    }
}