package com.jiaoyinbrother.monkeyking.manager.mvpactivity.timereturncar

import android.content.Context
import com.jiaoyinbrother.library.base.BasePresenterImpl
import com.jiaoyinbrother.library.bean.TimeApplyCarRequest
import com.jiaoyinbrother.library.bean.TimeApplyCarResult
import com.jiaoyinbrother.library.retrofit.BaseObserver
import com.jiaoyinbrother.library.retrofit.RetrofitHelper2
import io.reactivex.android.schedulers.AndroidSchedulers
import io.reactivex.schedulers.Schedulers
import java.util.concurrent.TimeUnit

class TimeReturnCarPresenter(context: Context, view: ITimeReturnCarContract.view) :
        BasePresenterImpl<ITimeReturnCarContract.view>(context, view), ITimeReturnCarContract.presenter {


    /**
     * 锁门并还车
     * */
    override fun requestApplyCar(request: TimeApplyCarRequest) {
        val service = RetrofitHelper2.getInstance(context).service
        val params = RetrofitHelper2.getInstance(context).convertRequestToMap(request)
        val observable = service.timeApplyCar(params).debounce(1000, TimeUnit.MILLISECONDS)
        observable
                .subscribeOn(Schedulers.io())
                .doOnSubscribe {
                    view.showLoadingDialog()
                }
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(object : BaseObserver<TimeApplyCarResult>(context,this) {
                    override fun onSuccess(response: TimeApplyCarResult?) {
                        view.dismissLoadingDialog()
                        view.onSuccess(response)
                    }
                })
    }

}