package com.jiaoyinbrother.monkeyking.manager.mvpactivity.timeusingcar

import android.annotation.SuppressLint
import android.content.Context
import android.content.Intent
import android.text.SpannableStringBuilder
import android.text.TextUtils
import android.view.View
import com.baidu.location.BDLocation
import com.bumptech.glide.Glide
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseActivity
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.timereturncar.TimeReturnCarActivity
import com.jiaoyinbrother.monkeyking.manager.util.DialogUtil
import com.jiaoyinbrother.monkeyking.manager.util.MKUtil
import com.jiaoyinbrother.monkeyking.manager.view.IOSdialog.IOSAlertDialog
import com.jiaoyinbrother.library.bean.*
import com.jiaoyinbrother.library.util.*
import com.jiaoyinbrother.library.widget.GeneralBottomButton
import com.jiaoyinbrother.library.widget.TimeCostDialog
import com.sensorsdata.analytics.android.sdk.SensorsDataAPI
import io.reactivex.Flowable
import io.reactivex.android.schedulers.AndroidSchedulers
import io.reactivex.disposables.Disposable
import kotlinx.android.synthetic.main.activity_time_using_car.*
import org.json.JSONException
import org.json.JSONObject
import java.util.concurrent.TimeUnit

class TimeUsingCarActivity : MvpBaseActivity<TimeUsingCarPresenter>(), ITimeUsingCarContract.view {

    private var orderID = ""
    private var carID = ""
    private var carControlType = ""
    private var returnSiteID = ""
    private var amount = ""
    private var userUtil: UserUtil? = null
    private var mReturnSite: SiteBean? = null
    private var mCountDown: Disposable? = null
    private var mOrderInfo: TimeOrderDetailResult? = null
    private var mCalcInfo: TimeOrderCalcResult? = null

    override fun initPresenter(): TimeUsingCarPresenter {
        return TimeUsingCarPresenter(this, this)
    }

    override fun getLayoutId(): Int {
        orderID = intent.getStringExtra(ConstantsUtil.ORDER_ID)
        return R.layout.activity_time_using_car
    }

    override fun initView() {}

    override fun initToolBar() {
        mainTitle.text = "用车中"
        subImg1.setBackgroundResource(R.mipmap.ic_find_white)
    }

    override fun initData() {
        userUtil = UserUtil(this)
        presenter.requestOrderInfo(getOrderInfoRequest())
        countDown()
    }

    override fun initListeners() {
        //客服
        subImg1.setOnClickListener({
            DialogUtil.setMainServiceDialog(this@TimeUsingCarActivity, {})
            SensorsDataAPI.sharedInstance().setViewID(subImg1, "order_sc_customer_service")
        })
        // 日租规则dialog
        dailyRentPrompt.setOnClickListener({
            showTimeCostDialog()
        })
        //  时租计费dialog
        timeRentPrompt.setOnClickListener({
            showTimeCostDialog()
            SensorsDataAPI.sharedInstance().setViewID(timeRentPrompt, "order_sc_cost_rule")

        })
        // 切换预计还车网点
        siteLayout.setOnClickListener({
//            val intent = Intent(this, TimeReturnSiteListActivity::class.java)
//            intent.putExtra(TimeShareCarFragment.SITE, mReturnSite)
//            startActivityForResult(intent, TimeConfirmOrderActivity.REQUEST_RETURN_SITE)
        })
        // 第三方导航
        siteLocation.setOnClickListener {
            val location = BDLocation()
            location.latitude = UserLocationUtil(this@TimeUsingCarActivity).userGPSLocation.lat
            location.longitude = UserLocationUtil(this@TimeUsingCarActivity).userGPSLocation.lng
            MapUtil().startChooseMap(this@TimeUsingCarActivity, UserLocationUtil(this@TimeUsingCarActivity).userGPSLocation, mReturnSite?.location!!, mReturnSite?.name!!)

            SensorsDataAPI.sharedInstance().setViewID(siteLocation, "order_sc_navigation")
        }
        // 开锁
        openCar.setOnClickListener {
            presenter.requestCarControl(getCarControlRequest(CarControlUtil().carUnlock), 1)
        }
        // 锁车
        lockCar.setOnClickListener({
            presenter.requestCarControl(getCarControlRequest(CarControlUtil().carLock), 1)
        })
        // 还车
        onBackCar.setListener(object : GeneralBottomButton.SubmitListener {
            override fun submit() {
                presenter.requestBackCar(getCalcRequest(APPLY))
            }
        })
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        when (requestCode) {
//            TimeConfirmOrderActivity.REQUEST_RETURN_SITE -> {
//                val serializableExtra = data?.getSerializableExtra(TimeShareCarFragment.RETURN_SITE)
//                if (serializableExtra != null) {
//                    mReturnSite = serializableExtra as SiteBean
//                    returnSiteID = mReturnSite?.siteid.toString()
//                    presenter.requestSiteModify(getSiteRequest())
//                }
//            }
        }
    }

    override fun onDestroy() {
        mCountDown?.dispose()
        super.onDestroy()
    }

    /**
     * 返回首页
     * */
    override fun onBackPressed() {
        MKUtil.goBackMainPage(this)
    }

    /**
     * 费用明细
     * */
    private fun showTimeCostDialog() {
        TimeCostDialog(this@TimeUsingCarActivity)
                .build()
                .setData(mCalcInfo)
                .show()
    }

    /**
     * 分时订单计算
     *
     * @return TimeOrderCalcRequest
     * */
    private fun getCalcRequest(type: String): TimeOrderCalcRequest {
        val request = TimeOrderCalcRequest()
        request.order_id = orderID
        request.type = type
        return request
    }

    /**
     * 分时订单详情
     *
     * @return TimeOrderDetailRequest
     * */
    private fun getOrderInfoRequest(): TimeOrderDetailRequest {
        val request = TimeOrderDetailRequest()
        request.order_id = orderID
        request.user_id = userUtil?.userId.toString()
        return request
    }

    /**
     * 分时切换网点
     *
     * @return TimeSiteModifyRequest
     * */
    private fun getSiteRequest(): TimeSiteModifyRequest {
        val request = TimeSiteModifyRequest()
        request.order_id = orderID
        request.type = "SITE"
        request.return_site_id = returnSiteID
        return request
    }

    /**
     * 分时车辆控制
     *
     * @return TimeCarControlRequest
     * */
    private fun getCarControlRequest(type: String): TimeCarControlRequest {
        carControlType = type
        val request = TimeCarControlRequest()
        request.user_id = userUtil?.userId.toString()
        request.role = userUtil?.userRole.toString()
        request.order_id = orderID
        request.car_id = carID
        request.control_type = type
        return request
    }

    private fun countDown() {
        mCountDown = Flowable.interval(COUNT_DOWN, TimeUnit.MINUTES)
                .onBackpressureDrop()
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe({ _ ->
                    presenter.requestCalcInfo(getCalcRequest(CALC))
                })
    }

    /**
     * 分时calc result
     * */
    override fun setCalcSuccess(result: TimeOrderCalcResult) {
        mCalcInfo = result
        val bill = result.bill
        // 分时转日租提示 黄条
        if (Util.isEmptyList(result.prompt)) {
            promptLayout.visibility = View.GONE
        } else {
            promptLayout.visibility = View.VISIBLE
            val spannableString = SpannableStringBuilder("")
            TextUtil.generatePromptString(spannableString, result.prompt)
            prompt.text = spannableString
        }
        amount = bill.total_amount.toString()
        // 分时|日租
        if (bill?.is_short_rent == ConstantsUtil.RENT_TIME) {
            // 分时
            dailyRentLayout.visibility = View.GONE
            timeRentLayout.visibility = View.VISIBLE
            // 分时价格
            timeRentMileage.text = if (bill.miles == 0.0f) "-" else bill.miles.toString()
            timeRentUseTime.text = if (bill.times == 0.0f) "0" else bill.times?.toInt().toString()
            timeRentCost.text = MoneyUtil().getAmount(bill.total_amount.toString())
        } else {
            // 日租
            dailyRentLayout.visibility = View.VISIBLE
            timeRentLayout.visibility = View.GONE
            // 日租提醒
            dailyRentWarning.text = result.short_prompt
        }
        // 用车注意事项
        useCarPrompt.text = result.tips
    }

    /**
     * 分时order detail result
     * */
    @SuppressLint("SetTextI18n")
    override fun setOrderSuccess(result: TimeOrderDetailResult) {
        mOrderInfo = result
        val car = result.car
        if (car != null) {
            carID = car.car_id

            Glide.with(this@TimeUsingCarActivity).load(car.pic_url).into(usingCarImg)
            usingCarNumber.text = car.number
            usingCarInfo.text = "${car.car_type_name}|${car.color_name}|${car.carriage}|${car.capacity}座"
        }
        // 网点
        mReturnSite = result.return_site
        if (mReturnSite != null) {
            returnSiteID = mReturnSite?.siteid.toString()
            siteName.text = "${mReturnSite?.city} - ${mReturnSite?.name}"
            siteAddress.text = mReturnSite?.address
        }
        presenter.requestCalcInfo(getCalcRequest(CALC))
    }

    /**
     * 分时car control success result
     * */
    override fun setCarControlSuccess() {
        if (carControlType == CarControlUtil().carLock) {
            showToast("锁车成功")
            sensorsData(ConstantsUtil.E_SC_LOCKCAR, true, "")
        } else {
            showToast("开锁成功")
            sensorsData(ConstantsUtil.E_SC_UNLOCKCAR_STEP2, true, "")
        }
    }

    /**
     * 分时car control failed result
     * */
    override fun setCarControlFailed(msg: String) {
        showToast(msg)
        if (carControlType == CarControlUtil().carLock) {
            sensorsData(ConstantsUtil.E_SC_LOCKCAR, false, msg)
        } else {
            sensorsData(ConstantsUtil.E_SC_UNLOCKCAR_STEP2, true, msg)
        }
    }

    /**
     * 分时site modify
     * */
    override fun setSiteModify() {
        siteName.text = mReturnSite?.name
        siteAddress.text = mReturnSite?.address
        presenter.requestCalcInfo(getCalcRequest(CALC))
    }

    override fun setBackCar(result: TimeOrderCalcResult) {
        // 去还车dialog
        if (!TextUtils.isEmpty(result.toast)) {
            IOSAlertDialog(this@TimeUsingCarActivity)
                    .builder()
                    .setTitle("温馨提示")
                    .setMsg(result.toast, true)
                    .setRightButton("取消", {})
                    .setLeftButton("继续还车", {
                        sensorsData1()
                        TimeReturnCarActivity.newInstance(this@TimeUsingCarActivity, orderID)
                    })
                    .show()
        } else {
            TimeReturnCarActivity.newInstance(this@TimeUsingCarActivity, orderID)
        }
    }

    companion object {
        // 心跳间隔
        const val COUNT_DOWN = 5L
        const val CALC = "CALC"
        const val APPLY = "APPLY"

        fun newInstance(context: Context, orderId: String) {
            val intent = Intent(context, TimeUsingCarActivity::class.java)
            intent.putExtra(ConstantsUtil.ORDER_ID, orderId)
            context.startActivity(intent)
        }
    }

    /**
     * 神策埋点
     * */
    private fun sensorsData(key: String, success: Boolean, reason: String) {
        val properties = JSONObject()
        try {
            properties.put("order_id", orderID)
            properties.put("car_id", carID)
            properties.put("is_success", success)
            properties.put("fail_reason", reason)
            StatisticsUtil.onSensorsDataTrack(key, properties)
        } catch (e: JSONException) {
            e.printStackTrace()
        }
    }

    private fun sensorsData1() {
        val properties = JSONObject()
        try {
            properties.put("order_id", orderID)
            properties.put("car_id", carID)
            properties.put("real_return_site_id", returnSiteID)
            properties.put("order_amount", amount)
            StatisticsUtil.onSensorsDataTrack(ConstantsUtil.E_SC_RETURNCAR_STEP1, properties)
        } catch (e: JSONException) {
            e.printStackTrace()
        }
    }
}