package com.jiaoyinbrother.monkeyking.manager.mvpactivity.uploadcheckimage

import android.Manifest
import android.annotation.SuppressLint
import android.content.Context
import android.content.Intent
import android.net.Uri
import android.os.Build
import android.support.v4.content.FileProvider
import android.view.View
import com.jeremyliao.livedatabus.LiveDataBus
import com.jiaoyinbrother.library.bean.CheckImgBean
import com.jiaoyinbrother.library.util.LogUtil
import com.jiaoyinbrother.library.util.PhotoUtils
import com.jiaoyinbrother.monkeyking.manager.CarEntity
import com.jiaoyinbrother.monkeyking.manager.Constants
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseActivity
import com.jiaoyinbrother.monkeyking.manager.util.ImageSelectorUtils
import com.jiaoyinbrother.monkeyking.manager.view.CheckImageView
import com.tbruyelle.rxpermissions2.RxPermissions
import kotlinx.android.synthetic.main.activity_upload_check_image.*
import java.io.File

class UploadCheckImageActivity : MvpBaseActivity<UploadCheckImagePresenter>(), IUploadCheckImageContract.View {

    override fun initPresenter(): UploadCheckImagePresenter {
        return UploadCheckImagePresenter(this, this)
    }

    override fun getLayoutId(): Int {
        return R.layout.activity_upload_check_image
    }

    override fun initView() {
        onSure.disable()
    }

    override fun initToolBar() {
        mainTitle.text = "上传验车图片"
    }

    override fun initData() {
        presenter.getData(intent)
    }

    override fun initListeners() {
        onSure.setOnClickListener {
            presenter.onLoadPhotos()
        }

        pic_oil.setListener(object : CheckImageView.CheckCarClickListener {
            override fun onBigPhoto(url: String) {
                presenter.showBigImage(url)
            }

            override fun onDelPhoto() {
                presenter.onDelPath(UploadCheckImagePresenter.INDEX_OIL)
            }

            override fun onGetPhoto() {
                presenter.onGetPic(UploadCheckImagePresenter.INDEX_OIL)
            }
        })

        pic_oil_return.setListener(object : CheckImageView.CheckCarClickListener {
            override fun onBigPhoto(url: String) {
                presenter.showBigImage(url)
            }

            override fun onDelPhoto() {
                presenter.onDelPath(UploadCheckImagePresenter.INDEX_OIL)
            }

            override fun onGetPhoto() {
                presenter.onGetPic(UploadCheckImagePresenter.INDEX_OIL)
            }
        })

        pic_front.setListener(object : CheckImageView.CheckCarClickListener {
            override fun onBigPhoto(url: String) {
                presenter.showBigImage(url)
            }

            override fun onDelPhoto() {
                presenter.onDelPath(UploadCheckImagePresenter.INDEX_FRONT)
            }

            override fun onGetPhoto() {
                presenter.onGetPic(UploadCheckImagePresenter.INDEX_FRONT)
            }
        })

        pic_left_front_45.setListener(object : CheckImageView.CheckCarClickListener {
            override fun onBigPhoto(url: String) {
                presenter.showBigImage(url)
            }

            override fun onDelPhoto() {
                presenter.onDelPath(UploadCheckImagePresenter.INDEX_LEFT_FRONT)
            }

            override fun onGetPhoto() {
                presenter.onGetPic(UploadCheckImagePresenter.INDEX_LEFT_FRONT)
            }
        })

        pic_left.setListener(object : CheckImageView.CheckCarClickListener {
            override fun onBigPhoto(url: String) {
                presenter.showBigImage(url)
            }

            override fun onDelPhoto() {
                presenter.onDelPath(UploadCheckImagePresenter.INDEX_LEFT)
            }

            override fun onGetPhoto() {
                presenter.onGetPic(UploadCheckImagePresenter.INDEX_LEFT)
            }
        })

        pic_left_back_45.setListener(object : CheckImageView.CheckCarClickListener {
            override fun onBigPhoto(url: String) {
                presenter.showBigImage(url)
            }

            override fun onDelPhoto() {
                presenter.onDelPath(UploadCheckImagePresenter.INDEX_LEFT_BACK)
            }

            override fun onGetPhoto() {
                presenter.onGetPic(UploadCheckImagePresenter.INDEX_LEFT_BACK)
            }
        })

        pic_right_back_45.setListener(object : CheckImageView.CheckCarClickListener {
            override fun onBigPhoto(url: String) {
                presenter.showBigImage(url)
            }

            override fun onDelPhoto() {
                presenter.onDelPath(UploadCheckImagePresenter.INDEX_RIGHT_BACK)
            }

            override fun onGetPhoto() {
                presenter.onGetPic(UploadCheckImagePresenter.INDEX_RIGHT_BACK)
            }
        })

        pic_right.setListener(object : CheckImageView.CheckCarClickListener {
            override fun onBigPhoto(url: String) {
                presenter.showBigImage(url)
            }

            override fun onDelPhoto() {
                presenter.onDelPath(UploadCheckImagePresenter.INDEX_RIGHT)
            }

            override fun onGetPhoto() {
                presenter.onGetPic(UploadCheckImagePresenter.INDEX_RIGHT)
            }
        })

        pic_right_front_45.setListener(object : CheckImageView.CheckCarClickListener {
            override fun onBigPhoto(url: String) {
                presenter.showBigImage(url)
            }

            override fun onDelPhoto() {
                presenter.onDelPath(UploadCheckImagePresenter.INDEX_RIGHT_FRONT)
            }

            override fun onGetPhoto() {
                presenter.onGetPic(UploadCheckImagePresenter.INDEX_RIGHT_FRONT)
            }
        })
    }


    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        presenter.onActivityResult(requestCode, resultCode, data)
    }

    @SuppressLint("CheckResult")
    override fun setCamera(path: String) {

        val fileUri = File(path)

        var imageUri = Uri.fromFile(fileUri)
        //通过FileProvider创建一个content类型的Uri
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.N) {
            imageUri = FileProvider.getUriForFile(this, "$packageName.fileProvider", fileUri)
        }

        RxPermissions(this).request(Manifest.permission.CAMERA,
                Manifest.permission.READ_EXTERNAL_STORAGE, Manifest.permission.WRITE_EXTERNAL_STORAGE).subscribe({ granted ->
            if (granted) { // Always true pre-M
                if (imageUri != null)
                PhotoUtils.takePicture(this, imageUri!!, CarEntity.REQUEST_CAMERA)

//                PhotoUtils.takePicture(this@UploadCheckImageActivity, File(path), CarEntity.REQUEST_CAMERA)
            } else {
                //permission denied
            }
        }, { throwable ->
            LogUtil.e("RxJava throwable = $throwable")
        })
    }

    override fun setAlbum() {
        ImageSelectorUtils.openPhoto(this, Constants.REQUEST_PIC, true, 1, null, "")
    }

    override fun setOilPhoto(url: String?) {
        pic_oil.setData(url)
    }

    override fun setReturnOilPhoto(url: String?) {
        pic_oil_return.setData(url)
    }

    override fun setFrontPhoto(url: String?) {
        pic_front.setData(url)
    }

    override fun setLeftFrontPhoto(url: String?) {
        pic_left_front_45.setData(url)
    }

    override fun setLeftPhoto(url: String?) {
        pic_left.setData(url)
    }

    override fun setLeftBackPhoto(url: String?) {
        pic_left_back_45.setData(url)
    }

    override fun setRightFrontPhoto(url: String?) {
        pic_right_front_45.setData(url)
    }

    override fun setRightPhoto(url: String?) {
        pic_right.setData(url)
    }

    override fun setRightBackPhoto(url: String?) {
        pic_right_back_45.setData(url)
    }

    override fun setActiveSure(b: Boolean) {
        if (b) onSure.normal() else onSure.disable()
    }

    override fun setResultStatus4(images: ArrayList<CheckImgBean>) {
        LiveDataBus.get().with("Take_Check_Image").postValue(images)
        finish()
    }

    override fun setResultStatus5(images: ArrayList<CheckImgBean>) {
        LiveDataBus.get().with("Return_Check_Image").postValue(images)
        finish()
    }

    override fun setHideReturn() {
        pic_oil.visibility = View.VISIBLE
        pic_oil_return.visibility = View.GONE
    }

    override fun setHideTake() {
        pic_oil.visibility = View.GONE
        pic_oil_return.visibility = View.VISIBLE
    }

    companion object {
        fun newInstance(context: Context, status: Int, images: ArrayList<CheckImgBean>?) {
            val intent = Intent(context, UploadCheckImageActivity::class.java)
            intent.putExtra("ORDER_STATUS", status)
            intent.putExtra("CHECK_IMAGES", images)
            context.startActivity(intent)
        }
    }
}