package com.jiaoyinbrother.monkeyking.manager.mvpdialog.renthistorydialog

import android.app.Dialog
import android.os.Bundle
import android.support.v4.app.DialogFragment
import android.support.v4.content.ContextCompat
import android.view.Gravity
import android.view.View
import android.view.WindowManager
import com.jiaoyinbrother.library.bean.HistoryListBean
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpdialog.MVPDialogFragment
import kotlinx.android.synthetic.main.dialog_rent_history.*


class RentHistoryDialog : MVPDialogFragment<RentHistoryPresenter>(), RentHistoryContract.View{

    override fun setHistories(list: List<HistoryListBean>?) {
        mAdapter?.list = list
        rent_history_recyclerview.adapter = mAdapter
    }

    override fun getLayoutId(): Int {
        return R.layout.dialog_rent_history
    }

    override fun initViews(view: View?, savedInstanceState: Bundle?) {
        setStyle(DialogFragment.STYLE_NO_FRAME, R.style.Dialog_Transparent)
    }

    override fun initToolbar(savedInstanceState: Bundle?) {

    }

    override fun initListeners() {
        cancel_ll?.setOnClickListener {
            dismiss()
        }
    }

    override fun onCreateDialog(savedInstanceState: Bundle?): Dialog {
        val dialog = Dialog(requireContext(),theme)
        dialog.setCancelable(false)
        dialog.setCanceledOnTouchOutside(false)
//        return super.onCreateDialog(savedInstanceState)
        return dialog
    }

    override fun onActivityCreated(savedInstanceState: Bundle?) {
        super.onActivityCreated(savedInstanceState)

        //dialog弹出样式
        dialog?.window?.setBackgroundDrawable(ContextCompat.getDrawable(context!!, R.drawable.bg_dialog_car_detail))
        dialog?.window?.setLayout(WindowManager.LayoutParams.MATCH_PARENT, WindowManager.LayoutParams.WRAP_CONTENT)
        dialog?.window?.setGravity(Gravity.BOTTOM)
        dialog?.window?.setWindowAnimations(R.style.dialog_anim_down2up)
    }

    private var mAdapter : RentHistoryAdapter ?= null

    override fun initData() {
        mAdapter = RentHistoryAdapter()
        val bundle = arguments
        if (bundle !=null){
            val userId = bundle.getString("RENTER_USER_ID")
            presenter.getHistories(userId?:"")
        }
    }

    override fun initPresenter(): RentHistoryPresenter {
        return RentHistoryPresenter(context!!,this)
    }

}