package com.jiaoyinbrother.monkeyking.manager.mvpdialog.renthistorydialog

import android.content.Context
import com.jiaoyinbrother.library.base.BasePresenterImpl
import com.jiaoyinbrother.library.bean.OrderDetailRequest
import com.jiaoyinbrother.library.bean.OrderManagerHistory
import com.jiaoyinbrother.library.bean.OrdersRequest
import com.jiaoyinbrother.library.retrofit.BaseObserver
import com.jiaoyinbrother.library.retrofit.RetrofitHelper
import io.reactivex.android.schedulers.AndroidSchedulers
import io.reactivex.schedulers.Schedulers
import java.util.concurrent.TimeUnit

class RentHistoryPresenter(context: Context, view: RentHistoryContract.View) :
    BasePresenterImpl<RentHistoryContract.View>(context, view), RentHistoryContract.Presenter {

    override fun getHistories(userId: String) {

        val request = OrdersRequest()
        request.user_id = userId
        val service = RetrofitHelper.getInstance(context).service
        val params = RetrofitHelper.getInstance(context).convertRequestToMap(request)
        val observable = service.getUserOrderHistory(params).debounce(1000, TimeUnit.MILLISECONDS)
        observable.subscribeOn(Schedulers.io()).doOnSubscribe {
            view.showLoadingDialog()
        }.observeOn(AndroidSchedulers.mainThread()).subscribe(object : BaseObserver<OrderManagerHistory>(context, this) {
            override fun onSuccess(response: OrderManagerHistory) {
                view.dismissLoadingDialog()
                view.setHistories(response.history_list)

            }
        })
    }


}
