package com.jiaoyinbrother.monkeyking.manager.mvpdialog.selectdate

import android.os.Bundle
import android.support.v4.app.DialogFragment
import android.support.v4.app.FragmentManager
import android.text.TextUtils
import android.view.Gravity
import android.view.View
import android.view.WindowManager
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpdialog.MVPDialogFragment
import kotlinx.android.synthetic.main.dialog_select_date_mvp.*
import java.util.*


class SelectDateMVPDialog : MVPDialogFragment<SelectDatePresenter>(), ISelectDateContract.View {

    override fun viewDismiss() {
        dismiss()
    }

    override fun setStartAndEndDate(start: String, end: String) {
        start_date_tv.text = start
        end_date_tv.text = end
    }

    override fun setTitle(title: String) {
        tv_type_time?.text = title
    }

    override fun setYearView(yearList: List<String>) {
        l_year?.data = yearList
    }

    override fun setDayView(dayList: List<String>) {
        l_day?.data = dayList

    }

    override fun getYearIndex(): Int {
        return l_year.selectedItemPosition
    }

    override fun setYearIndex(index: Int) {
        l_year.selectedItemPosition = index
    }

    override fun getDayIndex(): Int {
        return l_day.selectedItemPosition
    }

    override fun setDayIndex(index: Int) {
        l_day.selectedItemPosition = index
    }


    override fun getLayoutId(): Int {
        return R.layout.dialog_select_date_mvp
    }

    override fun initViews(view: View?, savedInstanceState: Bundle?) {

        l_year?.setOnItemSelectedListener { wheelView, _, position ->
            onTimeItemSelected()
        }

        l_day?.setOnItemSelectedListener { wheelView, _, position ->
            onTimeItemSelected()
        }

        btn_time_control_cancel?.setOnClickListener {
            dismiss()
        }
        btn_time_control_confirm?.setOnClickListener {
            presenter?.onConfirm()
        }
        start_date_ll?.setOnClickListener {
            presenter?.onTabClicked(SELECT_DATE_TAB_START)
        }
        end_date_ll?.setOnClickListener {
            presenter?.onTabClicked(SELECT_DATE_TAB_END)
        }
    }

    override fun setDateTabView(isStart: Boolean) {
        if (!isAdded) {
            return
        }
        if (isStart) {
            start_date_ll?.setBackgroundColor(resources.getColor(R.color.color_cd2811))
            start_name_tv?.setTextColor(resources.getColor(R.color.white))
            start_date_tv?.setTextColor(resources.getColor(R.color.white))
            end_date_ll?.setBackgroundColor(resources.getColor(R.color.color_f0f0f0))
            end_name_tv?.setTextColor(resources.getColor(R.color.color_444444))
            end_date_tv?.setTextColor(resources.getColor(R.color.color_444444))
        } else {
            start_date_ll?.setBackgroundColor(resources.getColor(R.color.color_f0f0f0))
            start_name_tv?.setTextColor(resources.getColor(R.color.color_444444))
            start_date_tv?.setTextColor(resources.getColor(R.color.color_444444))
            end_date_ll?.setBackgroundColor(resources.getColor(R.color.color_cd2811))
            end_name_tv?.setTextColor(resources.getColor(R.color.white))
            end_date_tv?.setTextColor(resources.getColor(R.color.white))
        }
    }

    override fun initToolbar(savedInstanceState: Bundle?) {

    }

    override fun initListeners() {

    }

    override fun initData() {
        if (arguments == null && mOnResultListener == null) {
            dismiss()
            return
        } else {
            presenter?.initData(arguments!!, mOnResultListener!!)
        }

    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setStyle(DialogFragment.STYLE_NO_FRAME, R.style.Dialog_Transparent)
    }

    override fun onActivityCreated(savedInstanceState: Bundle?) {
        super.onActivityCreated(savedInstanceState)
        //初始化样式
        dialog?.window?.setLayout(WindowManager.LayoutParams.MATCH_PARENT, WindowManager.LayoutParams.WRAP_CONTENT)
        dialog?.window?.setGravity(Gravity.BOTTOM)
        dialog?.window?.setWindowAnimations(R.style.dialog_anim_down2up)
    }

    override fun initPresenter(): SelectDatePresenter {
        return SelectDatePresenter(requireContext(), this)
    }

    private fun show(supportFragmentManager: FragmentManager?) {
        try {
            show(supportFragmentManager, "Date_dialog")
        } catch (e: Exception) {
        }
    }

    private var mOnResultListener: OnResultListener? = null

    private fun setResultListener(onResultListener: OnResultListener) {
        mOnResultListener = onResultListener
    }

    private var mDialogType = SELECT_DATE_TAB_END

    private fun setDialogType(dialogType: Int) {
        mDialogType = dialogType
    }

    companion object {

        const val SELECTED_DATE_TAB_TYPE = "SELECTED_TIME_TAB_TYPE"
        const val SELECT_DATE_START_DATE = "SELECT_DATE_START_DATE"
        const val SELECT_DATE_END_DATE = "SELECT_DATE_END_DATE"

        const val SELECT_DATE_TAB_START = 1
        const val SELECT_DATE_TAB_END = 2

        fun newMainDialog(
                startTime: String?,
                endTime: String?,
                tab: Int,
                listener: OnResultListener,
                fragmentManager: FragmentManager
        ) {
            val selectDateTimeMVPDialog = SelectDateMVPDialog()
            val bundle = Bundle()
            if (!TextUtils.isEmpty(startTime)) {
                bundle.putString(SELECT_DATE_START_DATE, startTime)
            }
            if (!TextUtils.isEmpty(endTime)) {
                bundle.putString(SELECT_DATE_END_DATE, endTime)
            }
            bundle.putInt(SELECTED_DATE_TAB_TYPE, tab)
            selectDateTimeMVPDialog.arguments = bundle
            selectDateTimeMVPDialog.setResultListener(listener)
            selectDateTimeMVPDialog.show(fragmentManager)
        }
    }


    private fun onTimeItemSelected() {
        btn_time_control_cancel?.isEnabled = true
        btn_time_control_confirm?.isEnabled = true
        presenter?.onLoopEnd()
    }

    interface OnResultListener {
        fun onConfirm(startDate: Date?, endDate: Date?)
    }
}
