package com.jiaoyinbrother.monkeyking.mvpdialog.selectdatetime

import android.os.Bundle
import android.support.v4.app.DialogFragment
import android.support.v4.app.FragmentManager
import android.view.Gravity
import android.view.View
import android.view.WindowManager
import android.widget.LinearLayout
import android.widget.TextView
import com.jiaoyinbrother.library.util.DateTimeUtil
import com.jiaoyinbrother.library.util.LogUtil
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpdialog.MVPDialogFragment
import com.zyyoona7.wheel.WheelView
import java.util.*


class SelectDateTimeMVPDialog : MVPDialogFragment<SelectDateTimePresenter>(), ISelectDateTimeContract.View {

    private var title_tv: TextView? = null
    private var dayView: WheelView<String>? = null
    private var hourView:  WheelView<String>? = null
    private var minuteView:  WheelView<String>? = null
    private var cancel_tv: View? = null
    private var submit_tv: View? = null
    private var show_date_ll: LinearLayout? = null
    private var start_date_ll: LinearLayout? = null
    private var end_date_ll: LinearLayout? = null
    private var start_name_tv: TextView? = null
    private var end_name_tv: TextView? = null
    private var start_date_tv: TextView? = null
    private var end_date_tv: TextView? = null


    override fun setDateTabVisibility(visibility: Int) {
        LogUtil.e("setDateTabVisibility, visibility = $visibility")
        show_date_ll?.visibility = visibility
    }

    override fun viewDismiss() {
        LogUtil.e("viewDismiss")
        dismiss()
    }

    override fun setTitle(title: String) {
        title_tv?.text = title
    }

    override fun setStartDateTabText(title: String) {
        start_date_tv?.text = title
    }

    override fun setEndDateTabText(title: String) {
        end_date_tv?.text = title
    }

    override fun getDateIndex(): Int {
        val index = dayView?.selectedItemPosition
        LogUtil.e("getDateIndex, index = $index")
        return index!!
    }

    override fun setDateIndex(index: Int) {
        LogUtil.e("setDateIndex, index = $index")
        dayView?.selectedItemPosition = index
    }

    override fun getHourIndex(): Int {
        val index = hourView?.selectedItemPosition
        LogUtil.e("getHourIndex, index = $index")
        return index!!
    }

    override fun setHourIndex(index: Int) {
        LogUtil.e("setHourIndex, index = $index")
        hourView?.selectedItemPosition = index
    }

    override fun getMinuteIndex(): Int {
        val index = minuteView?.selectedItemPosition
        LogUtil.e("getMinuteIndex, index = $index")
        return index!!
    }

    override fun setMinuteIndex(index: Int) {
        LogUtil.e("setMinuteIndex, index = $index")
        minuteView?.selectedItemPosition = index
    }

    override fun setHourView(hourList: List<String>) {
        if (hourList.isNotEmpty()) {
            hourView?.data = hourList
        }
    }

    override fun setMinuteView(minuteList: List<String>) {
        if (minuteList.isNotEmpty()) {
            minuteView?.data = minuteList
        }
    }

    override fun setDayView(dayList: List<String>) {
        LogUtil.e("setDayView, dayList = $dayList")
        if (dayList.isNotEmpty()){
            dayView?.data = dayList
        }
    }


    override fun getLayoutId(): Int {
        return R.layout.dialog_select_date_time_mvp
    }

    override fun initViews(view: View?, savedInstanceState: Bundle?) {

        title_tv = view?.findViewById(R.id.tv_type_time) as TextView
        cancel_tv = view?.findViewById(R.id.btn_time_control_cancel)
        submit_tv = view?.findViewById(R.id.btn_time_control_confirm)

        show_date_ll = view?.findViewById(R.id.show_date_ll) as LinearLayout
        start_date_ll = view?.findViewById(R.id.start_date_ll) as LinearLayout
        end_date_ll = view?.findViewById(R.id.end_date_ll) as LinearLayout
        start_name_tv = view?.findViewById(R.id.start_name_tv) as TextView
        end_name_tv = view?.findViewById(R.id.end_name_tv) as TextView
        start_date_tv = view?.findViewById(R.id.start_date_tv) as TextView
        end_date_tv = view?.findViewById(R.id.end_date_tv) as TextView

        dayView = view?.findViewById(R.id.l_day) as WheelView<String>
        hourView = view?.findViewById(R.id.l_hour) as  WheelView<String>
        minuteView = view?.findViewById(R.id.l_minute) as  WheelView<String>

        dayView?.setOnItemSelectedListener { wheelView, data, position ->
            onTimeItemSelected()
        }

        hourView?.setOnItemSelectedListener { wheelView, data, position ->

            onTimeItemSelected()
        }

        minuteView?.setOnItemSelectedListener { wheelView, data, position ->
            onTimeItemSelected()
        }

        cancel_tv?.setOnClickListener {
            dismiss()
        }
        submit_tv?.setOnClickListener {
            presenter?.onConfirm()
        }
        start_date_ll?.setOnClickListener {
            presenter?.onStartTimeTabClicked()
        }
        end_date_ll?.setOnClickListener {
            presenter?.onEndTimeTabClicked()
        }
    }

    override fun setDateTabView(isStart: Boolean) {
        //解决： Fragment not attached to a context 问题
        if(!isAdded){
            return
        }

        if (isStart) {
            start_date_ll?.setBackgroundColor(resources.getColor(R.color.color_FF3434))
            start_name_tv?.setTextColor(resources.getColor(R.color.white))
            start_date_tv?.setTextColor(resources.getColor(R.color.white))
            end_date_ll?.setBackgroundColor(resources.getColor(R.color.color_e5e5e5))
            end_name_tv?.setTextColor(resources.getColor(R.color.color_444444))
            end_date_tv?.setTextColor(resources.getColor(R.color.color_444444))
        } else {
            start_date_ll?.setBackgroundColor(resources.getColor(R.color.color_e5e5e5))
            start_name_tv?.setTextColor(resources.getColor(R.color.color_444444))
            start_date_tv?.setTextColor(resources.getColor(R.color.color_444444))
            end_date_ll?.setBackgroundColor(resources.getColor(R.color.color_FF3434))
            end_name_tv?.setTextColor(resources.getColor(R.color.white))
            end_date_tv?.setTextColor(resources.getColor(R.color.white))
        }
    }

    override fun initToolbar(savedInstanceState: Bundle?) {

    }

    override fun initListeners() {

    }

    override fun initData() {
        if (arguments == null && mOnResultListener == null) {
            dismiss()
            return
        } else {
            presenter?.initData(arguments!!, mOnResultListener!!)
        }

    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setStyle(DialogFragment.STYLE_NO_FRAME, R.style.Dialog_Transparent)
    }

    override fun onActivityCreated(savedInstanceState: Bundle?) {
        super.onActivityCreated(savedInstanceState)

        //初始化样式
        dialog?.window?.setLayout(WindowManager.LayoutParams.MATCH_PARENT, WindowManager.LayoutParams.WRAP_CONTENT)
        dialog?.window?.setGravity(Gravity.BOTTOM)
        dialog?.window?.setWindowAnimations(R.style.dialog_anim_down2up)
    }

    override fun initPresenter(): SelectDateTimePresenter {
        LogUtil.e("initPresenter********, mDialogType = $mDialogType")
        var presenter = SelectDateTimePresenter(context!!, this)

        when(mDialogType){
            TYPE_MAIN_START_END -> presenter = SelectDateTimeMainPresenter(context!!,this)
            TYPE_ADVANCE_BACK -> presenter = SelectDateTimeAdvanceBackPresenter(context!!,this)
            TYPE_ORDER_MODIFY -> presenter = SelectDateTimeModifyPresenter(context!!,this)
            TYPE_RELET -> presenter = SelectDateTimeReletPresenter(context!!,this)
        }

        return presenter
//        return SelectDateTimePresenter(context!!, this)
    }

    private fun show(supportFragmentManager: FragmentManager?) {
        try {
            show(supportFragmentManager, "datetime_dialog")
        } catch (e: Exception) {
        }
    }

    private var mOnResultListener: OnResultListener? = null

    private fun setResultListener(onResultListener: OnResultListener) {
        LogUtil.e("setResultListener*************************")
        mOnResultListener = onResultListener
    }

    private var mDialogType = TYPE_MAIN_START_END

    private fun setDialogType(dialogType:Int){
        mDialogType = dialogType
    }

    companion object Builder {
        const val START_TIME = "START_TIME"
        const val END_TIME = "END_TIME"
        const val MAX_TIME = "MAX_TIME"
        const val MIN_TIME = "MIN_TIME"

        const val SELECTED_TIME_TAB_TYPE = "SELECTED_TIME_TAB_TYPE"

        const val DIALOG_TYPE = "DIALOG_TYPE"
        //首页
        const val TYPE_MAIN_START_END = 1
        //提前还车
        const val TYPE_ADVANCE_BACK = 2
        //续租
        const val TYPE_RELET = 3
        //修改订单
        const val TYPE_ORDER_MODIFY = 4

        const val SELECT_DATE_TAB_START = 1
        const val SELECT_DATE_TAB_END = 2

        //修改订单相关
        const val MODIFY_TYPE = "MODIFY_TYPE"
        const val MODITY_0 = 0//取车时间可以修改，还车时间可以修改
        const val MODITY_1 = 1//取车时间不可以修改，还车时间可以修改
        const val MODITY_2 = 2//取车时间只能向前修改，只能向后修改
        const val MODITY_3 = 3//取车时间不可以修改，只能向后修改

        fun newMainDialog(
            startTime: Date,
            endTime: Date,
            defaultMode: Int,
            listener: OnResultListener,
            fragmentManager: FragmentManager
        ) {
            val selectDateTimeMVPDialog = SelectDateTimeMVPDialog()
            val bundle = Bundle()
            bundle.putSerializable(START_TIME, startTime)
            bundle.putSerializable(END_TIME, endTime)
            bundle.putInt(SELECTED_TIME_TAB_TYPE, defaultMode)
            bundle.putInt(DIALOG_TYPE, TYPE_MAIN_START_END)
            selectDateTimeMVPDialog.setDialogType(TYPE_MAIN_START_END)

            selectDateTimeMVPDialog.arguments = bundle
            selectDateTimeMVPDialog.setResultListener(listener)
            selectDateTimeMVPDialog.show(fragmentManager)

        }

        //endtime,显示的还车时间；maxEndTime,最大的还车时间
        fun newAdvanceBackDialog(
            endTime: Date,
            maxEndTime: Date,
            listener: OnResultListener,
            fragmentManager: FragmentManager
        ) {
            val selectDateTimeMVPDialog = SelectDateTimeMVPDialog()
            LogUtil.e("newAdvanceBackDialog, endTime=" + DateTimeUtil.dateToString(endTime))
            LogUtil.e("newAdvanceBackDialog, maxEndTime=" + DateTimeUtil.dateToString(maxEndTime))
            val bundle = Bundle()
            bundle.putSerializable(END_TIME, endTime)
            bundle.putSerializable(MAX_TIME, maxEndTime)
            bundle.putInt(SELECTED_TIME_TAB_TYPE, SELECT_DATE_TAB_END)
            bundle.putInt(DIALOG_TYPE, TYPE_ADVANCE_BACK)
            selectDateTimeMVPDialog.setDialogType(TYPE_ADVANCE_BACK)

            selectDateTimeMVPDialog.arguments = bundle
            selectDateTimeMVPDialog.setResultListener(listener)
            selectDateTimeMVPDialog.show(fragmentManager)

        }

        //endtime,显示的还车时间；minEndTime, 最小的还车时间，maxEndTime,最大的还车时间
        fun newOrderReletDialog(
            endTime: Date,
            minEndTime: Date,
            maxEndTime: Date,
            listener: OnResultListener,
            fragmentManager: FragmentManager
        ) {
            val selectDateTimeMVPDialog = SelectDateTimeMVPDialog()
            LogUtil.e("newOrderReletDialog, endTime=" + DateTimeUtil.dateToString(endTime))
            LogUtil.e("newOrderReletDialog, minEndTime=" + DateTimeUtil.dateToString(minEndTime))
            LogUtil.e("newOrderReletDialog, maxEndTime=" + DateTimeUtil.dateToString(maxEndTime))

            val bundle = Bundle()
            bundle.putSerializable(END_TIME, endTime)
            bundle.putSerializable(MAX_TIME, maxEndTime)
            bundle.putSerializable(MIN_TIME, minEndTime)
            bundle.putInt(SELECTED_TIME_TAB_TYPE, SELECT_DATE_TAB_END)
            bundle.putInt(DIALOG_TYPE, TYPE_RELET)
            selectDateTimeMVPDialog.setDialogType(TYPE_RELET)

            selectDateTimeMVPDialog.arguments = bundle
            selectDateTimeMVPDialog.setResultListener(listener)
            selectDateTimeMVPDialog.show(fragmentManager)

        }

        fun newOrderModifyDialog(
            startFlag: Int, endFlag: Int, selectedDateTab:Int,
            startTime: Date, endTime: Date, maxEndTime: Date, minEndTime: Date,
            listener: OnResultListener, fragmentManager: FragmentManager
        ) {

            var modifyType = MODITY_0
            if (startFlag == 1 && endFlag == 1) {
                modifyType = MODITY_0
            } else if (startFlag == 0 && endFlag == 1) {
                modifyType = MODITY_1
            } else if (startFlag == 2 && endFlag == 2) {
                modifyType = MODITY_2
            } else if (startFlag == 0 && endFlag == 2) {
                modifyType = MODITY_3
            }

            val selectDateTimeMVPDialog = SelectDateTimeMVPDialog()
            LogUtil.e("newAdvanceBackDialog, startTime=" + DateTimeUtil.dateToString(startTime))
            LogUtil.e("newAdvanceBackDialog, endTime=" + DateTimeUtil.dateToString(endTime))
            LogUtil.e("newAdvanceBackDialog, minEndTime=" + DateTimeUtil.dateToString(minEndTime))
            LogUtil.e("newAdvanceBackDialog, maxEndTime=" + DateTimeUtil.dateToString(maxEndTime))
            val bundle = Bundle()
            bundle.putSerializable(START_TIME, startTime)
            bundle.putSerializable(END_TIME, endTime)
            bundle.putSerializable(MAX_TIME, maxEndTime)
            bundle.putSerializable(MIN_TIME, minEndTime)
            bundle.putInt(SELECTED_TIME_TAB_TYPE, selectedDateTab)
            bundle.putInt(DIALOG_TYPE, TYPE_ORDER_MODIFY)
            bundle.putInt(MODIFY_TYPE, modifyType)
            selectDateTimeMVPDialog.setDialogType(TYPE_ORDER_MODIFY)

            selectDateTimeMVPDialog.arguments = bundle
            selectDateTimeMVPDialog.setResultListener(listener)
            selectDateTimeMVPDialog.show(fragmentManager)

        }
    }


    private fun onTimeItemSelected() {
        cancel_tv?.isEnabled = true
        submit_tv?.isEnabled = true

        presenter?.onLoopEnd()
    }

    interface OnResultListener {
        fun onConfirm(startDate: Date?, endDate: Date?)
    }
}
