package com.jiaoyinbrother.monkeyking.manager.mvpdialog.selectfestival

import android.graphics.Color
import android.graphics.drawable.ColorDrawable
import android.os.Bundle
import android.support.v4.app.FragmentManager
import android.support.v4.content.ContextCompat
import android.view.Gravity
import android.view.View
import android.view.WindowManager
import com.jiaoyinbrother.library.bean.HolidaysBean
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.adapter.SelectFestivalAdapter
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.price.holiday.PriceHolidayActivity
import com.jiaoyinbrother.monkeyking.manager.mvpdialog.MVPDialogFragment
import kotlinx.android.synthetic.main.dialog_select_festival.*
import java.io.Serializable

class SelectFestivalDialog : MVPDialogFragment<SelectFestivalPresenter>(), SelectFestivalContract.View {


    private var mAdapter: SelectFestivalAdapter? = null
    private var mHolidayList: ArrayList<HolidaysBean>? = null
    private var mOnListener: OnListener? = null

    override fun initPresenter(): SelectFestivalPresenter {
        return SelectFestivalPresenter(requireContext(), this)
    }

    override fun getLayoutId(): Int {
        return R.layout.dialog_select_festival
    }

    override fun initViews(view: View?, savedInstanceState: Bundle?) {
        mAdapter = SelectFestivalAdapter(requireContext())
        rv_festival?.adapter = mAdapter
    }

    override fun initData() {
        mHolidayList = arguments?.getSerializable(PriceHolidayActivity.HOLIDAY_LIST) as? ArrayList<HolidaysBean>
        val holidaysBean = arguments?.getSerializable(PriceHolidayActivity.HOLIDAY_RESULT) as? HolidaysBean
        mAdapter?.list = mHolidayList
        mAdapter?.notifyDataSetChanged()
        mAdapter?.setSelectItem(holidaysBean)
    }


    override fun initToolbar(savedInstanceState: Bundle?) {
    }

    override fun initListeners() {
        mAdapter?.setOnItemListener(object : SelectFestivalAdapter.OnItemListener {
            override fun onSelect(holiday: HolidaysBean?) {
                mOnListener?.onSelect(holiday)
                dismiss()
            }

        })


        tv_cancel?.setOnClickListener {
            dismiss()
        }
    }

    fun show(manager: FragmentManager?, holidayList: ArrayList<HolidaysBean>?,defaultHolidaysBean: HolidaysBean?) {
        try {
            if (holidayList == null || holidayList?.isEmpty()) {
                return
            }
            val bundle = Bundle()
            bundle.putSerializable(PriceHolidayActivity.HOLIDAY_LIST, holidayList as? Serializable)
            bundle.putSerializable(PriceHolidayActivity.HOLIDAY_RESULT,defaultHolidaysBean)
            arguments = bundle
            super.show(manager, "select_festival")
        } catch (e: Exception) {
        }
    }

    override fun onActivityCreated(savedInstanceState: Bundle?) {
        super.onActivityCreated(savedInstanceState)
        dialog?.window?.setBackgroundDrawable(ContextCompat.getDrawable(requireContext(), R.drawable.bg_dialog_car_detail))
        dialog?.window?.setLayout(WindowManager.LayoutParams.MATCH_PARENT, WindowManager.LayoutParams.WRAP_CONTENT)
        dialog?.window?.setGravity(Gravity.BOTTOM)
        dialog?.window?.setWindowAnimations(R.style.dialog_anim_down2up)
    }

    fun setOnListener(listener: OnListener) {
        this.mOnListener = listener
    }

    interface OnListener {
        fun onSelect(holiday: HolidaysBean?)
    }
}