package com.jiaoyinbrother.monkeyking.manager.mvpdialog.selectobject

import android.support.v7.widget.RecyclerView
import android.util.SparseArray
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.TextView
import com.jiaoyinbrother.library.bean.ManagerSiteBean
import com.jiaoyinbrother.monkeyking.manager.R

class SelectAnyAdapter(private val list: List<String>)
    : RecyclerView.Adapter<SelectAnyAdapter.ViewHolder>() {

    interface OnItemClickListener {
        fun onItemClick(v: View, pos: Int)
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): SelectAnyAdapter.ViewHolder {
        return ViewHolder(LayoutInflater.from(parent.context).inflate(R.layout.item_site_text, parent, false))
    }

    override fun onBindViewHolder(holder: SelectAnyAdapter.ViewHolder, position: Int) {
        val tvName = holder.findViewById<TextView>(R.id.tvName)
        tvName.text = list[position]
        tvName.tag = position
    }

    override fun getItemCount(): Int {
        return list.size
    }

    inner class ViewHolder(view: View) : RecyclerView.ViewHolder(view) {
        private val views: SparseArray<View> by lazy {
            SparseArray<View>()
        }

        fun <T : View?> findViewById(viewId: Int): T {
            var view = views[viewId]
            if (view == null) {
                view = itemView.findViewById(viewId)
                views.put(viewId, view)
            }
            return view as T
        }

    }
}
