package com.jiaoyinbrother.monkeyking.manager.mvpdialog.selectobject

import android.os.Bundle
import android.support.v4.app.DialogFragment
import android.support.v4.app.FragmentManager
import android.text.TextUtils
import android.view.Gravity
import android.view.View
import android.view.WindowManager
import com.jiaoyinbrother.library.util.LogUtil
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpdialog.MVPDialogFragment
import com.leochuan.CenterSnapHelper
import com.leochuan.ScaleLayoutManager
import com.leochuan.ViewPagerLayoutManager
import kotlinx.android.synthetic.main.dialog_select_object.*

class SelectAnyDialog : MVPDialogFragment<SelectAnyPresenter>(), ISelectAnyContract.View {


    private var listener: OnResultListener? = null

    override fun initPresenter(): SelectAnyPresenter {
        return SelectAnyPresenter(requireContext(), this)
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setStyle(DialogFragment.STYLE_NO_FRAME, R.style.Dialog_Transparent)
    }

    override fun onActivityCreated(savedInstanceState: Bundle?) {
        super.onActivityCreated(savedInstanceState)
        //初始化样式
        dialog?.window?.setLayout(WindowManager.LayoutParams.MATCH_PARENT, WindowManager.LayoutParams.WRAP_CONTENT)
        dialog?.window?.setGravity(Gravity.BOTTOM)
        dialog?.window?.setWindowAnimations(R.style.dialog_anim_down2up)
    }

    override fun getLayoutId(): Int = R.layout.dialog_select_object

    override fun initViews(view: View?, savedInstanceState: Bundle?) {}

    override fun initToolbar(savedInstanceState: Bundle?) {}

    override fun initListeners() {}

    override fun initData() {
        presenter.getData(arguments)

        val builder = ScaleLayoutManager.Builder(context, 0)
        builder.setMaxAlpha(1f)
        builder.setMinAlpha(0.7f)
        builder.setOrientation(ViewPagerLayoutManager.VERTICAL)
        val viewPagerLayoutManager = ScaleLayoutManager(builder)
        data_view.layoutManager = viewPagerLayoutManager
        val adapter = SelectAnyAdapter(presenter.mUseData)
        data_view.adapter = adapter
        val centerSnapHelper = CenterSnapHelper()
        centerSnapHelper.attachToRecyclerView(data_view)
        var indexOfFirst = presenter.mUseData.indexOfFirst { TextUtils.equals(presenter.defData, it) }
        if (indexOfFirst<0){
            indexOfFirst = 0
        }
        data_view.scrollToPosition(indexOfFirst)

        dialog_fg_submit_tv?.setOnClickListener {
            val result =  presenter.mUseData[viewPagerLayoutManager.currentPosition]
            LogUtil.e("Lyy selected result --->>>>${result}")
            listener?.onResult(result)
            dismiss()
        }

        dialog_fg_cancel_tv?.setOnClickListener {
            dismiss()
        }
    }

    private fun show(supportFragmentManager: FragmentManager?) {
        supportFragmentManager?.let {
            try {
                show(it, DIALOG_TYPE)
            } catch (e: Exception) {
            }
        }
    }

    companion object {
        const val DIALOG_TYPE = "SELECT_OBJECT"

        const val DIALOG_DEF_TITLE = "DIALOG_DEF_TITLE"
        const val DIALOG_DEF_DATA = "DIALOG_DEF_DATA"
        const val DIALOG_DATA = "DIALOG_DATA"

        fun newDialog(manager: FragmentManager, title: String?, defData: String?, data: ArrayList<Int>, listener: OnResultListener) {
            val dialog = SelectAnyDialog()
            val bundle = Bundle()
            if (!TextUtils.isEmpty(defData)) {
                bundle.putString(DIALOG_DEF_TITLE, title)
            }
            if (!TextUtils.isEmpty(defData)) {
                bundle.putString(DIALOG_DEF_DATA, defData)
            }
            bundle.putSerializable(DIALOG_DATA, data)
            dialog.arguments = bundle
            dialog.setOnResultListener(listener)
            dialog.show(manager)
        }
    }

    fun setOnResultListener(listener: OnResultListener) {
        this.listener = listener
    }

    interface OnResultListener {
        fun onResult(result: String)
    }

    override fun setTitle(title: String?) {
        dialog_fg_title_tv?.text = if (TextUtils.isEmpty(title)) "选择" else title
    }
}