package com.jiaoyinbrother.monkeyking.manager.push.oppo

import android.content.Context

import com.coloros.mcssdk.PushService
import com.coloros.mcssdk.mode.AppMessage
import com.coloros.mcssdk.mode.CommandMessage
import com.coloros.mcssdk.mode.SptDataMessage
import com.jiaoyinbrother.library.util.LogUtil


class OPPOPushReceiver : PushService() {

    /**
     * 普通应用消息，视情况看是否需要重写
     *
     * @param context
     * @param appMessage
     */
    override fun processMessage(context: Context?, appMessage: AppMessage?) {
        super.processMessage(context, appMessage)
        LogUtil.e("oppo appMessage ---" + appMessage.toString())
    }

    /**
     * 命令消息，主要是服务端对客户端调用的反馈，一般应用不需要重写此方法
     *
     * @param context
     * @param commandMessage
     */
    override fun processMessage(context: Context?, commandMessage: CommandMessage) {
        super.processMessage(context, commandMessage)
        LogUtil.e("oppo commandMessage content ---" + commandMessage.content)
        LogUtil.e("oppo commandMessage params ---" + commandMessage.params)
    }

    /**
     * 透传消息处理，应用可以打开页面或者执行命令,如果应用不需要处理透传消息，则不需要重写此方法
     *
     * @param context
     * @param sptDataMessage
     */
    override fun processMessage(context: Context?, sptDataMessage: SptDataMessage?) {
        super.processMessage(context, sptDataMessage)
        LogUtil.e("oppo sptDataMessage ---" + sptDataMessage.toString())
    }
}
