package com.jiaoyinbrother.monkeyking.manager.selfcheck

import android.Manifest
import android.annotation.SuppressLint
import android.app.Activity
import android.content.Context
import android.content.Intent
import android.view.View
import com.jiaoyinbrother.library.util.ConstantsUtil
import com.jiaoyinbrother.library.util.LogUtil
import com.jiaoyinbrother.library.util.PhotoUtils
import com.jiaoyinbrother.monkeyking.manager.CarEntity
import com.jiaoyinbrother.monkeyking.manager.Constants
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.MvpBaseActivity
import com.jiaoyinbrother.monkeyking.manager.util.ImageSelectorUtils
import com.jiaoyinbrother.monkeyking.manager.view.CheckImageView
import com.jiaoyinbrother.monkeyking.manager.view.IOSdialog.IOSAlertDialog
import com.tbruyelle.rxpermissions2.RxPermissions
import kotlinx.android.synthetic.main.activity_upload_check_image.*
import java.io.File

class SelfCheckActivity : MvpBaseActivity<SelfCheckPresenter>(), ISelfCheckContract.View {


    override fun initPresenter(): SelfCheckPresenter {
        return SelfCheckPresenter(this, this)
    }

    override fun getLayoutId(): Int {
        return R.layout.activity_upload_check_image
    }

    override fun initView() {
        onSure.disable()
    }

    override fun initToolBar() {
        mainTitle.text = "上传验车图片"
    }

    override fun initData() {
        presenter.getData(intent)
    }

    override fun initListeners() {
        onSure.setOnClickListener {
            presenter.onLoadPhotos()
        }

        pic_oil.setListener(object : CheckImageView.CheckCarClickListener {
            override fun onBigPhoto(url: String) {
                presenter.showBigImage(url)
            }

            override fun onDelPhoto() {
                presenter.onDelPath(SelfCheckPresenter.INDEX_OIL)
            }

            override fun onGetPhoto() {
                presenter.onGetPic(SelfCheckPresenter.INDEX_OIL)
            }
        })

        pic_oil_return.setListener(object : CheckImageView.CheckCarClickListener {
            override fun onBigPhoto(url: String) {
                presenter.showBigImage(url)
            }

            override fun onDelPhoto() {
                presenter.onDelPath(SelfCheckPresenter.INDEX_OIL)
            }

            override fun onGetPhoto() {
                presenter.onGetPic(SelfCheckPresenter.INDEX_OIL)
            }
        })

        pic_front.setListener(object : CheckImageView.CheckCarClickListener {
            override fun onBigPhoto(url: String) {
                presenter.showBigImage(url)
            }

            override fun onDelPhoto() {
                presenter.onDelPath(SelfCheckPresenter.INDEX_FRONT)
            }

            override fun onGetPhoto() {
                presenter.onGetPic(SelfCheckPresenter.INDEX_FRONT)
            }
        })

        pic_left_front_45.setListener(object : CheckImageView.CheckCarClickListener {
            override fun onBigPhoto(url: String) {
                presenter.showBigImage(url)
            }

            override fun onDelPhoto() {
                presenter.onDelPath(SelfCheckPresenter.INDEX_LEFT_FRONT)
            }

            override fun onGetPhoto() {
                presenter.onGetPic(SelfCheckPresenter.INDEX_LEFT_FRONT)
            }
        })

        pic_left.setListener(object : CheckImageView.CheckCarClickListener {
            override fun onBigPhoto(url: String) {
                presenter.showBigImage(url)
            }

            override fun onDelPhoto() {
                presenter.onDelPath(SelfCheckPresenter.INDEX_LEFT)
            }

            override fun onGetPhoto() {
                presenter.onGetPic(SelfCheckPresenter.INDEX_LEFT)
            }
        })

        pic_left_back_45.setListener(object : CheckImageView.CheckCarClickListener {
            override fun onBigPhoto(url: String) {
                presenter.showBigImage(url)
            }

            override fun onDelPhoto() {
                presenter.onDelPath(SelfCheckPresenter.INDEX_LEFT_BACK)
            }

            override fun onGetPhoto() {
                presenter.onGetPic(SelfCheckPresenter.INDEX_LEFT_BACK)
            }
        })

        pic_right_back_45.setListener(object : CheckImageView.CheckCarClickListener {
            override fun onBigPhoto(url: String) {
                presenter.showBigImage(url)
            }

            override fun onDelPhoto() {
                presenter.onDelPath(SelfCheckPresenter.INDEX_RIGHT_BACK)
            }

            override fun onGetPhoto() {
                presenter.onGetPic(SelfCheckPresenter.INDEX_RIGHT_BACK)
            }
        })

        pic_right.setListener(object : CheckImageView.CheckCarClickListener {
            override fun onBigPhoto(url: String) {
                presenter.showBigImage(url)
            }

            override fun onDelPhoto() {
                presenter.onDelPath(SelfCheckPresenter.INDEX_RIGHT)
            }

            override fun onGetPhoto() {
                presenter.onGetPic(SelfCheckPresenter.INDEX_RIGHT)
            }
        })

        pic_right_front_45.setListener(object : CheckImageView.CheckCarClickListener {
            override fun onBigPhoto(url: String) {
                presenter.showBigImage(url)
            }

            override fun onDelPhoto() {
                presenter.onDelPath(SelfCheckPresenter.INDEX_RIGHT_FRONT)
            }

            override fun onGetPhoto() {
                presenter.onGetPic(SelfCheckPresenter.INDEX_RIGHT_FRONT)
            }
        })
    }


    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        presenter.onActivityResult(requestCode, resultCode, data)
    }

    override fun setHideTakePic() {
        pic_oil.visibility = View.GONE
        pic_oil_return.visibility = View.VISIBLE
    }

    override fun setHideReturnPic() {
        pic_oil.visibility = View.VISIBLE
        pic_oil_return.visibility = View.GONE
    }

    @SuppressLint("CheckResult")
    override fun setCamera(path: String) {
        RxPermissions(this).request(Manifest.permission.CAMERA,
                Manifest.permission.READ_EXTERNAL_STORAGE, Manifest.permission.WRITE_EXTERNAL_STORAGE).subscribe({ granted ->
            if (granted) { // Always true pre-M
                PhotoUtils.takePicture(this@SelfCheckActivity, File(path), CarEntity.REQUEST_CAMERA)
            } else {
                //permission denied
            }
        }, { throwable ->
            LogUtil.e("RxJava throwable = $throwable")
        })
    }

    override fun setAlbum() {
        ImageSelectorUtils.openPhoto(this, Constants.REQUEST_PIC, true, 1, null, "")
    }

    override fun setOilPhoto(url: String?) {
        pic_oil.setData(url)
    }

    override fun setReturnOilPhoto(url: String?) {
        pic_oil_return.setData(url)
    }

    override fun setFrontPhoto(url: String?) {
        pic_front.setData(url)
    }

    override fun setLeftFrontPhoto(url: String?) {
        pic_left_front_45.setData(url)
    }

    override fun setLeftPhoto(url: String?) {
        pic_left.setData(url)
    }

    override fun setLeftBackPhoto(url: String?) {
        pic_left_back_45.setData(url)
    }

    override fun setRightFrontPhoto(url: String?) {
        pic_right_front_45.setData(url)
    }

    override fun setRightPhoto(url: String?) {
        pic_right.setData(url)
    }

    override fun setRightBackPhoto(url: String?) {
        pic_right_back_45.setData(url)
    }

    override fun setActiveSure(b: Boolean) {
        if (b) onSure.normal() else onSure.disable()
    }


    override fun setAlertTip() {
        IOSAlertDialog(this).builder().setTitle("温馨提示").setMsg("提交后，验车图片不能进行修改。请确定是否提交图片", true)
                .setRightButton("确定") {
                    presenter.apiUploadPics()
                }.setLeftButton("取消") {}.show()
    }

    override fun setPageClose() {
        setResult(ConstantsUtil.ORDER_REFRESH_CODE)
        finish()
    }

    companion object {
        fun newInstance(context: Context, status: Int, orderId: String) {
            val intent = Intent(context, SelfCheckActivity::class.java)
            intent.putExtra("ORDER_STATUS", status)
            intent.putExtra("ORDER_ID", orderId)
            (context as Activity).startActivityForResult(intent, Constants.SELF_CHECK_PIC)
        }
    }
}