package com.jiaoyinbrother.monkeyking.manager.util

import android.content.Context
import android.graphics.drawable.Drawable
import android.text.TextUtils
import android.util.AttributeSet
import android.view.LayoutInflater
import android.view.View
import android.widget.ImageView
import android.widget.RelativeLayout
import android.widget.TextView
import com.jiaoyinbrother.monkeyking.manager.R

class NoDataView @JvmOverloads constructor(context: Context?, attrs: AttributeSet? = null, defStyleAttr: Int = 0) :
    RelativeLayout(context, attrs, defStyleAttr) {

    private var type: Int = 0
    private var mTitle: String? = null

    private var mIconView: ImageView? = null
    private var mTitleView: TextView? = null
    private var mRedButtonView: TextView? = null
    private var mStrokeButtonView: TextView? = null

    init {
        if (attrs != null) {
            getAttr(attrs)
        }
        createLayout()
    }

    private fun createLayout() {
        val inflater = context.getSystemService(Context.LAYOUT_INFLATER_SERVICE) as LayoutInflater
        inflater.inflate(
            R.layout.no_data_view,
            this
        )//To change body of created functions use File | Settings | File Templates.
        mIconView = findViewById(R.id.no_data_view_icon)
        mTitleView = findViewById(R.id.no_data_view_title)
        mRedButtonView = findViewById(R.id.no_data_view_button_red)
        mStrokeButtonView = findViewById(R.id.no_data_view_button_stroke)

        setTypeState(type)
//        if (btnStyle != null){
////            mButtonView?.background = btnBcg
//            mButtonView?.setTextAppearance(context,btnStyle)
//        }
    }

    private fun getAttr(attrs: AttributeSet) {
        val typedArray = context.obtainStyledAttributes(attrs, R.styleable.NoDataView)
        //type = typedArray.getResourceId(R.styleable.NoDataView_type, 0)
        type = typedArray.getInt(R.styleable.NoDataView_type, 0)
        mTitle = typedArray.getString(R.styleable.NoDataView_title)
        typedArray.recycle()
    }

    fun setTitleContent(content: String?) {
        mTitleView?.text = content
    }

    fun setButtonListener(listener: OnClickListener) {
        mStrokeButtonView?.setOnClickListener(listener)
        mRedButtonView?.setOnClickListener(listener)
    }

    fun setState(mType: Int){
        setTypeState(mType)
    }


    private fun setTypeState(mType: Int) {
        var title: String? = null
        var resource: Int? = 0
//        var btnBcg :Drawable ? = null
//        var btnStyle :Int ? = null
        //类型
        when (mType) {
            1 -> {
                title = "网络不给力，请稍后重试"
                resource = R.mipmap.icon_no_data_net
                mStrokeButtonView?.visibility = View.VISIBLE
                mStrokeButtonView?.text = "刷新"
//                btnBcg = context.resources.getDrawable(R.drawable.bg_corners_button_stroke)
//                btnStyle = R.style.NoDataViewButtonStyle_Net
            }
            2 -> {
                title = "抱歉，没有符合条件的车辆哦"
                resource = R.mipmap.icon_no_data_car_list
                mRedButtonView?.visibility = View.VISIBLE
                mRedButtonView?.text = "换个时间地点试试吧"
//                btnBcg = context.resources.getDrawable(R.drawable.bg_corners_button_red)
//                btnStyle = R.style.NoDataViewButtonStyle_CarList
            }
            3,
            5 -> {
                title = "抱歉，没有符合条件的车型哦\n换个条件试试吧"
                resource = R.mipmap.icon_no_data_car_list
                mStrokeButtonView?.visibility = View.GONE
            }
            4 -> {
                title = "没有找到您搜索的地点"
                resource = R.mipmap.icon_no_data_address
                mStrokeButtonView?.visibility = View.GONE
            }
        }

        if (!TextUtils.isEmpty(mTitle)) {
            title = mTitle
        }

        mTitleView?.text = title
        mIconView?.setImageResource(resource!!)
    }

}