package com.jiaoyinbrother.monkeyking.manager.util

import com.jiaoyinbrother.library.util.DateTimeUtil
import com.jiaoyinbrother.library.util.LogUtil
import java.text.DecimalFormat
import java.util.*
import kotlin.collections.ArrayList

class SelectDateTimeUtil{
    val MAX_MONTH_NUM = 3// 本应用支持的选择时间的最大月范围

    fun getLastDayOfStartDate():Calendar{
        val calendar = getLastDayOfAMonth(MAX_MONTH_NUM)
        calendar.set(Calendar.HOUR_OF_DAY, 22)
        calendar.set(Calendar.MINUTE, 30)
        return calendar
    }

    fun getLastDayOfEndDate():Calendar{
        val calendar = getLastDayOfAMonth(MAX_MONTH_NUM)
        calendar.set(Calendar.HOUR_OF_DAY, 23)
        calendar.set(Calendar.MINUTE, 30)
        return calendar
    }

    private fun getLastDayOfAMonth(month: Int): Calendar {
        val calendar = Calendar.getInstance()
        calendar.set(Calendar.DAY_OF_MONTH, 1)
        calendar.add(Calendar.MONTH, month)// 1.先推到MAX_MONTH_NUM个月后的第一天00:00
        calendar.add(Calendar.DAY_OF_YEAR, -1)
        LogUtil.e("getLastDayOfAMonth = " + DateTimeUtil.dateToString(calendar.time))
        return calendar
    }

    fun adjustEndDateByStartDate(startDate: Date, endDate: Date, maxDate: Date): Date {
        var retDate = endDate
        LogUtil.e("adjustEndDateByStartDate, startDate =" + DateTimeUtil.dateToString(startDate))
        LogUtil.e("adjustEndDateByStartDate, endDate =" + DateTimeUtil.dateToString(endDate))
        LogUtil.e("adjustEndDateByStartDate, maxDate =" + DateTimeUtil.dateToString(maxDate))

        if(DateTimeUtil.isFirstDateEqualOrAfterSecond(startDate,endDate)){
            retDate = getEndTimeByStartDate(startDate).time
            LogUtil.e("adjustEndDateByStartDate, isFirstDateEqualOrAfterSecond = true")
            if (retDate.after(maxDate)) {
                retDate = maxDate
            }
        }else{
            LogUtil.e("adjustEndDateByStartDate, isFirstDateEqualOrAfterSecond = false")
        }

        LogUtil.e("adjustEndDateByStartDate, retDate =" + DateTimeUtil.dateToString(retDate))
        return retDate

    }

    private fun getEndTimeByStartDate(startDate: Date): Calendar {

        val calendar = Calendar.getInstance()
        calendar.time = startDate
        calendar.add(Calendar.DAY_OF_YEAR, 2)
        return calendar

    }

    fun getHourList():ArrayList<String>{
        val hourList = ArrayList<String>()
        hourList.clear()

        // 如果是个数,则显示为"02"的样式
        val patten = "00"
        val decimal = DecimalFormat(patten)

        for (i in 0..23) {
            hourList.add(decimal.format(i.toLong()))
        }
        return hourList
    }

    fun getMinuteList():ArrayList<String>{
        val minuteList = ArrayList<String>()
        minuteList.clear()
        minuteList.add("00")
        minuteList.add("30")
        return minuteList
    }


    fun getSelectedCalendar(dayList:List<Date> ,dateIndex:Int, hourIndex:Int, minuteIndex:Int): Calendar {

        //date, 从生成的时间取回
        val calendar = Calendar.getInstance()
//        if (mDayListDate != null && dateIndex < mDayListDate!!.size)
//            calendar.time = mDayListDate!![dateIndex]
        if(dateIndex<dayList.size)
            calendar.time  = dayList[dateIndex]
        //1-24 对应 1-24小时
        calendar.set(Calendar.HOUR_OF_DAY, hourIndex)

        //0,1 对应 0,30分钟
        if (minuteIndex == 0)
            calendar.set(Calendar.MINUTE, 0)
        else
            calendar.set(Calendar.MINUTE, 30)

        LogUtil.e("calendar = " + DateTimeUtil.dateToString(calendar.time))
        return calendar
    }


    fun getDateWithValidMinute(date: Date): Calendar {
        val calendar = Calendar.getInstance()
        LogUtil.e("getDateWithValidMinute, in date = " + DateTimeUtil.dateToString(date))
        calendar.time = date
        val minute = calendar.get(Calendar.MINUTE)
        //处理传入不是30，0 问题
        if (minute == 0) {

        } else if (minute > 0 && minute <= 30) {
            calendar.set(Calendar.MINUTE, 30)
        } else {
            //+ 30分钟，然后分钟设置为0，可以解决跨月，跨年等问题
            calendar.add(Calendar.MINUTE, 30)
            calendar.set(Calendar.MINUTE, 0)
        }

        LogUtil.e("getDateWithValidMinute, out date = " + DateTimeUtil.dateToString(calendar.time))
        return calendar
    }
}
