package com.jiaoyinbrother.monkeyking.manager.view

import android.content.Context
import android.text.format.DateUtils
import android.util.AttributeSet
import android.view.View
import android.widget.LinearLayout
import android.widget.ListView
import android.widget.Toast
import com.bumptech.glide.Glide
import com.bumptech.glide.load.resource.bitmap.CircleCrop
import com.bumptech.glide.request.RequestOptions
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.library.adapter.SiteInfoCommentListAdapter
import com.jiaoyinbrother.library.bean.MarkBean
import com.jiaoyinbrother.library.bean.SiteInfoCommentRequest
import com.jiaoyinbrother.library.presenter.SiteInfoCommentPresenterImpl
import com.jiaoyinbrother.library.util.LogUtil
import com.jiaoyinbrother.library.view.IGeneralModel
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.commentreply.CommentReplyActivity.Companion.COMMENT_REPLY_KEY_BAD
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.commentreply.CommentReplyActivity.Companion.COMMENT_REPLY_KEY_GOOD
import com.jiaoyinbrother.monkeyking.manager.mvpactivity.commentreply.CommentReplyActivity.Companion.COMMENT_REPLY_KEY_NEUTRAL
import kotlinx.android.synthetic.main.layout_comment_list.view.*

/**
 * Created by zhangbo on 2018/1/4.
 */
class CommentListLayout @JvmOverloads constructor(
        context: Context, attrs: AttributeSet? = null, defStyleAttr: Int = 0
) : LinearLayout(context, attrs, defStyleAttr), IGeneralModel {


    var adapter: SiteInfoCommentListAdapter? = null
    var type = ""
    private var mListView: ListView? = null
    private var mCommentType = ""
    private var mPageNum: Int = 1
    private var mSelectPage: Int = 1
    var siteid = ""
    var siteManagerid = ""
    private var presenter = SiteInfoCommentPresenterImpl(context, MarkBean::class.java,this)

    init {
        inflate(context, R.layout.layout_comment_list, this)

        comment_radio_group.setOnCheckedChangeListener({ _, checkedId ->

            when(checkedId){
                R.id.comment_item_1->mSelectPage = 1
                R.id.comment_item_2->mSelectPage = 2
                R.id.comment_item_3->mSelectPage = 3
                R.id.comment_item_4->mSelectPage = 4
            }
            mPageNum = 1
            check(mSelectPage)
        })
        adapter = SiteInfoCommentListAdapter(context)
//        presenter.addListener(this)
        mListView = comment_layout_list.refreshableView
        mListView?.adapter = adapter


        comment_layout_list.setOnRefreshListener({ refreshView ->
            val label = DateUtils.formatDateTime(context, System.currentTimeMillis(),
                    DateUtils.FORMAT_SHOW_TIME or DateUtils.FORMAT_SHOW_DATE or DateUtils.FORMAT_ABBREV_ALL)
            refreshView.loadingLayoutProxy.setLastUpdatedLabel(label)
            mPageNum = 1
            check(mSelectPage)

        })


        comment_layout_list.setOnLastItemVisibleListener({
            mPageNum += 1
            check(mSelectPage)
        })
    }

    fun check(index: Int) {
        var request = SiteInfoCommentRequest()
        when (index) {
            1 -> {
                mCommentType = ""
                mSelectPage = 1
            }
            2 -> {
                mCommentType = COMMENT_REPLY_KEY_GOOD
                mSelectPage = 2
            }
            3 -> {
                mCommentType = COMMENT_REPLY_KEY_NEUTRAL
                mSelectPage = 3
            }
            4 -> {
                mCommentType = COMMENT_REPLY_KEY_BAD
                mSelectPage = 4
            }
        }
        request.page_size = 10
        request.page = mPageNum
        if (mCommentType.isNotEmpty()) {
            request.type = mCommentType
        }
        if (type == TYPE_SITE)
            request.siteid = siteid
        else
            request.uid = siteManagerid
        presenter.requestSiteInfoComment(request)
    }

    fun initData(id: String, type: String) {

        if (type == TYPE_SITE) {
            personal_layout.visibility = View.GONE
            faint_line1.visibility = View.GONE
            think_line.visibility = View.GONE
            faint_line2.visibility = View.GONE
            this.siteid = id
        } else {
            personal_layout.visibility = View.VISIBLE
            faint_line1.visibility = View.VISIBLE
            think_line.visibility = View.VISIBLE
            faint_line2.visibility = View.VISIBLE
            this.siteManagerid = id
        }
        this.type = type
        comment_item_1.isChecked = true
    }

    override fun getCodeBeanFail(errorCode: Int) {

    }

    override fun getCodeObjectSuccess(bean: Any?) {
        var markBean = bean as MarkBean
//        更新header
        name.text = "运营专员"
        phone.text = siteManagerid

        Glide.with(context).load(markBean.headimg_url).placeholder(R.mipmap.img_head1)
                .apply(RequestOptions.bitmapTransform(CircleCrop())).into(img_head)

        tv_commission_count.text = ((markBean.rate0)?.toFloat() ?: 5.0f).toString()
        rb_commission.rating = (markBean.rate0)?.toFloat() ?: 5.0f
        comment_item_1.text = "全部评价(" + markBean.total + ")" //全部
        comment_item_2.text = "好评(" + markBean.good + ")" //好评
        comment_item_3.text = "中评(" + markBean.neutral + ")" //中评
        comment_item_4.text = "差评(" + markBean.bad + ")" //差评

//        adapter?.list =  markBean.marks

        if (mPageNum == 1) {
            if (markBean.marks == null || markBean.marks!!.size == 0){
                comment_layout_list.visibility = View.GONE
                comment_empty_data_layout.visibility = View.VISIBLE
            }else{
                comment_empty_data_layout.visibility = View.GONE
                comment_layout_list.visibility = View.VISIBLE
            }
            adapter?.initList(markBean.marks)
            LogUtil.e("mPageNum1->" + mPageNum)
            mListView?.smoothScrollToPosition(0)
        } else {
            adapter?.addList(markBean.marks)
            LogUtil.e("mPageNum2->" + mPageNum)
        }
            if (markBean.marks != null && markBean.marks!!.size > 0) {

            } else {
                if (mPageNum > 1){
                    Toast.makeText(context, "已经全部加载完毕", Toast.LENGTH_SHORT).show()
                }
            }
        comment_layout_list.onRefreshComplete()
    }


    companion object {
        val TYPE_SITE = "1"
        val TYPE_PERSON = "2"
    }
}