package com.jiaoyinbrother.monkeyking.manager.view

import android.annotation.SuppressLint
import android.content.Context
import android.util.AttributeSet
import android.webkit.WebChromeClient
import android.webkit.WebSettings
import android.webkit.WebView
import android.webkit.WebViewClient
import com.jiaoyinbrother.library.util.LogUtil
import kotlinx.android.synthetic.main.fragment_car_data_analysis.*


class EchartsView
@JvmOverloads constructor(context: Context, attrs: AttributeSet? = null) :
    WebView(context, attrs) {

    init {
        initView()
    }


    @SuppressLint("SetJavaScriptEnabled")
    private fun initView() {
        val webSettings = settings
        webSettings.cacheMode = WebSettings.LOAD_CACHE_ELSE_NETWORK
        webSettings.javaScriptEnabled = true
        webSettings.setSupportZoom(false)
        webSettings.javaScriptCanOpenWindowsAutomatically = true
        loadUrl("file:///android_asset/echarts.html")
    }

    fun refreshChart(listener: OnRefreshChartListener) {
        loadUrl("file:///android_asset/echarts.html")
        webViewClient = object : WebViewClient() {
            override fun onPageFinished(view: WebView?, url: String?) {
                super.onPageFinished(view, url)
                listener?.onRefresh()
            }

            override fun shouldOverrideUrlLoading(view: WebView?, url: String?): Boolean {
                loadUrl(url)
                return super.shouldOverrideUrlLoading(view, url)
            }
        }
    }

    fun resetChart() {
        webViewClient = null
    }

    interface OnRefreshChartListener {
        fun onRefresh()
    }
}