package com.jiaoyinbrother.monkeyking.manager.view

import android.content.Context
import android.support.constraint.ConstraintLayout
import android.support.v7.widget.LinearLayoutManager
import android.util.AttributeSet
import android.view.LayoutInflater
import com.jiaoyinbrother.monkeyking.manager.R
import com.jiaoyinbrother.monkeyking.manager.adapter.TakeAlsoTimeLineAdapter
import kotlinx.android.synthetic.main.view_take_also_car_time_line.view.*

class TakeAlsoCarTimeLine @JvmOverloads constructor(context: Context, attrs: AttributeSet? = null, defStyleAttr: Int = 0)
    : ConstraintLayout(context, attrs, defStyleAttr) {

    private var styleType: Int = 0
    private var mAdapter: TakeAlsoTimeLineAdapter? = null


    companion object {
        private val deliver_normal = arrayOf("订单核实", "用户信息核实", "验车单")
        private val deliver_school = arrayOf("学籍认证", "订单核实", "用户信息核实", "验车单")
        private val deliver_contract_normal = arrayOf("订单核实", "用户信息核实", "验车单", "签署合同")
        private val deliver_contract_school = arrayOf("学籍认证", "订单核实", "用户信息核实", "验车单", "签署合同")
        private val refund_normal = arrayOf("订单核实", "验车单", "费用核实")
//        private val refund_contract = arrayOf("订单核实", "验车单", "费用核实", "签署合同")
        private val refund_contract = arrayOf("订单核实", "验车单", "费用核实")
        //
        const val DELIVER_NORMAL = 0
        const val DELIVER_SCHOOL = 1
        const val DELIVER_CONTRACT_NORMAL = 2
        const val DELIVER_CONTRACT_SCHOOL = 3
        const val REFUND_NORMAL = 4
        const val REFUND_CONTRACT = 5

        //
        const val INDEX_ZERO = 0
        const val INDEX_ONE = 1
        const val INDEX_TWO = 2
        const val INDEX_THREE = 3
        const val INDEX_FOUR = 4
    }


    init {
        val inflater = context.getSystemService(Context.LAYOUT_INFLATER_SERVICE) as LayoutInflater
        inflater.inflate(R.layout.view_take_also_car_time_line, this)
        if (attrs != null) {
            getAttr(attrs)
        }
        initData()
    }

    private fun getAttr(attrs: AttributeSet? = null) {
        val typedArray = context.obtainStyledAttributes(attrs, R.styleable.TakeAlsoCar)
        // 背景
        styleType = typedArray.getInteger(R.styleable.TakeAlsoCar_style_model, 0)
        typedArray.recycle()
    }

    private fun initData() {
        val manager = LinearLayoutManager(context)
        manager.orientation = LinearLayoutManager.HORIZONTAL
        state_recycler.layoutManager = manager
        initAdapter()
    }

    private fun initAdapter() {
        mAdapter = TakeAlsoTimeLineAdapter(context, initDataList())
        state_recycler?.adapter = mAdapter
    }

    private fun initDataList(): Array<String> {
        return when (styleType) {
            DELIVER_SCHOOL -> deliver_school
            DELIVER_CONTRACT_NORMAL -> deliver_contract_normal
            DELIVER_CONTRACT_SCHOOL -> deliver_contract_school
            REFUND_NORMAL -> refund_normal
            REFUND_CONTRACT -> refund_contract
            else -> deliver_normal
        }
    }

    fun setStyleType(type: Int) {
        styleType = type
        initAdapter()
    }

    fun setSelectIndex(index: Int) {
        mAdapter?.setSelectIndex(index)
    }
}
